define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;

  var init = function() {
    dom = $("#page-home");

    initJuicer();
    initEvent();
    loadData();
  };
  var initEvent=function(){
    dom.find(".list-search-area").on("change",function(){
      loadList();
    });
    dom.on("click",".data-item-list",function(){
      base.openUrl("index.html#evaluate_bureau.task-indicator-detail-list?"+$(this).attr("data-param"),"");
    });
  };

  var initJuicer = function() {
    juicer.register("fsPath", function() {
      return CONFIG.fsPath;
    });
    
     juicer.register("getValueByKey", constant.getValueByKey);
  };

  var loadData = function() {
    databind.submit([],{
      action:"inquireYearListEvaTenant",
      success:function(ret){
        var ops = [];
        var cd = new Date();
        var cy  = cd.getFullYear();
        var cm  = cd.getMonth()+1;
        var dy = cm<9?cy-1:cy;
        // ops.push($("<option>").val("").text("全部"));
        for(var idx in ret.datas){
          var dt = ret.datas[idx];
          var op  = $("<option>").val(dt).text(dt);
          if(dt.indexOf(dy)==0){op.attr("selected",true);}
          ops.push(op);
        }
        dom.find("select[name=year]").html(ops);
        var cv = base.getUrlParam("year");
        if(cv){
          dom.find("select[name=year]").val(cv);
        }
        loadList();
      }
    });


  };
  var loadList=function(){
    databind.submit(dom.find(".list-search-area"),{
      action:"inquireResultListEvaAppGlobal",
      success:function(ret){
        var html = juicer(dom.find("script[data-tmpl=listitem]").html(),ret);
        dom.find(".data-list").html(html);
        
        if(!ret.datas.length) {
      		dom.find(".empty-content").removeClass("none");
      	} else {
      		dom.find(".empty-content").addClass("none");
      	}
      }
    });
  };

  return {
    init: init
  };
});
