define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;

	var init = function() {
		dom = $("#page-task-indicator-detail");

		initJuicer();
		initEvent();
		loadData();
	};
	var initEvent=function(){
		dom.on("click","[data-id]",function(){
			window.location.href= "#evaluate_bureau.school-task-indicator-detail?data-id="+$(this).attr("data-id")+"&taskId="+$(this).attr("taskId")+"&name="+encodeURIComponent($(this).attr("textname"));
		});
	};

	var initJuicer = function() {
		juicer.register("fsPath", function() {
			return CONFIG.fsPath;
		});
		
	};

	var loadData = function() {
		var taskId ;
		databind.submit([],{
			action:"inquireResultObjectDetailEvaAppGlobal",
			data:{evaluateId:base.getUrlParam("data-id"),taskId:base.getUrlParam("taskId")},
			success:function(ret){
				var dt = ret.datas[0];
				databind.fillForm(dom.find(".data-item"),dt);
				if(dt.ranking<=3){
					dom.find(".data-item").find("[name=ranking],[name=totalScore]").addClass("orange");
				}
				dom.find(".page-header .title").text(dt.templateName);
				if(dt.logoUuid){
					dom.find(".data-item img.item").attr("src",CONFIG.fsPath+"/v1.0/viewPic.file?fileUuid="+dt.logoUuid);
				}
				
				if(dt.rankingDrift >= 1) {
					dom.find(".changeicon").removeClass("none").attr("src", constant.getValueByKey("driftIcon", dt.rankingDrift));	
				}
				
				taskId=  dt.taskId;

			}
		});
		loadIndi(base.getUrlParam("taskId"));

	};

	var loadIndi=function(taskId){
		databind.submit([],{
			action:"inquireResultEvaluateIndicatorListEvaAppTenant",
			data:{evaluateId:base.getUrlParam("data-id")},
			success:function(ret){
				var html = juicer(dom.find("script[data-tmpl=listitem]").html(),ret);
				dom.find(".data-list").html(html);
				dom.find(".data-list [data-id]").attr("taskId",taskId);
			}
		});
	};

	return {
		init: init
	};
});
