define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var chart  = require("js/chart");
	var dom;

	var init = function() {
		dom = $("#page-schooltask-indicator-detail");

		initJuicer();
		initEvent();
		loadData();
	};
	var initEvent=function(){
		// dom.on("click",".indicator-item",function(){
		// 	window.location.href= "#evaluate_bureau.page-schooltask-indicator-detail";
		// });
	};

	var initJuicer = function() {
		juicer.register("fsPath", function() {
			return CONFIG.fsPath;
		});
	};

	var loadData = function() {
		dom.find(".page-header .title").text(base.getUrlParam("name"));


		databind.submit([],{
			action:"inquireResultEvaluateIndicatorDetailEvaAppTenant",
			data:{evaluateIndicatorId:base.getUrlParam("data-id"),taskId:base.getUrlParam("taskId")},
			success:function(ret){
				var html = juicer(dom.find("script[data-tmpl=listitem]").html(),ret);
				dom.find(".data-list").html(html);
				loadCharts(ret);
				console.log(ret);
			}
		});


	};

	var loadCharts=function(ret){
		var dts  = ret.datas;
		dom.find(".score_charts").each(function(idx,itm){
			var charopt = {
				color:["#FF7344"],
				backgroundColor:"rgb(250,250,250)",
				grid: {left: '3%',right: '4%',bottom: '3%',containLabel: true},
				xAxis: {type: 'value',boundaryGap: [0, 0.01]},
				yAxis: {type: 'category',data: ['林建武','马云','刘德华','马克党','bullshit']},
				series:[{name:'2011年',type:'bar',label:{normal:{show:true,position:'insideRight'}},data:[4,3,4.5,4.4,3]},]
			};
			var dt = dts[idx];
			charopt.yAxis.data = dt.personNameList;
			charopt.series[0].data=dt.scoreList;
			chart.zzt({dom:$(itm),datas:charopt});
		});
	};

	return {
		init: init
	};
});
