// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("hash/pageRouter");
	var dialog = require("dialog");
	var dom;
	var init = function() {
		dom = $("#container");
		router.init();
		loadData();
		initEvent();
	};
	var initEvent = function() {
		//搜索区域点击
		$(".container").on("touchend", ".search", function() {
			router.route("hospitalFile.hospitalFileSearch");
		});
		//列表点击
		$(".container").on("touchend", ".listItem", function() {
			router.route("hospitalFile.hospitalFileDetail?taskId=" + $(this).attr("taskId"));
		});
		//后退
		$(".backBtn").on("touchend", function() {
			base.back();
		});

		//审批结果
		$("#result").on("touchend", function() {
			$(".bottom-result").removeClass("none");
			$(".fullBg").removeClass("none");
		});

		//快速选择
		$("#checkOpinion").on("touchend", function() {
			$(".bottom-opinion").removeClass("none");
			$(".fullBg").removeClass("none");
		});

		$(".fullBg").on("touchend", function() {
			$(this).addClass("none");
			$(".bottom-result").addClass("none");
			$(".bottom-opinion").addClass("none");
		});


		$(".checkBtn").on("touchend", function() {
			$(".checkBtn").removeClass("check");
			$(this).addClass("check");
		});

		//取消
		$(".cancle").on("touchend", function() {
			$(".fullBg").addClass("none");
			$(".bottom").addClass("none");
		});

		//完成（审批结果）
		$(".complete-result").on("touchend", function() {
			$(".fullBg").addClass("none");
			$(".bottom-result").addClass("none");
			var val = $("input[name='check']:checked").val();
			var t = $("input[name='check']:checked").parent().find("label").text();
			if (val != undefined) {
				$("#result").find(".prompt").html(t);
				$("#result").find(".prompt").attr("actionType", val);
				$("#result").find(".prompt").css("color", "#666");
				$(".contentBottom").removeClass("none");
			}
			if (val == 5) {
				$(".contentBottom").addClass("none");
			}
		});
		//完成（快速选择）
		$(".complete-opinion").on("touchend", function() {
			$(".fullBg").addClass("none");
			$(".bottom-opinion").addClass("none");
			var val = $("input[name='check']:checked").val();
			var t = $("input[name='check']:checked").parent().find("label").text();
			if (val != undefined) {
				$("#checkOpinion").find(".prompt").html(t);
				$("#checkOpinion").find(".prompt").css("color", "#666");
				$(".contentMid").find("textarea").val(t);
			}
		});
		//单人选择
		$(".contentBottom").on("touchend", function() {
			base.callSingleEmployeeSelector([], function(datas) {
				var name = [];
				var id = [];
				name.push(datas[0].name);
				id.push(datas[0].accountId);
				$(".contentBottom .prompt").attr("approverAccountId",id);
				$(".contentBottom .prompt").attr("approverName",name);
				$(".contentBottom .prompt").html(name);
				$(".contentBottom .prompt").css("color", "#666");
			});
		});

		//提交反馈
		$(".btn-submit").on("touchend", function() {
			var taskId = base.getUrlParam("taskId");
			var actionType = $("#result").find(".prompt").attr("actionType");
			var content = $(".contentMid").find("textarea").val();
			var approverAccountId = $(".contentBottom .prompt").attr("approverAccountId");
			var approverName = $(".contentBottom .prompt").attr("approverName");
			databind.submit({}, {
				action: "createTaskFeedback",
				version: "v1.0",
				data: {
					"taskId":taskId,
					"actionType": actionType,
					"content": content,
					"approverAccountId": approverAccountId,
					"approverName": approverName
				},
				success: function(data) {
					router.route("hospitalFile.hospitalFileList");
				}
			});
		});
	};
	var loadData = function() {

	};
	return {
		init: init
	};
});