// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var dom;
	var comFlag = 0;
	var noticeId;
	var noticeMemberId;
	var toAccountIdlist;
	var toNameList;
	var toTenantIdList;

	var init = function() {
		dom = $("#page-inform-create");
		router.init();
		juicer.register("fsPath", function() {
			return CONFIG.fsPath;
		});
		initEvent();
	};

	var initEvent = function() {

		noticeId = base.getUrlParam("noticeId");

		$("textarea").autosize();

		//附件上传按钮，调用原生附件上传
//		dom.find("#btn-attachAdd").on("click", function() {
//			base.selectImageFileAndCaptureImage(function(data) {
//				var attacheshtml = juicer($("#attaches-tpl").html(), data);
//				dom.find("#btn-attachAdd").before(attacheshtml);
//				//点击删除附件
//				dom.find(".attaches").on("click", function() {
//					$(this).remove();
//				});
//			});
//		});
		
		// 附件上传按钮，调用原生附件上传
		dom.find("#item-btn-attachAdd").on("click", function() {
			base.selectImageFileAndCaptureImage(function(data) {
				var attacheshtml = juicer($('.atts').html(), data);
				dom.find(".attachments").append(attacheshtml);
				// 点击查看详情
				downloadFile();
			});
		});

		dom.find(".btn-addBlue").off("click").on("click", function() {
			if(comFlag == 0) {
				//第一次提交
				comFlag = 1;
				// createTask();
				loadData();
			}
		});
	};
	
	var downloadFile = function() {
		dom.find(".section-wrap").find(".fileName").each(function(idx, itm) {
			var _t = $(itm);
			var url = $(itm).attr("url");
			var path = base.inquireDownloadUrlPath(url);
			if(path) {
				_t.off("click").on("click", function() {
					base.openUri("file://" + path);
				});
				_t.removeAttr("url");
			} else {
				_t.on("click", function() {
					var _t = $(this);
					var fileuuid = _t.attr("fileuuid");
					var filename = _t.attr("filename");
					var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid);
					if(path) {
						_t.off("click").on("click", function() {
							base.openUri("file://" + path);
						});
						return;
					}
					var opt = {
						url: CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid,
						filename: filename
					};
					base.downloadFileToSDCard(opt);
				});
			}
		});
		dom.find(".section-wrap").find(".img_delete").on("click", function() {
			$(this).parents('.attachment').remove();
			event.cancelBubble = true; // 取消触发外层的点击事件
		});
	};
	
	var createNoticeReportAccount = function() {
		var data;
		var title = dom.find("input[name=title]").val().replace(/(^\s*)|(\s*$)/g, "");
		var content = dom.find("textarea[name=content]").val();
		var attachmentSizes = [];
		var attachmentNames = [];
		var attachmentIds = [];

//		dom.find(".section-attaches-wrap").each(function(idx, itm) {
//			if($(this).hasClass("attaches")) {
//				attachmentSizes.push($(this).attr("fileSize"));
//				attachmentNames.push($(this).attr("fileName"));
//				attachmentIds.push($(this).attr("fileUuid"));
//			}
//		});

		dom.find(".fileName").each(function(idx, itm) {
			attachmentSizes.push($(this).attr("fileSize"));
			attachmentNames.push($(this).attr("fileName"));
			attachmentIds.push($(this).attr("fileUuid"));
		});

		if(attachmentSizes) {
			data = {
				title: title,
				content: content,
				fileSizeList: attachmentSizes,
				fileNameList: attachmentNames,
				fileUuidList: attachmentIds,
				toAccountIdList: toAccountIdlist,
				toNameList: toNameList,
				toTenantIdList: toTenantIdList,
				noticeMemberId: noticeMemberId
			}
		} else {
			data = {
				title: title,
				content: content,
				toAccountIdList: toAccountIdlist,
				toNameList: toNameList,
				toTenantIdList: toTenantIdList,
				noticeMemberId: noticeMemberId
			}
		};

		if(title && content) {
			databind.submit({}, {
				action: "createNoticeReportAccount",
				data: data,
				success: function(data) {
					comFlag = 0;
					base.alert(1, "发布成功", 1500);
					base.back();
				},
				fail: function(data) {
					comFlag = 0;
					dialog.loadDialog("dialog.tipsDialog", {
						params: {
							tips: "反馈报送创建失败，请重试！"
						}
					}, "medium");
				}
			});
		} else {
			comFlag = 0;
			dialog.loadDialog("dialog.tipsDialog", {
				params: {
					tips: "请完善反馈信息！"
				}
			}, "medium");
		};
	};

	var loadData = function() {
		databind.submit({}, {
			action: "inquireNoticeDetailAccount",
			version: "v1.0",
			data: {
				"noticeId": noticeId
			},
			success: function(data) {
				if(data.status == 200) {
					var dt = data.datas[0];
					for(var idx in dt.receivePersons) {
						var p = dt.receivePersons[idx];
						if(base.getUrlParam('type') == 2) { // 个人反馈
							if(p.mine && p.memberType == 1) {
								noticeMemberId = p.noticeMemberId;
							}
						} else {
							if(p.mine && p.memberType == 3) { // 单位反馈
								noticeMemberId = p.noticeMemberId;
							}
						}
					}
					toAccountIdlist = dt.ccIdList;
					toNameList = dt.ccNameList;
					toTenantIdList = dt.ccTenantIdList;
					createNoticeReportAccount();
				} else {
					base.alert(3, data.message);
				}
			}
		});
	};

	return {
		init: init
	};
});