// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var dom;
	var comFlag = 0;
	var noticeId;
	var type;
	var init = function() {
		dateEvent();
		dom = $("#page-inform-create");
		type = base.getUrlParam("formType");
		router.init();
		initFunction();
		initEvent();
		if(type == 1){
			dom.find("textarea[name='content_input']").remove();
		}
	};

	var initFunction = function() {
		juicer.register("fsPath", function() {
			return CONFIG.fsPath;
		});

		juicer.register("getcode", function(fileName) {
			return encodeURIComponent(fileName);
		});

		juicer.register("fileIcon", function(fileName) {
			var icon = "res/images/ficon/unknow_icon_16px.png";
			var ext = fileName.replace(/.*\.(\w+)/, "$1");
			if(!ext) {
				return icon;
			}
			ext = ext.toLowerCase();
			var extMap = {
				"apk": "apk_icon_16px",
				"xls": "excel_icon_16px",
				"csv": "excel_icon_16px",
				"xlsx": "excel_icon_16px",
				"ods": "excel_icon_16px",
				"ppt": "ppt_icon_16px",
				"pptx": "ppt_icon_16px",
				"odp": "ppt_icon_16px",
				"pdf": "pdf_icon_16px",
				"jpg": "pic_icon_16px",
				"png": "pic_icon_16px",
				"jpeg": "pic_icon_16px",
				"gif": "pic_icon_16px",
				"tif": "pic_icon_16px",
				"tiff": "pic_icon_16px",
				"psd": "ps_icon_16px",
				"txt": "txt_icon_16px",
				"mp4": "video_icon_16px",
				"avi": "video_icon_16px",
				"flv": "video_icon_16px",
				"rmvb": "video_icon_16px",
				"rm": "video_icon_16px",
				"3gp": "video_icon_16px",
				"mov": "video_icon_16px",
				"asf": "video_icon_16px",
				"wmv": "video_icon_16px",
				"mp3": "audio_icon_16px",
				"wav": "audio_icon_16px",
				"flac": "audio_icon_16px",
				"ape": "audio_icon_16px",
				"ogg": "audio_icon_16px",
				"doc": "word_icon_16px",
				"docx": "word_icon_16px",
				"odt": "word_icon_16px",
				"zip": "zip_icon_16px",
				"7z": "zip_icon_16px",
				"rar": "zip_icon_16px",
				"gz": "zip_icon_16px",
				"bz": "zip_icon_16px",
				"tar": "zip_icon_16px",
			};
			var pic = extMap[ext];
			if(pic) {
				icon = "res/images/ficon/" + pic + ".png";
			}

			return icon;
		});
	};

	var initEvent = function() {
		hasPerson();
		hasUnit();

		noticeId = base.getUrlParam("noticeId");
		if(noticeId) { // 若是转发通知
			dom.find("#btn-attachAdd").addClass("none");
			dom.find("#item-btn-attachAdd").removeClass("none");
			loadData();
			dom.find(".header-title").html("转发通知");
			dom.find('textarea[name=content]').attr('disabled', true);
		} else { // 新建通知
			dom.find('textarea[name=content]').attr('disabled', false);
		}

		$("textarea").autosize();

		//模拟radio的点击事件（是否推送）
		dom.find("label[name=ifNotice]").on("click", function(e) {
			dom.find("label[name=ifNotice]").removeClass("labelActive");
			if(!$(this).hasClass("labelActive")) {
				$(this).addClass("labelActive");
			}
		});

		//模拟radio的点击事件（发布人）
		dom.find("label[name=tenantFlag]").on("click", function(e) {
			dom.find("label[name=tenantFlag]").removeClass("labelActive");
			if(!$(this).hasClass("labelActive")) {
				$(this).addClass("labelActive");
			}
		});

		//模拟radio的点击事件（是否报送）
		dom.find("label[name=reportFlag]").on("click", function(e) {
			dom.find("label[name=reportFlag]").removeClass("labelActive");
			if(!$(this).hasClass("labelActive")) {
				$(this).addClass("labelActive");
			}
			var reportFlag = $(this).attr("num");
			if(reportFlag == "1") {
				dom.find("#reportToEmp").find(".message").removeClass("none");
			} else {
				dom.find("#reportToEmp").find(".message").addClass("none");
			}
		});

		//流转按钮点击 调用原生人员选择器（本单位及下属单位）
		dom.find("#flowToEmp").find(".flow").on("click", function() {
			var emId = [];
			dom.find("#flowToEmp").find(".personItem-wrap").each(function(idx, itm) {
				emId.push($(this).attr("employeeId"));
			});

			base.callEmployeeSelector({isCross:1,subOrSup:"sub",showArea:1,showGroup:1}, function(datas) {
				var data = {
					datas: datas
				};
				if(data) {
					dom.find("#flowToEmp").find(".section-wrap-pers").removeClass("none");
					dom.find("#flowToEmp").find(".section-wrap-pers").find(".clear").remove();
				};
				var ct = dom.find("#flowToEmp").find(".section-wrap-pers");
				var empSelectorhtml = $(juicer($("#empSelector-tpl").html(), data));
				empSelectorhtml.each(function(idx, itm) {
					var it = $(itm);
					if(ct.find('[toId=' + it.attr('toId') + '][toTenantId=' + it.attr('toTenantId') + ']').length > 0) {
						return;
					}
					ct.append(it);
				});
				dom.find("#flowToEmp").find(".section-wrap-pers").append('<div class="clear"></div>');
				//当前状态下可以直接删除选中的人
				dom.find("#flowToEmp").find(".personItem").on("click", function() {
					$(this).parent(".personItem-wrap").remove();
					hasPerson(); //删除选中的同时判断是否需要隐藏当前的class
				});
			});
		});

		//流转按钮点击 调用原生单位选择器
		dom.find("#flowToUnit").find(".flow").on("click", function() {
			var param = {};
			var tenantIds = [];
			dom.find("#flowToUnit").find(".unitItem-wrap").each(function(idx, itm) {
				tenantIds.push($(this).attr("toTenantId"));
			});
			param.tenantIds = tenantIds;
			param.supOrSub = "sub"; // 下属
			//			param.maxSelecteNum = 1; // 最大可选
			param.directly = 1; // 直属
			param.showArea = 1;
			base.callUnitSelector(param, function(datas) {
				var data = {
					datas: datas
				};
				if(data) {
					dom.find("#flowToUnit").find(".section-wrap-units").removeClass("none");
				};

				var unitSelectorhtml = juicer($("#unitSelector-tpl").html(), data);
				databind.fillForm(dom.find("#flowToUnit"), {
					unitSelector: unitSelectorhtml
				});
				//				dom.find("#flowToUnit").find(".section-wrap-units").append('<div class="loadMore none">查看更多</div>');
				//当前状态下可以直接删除选中的单位
				dom.find("#flowToUnit").find(".unitItem").on("click", function() {
					$(this).parent(".unitItem-wrap").remove();
					hasUnit(); //删除选中的同时判断是否需要隐藏当前的class
				});
				hideUnit();
			});
		});

		//报送按钮点击 调用原生人员选择器（本单位）
		dom.find("#reportToEmp").find(".report").on("click", function() {
			var emId = [];
			dom.find("#reportToEmp").find(".personItem-wrap").each(function(idx, itm) {
				emId.push($(this).attr("employeeId"));
			});

			base.callEmployeeSelector({isCross:0,subOrSup:"none",showArea:0,showGroup:1}, function(datas) {
				var data = {
					datas: datas
				};
				if(data) {
					dom.find("#reportToEmp").find(".section-wrap-pers").removeClass("none");
					dom.find("#reportToEmp").find(".section-wrap-pers").find(".clear").remove();
				};
				var ct = dom.find("#reportToEmp").find(".section-wrap-pers");
				var empSelectorhtml = $(juicer($("#empSelector-tpl-second").html(), data));
				empSelectorhtml.each(function(idx, itm) {
					var it = $(itm);
					if(ct.find('[ccId=' + it.attr('ccId') + '][ccTenantId=' + it.attr('ccTenantId') + ']').length > 0) {
						return;
					}
					ct.append(it);
				});
				dom.find("#reportToEmp").find(".section-wrap-pers").append('<div class="clear"></div>');
				//当前状态下可以直接删除选中的人
				dom.find("#reportToEmp").find(".personItem").on("click", function() {
					$(this).parent(".personItem-wrap").remove();
					hasPerson(); //删除选中的同时判断是否需要隐藏当前的class
				});
			});
		});

		// 附件上传按钮，调用原生附件上传
		dom.find("#item-btn-attachAdd").on("click", function() {
			base.selectImageFileAndCaptureImage(function(data) {
				var attacheshtml = juicer($('.atts').html(), data);
				dom.find(".attachments").append(attacheshtml);
				// 点击查看详情
				downloadFile();
			});
		});

		//提交新建任务
		dom.find(".footer-btn").find(".btn-addBlue").on("click", function() {
			if(comFlag == 0) {
				//第一次提交
				comFlag = 1;
				createTask();
			}
		});

	};

	var createTask = function() {
		var data;
		var title = dom.find("input[name=title]").val().replace(/(^\s*)|(\s*$)/g, "");
		var content = dom.find("textarea[name=content]").val();
		var links = dom.find("input[name=link]").val();
		var attachmentSizes = [];
		var attachmentNames = [];
		var attachmentIds = [];
		var ifNotice;
		var tenantFlag;
		var reportFlag;
		var targetDate;
		var toNames = [];
		var toIds = [];
		var toTypes = [];
		var toTenantIds = [];
		var ccNames = [];
		var ccIds = [];
		var ccTypes = [];
		var ccTenantIds = [];
		var content_input=dom.find(".content_input").val();
		if ($.trim(content_input).length>0) {
			content=content_input+"                           "+content;
		}
		targetDate = dom.find("input[name=targetDate]").val();

		if(links.replace(/(^\s*)|(\s*$)/g, "") && links.indexOf("http://") == -1 && links.indexOf("https://") == -1) {
			links = "https://" + links;
		}

		$.each(dom.find("label[name=ifNotice]"), function(idx, itm) {
			if($(itm).hasClass("labelActive")) {
				ifNotice = $(itm).attr("num")
			}
		});

		$.each(dom.find("label[name=tenantFlag]"), function(idx, itm) {
			if($(itm).hasClass("labelActive")) {
				tenantFlag = $(itm).attr("num")
			}
		});

		$.each(dom.find("label[name=reportFlag]"), function(idx, itm) {
			if($(itm).hasClass("labelActive")) {
				reportFlag = $(itm).attr("num")
			}
		});

		dom.find(".fileName").each(function(idx, itm) {
			attachmentSizes.push($(this).attr("fileSize"));
			attachmentNames.push($(this).attr("fileName"));
			attachmentIds.push($(this).attr("fileUuid"));
		});

		dom.find("#flowToEmp").find(".personItem-wrap").each(function(idx, itm) {
			toNames.push($(this).attr("toName"));
			toIds.push($(this).attr("toId"));
			toTypes.push($(this).attr("toType"));
			toTenantIds.push($(this).attr("toTenantId"));
		});

		dom.find("#reportToEmp").find(".personItem-wrap").each(function(idx, itm) {
			ccNames.push($(this).attr("ccName"));
			ccIds.push($(this).attr("ccId"));
			ccTypes.push($(this).attr("ccType"));
			ccTenantIds.push($(this).attr("ccTenantId"));
		});

		dom.find("#flowToUnit").find(".unitItem-wrap").each(function(idx, itm) {
			toNames.push($(this).attr("toName"));
			toIds.push($(this).attr("toId"));
			toTypes.push($(this).attr("toType"));
			toTenantIds.push($(this).attr("toTenantId"));
		});

		if(attachmentSizes) {
			if(reportFlag == "1") {
				data = {
					type: 1,
					subtype: "通知公告",
					title: title,
					content: content,
					link: links,
					toIds: toIds,
					toNames: toNames,
					toTypes: toTypes,
					toTenantIds: toTenantIds,
					ifNotice: ifNotice,
					tenantFlag:tenantFlag,
					reportFlag: reportFlag,
					targetDate: targetDate,
					ccNames: ccNames,
					ccIds: ccIds,
					ccTypes: ccTypes,
					ccTenantIds: ccTenantIds,
					pushAppKey: ["YX_BUREAU_NOTICE_APP", "YX_NOTICE_APP"],
					attachmentSizes: attachmentSizes,
					attachmentNames: attachmentNames,
					attachmentIds: attachmentIds
				}
			} else {
				data = {
					type: 1,
					subtype: "通知公告",
					title: title,
					content: content,
					link: links,
					toIds: toIds,
					toNames: toNames,
					toTypes: toTypes,
					toTenantIds: toTenantIds,
					ifNotice: ifNotice,
					tenantFlag:tenantFlag,
					reportFlag: 0,
					pushAppKey: ["YX_BUREAU_NOTICE_APP", "YX_NOTICE_APP"],
					attachmentSizes: attachmentSizes,
					attachmentNames: attachmentNames,
					attachmentIds: attachmentIds
				}
			}
		} else {
			if(reportFlag == "1") {
				data = {
					type: 1,
					subtype: "通知公告",
					link: links,
					title: title,
					content: content,
					ifNotice: ifNotice,
					tenantFlag:tenantFlag,
					toIds: toIds,
					toNames: toNames,
					toTypes: toTypes,
					toTenantIds: toTenantIds,
					reportFlag: reportFlag,
					targetDate: targetDate,
					ccNames: ccNames,
					ccIds: ccIds,
					ccTypes: ccTypes,
					ccTenantIds: ccTenantIds,
					pushAppKey: ["YX_BUREAU_NOTICE_APP", "YX_NOTICE_APP"]
				}
			} else {
				data = {
					type: 1,
					subtype: "通知公告",
					link: links,
					title: title,
					content: content,
					ifNotice: ifNotice,
					tenantFlag:tenantFlag,
					toIds: toIds,
					toNames: toNames,
					toTypes: toTypes,
					toTenantIds: toTenantIds,
					reprotFlag: 0,
					pushAppKey: ["YX_BUREAU_NOTICE_APP", "YX_NOTICE_APP"]
				}
			}
		};
		if(reportFlag == "1") {
			if(!(targetDate && ccNames.length && ccIds.length && ccTypes.length)) {
				comFlag = 0;
//				dialog.loadDialog("dialog.tipsDialog-create", {
				dialog.loadDialog("dialog.tipsDialog", {
					params: {
						tips: "请完善报送信息！"
					}
				}, "medium");
				return;
			}
		}

		if(title && toNames.length && toIds.length && toTypes.length) {
			databind.submit({}, {
				action: "createNoticeAccount",
				data: data,
				success: function(data) {
					comFlag = 0;
					base.alert(1, "发布成功", 1500);
					base.back();
				},
				fail: function(data) {
					comFlag = 0;
					dialog.loadDialog("dialog.tipsDialog", {
						params: {
							tips: "通知公告创建失败，请重试！"
						}
					}, "medium");
				}
			});
		} else {
			comFlag = 0;
			dialog.loadDialog("dialog.tipsDialog", {
				params: {
					tips: "请完善发布信息！"
				}
			}, "medium");
		};
	};

	var hasPerson = function() {
		// 流转人员
		var flowCounts = 0;
		$.each(dom.find("#flowToEmp").find(".personItem"), function() {
			flowCounts++;
		});
		if(flowCounts <= 0) {
			dom.find("#flowToEmp").find(".section-wrap-pers").addClass("none");
		};

		// 报送人员
		var reportCounts = 0;
		$.each(dom.find("#reportToEmp").find(".personItem"), function() {
			reportCounts++;
		});
		if(reportCounts <= 0) {
			dom.find("#reportToEmp").find(".section-wrap-pers").addClass("none");
		};
	};

	var hasUnit = function() {
		var counts = 0;
		$.each(dom.find(".unitItem"), function() {
			counts++;
		});

		if(counts <= 0) {
			dom.find(".section-wrap-units").addClass("none");
		};

		showNextUnit();
	};

	var loadMoreUnit = function() {
		dom.find("#flowToUnit").find(".unitItem-wrap").each(function(idx, itm) {
			$(this).removeClass("none");
		});
		dom.find(".loadMore").html("收起");
		dom.find(".loadMore").on("click", function() {
			hideUnit();
		});
	}

//	var hideUnit = function() {
//		var counts = 0;
//		dom.find("#flowToUnit").find(".unitItem-wrap").each(function(idx, itm) {
//			counts++;
//			$(this).removeClass("none");
//			if(counts > 3) {
//				$(this).addClass("none");
//			}
//		});
//		if(counts > 3) {
//			dom.find(".loadMore").removeClass("none");
//			dom.find(".loadMore").html("查看更多");
//			dom.find(".loadMore").on("click", function() {
//				loadMoreUnit();
//			});
//		} else {
//			dom.find(".loadMore").addClass("none");
//		}
//	}
	var hideUnit = function() {
		var counts = 0;
		dom.find("#flowToUnit").find(".unitItem-wrap").each(function(idx, itm) {
			counts++;
			$(this).removeClass("none");
			if(counts > 3) {
				$(this).addClass("none");
			}
		});
		if(counts > 3) {
			dom.find(".loadMore").removeClass("none");
			dom.find(".loadMore").html("查看更多");
			dom.find(".loadMore").on("click", function() {
				loadMoreUnit();
			});
		} else {
			dom.find(".loadMore").addClass("none");
		}
	}
	var showNextUnit = function() {
		var counts = 0;
		dom.find("#flowToUnit").find(".unitItem-wrap").each(function(idx, itm) {
			counts++;
			if(counts == 3) {
				$(this).removeClass("none");
			}
		});
		if(counts > 3) {
			dom.find(".loadMore").removeClass("none");
			dom.find(".loadMore").html("查看更多");
			dom.find(".loadMore").on("click", function() {
				loadMoreUnit();
			});
		} else {
			dom.find(".loadMore").addClass("none");
		}
	}

	var dateEvent = function() {
		console.log();
		var currYear = (new Date()).getFullYear();
		var opt = {};
		opt.date = {
			preset: 'date'
		};
		opt.datetime = {
			preset: 'datetime'
		};
		opt.time = {
			preset: 'time'
		};
		opt.default = {
			theme: 'android-ics light', //皮肤样式
			display: 'bottom', //显示方式
			mode: 'scroller', //日期选择模式
			lang: 'zh',
			startYear: currYear, //开始年份
			endYear: currYear + 3 //结束年份
		};

		//		var optDateTime = $.extend(opt['datetime'], opt['default']);
		//		$("#timesave").mobiscroll(optDateTime).datetime(optDateTime);
		var optDateTime = $.extend(opt['date'], opt['default']);
		$("#timesave").mobiscroll(optDateTime).date(optDateTime);

	}

	var loadData = function() {
		databind.submit({}, {
			action: "inquireNoticeDetailAccount",
			version: "v1.0",
			data: {
				"noticeId": noticeId
			},
			success: function(data) {
				var str = "";
				var dt = data.datas[0];
				var content = dt.content;

				content = content.replace(/＜/g, "<");
				content = content.replace(/＞/g, ">");
				content = content.replace(new RegExp("/fs/api/", "gm"), CONFIG.fsPath);
				var content = content.substring(content.indexOf(">") + 1, content.lastIndexOf("<"));
				dt.content = content ? content : dt.content;
				dt.targetDate = "";
				if(dt.title.substring(0, 2) == "转发") {} else {
					dt.title = "转发：" + dt.title;
				}
				databind.fillForm(dom.find(".container-section"), dt);
				if(!dt.attachments || dt.attachments.length === 0) {
					// dom.find(".attachments").remove();
				} else {
					var dic = {};
					dic.data = dt.attachments;
					var attacheshtml = juicer($('script.atts').html(), dic);
					dom.find("#item-btn-attachAdd").before(attacheshtml);
					// 查看详情
					downloadFile();
				}
				var link = dt.link;
				if(link) {
					dom.find("a[name=link]").attr("href", link);
				}
			}
		});
	};

	//	var downloadFile = function() {
	//		dom.find(".fileName").on("click", function() {
	//			var _t = $(this);
	//			var fileuuid = _t.attr("fileuuid");
	//			var filename = _t.attr("filename");
	//			var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid);
	//			console.log("path:" + path);
	//			if(path) {
	//				_t.off("click").on("click", function() {
	//					base.openUri("file://" + path);
	//				});
	//				return;
	//			}
	//			var opt = {
	//				url: CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid,
	//				filename: filename
	//			};
	//			base.downloadFileToSDCard(opt);
	//		});
	//		$(document).on("download_complete", function(e, url_complete) {
	//			console.log("download_complete:" + url_complete);
	//			dom.find(".fileName").each(function(idx, itm) {
	//				var _t = $(itm);
	//				var url = $(itm).attr("url");
	//				if(!url || url != url_complete) {
	//					return;
	//				}
	//				console.log("match");
	//				var path = base.inquireDownloadUrlPath(url);
	//				if(!path) {
	//					return;
	//				}
	//				base.openUri("file://" + path); // 下载完成直接打开
	//				_t.removeAttr("url");
	//			});
	//		});
	//		//		$(document).on("download_progress", function(e, data) {
	//		//			var url_complete = data.url;
	//		//			var percent = data.percent;
	//		//			dom.find(".fileName").each(function(idx, itm) {
	//		//				var _t = $(itm);
	//		//				var url = $(itm).attr("url");
	//		//				if(!url || url != url_complete) {
	//		//					return;
	//		//				}
	//		//				_t.html(percent + "%");
	//		//			});
	//		//		});
	//		dom.find(".img_delete").on("click", function() {
	//			$(this).remove();
	//		});
	//	};

	var downloadFile = function() {
		dom.find(".section-wrap").find(".fileName").each(function(idx, itm) {
			var _t = $(itm);
			var url = $(itm).attr("url");
			var path = base.inquireDownloadUrlPath(url);
			if(path) {
				_t.off("click").on("click", function() {
					base.openUri("file://" + path);
				});
				_t.removeAttr("url");
			} else {
				_t.on("click", function() {
					var _t = $(this);
					var fileuuid = _t.attr("fileuuid");
					var filename = _t.attr("filename");
					var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid);
					if(path) {
						_t.off("click").on("click", function() {
							base.openUri("file://" + path);
						});
						return;
					}
					var opt = {
						url: CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid,
						filename: filename
					};
					base.downloadFileToSDCard(opt);
				});
			}
		});
		dom.find(".section-wrap").find(".img_delete").on("click", function() {
			$(this).parents('.attachment').remove();
			event.cancelBubble = true; // 取消触发外层的点击事件
		});
	};

	$(document).on("download_complete", function(e, url_complete) {
		dom.find(".fileName").each(function(idx, itm) {
			var _t = $(itm);
			var url = $(itm).attr("url");
			if(!url || url != url_complete) {
				return;
			}
			var path = base.inquireDownloadUrlPath(url);
			if(!path) {
				return;
			}
			base.openUri("file://" + path); // 下载完直接打开
			_t.off("click").on("click", function() {
				base.openUri("file://" + path);
			});
			_t.removeAttr("url");
		});
	});

	$(document).on("download_progress", function(e, data) {
		var url_complete = data.url;
		var percent = data.percent;
		dom.find(".fileName").each(function(idx, itm) {
			var _t = $(itm);
			var url = $(itm).attr("url");
			if(!url || url != url_complete) {
				return;
			}
			//			_t.html(percent + "%");
			//			if(percent == 100) {
			//				_t.html("查看");
			//			}
		});
	});

	return {
		init: init
	};
});
