// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var type;
	var noticeId;
	var targetDate; // 报送截至日期
	var deleteActionName;
	var init = function() {
		if(base.getUrlParam("parameter")) {
			noticeId = base.getUrlParam("parameter");
		} else if(base.getUrlParam("businessId")) {
            noticeId = base.getUrlParam("businessId");
		} else {
			noticeId = base.getUrlParam("noticeId");
		}
		type = base.getUrlParam('type');
		if(type!=1){
			$("#timesave").remove();
		}
		// 若不是“单位通知”，则默认为“我收到的”，这边主要是原生消息管理点进详情页时候没有传type
		if(type == null) {
			type = 2;
		}
		dom = $("#informDetail");
		if(type==1){
			deleteActionName="deleteNoticeAccount";
		}else if(type==2){
			deleteActionName="deleteBatchNoticeToAccount";
		}else if (type==3) {
			dom.find(".delete-btn").addClass("none");
		}else if (type==5) {
			deleteActionName="deleteNoticeAccount";
		}
		dateEvent();
		router.init();
		initEvent();
		loadData();
	};

	var dateEvent = function() {
		var currYear = (new Date()).getFullYear();
		var opt = {};
		opt.date = {
			preset: 'date'
		};
		opt.datetime = {
			preset: 'datetime'
		};
		opt.time = {
			preset: 'time'
		};
		opt.default = {
			theme: 'android-ics light', //皮肤样式
			display: 'bottom', //显示方式
			mode: 'scroller', //日期选择模式
			lang: 'zh',
			startYear: currYear - 16, //开始年份
			endYear: currYear + 3 ,//结束年份
			onSelect: function (valueText, inst) {
				databind.submit([],{
					action: "updateNoticeReportFromAccount",
					data: {
						targetDate:valueText,
						noticeId:noticeId
					},
					success: function(data) {
						base.alert(1,"修改成功");
						conceal();
						loadData();
						dom.find("#timesave").addClass("none");
					}
				});
			}
		};
		//		var optDateTime = $.extend(opt['datetime'], opt['default']);
		//		$("#timesave").mobiscroll(optDateTime).datetime(optDateTime);
		var optDateTime = $.extend(opt['date'], opt['default']);
		$("#timesave").mobiscroll(optDateTime).date(optDateTime);
	};
	var initEvent = function() {

		//tab
		dom.on("click", " .tab .tab-header >*", function() {
			var tb = $(this).parents('.tab');
			tb.find(".tab-header>.active").removeClass("active");
			$(this).addClass('active');
			tb.find(".tab-content>*").hide();
			tb.find(".tab-content>[tabid=" + $(this).attr('tabid') + "]").show();
		});

		dom.find(".btn-addBlue").on("click", function() {
			//			base.alert(3, "报送时间：" + (util.parseDateStr(targetDate).getTime() + 1 * 24 * 60 * 60 * 1000) + "当前时间：" + (new Date()).getTime());
			// 在报送时间截止前才可以进行反馈报送
			if(targetDate && util.parseDateStr(targetDate).getTime() + 1 * 24 * 60 * 60 * 1000 > (new Date()).getTime()) {
				// 反馈报送时需要区分单位报送（type=3）还是个人报送（type=2）
				router.route("inform.feedback?noticeId=" + noticeId + "&type=" + type);
			} else {
				base.alert(3, "报送时间已截止");
			}
		});

		if(type == 1) {
			dom.find(".header .header-ops").removeClass("none");
		}

		juicer.register("fsPath", function() {
			return CONFIG.fsPath;
		});

		juicer.register("getcode", function(fileName) {
			return encodeURIComponent(fileName);
		});

		juicer.register("fileIcon", function(fileName) {
			var icon = "res/images/ficon/unknow_icon_16px.png";
			var ext = fileName.replace(/.*\.(\w+)/, "$1");
			if(!ext) {
				return icon;
			}
			ext = ext.toLowerCase();
			var extMap = {
				"apk": "apk_icon_16px",
				"xls": "excel_icon_16px",
				"csv": "excel_icon_16px",
				"xlsx": "excel_icon_16px",
				"ods": "excel_icon_16px",
				"ppt": "ppt_icon_16px",
				"pptx": "ppt_icon_16px",
				"odp": "ppt_icon_16px",
				"pdf": "pdf_icon_16px",
				"jpg": "pic_icon_16px",
				"png": "pic_icon_16px",
				"jpeg": "pic_icon_16px",
				"gif": "pic_icon_16px",
				"tif": "pic_icon_16px",
				"tiff": "pic_icon_16px",
				"psd": "ps_icon_16px",
				"txt": "txt_icon_16px",
				"mp4": "video_icon_16px",
				"avi": "video_icon_16px",
				"flv": "video_icon_16px",
				"rmvb": "video_icon_16px",
				"rm": "video_icon_16px",
				"3gp": "video_icon_16px",
				"mov": "video_icon_16px",
				"asf": "video_icon_16px",
				"wmv": "video_icon_16px",
				"mp3": "audio_icon_16px",
				"wav": "audio_icon_16px",
				"flac": "audio_icon_16px",
				"ape": "audio_icon_16px",
				"ogg": "audio_icon_16px",
				"doc": "word_icon_16px",
				"docx": "word_icon_16px",
				"odt": "word_icon_16px",
				"zip": "zip_icon_16px",
				"7z": "zip_icon_16px",
				"rar": "zip_icon_16px",
				"gz": "zip_icon_16px",
				"bz": "zip_icon_16px",
				"tar": "zip_icon_16px",
			};
			var pic = extMap[ext];
			if(pic) {
				icon = "res/images/ficon/" + pic + ".png";
			}

			return icon;
		});
		//popup上的取消按钮点击后隐藏popup和fullBg
		dom.find("#popups .popups-ops-left").on("click", function() {
			conceal();
			dom.find("#timesave").addClass("none");
		});

		//转发
		dom.find(".ops-relay").on("click", function() {
			router.route("inform.inform-create?noticeId=" + noticeId);
		});

		//操作
		dom.find(".operation").on("click", function() {
			$(document).find("#fullBg").removeClass("none");
			dom.find("#timesave").removeClass("none");
			dom.find("#popups").removeClass("none");
		});

		//修改时间
		dom.find(".update-date").on("click",function(){
//			conceal();
			dom.find("#timesave").trigger("focus");
		});
		//删除
		dom.find(".delete-btn").on("click",function(){
			var noticeIdList = [];
			noticeIdList.push(noticeId);
			var datas={};
			if (type==1||type==5) {
				datas={
					noticeId:noticeIdList
				};
			}else if (type==2) {
				datas={
					noticeIdList:noticeIdList
				};
			}
			dialog.loadDialog("dialog.confirmDialog", {
				params: {
					tips: "确定删除该公告吗？"
				},
				okFn: function() {
					databind.submit({}, {
						action: deleteActionName,
						data: datas,
						success: function(data) {
							dialog.hideDialog();
							base.back();
						}
					});
				}
			}, "medium");
		});
		//点击popup上的中止按钮跳确认中止任务finishOrStopTaskOfMine
		dom.find(".header .ops-delete").on("click", function() {
			var taskIds = [];
			taskIds.push(taskId);
			dialog.loadDialog("dialog.confirmDialog", {
				params: {
					tips: "确定删除该通知吗？"
				},
				okFn: function() {
					databind.submit({}, {
						action: "deleteTaskOfMine",
						data: {
							taskIds: taskIds
						},
						success: function(data) {
							dialog.hideDialog();
							base.back();
						}
					});
				}
			}, "medium");
		});
	};
	var conceal = function() {
		$(document).find("#fullBg").addClass("none");
		dom.find("#popups").addClass("none");
	};
	var loadData = function() {
		databind.submit({}, {
			action: "inquireNoticeDetailAccount",
			version: "v1.0",
			useCache: true,
			data: {
				"noticeId": noticeId
			},
			success: function(data) {
				var str = "";
				var dt = data.datas[0];
				var content = dt.content;
				targetDate = dt.targetDate;

				content = content.replace(/＜/g, "<");
				content = content.replace(/＞/g, ">");
				content = content.replace(new RegExp("/fs/api/", "gm"), CONFIG.fsPath);

				dt._readCount = 0;
				dt._reportCount = 0;
				for(var idx in dt.receivePersons) {
					var it = dt.receivePersons[idx];
					if(it.readState > 1) {
						dt._readCount++;
					}
					if(it.readState == 3) {
						dt._reportCount++;
					}
					if(it.mine==1){
						if(it.readState==1){
							dt._readCount++;
						}
						//it.readState=2; 已上报显示成未上报，去掉看看
					}
				}
				var fbs = juicer(dom.find('script.tomembers-tpl').html(), dt);
				dom.find('.tomembers').html(fbs);

				setTimeout(function() {
					loadFeedBack();
				}, 100);

				dt.content = content;

				$.each(dt.ccNameList, function(idx, val) {
					if(idx < dt.ccNameList.length - 1) {
						dt.ccNameList[idx] = val + "、";
					}
				});
				dt.timeTip = "";
				if(dt.reportFlag == 1){
					dt.timeTip = " 前报送给 "
				};
				dt.targetDate = dt.targetDate.substring(0, 10);

				databind.fillForm(dom.find(".container-section"), dt);
				if(!dt.attachments || dt.attachments.length === 0) {
					dom.find(".attachments").remove();
				} else {
					var html = juicer($("#attachments-tpl").html(), dt);
					dom.find(".attachments").html("").html(html);
					downloadFile();
				}
				var link = dt.link;
				if(link) {
					dom.find("a[name=link]").attr("href", link);
				} else {
					dom.find("a[name=link]").parent().remove();
				}
				var reportFlag = dt.reportFlag;
				if(type == 2 || type == 3) { // “我收到的（type=2）”、“单位通知（type=3）”显示反馈报送按钮
					if(reportFlag === 1) {
						dom.find(".footer").removeClass("none");
					}
				}
				if (type==1||type==5) {
					if(dt.mineState==1&&reportFlag==1){
						dom.find(".update-date").removeClass("none");
					}
				}
			},
		fail:function(){
			dialog.loadDialog("dialog.tipsDialog", {
				params: {
					tips: "该信息已删除！"
				},
				okFn: function() {
					alert("都")
				}
			}, "medium");
//			base.back();
		}
		});
	};

	var downloadFile = function() {
		dom.find(".attachmentButton").each(function(idx, itm) {
			var _t = $(itm);
			var url = $(itm).attr("url");
			var path = base.inquireDownloadUrlPath(url);
			if(path) {
				_t.off("click").on("click", function() {
					base.openUri("file://" + path);
				});
				_t.html("查看");
				_t.removeAttr("url");
			} else {
				_t.on("click", function() {
					var _t = $(this);
					var fileuuid = _t.attr("fileuuid");
					var filename = _t.attr("filename");
					var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid);
					if(path) {
						_t.off("click").on("click", function() {
							base.openUri("file://" + path);
						});
						_t.html("查看");
						return;
					}
					var opt = {
						url: CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid,
						filename: filename
					};
					base.downloadFileToSDCard(opt);
				});
			}
		});
	};

	$(document).on("download_complete", function(e, url_complete) {
		dom.find(".attachmentButton").each(function(idx, itm) {
			var _t = $(itm);
			var url = $(itm).attr("url");
			if(!url || url != url_complete) {
				return;
			}
			var path = base.inquireDownloadUrlPath(url);
			if(!path) {
				return;
			}
			_t.off("click").on("click", function() {
				base.openUri("file://" + path);
			});
			_t.html("查看");
			_t.removeAttr("url");
		});
	});

	$(document).on("download_progress", function(e, data) {
		var url_complete = data.url;
		var percent = data.percent;
		dom.find(".attachmentButton").each(function(idx, itm) {
			var _t = $(itm);
			var url = $(itm).attr("url");
			if(!url || url != url_complete) {
				return;
			}
			_t.html(percent + "%");
			//                              if(percent == 100) {
			//                                  _t.html("查看");
			//                              }
		});
	});

	var loadFeedBack = function() {
		var action = "inquireNoticeReportListByNoticeIdAccount";
		if(type == 3) {
			action = 'inquireNoticeReportListByNoticeIdTenant';
		}
		databind.submit([], {
			action: action,
			version: "v1.0",
			data: {
				noticeId: noticeId
			},
			success: function(ret) {
				dom.find('.tomembers .reports').empty();
				var tmpl = dom.find('script.atts').html();
				for(var idx in ret.datas) {
					var it = ret.datas[idx];
					var html = juicer(tmpl, ret.datas[idx]);
					dom.find('.reports[memberId=' + it.noticeMemberId + ']').append(html);
				}
				downloadFile();
			}
		});
	};

	var downloadFile = function() {
		dom.find(".attachmentButton").on("click", function() {
			var _t = $(this);
			var fileuuid = _t.attr("fileuuid");
			var filename = _t.attr("filename");
			var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid);
			console.log("path:" + path);
			if(path) {
				_t.off("click").on("click", function() {
					base.openUri("file://" + path);
				});
				_t.html("查看");
				return;
			}
			var opt = {
				url: CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid,
				filename: filename
			};
			base.downloadFileToSDCard(opt);
		});
		$(document).on("download_complete", function(e, url_complete) {
			console.log("download_complete:" + url_complete);
			dom.find(".attachmentButton").each(function(idx, itm) {
				var _t = $(itm);
				var url = $(itm).attr("url");
				if(!url || url != url_complete) {
					return;
				}
				console.log("match");
				var path = base.inquireDownloadUrlPath(url);
				if(!path) {
					return;
				}
				_t.off("click").on("click", function() {
					base.openUri("file://" + path);
				});
				_t.html("查看");
				_t.removeAttr("url");
			});
		});
		$(document).on("download_progress", function(e, data) {
			var url_complete = data.url;
			var percent = data.percent;
			dom.find(".attachmentButton").each(function(idx, itm) {
				var _t = $(itm);
				var url = $(itm).attr("url");
				if(!url || url != url_complete) {
					return;
				}
				_t.html(percent + "%");
			});
		});
	}
	return {
		init: init
	};
});
