define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var informMyReceivedHtml = require("./inform-my-received.html");
	var informMyReceivedJs = require("./inform-my-received.js");
	var informMySendHtml = require("./inform-my-send.html");
	var informMySendJs = require("./inform-my-send.js");
	var informCcSendHtml = require("./inform-cc-send.html");
	var informCcSendJs = require("./inform-cc-send.js");
	var informUnitReceivedHtml = require("./inform-unit-received.html");
	var informUnitReceivedJs = require("./inform-unit-received.js");
	var informUnitSendHtml = require("./inform-unit-send.html");
	var informUnitSendJs = require("./inform-unit-send.js");
	var selectedId;
	var dom;

	var init = function() {
		dom = $("#informMenustripPage");
		router.init();
		initJuicer();
		initEvent();
		loadData();

	}

	var initMenustrip = function() {
		$('#menustrip').mobiscroll().menustrip({
			theme: 'mobiscroll',
			display: 'top',
			type: 'tabs',
			onItemTap: function(event, inst) {
				var itemId = event.target.id;
				selectedId = itemId;
				dom.find("#content").empty();
				if(itemId == "inform-received") {
					$(document).trigger("informReceived");
					dom.find("#content").append(informMyReceivedHtml);
					informMyReceivedJs.init();
				} else if(itemId == "inform-send") {
					dom.find("#content").append(informMySendHtml);
					informMySendJs.init();
				} else if(itemId == "inform-cc-re") {
					$(document).trigger("informCc");
					dom.find("#content").append(informCcSendHtml);
					informCcSendJs.init();
				} else if(itemId == "inform-unit-re") {
					$(document).trigger("unitReceived");
					dom.find("#content").append(informUnitReceivedHtml);
					informUnitReceivedJs.init();
				} else if(itemId == "inform-unit-se") {
					dom.find("#content").append(informUnitSendHtml);
					informUnitSendJs.init();
				}
			},
			onMarkupReady: function(event, inst) {
				var badge;
				$(event.target).find('.mbsc-ms-item').each(function(i, v) {
					badge = $(v).data('badge');
					if(badge > 0 && badge < 100) {
						$(v).append('<span class="md-badge">' + badge + '</span>');
					} else if(badge >= 100) {
						$(v).append('<span class="md-badge bigBadge">99+</span>');
					}
				});
			},
		});
	}

	var initJuicer = function() {}

	var initEvent = function() {
		$(document).on("informReceived", function() {
						console.log("load Count");
			inquireCount1();
		});
		$(document).on("unitReceived", function() {
			//			console.log("load Count");
			inquireCount();
		});
		$(document).on("informCc", function() {
			//			console.log("load Count");
			inquireCount2();
		});	
		
		$(".search-right").on("click", function(){
			router.route("inform.inform-search-menustrip");
			
		});
	}

	var loadData = function() {

		inquireUnreadNoticeTenant();
		
	}

	var inquireCount = function() {
		databind.submit({}, {
			action: "inquireUnreadNoticeTenant",
			version: "v2.0",
			success: function(data) {
				var badge = data.datas[0];
				console.log(badge);
				$(document).find("#inform-unit-re .md-badge").remove();
				if(badge > 0 && badge < 100) {
					$(document).find("#inform-unit-re").append('<span class="md-badge">' + badge + '</span>');
				} else if(badge >= 100) {
					$(document).find("#inform-unit-re").append('<span class="md-badge bigBadge">99+</span>');
				}
			}
		});

	}

	var inquireUnreadNoticeTenant = function() {
		databind.submit({}, {
			action: "inquireUnreadNoticeTenant",
			version: "v2.0",
			success: function(data) {
				dom.find("#content").empty();

				var html = juicer(dom.find('#menustripTpl').html(), data);
				dom.find('#menustripTabs').append(html);
				if(selectedId) {
					dom.find("#" + selectedId).attr("data-selected", true);
					if(selectedId == "inform-received") {
						dom.find("#content").append(informMyReceivedHtml);
						informMyReceivedJs.init();
					} else if(selectedId == "inform-send") {
						dom.find("#content").append(informMySendHtml);
						informMySendJs.init();
					} else if(selectedId == "inform-cc-re") {
						dom.find("#content").append(informCcSendHtml);
						informCcSendJs.init();
					} else if(selectedId == "inform-unit-re") {
						dom.find("#content").append(informUnitReceivedHtml);
						informUnitReceivedJs.init();
					} else if(selectedId == "inform-unit-se") {
						dom.find("#content").append(informUnitSendHtml);
						informUnitSendJs.init();
					}
				} else {
					dom.find("#inform-received").attr("data-selected", true);
					dom.find("#content").append(informMyReceivedHtml);
					informMyReceivedJs.init();
				}

				var toReadCount = data.datas[0];
				if(toReadCount > 0) {
					dom.find("#inform-unit-re").attr("data-badge", toReadCount);
				}
				inquireUnreadNoticeAccount();
			}
		});
	}

	var inquireCount1 = function() {
		databind.submit({}, {
			action: "inquireUnreadNoticeAccount",
			version: "v2.0",
			success: function(data) {
				var badge = data.datas[0];
				console.log(badge);
				$(document).find("#inform-received .md-badge").remove();
				if(badge > 0 && badge < 100) {
					$(document).find("#inform-received").append('<span class="md-badge">' + badge + '</span>');
				} else if(badge >= 100) {
					$(document).find("#inform-received").append('<span class="md-badge bigBadge">99+</span>');
				}
			}
		});

	}

	var inquireUnreadNoticeAccount = function() {
		databind.submit({}, {
			action: "inquireUnreadNoticeAccount",
			version: "v2.0",
			success: function(data) {
				var toReadCount = data.datas[0];
				if(toReadCount > 0) {
					dom.find("#inform-received").attr("data-badge", toReadCount);
				}
				inquireUnreadNoticeCopyAccount();
			}
		});
	}
	
	var inquireCount2 = function() {
		databind.submit({}, {
			action: "inquireUnreadNoticeCopyAccount",
			version: "v2.0",
			success: function(data) {
				var badge = data.datas[0];
				console.log(badge);
				$(document).find("#inform-cc-re .md-badge").remove();
				if(badge > 0 && badge < 100) {
					$(document).find("#inform-cc-re").append('<span class="md-badge">' + badge + '</span>');
				} else if(badge >= 100) {
					$(document).find("#inform-cc-re").append('<span class="md-badge bigBadge">99+</span>');
				}
			}
		});

	}
	
	var inquireUnreadNoticeCopyAccount = function() {
		databind.submit({}, {
			action: "inquireUnreadNoticeCopyAccount",
			version: "v2.0",
			success: function(data) {

				var toReadCount = data.datas[0];
				if(toReadCount > 0) {
					dom.find("#inform-cc-re").attr("data-badge", toReadCount);
				}
				initMenustrip();
			}
		});
	}

	//	var InquireRequestApprovalUndoNumberEAAccount = function() {
	//		databind.submit({}, {
	//			action: "InquireRequestApprovalUndoNumberEAAccount",
	//			success: function(data) {
	//				var toReadCount = data.datas[0].todoCount;
	//				if(toReadCount > 0) {
	//					dom.find("#request-permit").attr("data-badge", toReadCount);
	//				}
	//				initMenustrip();
	//			}
	//		});
	//	}

	return {
		init: init
	};
});