// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var dom;
	var indexG;
	var totalP;
	var type;
	var ins;

	var init = function() {
		dom = $("#searchList");
		type = base.getUrlParam("fromType");
		router.init();
		dom.find("input[name=title]").focus();
		initEvent();
	};

	var initEvent = function() {
		switch(type) {
			case '1': // 我发出的
				dom.find(".container").attr('tpl-id', 'tpl-list');
				break;
			case '2': // 我收到的
				dom.find(".container").attr('action', 'inquireNoticeListToAccount');
				break;
			case '4': // 报送我的
				dom.find(".container").attr('action', 'inquireNoticeListCcAccount');
				break;
			case '3': // 单位收到的通知
				dom.find(".container").attr('action', 'inquireNoticeListToTenant');
				break;
			case '5': // 单位发出的通知
				dom.find(".container").attr('action', 'inquireNoticeListTenant');
				break;
			default:
				break;
		}

		//点击搜索按钮进行搜索
		dom.find(".header-ops").on("click", function() {
			dom.find(".loadList-item").remove();
			ins = dom.find(".search-middle input").val();
			if(ins) {
				dom.find(".search-right").removeClass("none");
				dom.find(".nodata").addClass("none");
				dom.find(".alist").find("input[name=title]").val(ins); // 关键字
				loadData(); // 搜索
			} else {
				dom.find(".search-right").addClass("none");
				dom.find(".nodata").removeClass("none");
				dom.find(".loadList-item").remove();
			}
		});

		//监听输入框的值变化
		dom.find(".search-middle input").trigger('input propertychange');
		dom.on("input propertychange", function() {
			ins = dom.find(".search-middle input").val();
			if(ins) {
				dom.find(".search-right").removeClass("none");
				dom.find(".nodata").addClass("none");
			} else {
				dom.find(".search-right").addClass("none");
				dom.find(".nodata").removeClass("none");
			}
		});

		//点击删除输入框内容
		dom.find(".search-right").on("click", function() {
			dom.find(".search-middle input").val("");
			$(this).addClass("none");
			dom.find(".container-loadList").html("");
			dom.find(".container-loadList").append('<div class="nodata">暂无数据</div>');
		});

		//通知公告详情
		dom.on("click", ".loadList-item", function() {
			var noticeId = $(this).attr("noticeId");
			if(!noticeId) {
				return;
			}
			router.route("inform.inform-detail?noticeId=" + noticeId + "&type=" + type);
		});
	};

	var loadData = function() {
		listView.more(dom.find(".alist"));
	};

	return {
		init: init
	};
});