/**
*Copyright 2015 | build time: 2015-4-20
*/
define(function(require, exports, module) {
  var T ={};
  var callbackMap = {};
  var fileSelectCallback;
  var inited = false;


  T.init = function(base){
    try {
      if(!_android_context){
        return false;
      }
    } catch (e) {
      return  false;
    } finally {
    }

    ////
    var ajaxClient = _android_context.getService('ajaxClient');
    var mediaManager = _android_context.getService('mediaManager');
    var pageManager = _android_context.getService("pageManager");
    var storageManager = _android_context.getService('storageManager');
    var sessionManager = _android_context.getService('sessionManager');
    var socialShareManager = _android_context.getService('socialShareManager');
    var phoneManager = _android_context.getService("phoneManager");

    T.fnAjax = function(oArg){

      var Path = oArg.path;
      if (!Path) {
        Path = CONFIG.ApiPath + "/";
      } else {
        Path += "/api/";
      }
      Path = Path.replace(/([^:])\/{2,}/g, "$1/");
      if (oArg.product) {
        Path = Path + oArg.product + "/";
      }
      var oData = "",
      n, v; // 处理oArg.oData中的数组
      if (!oArg.oData) {
        oArg.oData = {};
      }
      //请求参数oData
      if (typeof oArg.oData == 'string') {
        oData = oArg.oData;
      } else {
        var strForms = [];
        for (n in oArg.oData) {
          if (oArg.oData[n] instanceof Array) {

            for (var k in oArg.oData[n]) {
              strForms.push(encodeURIComponent(n) + "=" + encodeURIComponent(oArg.oData[n][k]));
            }
          } else {
            v = oArg.oData[n];
            v = $.isFunction(v) ? v() : v; // if value is fn, invoke it
            strForms.push(encodeURIComponent(n) + "=" + encodeURIComponent(v));
          }
        }
        oData = strForms.join("&");
      }
      // oData = oData + "&sessionUuid=" + base.getData("sid");
      oData = oData+"&sessionUuid="+sessionManager.getCurrentSessionUuid()+"&appKey="+CONFIG.appKey;
      //版本号
      var ApiVersion = oArg.version || CONFIG.ApiVersion;

      var request = {};
      request.url = (Path + ApiVersion + "/" + oArg.action + "");
      request.method = (oArg.stype || "POST");
      var header = {
        "Content-Type":"application/x-www-form-urlencoded; charset=UTF-8"
      };
      request.requestHeader = (JSON.stringify(header));
      // application/x-www-form-urlencoded; charset=UTF-8
      request.body=(oData);
      request.useCache = (oArg.useCache || false);
      if(request.useCache){
        request.cacheKey=request.url +'?'+ request.body;
      }

      var callback = {useCache:request.useCache,
        success:function(oRes){
          if (oRes && oRes.flag == "UNLOGIN") {
            T.login();
            return;
          }
          oArg.fnSuccess && oArg.fnSuccess(oRes);
        },
        error: function() {
          base.alert(3, "服务器异常,请稍后再试", 2000);
          oArg.error && oArg.error();
        }
      };
      var token  = new String(ajaxClient.executeJSON(JSON.stringify(request)));
      callbackMap[token]=callback;
    };

    T.uploadFile=function(path,callback){
      var token = ajaxClient.uploadFile(path);
      if(callback){
        callbackMap[token]={success:callback};
      }
    };

    T.setImgZoom=function(flag){
      pageManager.setImgZoom(flag);
    };

    T.getData=function(key){

      var val ;
      if(key == "sessionUuid"){
        val =  sessionManager.getCurrentSessionUuid();
      }else{
        val = storageManager.getItem(key);
      }
      if(val){
        return new String(val);
      }
      return ;
    };

    T.saveData=function(key,val){
      if(!val){
        val = "";
      }
      if(key == "sessionUuid"){
        sessionManager.setSessionUuid(val);
      }
      storageManager.setItem(key,val);
    };
    T.removeData=function(key){
      if(key == "sessionUuid"){
        T.clearData();
        sessionManager.removeSession();
      }
      storageManager.removeItem(key);
    };
    T.clearData=function(){
      storageManager.clear();
    };

    //opt:  {text:"text",picUrl:"http://xxxxxx or file://xxxxx",url:"http://xxxxxxxx"}
    T.socialShare=function(opt){
      socialShareManager.share(JSON.stringify(opt));
    };


    window._android_ajax_complete=function(token){
      var callback = callbackMap[token];
      if(!callback){
        return ;
      }
      var dataString = ajaxClient.getData(token);
      var data = JSON.parse(dataString);
      if(data.statusCode ==200){
        var dt = data.content;
        if(data.request.useCache&&data.cache==false){
          var req = data.request;
          var cacheKey = new String(req.url) +'?'+ new String(req.body);
          ajaxClient.putCache(dataString);
        }
        var contentData = JSON.parse(dt);
        if(callback.success){
          callback.success(contentData);
        }
        if(!data.cache){
          delete callbackMap[token];
        }
      }else{
        if(callback.error){
          callback.error();
        }
      }
    };
    window._android_ajax_fail=function(token){
      var callback = callbackMap[token];
      if(!callback){
        return ;
      }
      if(callback.error){
        callback.error();
      }
      if(callback.useCache===false){
        delete callbackMap[token];
      }
    };

    window._android_on_back_pressed=function(){
      base.back();
    };

    T.openUrl=function(url,packagename){
      pageManager.loadBundle(packagename,url);
    };


    T.callGallery=function(fids,idx){
      mediaManager.gallery(JSON.stringify({fileUuid:fids,index:idx}));
    };

    //文件选择 opt:{maxPixel:"最大图片像素",maxSize:"最大文件大小"}
    T.selectImageFile=function(callback,opt){
      fileSelectCallback = callback;
      var param = "";
      if(opt){
        param = JSON.stringify(opt);
      }
      mediaManager.selectImageFile(param);
    };
    T.selectImageFileAndCaptureImage=function(callback){
      var token = ajaxClient.selectImageFileAndCaptureImage();
      if(callback){
        callbackMap[token]={success:callback};
      }
    };
    T.selectFile=function(callback,opt){
      fileSelectCallback = callback;
      var param = "";
      if(opt){
        param = JSON.stringify(opt);
      }
      mediaManager.selectFile(param);
    };
    T.captureImage=function(callback,opt){
      fileSelectCallback = callback;
      var param = "";
      if(opt){
        param = JSON.stringify(opt);
      }
      mediaManager.captureImage(param);
    };
    window._android_on_file_select=function(path){
      console.log("fsc:");
      console.log(fileSelectCallback);
      if(fileSelectCallback){
        fileSelectCallback(path);
        fileSelectCallback = undefined;
      }
    };

    $("body").on("click","a",function(e){
      if(e._dealed){
        return false;
      }
      var t = $(this);
      var href = t.attr("href");
      if(href && href.indexOf("tel:")===0){
        phoneManager.makePhoneCall(href.replace(/tel:(.*)/,"$1"));
        e._dealed = true;
        return false;
      }
      if(t.attr("target")=="_blank"){
        console.log("_blank a:"+href);
        if(href.indexOf("http://")===0||href.indexOf("https://")===0){
          ajaxClient.openUrlSystem(href);
          e._dealed = true;
          return false;
        }
        pageManager.loadBundle("",window.location.href.replace(new RegExp('.*?'+CONFIG.BasePath+'(.*\/).*'),"$1")+href);
        e._dealed = true;
        return false;
      }
    });

    T.openUri=function(url){
      ajaxClient.openUrlSystem(url);
    };



    T.cleanHistory=function(){
      pageManager.cleanHistory();
    };


    T.locationChange=function(url){
      pageManager.switchInPackage(url);
    };


    T.close=function(){
      pageManager.close();
    };
    T.back=function(){
      console.log("on android_base.back");
      pageManager.back();
    };

    T.clearHistory=function(){
      pageManager.clearHistory();
    };

    //sdcard下载 未下载的会启动下载  已下载的会返回本地路径  opt{url:"下载地址",filename:"下载文件名"}
    T.downloadFileToSDCard=function(opt){
      return ajaxClient.downloadFileToSDCard(JSON.stringify(opt));
    };
    //查询已下载的url的本地路径 未下载过返回空字符串
    T.inquireDownloadUrlPath=function(url){
      return ajaxClient.inquireDownloadUrlPath(url);
    };

    window._android_download_complete=function(url){
      console.log("_android_download_complete:"+url);
      $(document).trigger("download_complete",url);
    };
    window._android_download_progress=function(url,percent){
      $(document).trigger("download_progress",{url:url,percent:percent});
    };
    //登录动作
    T.login=function(){
      pageManager.login();
    };


    //员工相关
    var organizationManager = _android_context.getService('OrganizationManager');
    T.callSingleEmployeeSelector=function(employeeIds,callback){
      var empIds="";
      if(employeeIds.push&&employeeIds.length>0){
        var arr = [];
        for(var idx in employeeIds){
          arr.push(employeeIds[idx]);
        }
        empIds="["+arr.join(",")+"]";
      }
      window.__employeeSelectorCallback = callback;
      organizationManager.callSingleEmployeeSelector(empIds);
    };
    T.callUnitSelector=function(param,callback){
      window.__unitSelectorCallback = callback;
      organizationManager.callUnitSelector(JSON.stringify(param));
    };
    window._android_on_unit_select=function(token){
      var ret = organizationManager.getData(token);
      if(!ret){return ;}
      var data = JSON.parse(ret);
      if(window.__unitSelectorCallback && typeof(window.__unitSelectorCallback)=="function"){
        window.__unitSelectorCallback(data.data);
      }
    };
    T.callEmployeeSelector=function(param,callback){
      window.__employeeSelectorCallback = callback;
       organizationManager.callEmployeeSelector(JSON.stringify(param));
    };
    T.callMultiEmployeeSelector=function(employeeIds,callback){
      var empIds="";
      if(employeeIds.push&&employeeIds.length>0){
        var arr = [];
        for(var idx in employeeIds){
          arr.push(employeeIds[idx]);
        }
        empIds="["+arr.join(",")+"]";
      }
      window.__employeeSelectorCallback = callback;
      organizationManager.callMultiEmployeeSelector(empIds);
    };
    window._android_on_employee_select=function(token){
      var ret = organizationManager.getData(token);
      if(!ret){return ;}
      var data = JSON.parse(ret);
      if(window.__employeeSelectorCallback&&typeof(window.__employeeSelectorCallback)=="function"){
        window.__employeeSelectorCallback(data.data);
      }
    };


    inited = true ;
    ////
    return true ;
  };
  module.exports = T;
});
