// 主界面
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var validator = require("validate");
  var constant  = require("constant");
  var databind = require("databind");

  var E = {};

  E.list = function(tableDom,paegControllerDom,opt,async){
    if($(tableDom).length==0){return ; }
  	initEvent(tableDom,paegControllerDom,opt);
    var  data  = loadData(tableDom,paegControllerDom,opt,async);
  };

  var loadData = function(tableDom,paegControllerDom,listOpt,async){
    //fill param
    // fillParam(tableDom);

    //call action
    var extraData ={};
    if($(tableDom).attr("ext-input")){
      var extInput = $($(tableDom).attr("ext-input"));
      fillParam(extInput);

      if(!validator.validate(extInput,listOpt?listOpt.validateFailCall:undefined)){
        return ;
      }
      extraData = base.parseForm(extInput);
    }
    if(!extraData.pageIndex){
      var pageIndex = base.getUrlParam("p");
      if(!pageIndex){pageIndex=1}
      extraData.pageIndex=pageIndex;
    }
    var tmpl = $(tableDom).attr("tpl-id")?$("#"+$(tableDom).attr("tpl-id")).html():"";
    var opt = {
      action  : $(tableDom).attr("action"),
      version  : $(tableDom).attr("version"),
      path  : $(tableDom).attr("path"),
      async : async=="undefined"?true:false,
      product  : $(tableDom).attr("product"),
      data:extraData,
      success:function(data){
        if(listOpt&&listOpt.preprocessing&&typeof(listOpt.preprocessing) == "function"){
          data = listOpt.preprocessing(data);
        }

        if(data.pageIndex){
          databind.createOrUpdateInput(tableDom,"pageIndex",data.pageIndex);
          databind.createOrUpdateInput(tableDom,"pageSize",data.pageSize);
          databind.createOrUpdateInput(tableDom,"totalPageCount",data.totalPageCount);
          databind.createOrUpdateInput(tableDom,"totalRecordCount",data.totalRecordCount);
        }
        if(tmpl){
          if(constant&&constant.getValueByKey){
            juicer.register("dict", constant.getValueByKey);
          }
          var tbody_html = juicer(tmpl,data);
          $(tableDom).find("tbody,.list-body").html(tbody_html);
        }

        $(tableDom).trigger("call-success",data);
        $(tableDom).trigger("data-change",data);
      }
    };

    databind.submit(tableDom,opt);
  };

  var fillParam=function(dom){
    var d = $(dom);
    var data = {};
    d.find("input[name],select[name]").each(function(idx,itm){
      var it = $(itm);
      var urlPara = base.getUrlParam(it.attr("name"));
      if(urlPara){
        data[it.attr("name")]=urlPara;
      }
    });
    databind.fillForm(dom,data);
  };
  var initEvent = function(tableDom,paegControllerDom,opt){
    //当前页面参数
    var para = window.location.hash;
    para = para.replace(/&?p=\d+/g,"");
    if(para.indexOf("?")==-1){
      para+="?";
    }else{
      para+="&";
    }
    para+="p=";
    //当前页码
    var currentPage = base.getUrlParam("p");
    if(!currentPage||currentPage<=0){
      currentPage = 1;
    }
    currentPage = parseInt(currentPage);

    var pc = $(paegControllerDom);
    pc.find(".btn-jumppage").unbind("click").on("click",function(){
      showFLoat('<div class="page-controller-pop" style="border: 1px solid #ADADAF;background-color: #fff;height: 45px;line-height: 45px;padding-right: 10px;padding-left: 10px;border-radius: 5px;box-shadow: 0 0 3px #CCCCCC;"><div class="fl">跳转到第	</div><div class="fl" style="width:30px;margin:0px 5px;height: 45px;"><input type="text" name="pageIndex" value="" style="height: 22px;width: 33px;border-color: #ADADAD;line-height: 22px;margin: 0px;margin-top: 11px;"></div><div class="fl">页	</div><div class="fl"><button type="button" class="btn-medium" style="margin-top: 11px;background-color: #F1F1F1;color: #000000;border-radius: 5px;height: 24px;line-height: 18px;min-width: 42px;">确定</button></div></div>',0,0);
      var fl = $(".float_area");
      var _t = $(this);
      // _t.offset().left+_t.width()-fl.width()
      // _t.offset().top+_t.height()
      fl.css("left",_t.offset().left+_t.width()-fl.width());
      fl.css("top",_t.offset().top+_t.height()-5);
      fl.css("color","#84a0be");
      fl.find("input").focus();
      fl.find("button").on("click",function(){
        var page = parseInt(fl.find("input").val());
        if(page>0){
          window.location.hash=para+page;
        }
        fl.html("");
      });
      return false;
    });

    $(tableDom).unbind("data-change").on("data-change",function(event,data){
      if(data&&data.totalPageCount&&currentPage>data.totalPageCount){
        window.location.hash=para+data.totalPageCount;
      }
      $(paegControllerDom).find(".text").text(''+data.pageIndex+'/'+data.totalPageCount+'页,共'+data.totalRecordCount+'条');
      //上一页下一页
      $(paegControllerDom).find(".prePage").attr("href",para+(currentPage-1)).show();
      $(paegControllerDom).find(".nextPage").attr("href",para+(currentPage+1)).show();

      if(data.pageIndex <= 1){
        $(paegControllerDom).find(".prePage").hide();
      }
      if(data.pageIndex >= data.totalPageCount){
        $(paegControllerDom).find(".nextPage").hide();
      }
    });
    var searchFristPage = function(opt){
      if($(tableDom).attr("ext-input")){
        var extInput = $($(tableDom).attr("ext-input"));
        if(!validator.validate(extInput,opt?opt.validateFailCall:undefined)){
          return ;
        }
        var para = window.location.hash;
        para = para.replace(/&?p=\d+/g,"");
        if(para.indexOf("?")==-1){
          para+="?";
        }else{
          para+="&";
        }
        para+="p=1";
        var data = base.parseForm(extInput);
        extInput.find("input[type=checkbox]").each(function(idx,itm){
          var it = $(itm);
          if(it.prop("checked")===false){
            para=para.replace(new RegExp("&"+encodeURIComponent(it.attr("name"))+"=.*?[&]","g"),"&");
          }
        });
        for(var k in data){
          para=para.replace(new RegExp("&"+encodeURIComponent(k)+"=.*?[&]","g"),"&");
          if(data[k]){
            para+="&"+encodeURIComponent(k)+"="+encodeURIComponent(data[k]);
          }
        }

        window.location.hash = para;
      }
    };

    //搜索按钮事件绑定
    $(tableDom).find(".table-search").unbind("click").on("click",function(){searchFristPage(opt);});
    if($(tableDom).attr("ext-input")){
      var extInput = $($(tableDom).attr("ext-input")).find(".table-search");
      extInput.unbind("click").on("click",function(){searchFristPage(opt);});
    }
  };

  E.more=function(tableDom,opt){
    if($(tableDom).length==0){return ; }
    loadDataMore(tableDom,opt);initEventMore(tableDom,opt);
  };

  function loadDataMore(tableDom,listOpt){
    var extraData ={};
    if($(tableDom).attr("ext-input")){
      var extInput = $($(tableDom).attr("ext-input"));
      fillParam(extInput);
      if(!validator.validate(extInput)){
        return ;
      }
      extraData = base.parseForm(extInput);
    }
    for(var k  in  extraData){
      tableDom.find(">input[name="+k+"]").remove();
      databind.createOrUpdateInput(tableDom,k,extraData[k]);
    }
    var tmpl = $(tableDom).attr("tpl-id")?$("#"+$(tableDom).attr("tpl-id")).html():"";
    var opt = {
      action  : $(tableDom).attr("action"),
      version  : $(tableDom).attr("version"),
      path  : $(tableDom).attr("path"),
      product  : $(tableDom).attr("product"),
      data:extraData,
      success:function(data){
        if(listOpt&&listOpt.preprocessing&&typeof(listOpt.preprocessing) == "function"){
          data = listOpt.preprocessing(data);
        }
        
        // add by HuangPW，为了显示“没有数据”，若出错，请删除
        if(data.datas.length == 0) {
          tableDom.find(".nodata").removeClass("none");
        } else {
        	tableDom.find(".nodata").addClass("none");
        }
        
        if(data.pageIndex){
          databind.createOrUpdateInput(tableDom,"pageIndex",data.pageIndex);
          databind.createOrUpdateInput(tableDom,"pageSize",data.pageSize);
          databind.createOrUpdateInput(tableDom,"totalPageCount",data.totalPageCount);
          databind.createOrUpdateInput(tableDom,"totalRecordCount",data.totalRecordCount);
        }
        if(tmpl){
          if(constant&&constant.getValueByKey){
            juicer.register("dict", constant.getValueByKey);
          }
          $(tableDom).find(".table-more").remove();
          var tbody_html = juicer(tmpl,data);
          var body ;
          if($(tableDom).hasClass("list-body")){
            body=$(tableDom);
          }else{
            body=$(tableDom).find("tbody,.list-body");
          }
          body.append(tbody_html);
          if(data.pageIndex >= data.totalPageCount){
            $(tableDom).find(".table-more").remove();
          }
        }
        $(tableDom).trigger("call-success",data);
        $(tableDom).trigger("data-change",data);
      }
    };
    databind.submit(tableDom,opt);
  }
  function initEventMore(tableDom,opt){
    tableDom.off("data-change").on("data-change",function(){
      $(tableDom).find(".table-more").off("click").on("click",function(){
        var pi = tableDom.find("input[name=pageIndex]");
        if(pi.length == 0 ){
          return ;
        }
        var intnPi = parseInt($(pi[0]).val());
        intnPi++;
        databind.createOrUpdateInput(tableDom,"pageIndex",intnPi);
        E.more(tableDom,opt);
      });
    });


  }

  return E;
});
