// 主界面
;define(function(require, exports, module) {
  'use strict';
  var T = {};
  T.jss = {};
  T.tmpls  ={};
  var databind = require("databind");
  var validator = require("validate");
  var base = require("base");

  var loadingCount = -1;
  var inited =false;
  var loadingcallback = [];

  var init=function(){
    if(inited){
      return ;
    }
    loadingCount = 0;
    inited = true;
    var  types=["text","text_int","label","submit","search","placeholder","text_email",
"textarea","dropbox","checkbox","date","time","split","datetime","attachment","radio","text_float","text_phone"];
    for(var idx in types){
      var type = types[idx];
      loadTmpl(type);
    }
  };
  var  loadTmpl=function(type){
    loadingCount++;
    require.async(CONFIG.BasePath+"/component/customForm/widgets/"+type+"/widget.js",function(jsfile){
      loadingCount--;
      if(jsfile&&jsfile.init){
        try {
          jsfile.init();
        } catch (e) {
          console.log(e);
        }
      }
      T.jss[type]=jsfile;
      // console.log("add type:"+type);
      loadComplete();

    });
    loadingCount++;
    require.async(CONFIG.BasePath+"/component/customForm/widgets/"+type+"/widget.html",function(htmlfile){
      loadingCount--;
      T.tmpls[type]=htmlfile;
      loadComplete();
    });
  };

  var loadComplete=function(){
  	if(loadingCount==0){
        // console.log("callback");
        for(var idx in  loadingcallback){
//      	console.log("loadingcallback");
          loadingcallback[idx]();
        }
      }
  }

	T.search = function(opt){
    var dom = $(opt.dom);
    dom.empty();
    dom.attr("formId",opt.tmpl.formId);
    dom.addClass("customForm-container");
    var data = opt.tmpl.fieldList;
    if(!data){
      return ;
    }
    for( var idx in data){
      var line = data[idx];
      var type = line.type;
      if(!type){continue;}
      var handler = T.jss[type];
      var tmpl = T.tmpls[type];
      if(!handler){console.log("unknown type "+type);continue ;}
      try {
        //var colDom = $(handler.renderEdit(tmpl,line,opt,T));

    	colDom.attr("data-customFormType",type);
        dom.append(colDom);
        colDom.trigger("customForm-event-draw");
      } catch (e) {
//      console.log("type:"+type+" render fail");
        console.log(e);
//      console.log(data);
      }
    }
    dom.trigger("data-change");
    if(opt.callback.searchFirst && typeof(opt.callback.searchFirst) == 'function'){
              opt.callback.searchFirst();
    }
  };
  T.create = function(opt){
    var dom = $(opt.dom);
    dom.empty();
    dom.attr("formId",opt.tmpl.formId);
    dom.addClass("customForm-container");
    var data = opt.tmpl.fieldList;
    if(!data){
      return ;
    }
    for( var idx in data){
      var line = data[idx];
      var type = line.type;
      if(!type){continue;}
      var handler = T.jss[type];
      var tmpl = T.tmpls[type];
      if(!handler){console.log("unknown type "+type);continue ;}
      try {
        //var colDom = $(handler.renderEdit(tmpl,line,opt,T));

    	var colDom;
    	if(opt.mobile && typeof(handler.renderEditMobile) == "function") {
            colDom = $(handler.renderEditMobile(tmpl,line,opt,T));
      	} else {
      		colDom = $(handler.renderEdit(tmpl,line,opt,T));
      	}

    	colDom.attr("data-customFormType",type);
        dom.append(colDom);
        colDom.trigger("customForm-event-draw");
      } catch (e) {
//      console.log("type:"+type+" render fail");
        console.log(e);
//      console.log(data);
      }
    }
    dom.trigger("data-change");
  };
  T.edit = function(opt){
    var dom = $(opt.dom);
    dom.empty();
    dom.attr("formId",opt.tmpl.formId);
    dom.attr("dataId",opt.data.dataId);
    dom.addClass("customForm-container");
    var data = opt.tmpl.fieldList;
    var valdata = opt.data;
    if(!data){
      return ;
    }
    for( var idx in data){
      var line = data[idx];
      var type = line.type;
      if(!type){continue;}
      var handler = T.jss[type];
      var tmpl = T.tmpls[type];
      if(!handler){console.log("unknown type "+type);continue ;}
      try {
        var colDom;
        if(type === 'radio') {
//      	console.log('dddddddddddddddd');
        }
    	if(opt.mobile && typeof(handler.renderEditMobile) == "function") {
    		colDom = $(handler.renderEditMobile(tmpl,line,opt,T));
    	} else {
    		colDom = $(handler.renderEdit(tmpl,line,opt,T));
    	}
        colDom.attr("data-customFormType",type);
        dom.append(colDom);
        colDom.trigger("customForm-event-draw");
        if(handler.setData && typeof(handler.setData) == "function"){
          handler.setData(colDom,valdata,T,tmpl);
        }else{
          T.fillForm(colDom,valdata);
        }
      } catch (e) {
//      console.log("type:"+type+" render fail");
        console.log(e);
//      console.log(data);
      }
    }
    dom.trigger("data-change");
  };
  T.validate=function(dom){
    var d = $(dom);
    if(d.length===0){
      return  {};
    }
    var errors = [];
    var chs = d.children();
    chs.each(function(idx,itm){
      var ch = $(itm);
      var type = ch.attr("data-customFormType");
      var js = T.jss[type];
      if(js&&js.validate&&typeof(js.validate)=='function'){
        errors.push(js.validate(ch,T));
      }else{
        var er = validator.validateInput(ch);
        if(er){
          errors.push(er);
          return false;
        }
      }
    });
    if(errors.length>0){
      base.alert(3,errors.join("<br>"));
      return false;
    }
    return true;
  };
  T.getData=function(dom){
    var d = $(dom);
    if(d.length===0){
      return  {};
    }
    var data={};
    var chs = d.children();
    chs.each(function(idx,itm){
      var ch = $(itm);
      var type = ch.attr("data-customFormType");
      var js = T.jss[type];
      if(js&&js.getData&&typeof(js.getData)=='function') {
    	var d = js.getData(ch,T);
        data = $.extend(data,d);
      } else {
        data  = $.extend(data,T.parseForm(ch));
      }
    });
    return data;
  };
  T.view=function(opt){
    var dom = $(opt.dom);
    var tmplData = opt.tmpl.fieldList;
    var data =opt.data;

    dom.empty();
    dom.attr("dataId",opt.dataId);
    dom.addClass("customForm-container-view");
    if(!data||!tmplData){
      return ;
    }

    for( var idx in tmplData){
      var line = tmplData[idx];
      var type = line.type;
      if(!type){continue;}
      var handler = T.jss[type];
      var tmpl = T.tmpls[type];
      if(!handler){console.log("unknown type "+type);return ;}
      try {
    	  var colDom
    	  if(opt.mobile && typeof(handler.renderViewMobile) == "function") {
    		  colDom = $(handler.renderViewMobile(tmpl,line,data[line.fieldCode],opt,T));
    	  } else {
    		  colDom = $(handler.renderView(tmpl,line,data[line.fieldCode],opt,T));
    	  }
        colDom.attr("data-customFormType",type);
        dom.append(colDom);

      } catch (e) {
//      console.log("type:"+type+" render fail");
        console.log(data);
      }
    }
    dom.trigger("data-change");
  };

  function loadForm(opt,callback){
    var formId = opt.tmpl.formId;
    var tmpl = opt.tmpl;
    if(tmpl.fieldList){
      callback(opt);
      return ;
    }
    // databind.submit({}, {
		// 	action: "inquireFormOfCreateTenant",
		// 	version: "v1.0",
		// 	data: {
		// 		formId : formId
		// 	},
		// 	product: "",
		// 	success: function(data) {
    //       var tmplData = data.datas[0];
    //       if(opt.callback.afterInquireForm && typeof(opt.callback.afterInquireForm) == 'function'){
    //           opt.callback.afterInquireForm(tmplData,opt);
    //       }
    //       opt.tmpl=tmplData;
    //       callback(opt)  ;
		// 	}
		// });
  }
  function loadData(opt,callback){
    loadForm(opt,function(opt){
      var dataId = opt.data.dataId;
      var formId = opt.tmpl.formId;
      var data = opt.data.data;
      if(data){
        callback(opt);
        return ;
      }
      // databind.submit({}, {
      //   action: "inquireFormDataTenant",
      //   version: "v1.0",
      //   data: {
      //     formId : formId,
      //     dataId: dataId
      //   },
      //   success: function(data) {
      //       var formData =data.datas[0].data;
      //       if(typeof(formData) =="string"){
      //         formData=JSON.parse(formData);
      //         formData.dataId = data.datas[0].dataId;
      //       }
      //
      //       if(opt.callback.afterInquireFormData && typeof(opt.callback.afterInquireFormData) == 'function'){
      //           opt.callback.afterInquireFormData(tmplData,opt);
      //       }
      //       opt.data=formData.data;
      //       opt.data.dataId = dataId;
      //       callback(opt)  ;
      //   }
      // });
    });

  }
  T.fillForm = function(dom,data){
    var d = $(dom);
    $.each(d.find("input,textarea,select,.data"),function(idx,itm){
      var it = $(itm);
      var val  = undefined
      var path = it.attr("path");
      if(path){
        ps = path.split(".");
        var obj = data;
        $.each(ps,function(idx,itm){
          obj  = obj[itm];
          if(!obj){
            return false;
          }
        });
        val = obj;
      }else{
        val = data[it.attr("name")];
      }
      if(typeof(val)=="undefined"){
        return ;
      }
      if(it.hasClass("data")){
        it.html(val);
      }else{
        if(it.attr("type")=="radio" || it.attr("type")=="checkbox"){
          if(it.val() == val){
            it.attr("checked","checked");
          }
        }else{
          it.val(val);
        }
      }
    });
    d.trigger("data-change");
  }
  T.parseForm = function(dom) {
    if (!dom) {
      dom = document;
    }
    var _d = $(dom);
    var ins = _d.find("input,textarea,select");
    var form = {};
    $.each(ins, function(idx, item) {
      var _t = $(item);
      if (_t.attr("type") == "checkbox" || _t.attr("type") == "radio") {
        if (!_t.is(":checked")) {
          return;
        }
      }
      var name = _t.attr("name");
      if (!name) {
        return;
      }
      var val = _t.val();
      if(val){val = val.replace(/^\s+/,"").replace(/\s+$/,"")}
      var exists = form[name];
      if (!exists) {

      } else {
        if (exists.push) {
          exists.push(val);
          val = exists;
        } else {
          var nv = [];
          nv.push(exists);
          nv.push(val);
          val = nv;
        }

      }
      form[name] = val;
    });
    return form;
  };

  T.uuid=function() {
    var s = [];
    var hexDigits = "0123456789abcdef";
    for (var i = 0; i < 36; i++) {
      s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
    }
    s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
    s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
    s[8] = s[13] = s[18] = s[23] = "-";

    var uuid = s.join("");
    return uuid;
  }

  return {
    init:init,
    search:function(opt){
//  	console.log(loadingCount);
      if(loadingCount!=0){
//    	console.log("callback");
        loadingcallback.push(function(){loadForm(opt,T.search);});
        return ;
      }
      loadForm(opt,T.search);
    },
    create:function(opt){
      if(loadingCount!=0){
        loadingcallback.push(function(){loadForm(opt,T.create);});
        // setTimeout(function(){loadForm(opt,T.create);},400);
        return ;
      }
      loadForm(opt,T.create);
    },
    view:function(opt){
      if(!opt.callback){opt.callback={};}
      if(loadingCount!=0){
        loadingcallback.push(function(){loadData(opt,T.view);});
        // setTimeout(function(){loadData(opt,T.view);},400);
        return ;
      }
      loadData(opt,T.view);
    },
    edit:function(opt){
      if(!opt.callback){opt.callback={};}
      if(loadingCount!=0){
        loadingcallback.push(function(){    loadData(opt,T.edit);});
        // setTimeout(function(){loadData(opt,T.edit);},400);
        return ;
      }
      loadData(opt,T.edit);
    },

    getData:T.getData
  };
});
