// 主界面
;define(function(require, exports, module) {
  'use strict';

  var renderEdit=function(tmpl,data,opt){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.input").html();
    var  td = $(tmplText);
    //var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
    var width = 100;
    td.css("width",width+"%");
    td.find(".customForm-area-label").html(data.fieldName+"：");
    td.find("select").attr("placeholder","请选择"+data.fieldName).attr("name",data.fieldCode);
    var opts = [];
    for(var idx in data.optionValueList){
      var v = data.optionValueList[idx];
      opts.push('<option value="'+v+'">'+v+'</option>');
    }
    td.find("select").append(opts.join(""));
    if(data.defaultValue){
      td.find("select").val(data.defaultValue);
    }
    if(data.required){
      var req = $("<span>*</span>").css("color","red");
      td.find(".customForm-area-label").prepend(req);
      td.find("input").attr("required",true);
    }
    return td;
  };
  var renderView=function(tmpl,tmplData,data,opt){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.view").html();
    var  td = $(tmplText);
    var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
    td.css("width",width+"%");
    td.find(".customForm-area-label").html(tmplData.fieldName+":");
    td.find(".customForm-area-val").attr("name",tmplData.fieldCode);
    if(data){
      td.find(".customForm-area-val").text(data);
    }
    return td;
  };
  var getData=function(dom){
    var input  = $(dom).find('select');
    var name = input.attr("name");
    var val = input.val();
    var ret = {};
    if(name&&val){
      ret[name]=val;
    }
    return ret;
  };

  return {
    renderEdit:renderEdit,
    renderView:renderView,
    getData:getData
  };
});
