// 主界面
;define(function(require, exports, module) {
  'use strict';
  var base = require("base");
  
  var renderEdit=function(tmpl,data,opt){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.input").html();
    var  td = $(tmplText);
    var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
    td.css("width",width+"%");
    td.find(".customForm-checkbox-label").html(data.fieldName);
    // td.find("select").attr("placeholder","请选择"+data.fieldName).attr("name",data.fieldCode);
    var opts = [];
    for(var idx in data.optionValueList){
      var v = data.optionValueList[idx];
      opts.push('<div><label><input type="checkbox" value="'+v+'"><div class="customForm-checkbox-opt-label">'+v+'</div><label></div>');
    }
    td.find(".customForm-checkbox-inputs>*").append(opts.join(""));
    td.find("input").attr("name",data.fieldCode);
    if(data.defaultValue){
      //td.find("select").val(data.defaultValue);
    	var  vs = data.defaultValue.split(',');
	    dom.find("input").each(function(iidx,itm){
	      for( var idx in vs){
	        var v  = vs[idx];
	        if($(itm).val() == v){
	          $(itm).attr("checked",true);
	        }
	      }
	    });
    }
    if(data.required){
      var req = $("<span>*</span>").css("color","#eb6566");
      td.find(".customForm-checkbox-label").append(req);
      td.find("input").attr("required",true);
    }
    return td;
  };
  
  
  var renderEditMobile=function(tmpl,data,opt){
	  var tpdom = $(tmpl);
	    var tmplText = tpdom.find("script.input_mobile").html();
	    var td = $(tmplText);
	   // td.find(".fieldName").text(data.fieldName);
	    td.css("width","100%");
	    td.find(".customForm-checkbox-label").html(data.fieldName);
	    if(data.required){
		    var req = $("<span>*</span>").css("color","#eb6566");
		    td.find(".customForm-checkbox-label").append(req);
		}
	    
	    if(data.defaultValue) {
	    	renderValue(td.find(".customForm-checkbox-inputs"), data.defaultValue.split(','));
	    }
	    
	    td.find(".customForm-checkbox-inputs").attr("name",data.fieldCode);
	    
	    var opts = [];
	    for(var idx in data.optionValueList){
	      var v = data.optionValueList[idx];
	      var checked = '';
	      var  vs = data.defaultValue.split(',');
	      for( var idx in vs){
		      if(v === vs[idx]) {
		    	  checked = 'checked';
		      }
		  }
	      opts.push('<div class="customForm-popups-item"><label><div class="customForm-checkbox-opt-label">'+v+'</div><div class="customForm-checkbox-opt-input"><input class="checkIcon '+ checked +'" type="checkbox" value="'+v+' "' + checked + '></div><label></div>');
	    }
	    
	    
	    var popup_td = $(tpdom.find("script.popups").html());
	    popup_td.append(opts.join(""));
	    
	    td.find(".customForm-checkbox-wrap-ops").on("click", popup_td, function(event) {
				$(document).find("#fullBg").removeClass("none");
				event.data.removeClass("none");
		    $(document).find(".fieldName").html(data.fieldName);
		    //默认选项数量
				var num = popup_td.find(".customForm-popups-item .checked").length;
				$(".count").text(num);
		});
	    //点击fullBg时隐藏popup和fullBg
		$(document).find("#fullBg").on("click", popup_td, function(event) {
			conceal(event.data);
		});
		
		//popup上的取消按钮点击后隐藏popup和fullBg
		popup_td.find(".customForm-popups-ops-left").on("click", popup_td, function(event) {
			conceal(event.data);
		});
		
		
		//多选选中
    popup_td.find(".customForm-popups-item .checkIcon").on("click",function(){
			if($(this).parent().find(".checked").length == 0){
	    	$(this).addClass("checked");
	    	var num = $(".count").text();
	    	$(".count").text(++num);
    	}else{
    		$(this).removeClass("checked");
    		var num = $(".count").text();
	    	$(".count").text(--num);
    	}
    })
		
		//popup上点击选项后将选项的值赋给选择器
		popup_td.find(".customForm-popups-ops-right").on("click", {"td" : td, "popup_td":popup_td, "base" : base}, function(event) {
			//var allOptionsHtml = '';
			var chekceds = [];
			event.data.popup_td.find(".customForm-checkbox-opt-input input").each(function(iidx,itm) {
		        if ($(itm).prop('checked') === true) {
		        	//allOptionsHtml += '<span class="customForm-checkbox-checkboxed-item">' + $(this).val() + '</span>';
		        	chekceds.push($(this).val());
	            }
	        });
			if(chekceds.length === 0) {
				event.data.base.alert(3, '请选择！');
				return;
			}
			//event.data.td.find(".customForm-checkbox-inputs").html(allOptionsHtml);
			event.data.td.find(".customForm-checkbox-inputs").attr("value", chekceds.join(','));
			renderValue(event.data.td.find(".customForm-checkbox-inputs"), chekceds);
			conceal(event.data.popup_td);
		});
		
	    td = td.append(popup_td);
	    return td;
	  };
  
	  var conceal = function(popup_td) {
			$(document).find("#fullBg").addClass("none");
			popup_td.addClass("none");
		};
		
  var renderValue = function(inputDom, values) {
	  var allOptionsHtml = '';
	  for( var idx in values) {
		  allOptionsHtml += '<span style="border:1px solid #4e7dd6;padding: 5px;color:#4e7dd6;margin-right:5px;" class="customForm-checkbox-checkboxed-item">' + values[idx] + '</span>';
	  }
	  inputDom.html(allOptionsHtml);
  }
		
  var renderView=function(tmpl,tmplData,data,opt){
    var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
    return renderViewCommon(tmpl,tmplData,data,opt,width);
  };
  
  var renderViewMobile=function(tmpl,tmplData,data,opt){
	    return renderViewCommon(tmpl,tmplData,data,opt,100);
  };
  
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
	    var tpdom = $(tmpl);
	    var tmplText = juicer(tpdom.find("script.view").html(),{data:data});
	    var  td = $(tmplText);
	    td.css("width",width+"%");
	    td.find(".customForm-checkbox-label").html(tmplData.fieldName+":");
	    td.find(".customForm-checkbox-val").attr("name",tmplData.fieldCode);
	    // if(data){
	    //   td.find(".customForm-checkbox-val").text(data);
	    // }
	    return td;
	  };
	  
  var getData=function(dom,component){
	var ret = {};
    if($(dom).find('.customForm-popups').length === 0) {
    	var value = component.parseForm(dom);
    	ret = value;
    } else {
    	var input = $(dom).find(".customForm-checkbox-inputs");
    	value = input.attr("value").split(",");
    	var name = input.attr("name");
    	ret[name] = value;
    }
    return ret;
  };
  var setData = function(dom,datas,component){
	if(dom.find("input").length > 0) {
		var name  = dom.find("input").attr("name");
	    var  vs = datas[name];
	    dom.find("input").each(function(iidx,itm){
	      for( var idx in vs){
	        var v  = vs[idx];
	        if($(itm).val() == v){
	          $(itm).attr("checked",true);
	        }
	      }
	    });
	} else {
		var input = dom.find(".customForm-checkbox-inputs");
		var name  = input.attr("name");
		var  vs = datas[name];
		input.attr("value", vs.join(','));
		var allOptionsHtml = '';
		renderValue(input, vs);
	}
    
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile :renderEditMobile,
    renderView:renderView,
    renderViewMobile : renderViewMobile,
    getData:getData,
    setData:setData
  };
});
