// 主界面
;define(function(require, exports, module) {
  'use strict';
  var currYear = (new Date()).getFullYear();
  var dateOpt={};
  dateOpt.date = {preset : 'date'};
  dateOpt.datetime = {preset : 'datetime'};
  dateOpt.time = {preset : 'time'};
  dateOpt.default = {
	  theme: 'android-ics light', //皮肤样式
      display: 'modal', //显示方式 
      mode: 'scroller', //日期选择模式
	  lang:'zh',
      startYear:currYear - 100, //开始年份
      endYear:currYear + 100 //结束年份
  };
	
  var renderEdit=function(tmpl,data,opt){
	  var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
      return renderEditCommon(tmpl,data,opt,'input',width);
  };
  
  var renderEditMobile = function(tmpl,data,opt,component) {
	    var width = 100;
	    var td = renderEditCommon(tmpl,data,opt,'input_mobile',width);
	    /**var id = component.uuid();
	    td.find("input").attr("id",id);
	    
	    td.on("customForm-event-draw",function(){
	    	flatpickr('#' + $(this).find("input").attr("id"));
	    });**/
	    
	    td.find("input").val('').mobiscroll($.extend(dateOpt['date'], dateOpt['default']));
	    
	    return td;
  };
  
  var renderEditCommon = function(tmpl,data,opt, tmplClass, width) {
	  var tpdom = $(tmpl);
	    var tmplText = tpdom.find("script." + tmplClass).html();
	    var  td = $(tmplText);
	    td.css("width",width+"%");
	    if(data.fieldName){
		    td.find(".customForm-date-label").html(data.fieldName);
	    }
	    td.find("input").attr("placeholder","日期").attr("name",data.fieldCode).attr("description",data.fieldName);
	    td.attr("name",data.fieldCode);
	    if(data.defaultValue){
	      td.find("input").val(data.defaultValue);
	    }
	    if(data.required){
	      var req = $("<span>*</span>").css("color","#eb6566");
	      td.find(".customForm-date-label").append(req);
	      td.find("input").attr("required",true);
	    }
	    td.find("input").on("change keyup blur",function(){
	      var val = $(this).val();
	      var required =$(this).attr("required");
	      if(!val && required){
	      	td.find(".customForm-date-label").css("color","#eb6566");
	        td.addClass("customForm-input-invalid");
	        td.attr("title","请输入"+data.fieldName);
	        return ;
	      }
	      td.find(".customForm-date-label").css("color","#969696");
	      td.removeClass("customForm-input-invalid");
	      td.removeAttr("title");
	    });
	    return td;
  }
  
  var renderView=function(tmpl,tmplData,data,opt){
	  var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
	  return(tmpl,tmplData,data,opt,width);
  };
  
  var renderViewMobile=function(tmpl,tmplData,data,opt){
	  return(tmpl,tmplData,data,opt,100);
  };
  
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.view").html();
    var  td = $(tmplText);
    var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
    td.css("width",width+"%");
    td.find(".customForm-date-label").html(tmplData.fieldName);
    td.find(".customForm-date-val").attr("name",tmplData.fieldCode);
    if(data){
      td.find(".customForm-date-val").text(data);
    }
    return td;
  };
  var getData=function(dom){
    var name = $(dom).attr("name");
    var val = $(dom).find("input.Wdate").val();
    if(name && val){
      var ret = {};
      ret[name]=val;
      return ret ;
    }
    return {};
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile : renderEditMobile,
    renderView:renderView,
    renderViewMobile:renderViewMobile,
    getData:getData
  };
});
