// 主界面
;define(function(require, exports, module) {
  'use strict';
  var currYear = (new Date()).getFullYear();
  var dateOpt={};
  dateOpt.date = {preset : 'date'};
  dateOpt.datetime = {preset : 'datetime'};
  dateOpt.time = {preset : 'time'};
  dateOpt.default = {
	  theme: 'android-ics light', //皮肤样式
      display: 'modal', //显示方式 
      mode: 'scroller', //日期选择模式
	  lang:'zh',
      startYear:currYear - 100, //开始年份
      endYear:currYear + 100 //结束年份
  };
  
  var renderEdit=function(tmpl,data,opt){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.input").html();
    var  td = $(tmplText);
    var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
    td.css("width",width+"%");
    td.find(".customForm-datetime-label").html(data.fieldName);
    td.find(".customForm-datetime-input input").attr("placeholder","日期").attr("name",data.fieldCode).attr("description",data.fieldName);
    td.attr("name",data.fieldCode);
    if(data.required){
      var req = $("<span>*</span>").css("color","#EB6566");
      td.find(".customForm-datetime-label").append(req);
      td.attr("required",true);
    }
    td.find("input").on("change keyup blur",function(){
      var required =td.attr("required");
      if(required){
        var pass = true;
        td.find("input").each(function(idx,itm){
          if(!$(itm).val()){
            td.addClass("customForm-input-invalid");
            td.attr("title","请输入"+data.fieldName);
            pass = false;
            return false;
          }
        });
        if(pass){
          td.removeClass("customForm-input-invalid");
          td.removeAttr("title");
        }
      }
    });
    td.find(".customForm-datetime-time input").on("keyup change",function(){
      var t = $(this);
      var v = t.val();
      var  pi = parseInt(v,10);
      if(pi<0){pi = -pi;}
      if(t.hasClass("customForm-time-hour") && pi>23){pi=23;}
      if(t.hasClass("customForm-time-minute") && pi>59){pi=59;}
      if(isNaN(pi)){
        pi="";
      }
      if(pi!=v){
        t.val(pi);
      }
    });
    return td;
  };
  var renderEditMobile=function(tmpl,data,opt){
	    var tpdom = $(tmpl);
	    var tmplText = tpdom.find("script.inputMobile").html();
	    var  td = $(tmplText);
	    var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
	    td.css("width","100%");
	    td.find(".customForm-datetime-label").html(data.fieldName);
	    td.find(".customForm-datetime-input input").attr("placeholder","日期").attr("name",data.fieldCode).attr("description",data.fieldName);
	    td.attr("name",data.fieldCode);
	    if(data.required){
	      var req = $("<span>*</span>").css("color","#EB6566");
	      td.find(".customForm-datetime-label").append(req);
	      td.attr("required",true);
	    }
	    td.find("input").val('').mobiscroll($.extend(dateOpt['datetime'], dateOpt['default']));
	    return td;
  };
  
  var renderView=function(tmpl,tmplData,data,opt){
	   var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
	   return renderViewCommon(tmpl,tmplData,data,opt,width);
  };
  
  var renderViewMobile=function(tmpl,tmplData,data,opt){
	   var width = 100;
	   return renderViewCommon(tmpl,tmplData,data,opt,width);
  };
 
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.view").html();
    var  td = $(tmplText);
    td.css("width",width+"%");
    td.find(".customForm-datetime-label").html(tmplData.fieldName+":");
    td.find(".customForm-datetime-val").attr("name",tmplData.fieldCode);
    if(data){
      td.find(".customForm-datetime-val").text(data);
    }
    return td;
  };
  var getData=function(dom){
    var name = $(dom).attr("name");
    
    if($(dom).find("input.customForm-time-hour").length > 0) {
        var valDate = $(dom).find("input.Wdate").val();
        var valHour = $(dom).find("input.customForm-time-hour").val();
        var valMinute = $(dom).find("input.customForm-time-minute").val();

        if(name && valDate && valHour && valMinute){
            var ret = {};
            ret[name]=valDate+" "+(valHour<10?"0":"")+valHour+":"+(valMinute<10?"0":"")+valMinute;
           return ret ;
        }
    } else {
    	var valDate = $(dom).find("input.Wdate").val();
    	if(name && valDate){
            var ret = {};
            ret[name]=valDate;
           return ret ;
        }
    }
    return {};
  };

  var setData=function(dom,datas,T){
      var name = $(dom).attr("name");
      var v = datas[name];
      if(!v){
        return ;
      }
      var dt = v.split(" ")[0];
      var tm = v.split(" ")[1];
      var vs  = tm.split(":");
      $(dom).find("input.Wdate").val(dt);
      $(dom).find("input.customForm-time-hour").val(vs[0]);
      $(dom).find("input.customForm-time-minute").val(vs[1]);
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile : renderEditMobile,
    renderView:renderView,
    renderViewMobile:renderViewMobile,
    getData:getData,
    setData:setData
  };
});
