// 主界面
;define(function(require, exports, module) {
  'use strict';

  var renderEdit=function(tmpl,data,opt){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.input").html();
    var  td = $(tmplText);
    var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
    td.css("width","100%");
    td.find(".customForm-dropbox-label").html(data.fieldName);
    td.find("select").attr("placeholder","请选择"+data.fieldName).attr("name",data.fieldCode);
    if(data.dataSource) {
    	var dataSource = JSON.parse(data.dataSource);
    	databind.submit([], {
			action: dataSource.action,
			version: dataSource.version,
			product: "",
			data: dataSource.params,
			success: function(data) {
				var dt = data.datas;
				var opts = [];
				opts.push('<option value="">全部</option>');
				for (var i in dt) {
					opts.push('<option value="'+dt[i].codeDispName+'">'+dt[i].codeDispName+'</option>');
				}
				td.find("select").append(opts.join(""));
			}
		});
    } else {
    	var opts = [];
    	for(var idx in data.optionValueList){
    	    var v = data.optionValueList[idx];
    	    opts.push('<option value="'+v+'">'+v+'</option>');
    	}
    	td.find("select").append(opts.join(""));
    }
    
    if(data.defaultValue){
      td.find("select").val(data.defaultValue);
    }
    if(data.required){
      var req = $("<span>*</span>").css("color","#EB6566");
      td.find(".customForm-dropbox-label").append(req);
      td.find("input").attr("required",true);
    }
    return td;
  };
  
  var renderEditMobile=function(tmpl,data,opt){
	    var tpdom = $(tmpl);
	    var tmplText = tpdom.find("script.input_mobile").html();
	    var td = $(tmplText);
	    td.css("width","100%");
	    td.find(".customForm-dropbox-label").html(data.fieldName);
	    
	    if(data.required){
		    var req = $("<span>*</span>").css("color","#EB6566");
		    td.find(".customForm-dropbox-label").append(req);
		}
	    
	    if(data.defaultValue){
	    	td.find(".customForm-dropbox-input").html("<span style='border:1px solid #4e7dd6;padding: 5px;color:#4e7dd6;'>"+data.defaultValue+"</span>");
	    }
	    
	    td.find(".customForm-dropbox-input").attr("name",data.fieldCode);
	    
	    var opts = [];
	    for(var idx in data.optionValueList){
	      var v = data.optionValueList[idx];
	      opts.push('<div class="customForm-popups-item">' + v + '</div>');
	      //opts.push('<option value="'+v+'">'+v+'</option>');
	    }
	    
	    var popup_td = $(tpdom.find("script.popups").html());
	    popup_td.append(opts.join(""));
	    
	    td.find(".customForm-dropbox-wrap-ops").on("click", popup_td, function(event) {
			$(document).find("#fullBg").removeClass("none");
			event.data.removeClass("none");
		});
	    //点击fullBg时隐藏popup和fullBg
		$(document).find("#fullBg").on("click", popup_td, function(event) {
			conceal(event.data);
		});
		
		//popup上的取消按钮点击后隐藏popup和fullBg
		popup_td.find(".customForm-popups-ops-left").on("click", popup_td, function(event) {
			conceal(event.data);
		});
		
		//popup上点击选项后将选项的值赋给选择器
		popup_td.find(".customForm-popups-item").on("click", {"td": td,"popup_td" : popup_td}, function(event) {
			var itemValue = $(this).html();
			event.data.td.find(".customForm-dropbox-input").html("<span style='border:1px solid #4e7dd6;padding: 5px;color:#4e7dd6;'>"+itemValue+"</span>");
			conceal(event.data.popup_td);
		});
		
	    td = td.append(popup_td);
	    return td;
  };
  
  var conceal = function(popup_td) {
		$(document).find("#fullBg").addClass("none");
		popup_td.addClass("none");
	};
	  
	var renderView=function(tmpl,tmplData,data,opt){
		var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
		return renderViewCommon(tmpl,tmplData,data,opt,width);
	};
	
	var renderViewMobile=function(tmpl,tmplData,data,opt){
		var width = 100;
		return renderViewCommon(tmpl,tmplData,data,opt,width);
	};
	
	
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.view").html();
    var  td = $(tmplText);
    td.css("width","100%");
    td.find(".customForm-dropbox-label").html(tmplData.fieldName);
    td.find(".customForm-dropbox-val").attr("name",tmplData.fieldCode);
    if(data){
      td.find(".customForm-dropbox-val").text(data);
    }
    return td;
  };
  var getData=function(dom){
    var ret = {};
    
    if($(dom).find('select').length > 0) {
    	var input  = $(dom).find('select');
    	var name = input.attr("name");
    	var val = input.val();
        if(name&&val){
          ret[name]=val;
        }
    } else {
    	var input = $(dom).find(".customForm-dropbox-input");
    	var val = input.text()
    	var name = $(dom).find(".customForm-dropbox-input").attr("name");
        if(name&&val){
          ret[name]=val;
        }
    }
    return ret;
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile : renderEditMobile,
    renderView:renderView,
    renderViewMobile : renderViewMobile,
    getData:getData
  };
});
