// 主界面
;define(function(require, exports, module) {
  'use strict';
  var renderEdit=function(tmpl,data,opt){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.input").html();
    var  td = $(tmplText);
    var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
    td.css("width",width+"%");
    td.find(".customForm-radio-label").html(data.fieldName);
    // td.find("select").attr("placeholder","请选择"+data.fieldName).attr("name",data.fieldCode);
    var opts = [];
    for(var idx in data.optionValueList){
      var v = data.optionValueList[idx];
      opts.push('<div title="'+v+'"><label><input type="radio" value="'+v+'"><div class="customForm-radio-opt-label">'+v+'</div><label></div>');
    }
    td.find(".customForm-radio-inputs>*").append(opts.join(""));
    td.find("input").attr("name",data.fieldCode);
    if(data.defaultValue){
      td.find("input").each(function(idx,it){
        if($(it).val() == data.defaultValue){
          $(it).attr("checked",true);
        }
      });
    }
    if(data.required){
      var req = $("<span>*</span>").css("color","#EB6566");
      td.find(".customForm-radio-label").append(req);
      td.find("input").attr("required",true);
    }
    return td;
  };
  
  var renderEditMobile=function(tmpl,data,opt){
	    var tpdom = $(tmpl);
	    var tmplText = tpdom.find("script.input_mobile").html();
	    var td = $(tmplText);
	    td.css("width","100%");
	    td.find(".customForm-radio-label").html(data.fieldName);
	    
	    if(data.required){
		    var req = $("<span>*</span>").css("color","#EB6566");
		    td.find(".customForm-radio-label").append(req);
		}
	    
	    if(data.defaultValue){
	    	td.find(".customForm-radio-input").html(data.defaultValue);
	    }
	    
	    td.find(".customForm-radio-input").attr("name",data.fieldCode);
	    
	    var opts = [];
	    for(var idx in data.optionValueList){
	      var v = data.optionValueList[idx];
	      opts.push('<div class="customForm-popups-item"><span class=""></span>' + v + '</div>');
	      //opts.push('<option value="'+v+'">'+v+'</option>');
	    }
	    
	    var popup_td = $(tpdom.find("script.popups").html());
	    popup_td.append(opts.join(""));
	    
	    td.find(".customForm-radio-wrap-ops").on("click", popup_td, function(event) {
			$(document).find("#fullBg").removeClass("none");
			event.data.removeClass("none");
		});
	    //点击fullBg时隐藏popup和fullBg
		$(document).find("#fullBg").on("click", popup_td, function(event) {
			conceal(event.data);
		});
		
		//popup上的取消按钮点击后隐藏popup和fullBg
		popup_td.find(".customForm-popups-ops-left").on("click", popup_td, function(event) {
			conceal(event.data);
		});
		
		//popup上点击选项后将选项的值赋给选择器
		popup_td.find(".customForm-popups-item").on("click", {"td": td,"popup_td" : popup_td}, function(event) {
			var itemValue = $(this).html();
			event.data.td.find(".customForm-radio-inputs").html('<span style="border:1px solid #4e7dd6;padding: 5px;color:#4e7dd6;">' + itemValue + '</span>');
			conceal(event.data.popup_td);
		});
		
	    td = td.append(popup_td);
	    return td;
    };

    var conceal = function(popup_td) {
		$(document).find("#fullBg").addClass("none");
		popup_td.addClass("none");
	};
	
	
	var renderView=function(tmpl,tmplData,data,opt){
		var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
		return renderViewCommon(tmpl,tmplData,data,opt,width);
	};
	
	var renderViewMobile=function(tmpl,tmplData,data,opt){
		var width = 100;
		return renderViewCommon(tmpl,tmplData,data,opt,width);
	};
	
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = juicer(tpdom.find("script.view").html(),{data:data});
    var  td = $(tmplText);
    td.css("width",width+"%");
    td.find(".customForm-radio-label").html(tmplData.fieldName);
    td.find(".customForm-radio-val").attr("name",tmplData.fieldCode);
    // if(data){
    //   td.find(".customForm-radio-val").text(data);
    // }
    return td;
  };
  var getData=function(dom,component){
    var input  = $(dom).find('input');
    return component.parseForm(dom);
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile: renderEditMobile,
    renderView:renderView,
    renderViewMobile:renderViewMobile,
    getData:getData
  };
});
