// 主界面
;define(function(require, exports, module) {
  'use strict';

  var renderEdit=function(tmpl,data,opt){
    var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
    return renderEditCommon(tmpl,data,opt,width);
  };
  
  var renderEditMobile=function(tmpl,data,opt){
	    var width = 100;
	    return renderEditCommon(tmpl,data,opt,width);
  };
  
  var renderEditCommon=function(tmpl,data,opt,width){
	    var tpdom = $(tmpl);
	    var tmplText = tpdom.find("script.input").html();
	    var  td = $(tmplText);
	    td.css("width",width+"%");
	    if(data.fieldName.length > 4){
	    	td.find(".customForm-text-label").css("line-height","25px");
	    }
	    td.find(".customForm-text-label").html(data.fieldName);
	    td.find("input").attr("placeholder",data.placeholder).attr("name",data.fieldCode).attr("description",data.fieldName);
	    td.find(".customForm-tip").text(data.remark);
	    if(data.length){
	      td.find("input").attr("maxLength",data.length);
	    }
	    if(data.defaultValue){
	      td.find("input").val(data.defaultValue);
	    }
	    if(data.required){
	      var req = $("<span>*</span>").css("color","#eb6566");
	      td.find(".customForm-text-label").append(req);
	      td.find("input").attr("required",true);
	    }
	    td.find("input").on("change keyup blur",function(){
	      var val = $(this).val();
	      var required =$(this).attr("required");
	      var maxLength = parseInt($(this).attr("maxLength"),10);
	      if(val&&maxLength && val.length>maxLength){
	        val = val.substring(0,maxLength);
	        $(this).val(val);
	      }
	      if(!val && required){
	      	td.find(".customForm-text-label").css("color","#eb6566");
	        td.addClass("customForm-input-invalid");
	        td.attr("title","请输入"+data.fieldName);
	        return ;
	      }
	      td.removeClass("customForm-input-invalid");
	      td.find(".customForm-text-label").css("color","#969696");
	      td.removeAttr("title");
	    });
	    return td;
	  };
  
  var renderView=function(tmpl,tmplData,data,opt){
    var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
    return renderViewCommon(tmpl,tmplData,data,opt,100);
  };
  
  var renderViewMobile=function(tmpl,tmplData,data,opt) {
	    return renderViewCommon(tmpl,tmplData,data,opt,100);
  };
  
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
	    var tpdom = $(tmpl);
	    var tmplText = tpdom.find("script.view").html();
	    var  td = $(tmplText);
	    td.css("width",width+"%");
	    
	    td.find(".customForm-text-label").html(tmplData.fieldName);
	    td.find(".customForm-text-val").attr("name",tmplData.fieldCode);
	    if(data){
	      td.find(".customForm-text-val").text(data);
	    }
	    return td.prop("outerHTML");
  };
	  
  var getData=function(dom){
    var input  = $(dom).find('input');
    var name = input.attr("name");
    var val = input.val();
    var ret = {};
    if(name&&val){
      ret[name]=val;
    }
    return ret;
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile:renderEditMobile,
    renderView:renderView,
    renderViewMobile:renderViewMobile,
    getData:getData
  };
});
