// 主界面
;define(function(require, exports, module) {
  'use strict';

  var renderEdit=function(tmpl,data,opt){
	  var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
	  return renderEditCommon(tmpl,data,opt,width);
  }
  
  var renderEditMobile=function(tmpl,data,opt){
	  var width = 100;
	  return renderEditCommon(tmpl,data,opt,width);
  }
  
  var renderEditCommon=function(tmpl,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.input").html();
    var  td = $(tmplText);
    
    td.css("width",width+"%");
    td.find(".customForm-text-label").html(data.fieldName+"：");
    td.find("input").attr("placeholder",data.placeholder).attr("name",data.fieldCode).attr("description",data.fieldName);
    td.find(".customForm-tip").text(data.remark);
    if(data.unit){
      td.find(".customForm-text-input-unit").text(data.unit);
    }
    if(data.defaultValue){
      td.find("input").val(data.defaultValue).trigger("change");
    }
    td.find("input").on("keyup change",function(){
      var t = $(this);
      var v = t.val();
      var  pi = parseInt(v,10);
      if(isNaN(pi)){
        pi="";
      }
      if(pi!=v){
        t.val(pi);
      }
    });
    return td;
  };
  
  var renderView=function(tmpl,tmplData,data,opt){
	  var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
	  return renderViewCommon(tmpl,tmplData,data,opt,width);
  };
  
  var renderViewMobile=function(tmpl,tmplData,data,opt){
	  var width = 100;
	  return renderViewCommon(tmpl,tmplData,data,opt,width);
  };
  
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.view").html();
    var  td = $(tmplText);
    var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
    td.css("width",width+"%");
    td.find(".customForm-text-label").html(tmplData.fieldName+":");
    td.find(".customForm-text-val").attr("name",tmplData.fieldCode);
    if(data){
      td.find(".customForm-text-val").text(data);
    }
    return td.prop("outerHTML");
  };
  var getData=function(dom){
    var input  = $(dom).find('input');
    var name = input.attr("name");
    var val = input.val();
    var ret = {};
    if(name){
      var ival =parseInt(val,10);
      if( isNaN(ival)  || typeof(ival)=="undefined"){
        return {};
      }
      ret[name]=ival;
    }
    return ret;
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile:renderEditMobile,
    renderView:renderView,
    renderViewMobile:renderViewMobile,
    getData:getData
  };
});
