// 主界面
;define(function(require, exports, module) {
  'use strict';

  var renderEdit=function(tmpl,data,opt){
	  var width = 100/(parseInt(data.lineWidth?data.lineWidth:1)/1);
	  return renderEditCommon(tmpl,data,opt,width);
  };
  var renderEditMobile=function(tmpl,data,opt){
	  var width = 100;
	  return renderEditCommon(tmpl,data,opt,width);
  };
  
  var renderEditCommon=function(tmpl,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.input").html();
    var  td = $(tmplText);
    td.css("width",width+"%");
    if(data.fieldName.length > 4){
    	var t = td.find(".customForm-textarea-label")
    	t.css("line-height","20px");
    	t.css("padding-top","50px");
    }
    td.find(".customForm-textarea-label").html(data.fieldName);
    td.find("textarea").attr("placeholder","请输入"+data.fieldName).attr("name",data.fieldCode).attr("description",data.fieldName).attr("rows",8);
    if(data.length){
      td.find("textarea").attr("maxLength",data.length);
    }
    if(data.defaultValue){
      td.find("textarea").val(data.defaultValue);
    }
    if(data.required){
      var req = $("<span>*</span>").css("color","#EB6566");
      td.find(".customForm-textarea-label").append(req);
      td.find("textarea").attr("required",true);
    }
    td.find("textarea").on("change keyup blur",function(){
      var val = $(this).val();
      var required =$(this).attr("required");
      var maxLength = parseInt($(this).attr("maxLength"),10);
      if(val&&maxLength && val.length>maxLength){
        val = val.substring(0,maxLength);
        $(this).val(val);
      }
      if(!val && required){
        td.addClass("customForm-input-invalid");
        td.attr("title","请输入"+data.fieldName);
        return ;
      }
      td.removeClass("customForm-input-invalid");
      td.removeAttr("title");
    });
    return td;
  };
  
  var renderView=function(tmpl,tmplData,data,opt){
	  var width = 100/(parseInt(tmplData.lineWidth?tmplData.lineWidth:1)/1);
	  return renderViewCommon(tmpl,tmplData,data,opt,width);
  };
  
  var renderViewMobile=function(tmpl,tmplData,data,opt){
	  var width = 100;
	  return renderViewCommon(tmpl,tmplData,data,opt,width);
  };
  
  var renderViewCommon=function(tmpl,tmplData,data,opt,width){
    var tpdom = $(tmpl);
    var tmplText = tpdom.find("script.view").html();
    var  td = $(tmplText);
    
    td.css("width",width+"%");
    td.find(".customForm-textarea-label").html(tmplData.fieldName);
    td.find(".customForm-textarea-val").attr("name",tmplData.fieldCode);
    if(data){
      data = data.replace(/<\/?script>/g,"")
      .replace(/(.*)\n/g,"<p>$1</p>");
      td.find(".customForm-textarea-val").html(data);
    }
    return td.prop("outerHTML");
  };
  var getData=function(dom){
    var input  = $(dom).find('textarea');
    var name = input.attr("name");
    var val = input.val();
    var ret = {};
    if(name&&val){
      ret[name]=val;
    }
    return ret;
  };

  return {
    renderEdit:renderEdit,
    renderEditMobile:renderEditMobile,
    renderView:renderView,
    renderViewMobile:renderViewMobile,
    getData:getData
  };
});
