// 主界面
define(function(require, exports, module) {
  'use strict';
  var base = require("base");
  var T = {};
  var retry = 100;


  //id:节点id
  //fileUuid:预览文件id
  //type:预览方式  0:图->图   1:html->html 2:n->html 3:n->jpg 4:video->mp4,5.txt,6.mp3
  T.filePreview = function(type,opt){
    var domId = opt.id;
    var dom = $("#"+domId);
    if(dom.length===0){
      return ;
    }
    opt.retry=100;
    var orgFileUuid = opt.fileUuid;
    var targetFileUuid ;
    var mode =1 ; // 1 立刻预览  2 请求服务端转换之后预览
    var convertType;
    var view = CONFIG.BasePath+"/component/docPreview/";
    switch (type) {
      case 0:
      targetFileUuid = orgFileUuid;
      if(orgFileUuid.push){
        //如果是图片数组 使用图集视图
        view += "preview-gallery";
        opt.style=1;
      }else{
        view += "preview-pic";
      }
      break;
      case  1:
      targetFileUuid = orgFileUuid;
      view += "preview-html";
      break;
      case 2:
      view += "preview-html";
      convertType=0;
      mode=2;
      break;
      case 3:
      view += "preview-gallery";
      convertType=2;
      mode=2;
      break;
      case 4:
      view += "preview-video";
      convertType=3;
      mode=2;
      break;
      case 5:
      targetFileUuid = orgFileUuid;
      view += "preview-txt";
      mode=1;
      break;
      case 6:
      targetFileUuid = orgFileUuid;
      view += "preview-video";
      opt.audio=true;
      mode=1;
      break;
      default:
        if(opt&&opt.fail&&typeof(opt.fail)=='function'){
          opt.fail({opt:opt,message:"不支持的转换格式"});
        }

    }

    switch (mode) {
      case 1:
      require.async(view,function(view){
        view.init(targetFileUuid,opt);
      });
      break;
      case 2 :
      requireConvert(convertType,view,opt);
      break;
      default:
    }
  };

  var requireConvert=function(convertType,view,opt){
    $.ajax({
      url:CONFIG.fsPath+"/v1.0/inquireFilePreviewFiles.json?fileUuid="+opt.fileUuid+"&convertType="+convertType,
      dataType:"json",
      success:function(ret){
        if(ret.flag.toLowerCase()=="success"){

          require.async(view,function(view){
            view.init(ret.datas,opt);
          });
          return;
        }
        if(ret.message&&ret.message.indexOf("转换中")>=0){
          if(opt.retry>0){
            opt.retry--;
            setTimeout(function(){requireConvert(convertType,view,opt);},3000);
          }else{
              if(opt&&opt.fail&&typeof(opt.fail)=='function'){
                opt.fail({opt:opt,message:"预览转换失败,请下载查看"});
              }
          }
        }
          if(ret.flag&&ret.flag.toLowerCase().indexOf("transfer_fail")>=0){
            if(opt&&opt.fail&&typeof(opt.fail)=='function'){
              opt.fail({opt:opt,message:"预览转换失败,请下载查看"});
            }
          }

      }
    });
  };


  return T;
});
