define(function (require, exports, module) {
    var base = require("base");
    var databind = require("databind");
    var homepage = require("../markManage/homepage");
    var html;
    var css;
    var dom;
    var pageIndex = 1;
    var pageSize = 10;
    var totalPageCount;
    var _opt = {
        action: "",
        data: {
            pageIndex: pageIndex,
            pageSize: pageSize
        },
        juicerInit: null,
        emptyText: "",
        dataItem: {
            itemClass: ".list-item",
            itemClick: null,
            itemEvent: null
        },
        template: {}
    };

    var init = function ($componentContainer, opt) {
        _opt = $.extend(true, _opt, opt);

        initView($componentContainer);

        dom = $componentContainer.find(".component-container");

        initEvent();

        loadData(1);
    };

    var initView = function ($componentContainer) {
        html = require("./listview-pageable.html");
        css = require("./listview-pageable.css");
        $componentContainer.html(html);
        if (_opt.emptyText) {
            $componentContainer.find(".empty-view-text").text(_opt.emptyText);
        }
    }

    var initEvent = function () {
        dom.on("click", _opt.dataItem.itemClass, function () {
            if (_opt.dataItem.itemClick) {
                _opt.dataItem.itemClick(this);
            }
        });

        dom.find(".network-view").on("click", function () {
            loadData(1);
        });

        // dom.find(".load-more-view-text").on("click", function () {
        //     $(this).text("正在加载中...");
        //     loadData(pageIndex + 1);
        // });

        //自动加载更多
        $(window).scroll(
          function() {
            var scrollTop = $(this).scrollTop();
            var scrollHeight = $(document).height();
            var windowHeight = $(this).height();
            if (scrollTop == 0) {
              //当滚动条不存在时，不做处理
            }else {
              if (scrollTop + windowHeight == scrollHeight) {
                // 此处是滚动条到底部时候触发的事件，在这里写要加载的数据，或者是拉动滚动条的操作
                if(_opt.data.pageIndex < totalPageCount){
                  loadData(pageIndex + 1);
                }
              }
            }
          });

        if (_opt.juicerInit) {
            _opt.juicerInit();
        }

        if (_opt.dataItem.itemEvent) {
            _opt.dataItem.itemEvent(dom);
        }


    }

    var loadData = function (page) {
        window._android_on_resume = function () {
            loadData(1);
        };

        if (page === 1) {
            dom.find(".loading-view").removeClass("none");
        }

        dom.find(".empty-view").addClass("none");
        dom.find(".network-view").addClass("none");

        var data = _opt.data;
        data.pageIndex = page;

        databind.submit([], {
            action: _opt.action,
            async:false,
            data: data,
            success: function (ret) {
                if (ret.datas && ret.datas.length > 0 && ret.datas[0].isOpen) {
                    base.saveData("isOpen", String(ret.datas[0].isOpen));
                }else {
                    // alert("服务端错误");
                    base.saveData("isOpen", "false");
                }
                dom.find(".loading-view").addClass("none");

                if (!ret.datas.length && page === 1) {
                    dom.find(".empty-view").removeClass("none");

                    return;
                }

                if (page === ret.totalPageCount) {
                    // dom.find(".load-more-view").addClass("none");
                    dom.find(".load-more-view-text").text("已经到最后一条了");
                } else {
                    dom.find(".load-more-view-text").text("加载更多");
                    dom.find(".load-more-view").removeClass("none");
                }

                if (page === 1) {
                    dom.find('.data-list').html("");
                }

                $(".totalRecordCount").text(ret.totalRecordCount > 99 ? "99+" : ret.totalRecordCount);

                var html = juicer(_opt.template.html(), ret)
                dom.find('.data-list').append(html);

                pageIndex = page;
                totalPageCount = ret.totalPageCount;

                PullToRefresh.init({
                    mainElement: '.listview-pageable',
                    instructionsPullToRefresh: "下拉刷新",
                    instructionsReleaseToRefresh: "松开加载",
                    instructionsRefreshing: "正在加载...",
                    onRefresh: function () {
                        loadData(1);
                        window.location.reload();
                    }
                });
            },
            fail: function (error) {
                dom.find(".loading-view").addClass("none");
                if (page === 1) {
                    dom.find(".network-view").removeClass("none");
                } else {
                    base.alert(3, "数据请求失败，请检查网络连接");
                    dom.find(".load-more-view-text").text("尝试加载");
                }
            }
        });
    }

    return {
        init: init
    };
});
