// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var dom;
	var classId;
	var courseDayWidth;
	var courseEnterWidth;

	var init = function() {
		dom = $("#page-information-list");
		classId = base.getUrlParam("classId");
		router.init();
		initEvent();
		CourseScheduleListMethod();
	}

	var initEvent = function() {

		courseDayWidth = dom.find(".courseDay").width();
		courseEnterWidth = dom.find(".col").width() * 0.10;
		dom.find(".dayChangeImg").css({"left":courseEnterWidth + "px"});

		$(".header").on("click",".backBtn",function(){
			base.back();
			return false;
		});

		dom.find(".first").on("click",function(){
			dom.find(".courseDay-active").removeClass("courseDay-active");
			dom.find(".first").addClass("courseDay-active");

			methodForCourse();
			dom.find(".firstCourse").removeClass("courseName-row");
			dom.find(".firstCourse").addClass("courseName-row-active");
			dom.find(".firstCourseName").addClass("col courseName-row-name");
			dom.find(".firstCourse .teacherName").attr("style","");
			dom.find(".firstCourse .teacherName").addClass("col");
			dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
			dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
		});
		dom.find(".second").on("click",function(){
			dom.find(".courseDay-active").removeClass("courseDay-active");
			dom.find(".second").addClass("courseDay-active");

			methodForCourse();
			dom.find(".secondCourse").removeClass("courseName-row");
			dom.find(".secondCourse").addClass("courseName-row-active");
			dom.find(".secondCourseName").addClass("col courseName-row-name");
			dom.find(".secondCourse .teacherName").attr("style","");
			dom.find(".secondCourse .teacherName").addClass("col");
			dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
			dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
		});
		dom.find(".third").on("click",function(){
			dom.find(".courseDay-active").removeClass("courseDay-active");
			dom.find(".third").addClass("courseDay-active");

			methodForCourse();
			dom.find(".thirdCourse").removeClass("courseName-row");
			dom.find(".thirdCourse").addClass("courseName-row-active");
			dom.find(".thirdCourseName").addClass("col courseName-row-name");
			dom.find(".thirdCourse .teacherName").attr("style","");
			dom.find(".thirdCourse .teacherName").addClass("col");
			dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
			dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
		});
		dom.find(".forth").on("click",function(){
			dom.find(".courseDay-active").removeClass("courseDay-active");
			dom.find(".forth").addClass("courseDay-active");

			methodForCourse();
			dom.find(".forthCourse").removeClass("courseName-row");
			dom.find(".forthCourse").addClass("courseName-row-active");
			dom.find(".forthCourseName").addClass("col courseName-row-name");
			dom.find(".forthCourse .teacherName").attr("style","");
			dom.find(".forthCourse .teacherName").addClass("col");
			dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
			dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
		});
		dom.find(".fifth").on("click",function(){
			dom.find(".courseDay-active").removeClass("courseDay-active");
			dom.find(".fifth").addClass("courseDay-active");

			methodForCourse();
			dom.find(".fifthCourse").removeClass("courseName-row");
			dom.find(".fifthCourse").addClass("courseName-row-active");
			dom.find(".fifthCourseName").addClass("col courseName-row-name");
			dom.find(".fifthCourse .teacherName").attr("style","");
			dom.find(".fifthCourse .teacherName").addClass("col");
			dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
			dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
		});
		dom.find(".sixth").on("click",function(){
			dom.find(".courseDay-active").removeClass("courseDay-active");
			dom.find(".sixth").addClass("courseDay-active");

			methodForCourse();
			dom.find(".sixthCourse").removeClass("courseName-row");
			dom.find(".sixthCourse").addClass("courseName-row-active");
			dom.find(".sixthCourseName").addClass("col courseName-row-name");
			dom.find(".sixthCourse .teacherName").attr("style","");
			dom.find(".sixthCourse .teacherName").addClass("col");
			dom.find(".sixth").css({width:"22%"});
			dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
			dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
		});
		dom.find(".seventh").on("click",function(){
			dom.find(".courseDay-active").removeClass("courseDay-active");
			dom.find(".seventh").addClass("courseDay-active");

			methodForCourse();
			dom.find(".seventhCourse").removeClass("courseName-row");
			dom.find(".seventhCourse").addClass("courseName-row-active");
			dom.find(".seventhCourseName").addClass("col courseName-row-name");
			dom.find(".sixthCourse .teacherName").attr("style","");
			dom.find(".seventhCourse .teacherName").addClass("col");
			dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
			dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
		});
	};

	var methodForCourse = function(){
			dom.find(".courseName-row-active").addClass("courseName-row");
			dom.find(".courseName-row-active .courseName-row-name").removeClass("courseName-row-name");
			dom.find(".courseName-row-active .col").removeClass("col");
			dom.find(".courseName-row-active .teacherName").css({display:"none"});
			dom.find(".courseName-row-active").removeClass("courseName-row-active");
	};

	var CourseScheduleListMethod = function(){
		databind.submit([], {
			action: "inquireCourseScheduleListTenant",
			version: "v1.0",
			data:{
				classId:classId
			},
			success: function(data) {
				databind.submit([],{
					action:"inquireCourseTimeDetailTenant",
					version:"v1.0",
					success:function(detailData){

						//判断能不能切换
						if (detailData.datas[0].saturday || detailData.datas[0].sunday) {
							dom.find(".dayChangeImg").removeClass("none");
							dom.find(".dayChangeImg2").removeClass("none");
							//有周日
							if (detailData.datas[0].sunday) {
								//重绑周五事件
								dom.find(".fifth").unbind("click");
								dom.find(".fifth").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".fifth").addClass("courseDay-active");

								methodForCourse();
								dom.find(".fifthCourse").removeClass("courseName-row");
								dom.find(".fifthCourse").addClass("courseName-row-active");
								dom.find(".fifthCourseName").addClass("col courseName-row-name");
								dom.find(".fifthCourse .teacherName").attr("style","");
								dom.find(".fifthCourse .teacherName").addClass("col");
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});

								dom.find(".sixth").css({width:"17%",display:"block"});
								dom.find(".sixthCourse").css({display:"block"});
								dom.find(".first").css({width:"0%",display:"none"});
								dom.find(".firstCourse").css({width:"0%",display:"none"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								});

								//重绑周二事件
								dom.find(".second").unbind("click");
								dom.find(".second").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".second").addClass("courseDay-active");

								methodForCourse();
								dom.find(".secondCourse").removeClass("courseName-row");
								dom.find(".secondCourse").addClass("courseName-row-active");
								dom.find(".secondCourseName").addClass("col courseName-row-name");
								dom.find(".secondCourse .teacherName").attr("style","");
								dom.find(".secondCourse .teacherName").addClass("col");

								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								dom.find(".first").css({width:"17%",display:"block"});
								dom.find(".firstCourse").css({width:"17%",display:"block"});
								dom.find(".sixth").css({width:"0%",display:"none"});
								dom.find(".sixthCourse").css({display:"none"});
								dom.find(".second").css({width:"22%"});	
								dom.find(".secondCourse").css({width:"22%"});
									//重绑周三事件
									dom.find(".third").unbind("click");
									dom.find(".third").on("click",function(){
									dom.find(".courseDay-active").removeClass("courseDay-active");
									dom.find(".third").addClass("courseDay-active");

									methodForCourse();
									dom.find(".thirdCourse").removeClass("courseName-row");
									dom.find(".thirdCourse").addClass("courseName-row-active");
									dom.find(".thirdCourseName").addClass("col courseName-row-name");
									dom.find(".thirdCourse .teacherName").attr("style","");
									dom.find(".thirdCourse .teacherName").addClass("col");
									dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
									dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									dom.find(".second").css({width:"17%"});
									dom.find(".secondCourse").css({width:"17%"});
									dom.find(".first").css({width:"17%"});
									dom.find(".firstCourse").css({width:"17%"});
									});
									//重绑周四事件
									dom.find(".forth").unbind("click");
									dom.find(".forth").on("click",function(){
									dom.find(".courseDay-active").removeClass("courseDay-active");
									dom.find(".forth").addClass("courseDay-active");

									methodForCourse();
									dom.find(".forthCourse").removeClass("courseName-row");
									dom.find(".forthCourse").addClass("courseName-row-active");
									dom.find(".forthCourseName").addClass("col courseName-row-name");
									dom.find(".forthCourse .teacherName").attr("style","");
									dom.find(".forthCourse .teacherName").addClass("col");
									dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
									dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									dom.find(".second").css({width:"17%"});
									dom.find(".secondCourse").css({width:"17%"});
									dom.find(".first").css({width:"17%"});
									dom.find(".firstCourse").css({width:"17%"});
									});
								});

								//重绑周一事件
								dom.find(".first").unbind("click");
								dom.find(".first").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".first").addClass("courseDay-active");

								methodForCourse();
								dom.find(".firstCourse").removeClass("courseName-row");
								dom.find(".firstCourse").addClass("courseName-row-active");
								dom.find(".firstCourseName").addClass("col courseName-row-name");
								dom.find(".firstCourse .teacherName").attr("style","");
								dom.find(".firstCourse .teacherName").addClass("col");

								dom.find(".first").css({width:"22%"});
								dom.find(".firstCourse").css({width:"22%"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								});

								//重绑周三事件
								dom.find(".third").unbind("click");
								dom.find(".third").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".third").addClass("courseDay-active");

								methodForCourse();
								dom.find(".thirdCourse").removeClass("courseName-row");
								dom.find(".thirdCourse").addClass("courseName-row-active");
								dom.find(".thirdCourseName").addClass("col courseName-row-name");
								dom.find(".thirdCourse .teacherName").attr("style","");
								dom.find(".thirdCourse .teacherName").addClass("col");
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								dom.find(".first").css({width:"17%"});
								dom.find(".firstCourse").css({width:"17%"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								});

								//重绑周四事件
								dom.find(".forth").unbind("click");
								dom.find(".forth").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".forth").addClass("courseDay-active");

								methodForCourse();
								dom.find(".forthCourse").removeClass("courseName-row");
								dom.find(".forthCourse").addClass("courseName-row-active");
								dom.find(".forthCourseName").addClass("col courseName-row-name");
								dom.find(".forthCourse .teacherName").attr("style","");
								dom.find(".forthCourse .teacherName").addClass("col");
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								dom.find(".first").css({width:"17%"});
								dom.find(".firstCourse").css({width:"17%"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								});

								//重绑周六事件
								dom.find(".sixth").unbind("click");
								dom.find(".sixth").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".sixth").addClass("courseDay-active");

								methodForCourse();
								dom.find(".sixthCourse").removeClass("courseName-row");
								dom.find(".sixthCourse").addClass("courseName-row-active");
								dom.find(".sixthCourseName").addClass("col courseName-row-name");
								dom.find(".sixthCourse .teacherName").attr("style","");
								dom.find(".sixthCourse .teacherName").addClass("col");
								dom.find(".sixth").css({width:"22%"});
								dom.find(".seventh").css({width:"17%",display:"block"});
								dom.find(".seventhCourse").css({display:"block"});
								dom.find(".second").css({width:"0%",display:"none"});
								dom.find(".secondCourse").css({width:"0%",display:"none"});

								dom.find(".courseName-row-active").css({"line-height":""});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									//重绑周四事件
									dom.find(".forth").unbind("click")
									dom.find(".forth").on("click",function(){
									dom.find(".courseDay-active").removeClass("courseDay-active");
									dom.find(".forth").addClass("courseDay-active");

									methodForCourse();
									dom.find(".forthCourse").removeClass("courseName-row");
									dom.find(".forthCourse").addClass("courseName-row-active");
									dom.find(".forthCourseName").addClass("col courseName-row-name");
									dom.find(".forthCourse .teacherName").attr("style","");
									dom.find(".forthCourse .teacherName").addClass("col");
									dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
									dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									dom.find(".sixth").css({width:"17%",display:"block"});
									dom.find(".sixthCourse").css({display:"block"});
									});
									//重绑周三事件
									dom.find(".third").unbind("click")
									dom.find(".third").on("click",function(){
										dom.find(".courseDay-active").removeClass("courseDay-active");
										dom.find(".third").addClass("courseDay-active");

										methodForCourse();
										dom.find(".thirdCourse").removeClass("courseName-row");
										dom.find(".thirdCourse").addClass("courseName-row-active");
										dom.find(".thirdCourseName").addClass("col courseName-row-name");
										dom.find(".thirdCourse .teacherName").attr("style","");
										dom.find(".thirdCourse .teacherName").addClass("col");
										dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
										dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
										dom.find(".sixth").css({width:"17%",display:"block"});
										dom.find(".sixthCourse").css({display:"block"});
										dom.find(".seventh").css({width:"0%",display:"none"});
										dom.find(".seventhCourse").css({display:"none"});
										dom.find(".second").css({width:"17%",display:"block"});
										dom.find(".secondCourse").css({width:"17%",display:"block"});
										//重绑周四
											dom.find(".forth").unbind("click");
											dom.find(".forth").on("click",function(){
											dom.find(".courseDay-active").removeClass("courseDay-active");
											dom.find(".forth").addClass("courseDay-active");

											methodForCourse();
											dom.find(".forthCourse").removeClass("courseName-row");
											dom.find(".forthCourse").addClass("courseName-row-active");
											dom.find(".forthCourseName").addClass("col courseName-row-name");
											dom.find(".forthCourse .teacherName").attr("style","");
											dom.find(".forthCourse .teacherName").addClass("col");
											dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
											dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
											dom.find(".first").css({width:"17%"});
											dom.find(".firstCourse").css({width:"17%"});
											dom.find(".second").css({width:"17%"});
											dom.find(".secondCourse").css({width:"17%"});
											dom.find(".sixth").css({width:"17%",display:"block"});
											dom.find(".sixthCourse").css({display:"block"});
											});
										//重绑周五
											dom.find(".fifth").unbind("click");
											dom.find(".fifth").on("click",function(){
											dom.find(".courseDay-active").removeClass("courseDay-active");
											dom.find(".fifth").addClass("courseDay-active");

											methodForCourse();
											dom.find(".fifthCourse").removeClass("courseName-row");
											dom.find(".fifthCourse").addClass("courseName-row-active");
											dom.find(".fifthCourseName").addClass("col courseName-row-name");
											dom.find(".fifthCourse .teacherName").attr("style","");
											dom.find(".fifthCourse .teacherName").addClass("col");
											dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
											dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});

											dom.find(".sixth").css({width:"17%",display:"block"});
											dom.find(".sixthCourse").css({display:"block"});
											dom.find(".first").css({width:"0%",display:"none"});
											dom.find(".firstCourse").css({width:"0%",display:"none"});
											dom.find(".second").css({width:"17%"});
											dom.find(".secondCourse").css({width:"17%"});
											});
									});
								});
								//重绑点击周日事件
								dom.find(".seventh").unbind("click");
								dom.find(".seventh").on("click",function(){
									dom.find(".courseDay-active").removeClass("courseDay-active");
									dom.find(".seventh").addClass("courseDay-active");

									methodForCourse();
									dom.find(".seventhCourse").removeClass("courseName-row");
									dom.find(".seventhCourse").addClass("courseName-row-active");
									dom.find(".seventhCourseName").addClass("col courseName-row-name");
									dom.find(".seventhCourse .teacherName").addClass("col");
									dom.find(".seventh").css({width:"22%"});
									dom.find(".sixth").css({width:"17%",display:"block"});
									dom.find(".sixthCourse").css({display:"block"});
										//重绑周四
										dom.find(".forth").unbind("click");
										dom.find(".forth").on("click",function(){
										dom.find(".courseDay-active").removeClass("courseDay-active");
										dom.find(".forth").addClass("courseDay-active");

										methodForCourse();
										dom.find(".forthCourse").removeClass("courseName-row");
										dom.find(".forthCourse").addClass("courseName-row-active");
										dom.find(".forthCourseName").addClass("col courseName-row-name");
										dom.find(".forthCourse .teacherName").addClass("col");
										dom.find(".forthCourse .teacherName").attr("style","");
										dom.find(".seventh").css({width:"17%",display:"block"});
										dom.find(".seventhCourse").css({display:"block"});
										dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
										dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									});
										//重绑周五
										dom.find(".fifth").unbind("click");
										dom.find(".fifth").on("click",function(){
										dom.find(".courseDay-active").removeClass("courseDay-active");
										dom.find(".fifth").addClass("courseDay-active");

										methodForCourse();
										dom.find(".fifthCourse").removeClass("courseName-row");
										dom.find(".fifthCourse").addClass("courseName-row-active");
										dom.find(".fifthCourseName").addClass("col courseName-row-name");
										dom.find(".fifthCourse .teacherName").attr("style","");
										dom.find(".fifthCourse .teacherName").addClass("col");
										dom.find(".seventh").css({width:"17%",display:"block"});
										dom.find(".seventhCourse").css({display:"block"});
										dom.find(".sixth").css({width:"17%",display:"block"});
										dom.find(".sixthCourse").css({display:"block"});
										dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
										dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
										});
								});
							}
							//有周六没周日
							else if (detailData.datas[0].saturday && !detailData.datas[0].sunday) {
								//重绑周五事件
								dom.find(".fifth").unbind("click");
								dom.find(".fifth").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".fifth").addClass("courseDay-active");

								methodForCourse();
								dom.find(".fifthCourse").removeClass("courseName-row");
								dom.find(".fifthCourse").addClass("courseName-row-active");
								dom.find(".fifthCourseName").addClass("col courseName-row-name");
								dom.find(".fifthCourse .teacherName").attr("style","");
								dom.find(".fifthCourse .teacherName").addClass("col");
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});

								dom.find(".sixth").css({width:"17%",display:"block"});
								dom.find(".sixthCourse").css({display:"block"});
								dom.find(".first").css({width:"0%",display:"none"});
								dom.find(".firstCourse").css({width:"0%",display:"none"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								});

								//重绑周二事件
								dom.find(".second").unbind("click");
								dom.find(".second").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".second").addClass("courseDay-active");

								methodForCourse();
								dom.find(".secondCourse").removeClass("courseName-row");
								dom.find(".secondCourse").addClass("courseName-row-active");
								dom.find(".secondCourseName").addClass("col courseName-row-name");
								dom.find(".secondCourse .teacherName").attr("style","");
								dom.find(".secondCourse .teacherName").addClass("col");

								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								dom.find(".first").css({width:"17%",display:"block"});
								dom.find(".firstCourse").css({width:"17%",display:"block"});
								dom.find(".sixth").css({width:"0%",display:"none"});
								dom.find(".sixthCourse").css({display:"none"});
								dom.find(".second").css({width:"22%"});	
								dom.find(".secondCourse").css({width:"22%"});
									//重绑周三事件
									dom.find(".third").unbind("click");
									dom.find(".third").on("click",function(){
									dom.find(".courseDay-active").removeClass("courseDay-active");
									dom.find(".third").addClass("courseDay-active");

									methodForCourse();
									dom.find(".thirdCourse").removeClass("courseName-row");
									dom.find(".thirdCourse").addClass("courseName-row-active");
									dom.find(".thirdCourseName").addClass("col courseName-row-name");
									dom.find(".thirdCourse .teacherName").attr("style","");
									dom.find(".thirdCourse .teacherName").addClass("col");
									dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
									dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									dom.find(".second").css({width:"17%"});
									dom.find(".secondCourse").css({width:"17%"});
									dom.find(".first").css({width:"17%"});
									dom.find(".firstCourse").css({width:"17%"});
									});
									//重绑周四事件
									dom.find(".forth").unbind("click");
									dom.find(".forth").on("click",function(){
									dom.find(".courseDay-active").removeClass("courseDay-active");
									dom.find(".forth").addClass("courseDay-active");

									methodForCourse();
									dom.find(".forthCourse").removeClass("courseName-row");
									dom.find(".forthCourse").addClass("courseName-row-active");
									dom.find(".forthCourseName").addClass("col courseName-row-name");
									dom.find(".forthCourse .teacherName").attr("style","");
									dom.find(".forthCourse .teacherName").addClass("col");
									dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
									dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									dom.find(".second").css({width:"17%"});
									dom.find(".secondCourse").css({width:"17%"});
									dom.find(".first").css({width:"17%"});
									dom.find(".firstCourse").css({width:"17%"});
									});
								});

								//重绑周一事件
								dom.find(".first").unbind("click");
								dom.find(".first").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".first").addClass("courseDay-active");

								methodForCourse();
								dom.find(".firstCourse").removeClass("courseName-row");
								dom.find(".firstCourse").addClass("courseName-row-active");
								dom.find(".firstCourseName").addClass("col courseName-row-name");
								dom.find(".firstCourse .teacherName").attr("style","");
								dom.find(".firstCourse .teacherName").addClass("col");

								dom.find(".first").css({width:"22%"});
								dom.find(".firstCourse").css({width:"22%"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								});

								//重绑周三事件
								dom.find(".third").unbind("click");
								dom.find(".third").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".third").addClass("courseDay-active");

								methodForCourse();
								dom.find(".thirdCourse").removeClass("courseName-row");
								dom.find(".thirdCourse").addClass("courseName-row-active");
								dom.find(".thirdCourseName").addClass("col courseName-row-name");
								dom.find(".thirdCourse .teacherName").attr("style","");
								dom.find(".thirdCourse .teacherName").addClass("col");
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								dom.find(".first").css({width:"17%"});
								dom.find(".firstCourse").css({width:"17%"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								});

								//重绑周四事件
								dom.find(".forth").unbind("click");
								dom.find(".forth").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".forth").addClass("courseDay-active");

								methodForCourse();
								dom.find(".forthCourse").removeClass("courseName-row");
								dom.find(".forthCourse").addClass("courseName-row-active");
								dom.find(".forthCourseName").addClass("col courseName-row-name");
								dom.find(".forthCourse .teacherName").attr("style","");
								dom.find(".forthCourse .teacherName").addClass("col");
								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
								dom.find(".first").css({width:"17%"});
								dom.find(".firstCourse").css({width:"17%"});
								dom.find(".second").css({width:"17%"});
								dom.find(".secondCourse").css({width:"17%"});
								});

								//重绑周六事件
								dom.find(".sixth").unbind("click");
								dom.find(".sixth").on("click",function(){
								dom.find(".courseDay-active").removeClass("courseDay-active");
								dom.find(".sixth").addClass("courseDay-active");

								methodForCourse();
								dom.find(".sixthCourse").removeClass("courseName-row");
								dom.find(".sixthCourse").addClass("courseName-row-active");
								dom.find(".sixthCourseName").addClass("col courseName-row-name");
								dom.find(".sixthCourse .teacherName").attr("style","");
								dom.find(".sixthCourse .teacherName").addClass("col");
								dom.find(".sixth").css({width:"22%"});

								dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
								dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									//重绑周四事件
									dom.find(".forth").unbind("click")
									dom.find(".forth").on("click",function(){
									dom.find(".courseDay-active").removeClass("courseDay-active");
									dom.find(".forth").addClass("courseDay-active");

									methodForCourse();
									dom.find(".forthCourse").removeClass("courseName-row");
									dom.find(".forthCourse").addClass("courseName-row-active");
									dom.find(".forthCourseName").addClass("col courseName-row-name");
									dom.find(".forthCourse .teacherName").attr("style","");
									dom.find(".forthCourse .teacherName").addClass("col");
									dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
									dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
									dom.find(".sixth").css({width:"17%",display:"block"});
									dom.find(".sixthCourse").css({display:"block"});
									});
									//重绑周三事件
									dom.find(".third").unbind("click")
									dom.find(".third").on("click",function(){
										dom.find(".courseDay-active").removeClass("courseDay-active");
										dom.find(".third").addClass("courseDay-active");

										methodForCourse();
										dom.find(".thirdCourse").removeClass("courseName-row");
										dom.find(".thirdCourse").addClass("courseName-row-active");
										dom.find(".thirdCourseName").addClass("col courseName-row-name");
										dom.find(".thirdCourse .teacherName").attr("style","");
										dom.find(".thirdCourse .teacherName").addClass("col");
										dom.find(".courseName-row-active").css({"line-height":(courseDayWidth/2)+"px"});
										dom.find(".courseName-row").css({"line-height":courseDayWidth+"px"});
										dom.find(".sixth").css({width:"17%",display:"block"});
										dom.find(".sixthCourse").css({display:"block"});
									});
								});
							}
						}

						data.detail = detailData.datas[0];
						var totalDataArr = [];
						//上午的课
						for (var i = 0; i < detailData.datas[0].morningNum; i++) {
							var rowArr = ["","","","","","","",""];
							for (var j = 0; j < data.datas.length; j++) {
								var dic = data.datas[j];
								if (dic.classType == 1 && dic.classSectionNum == (i+1)) {
									rowArr.push(dic);
								}
							}
							console.log(rowArr);
							addToDataArrMethod(i+1,rowArr,totalDataArr);
						}
						//下午的课
						for (var i = 0; i < detailData.datas[0].noonNum; i++) {
							var rowArr = ["","","","","","","",""];
							for (var j = 0; j < data.datas.length; j++) {
								var dic = data.datas[j];
								if (dic.classType == 2 && dic.classSectionNum == (i+1)) {
									rowArr.push(dic);
								}
							}
							addToDataArrMethod(totalDataArr.length,rowArr,totalDataArr);
						}
						//晚上的课
						for (var i = 0; i < detailData.datas[0].tonightNum; i++) {
							var rowArr = ["","","","","","","",""];
							for (var j = 0; j < data.datas.length; j++) {
								var dic = data.datas[j];
								if (dic.classType == 3 && dic.classSectionNum == (i+1)) {
									rowArr.push(dic);
								}
							}
							addToDataArrMethod(totalDataArr.length,rowArr,totalDataArr);
						}
						console.log(totalDataArr);
						data.dataArr = totalDataArr;

						var html = juicer($("#course-tpl").html(), data);
						dom.find(".courseTplJuicer").html(html);

						dom.find(".firstCourse").on("click",function(){
						dom.find(".first").trigger("click");
						});

						dom.find(".secondCourse").on("click",function(){
							dom.find(".second").trigger("click");
						});

						dom.find(".thirdCourse").on("click",function(){
							dom.find(".third").trigger("click");
						});

						dom.find(".forthCourse").on("click",function(){
							dom.find(".forth").trigger("click");
						});

						dom.find(".fifthCourse").on("click",function(){
							dom.find(".fifth").trigger("click");
						});

						dom.find(".sixthCourse").on("click",function(){
							dom.find(".sixth").trigger("click");
						});

						dom.find(".seventhCourse").on("click",function(){
							dom.find(".seventh").trigger("click");
						});
				
						// 设置当前是周几
						chooseDay();
						//修改单元格高度
						dom.find(".courseTplJuicer .courseRow").css({height:courseDayWidth+"px"});
						dom.find(".courseTplJuicer .courseEnter-row").css({"line-height":courseDayWidth+"px"});
						dom.find(".courseTplJuicer .courseName-row").css({"line-height":courseDayWidth+"px"});
					}
				});
			}
		});
	};

	var addToDataArrMethod = function(index,arr,dataArr){
		if (arr.length !== 0) {
			var rowFinal = ["","","","","","","",""];
			for (var i = 0; i < arr.length; i++) {
			var dic = arr[i];
			rowFinal[0] = index;
			rowFinal[dic.workDay] = dic;
			}
			dataArr[index] = rowFinal;
		}
		else{
			var rowFinal = ["","","","","","","",""];
			var dic = arr[i];
			rowFinal[0] = index + 1;
			dataArr[index] = rowFinal;
		}
	};

	var chooseDay = function(){
		var date = new Date();
				switch(date.getDay()){
					case 1:
					dom.find(".first").addClass("todayColor");
					dom.find(".first").trigger("click");
					break;
					case 2:
					dom.find(".second").addClass("todayColor");
					dom.find(".second").trigger("click");
					break;
					case 3:
					dom.find(".third").addClass("todayColor");
					dom.find(".third").trigger("click");
					break;
					case 4:
					dom.find(".forth").addClass("todayColor");
					dom.find(".forth").trigger("click");
					break;
					case 5:
					dom.find(".fifth").addClass("todayColor");
					dom.find(".fifth").trigger("click");
					break;
					case 6:
					dom.find(".sixth").addClass("todayColor");
					dom.find(".first").trigger("click");
					break;
					case 7:
					dom.find(".seventh").addClass("todayColor");
					dom.find(".first").trigger("click");
					break;
					default:
					break;
				}
	};

	return {
		init: init
	};
});
