define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;

  var init = function() {
    dom = $("#page-teacher-scheduling");

    initJuicer();
    initEvent();
    loadData();
  };
  var initEvent=function(){
    initClickEvent();
    dom.find('.btn-more').on('click',function(){
      window.location.href="#course.more";
    });
  };

  var initJuicer = function() {
    juicer.register("fsPath", function() {
      return CONFIG.fsPath;
    });

    juicer.register("getValueByKey", constant.getValueByKey);
  };

  var loadData = function() {
    dom.find('.page-header .title').text(base.getUrlParam("name")+"的课程表");
    loadTimeTable();

  };

  function loadTimeTable(){
    databind.submit([],{
      action:'inquireCurrentScheduleTimeTableListTenant',
      success:function(ret){
        dom.find('.kcb-container').html(juicer(dom.find('script[data-tmpl-name=kcb]').html(),ret));

        var cd = new Date();
        dom.find("[data-wd="+cd.getDay()+"]").addClass("todayisbeautifulday");

        loadScheduling();
      }
    });
  }
  function loadScheduling(){
    databind.submit([],{
      action:'inquireTeacherCourseScheduleListTenant',
      data:{semesterCode:$("#semesterSelect").val(),teacherAccountId:base.getUrlParam('aid')},
      success:function(ret){
        var dt = ret.datas[0];

        for(var idx in ret.datas[0].teacherCourseScheduleDtoList){
          var l =  ret.datas[0].teacherCourseScheduleDtoList[idx];
          appendKcbItem(dom.find("[pos="+l.workDay+"-"+l.classSection+"]>div"),l);
        }
      }
    });
    base.adaptHeight(dom);
  }
  function appendKcbItem(dd,data){
    var exists = dd.find(".course-item");
    if(exists.length){
      return ;
    }
    dd.append(juicer(dom.find("script[data-tmpl-name=course-kcb]").html(),data));
    var chs  = dd.children();
    chs.each(function(idx,itm){
      $(itm).css("width",(100/chs.length)+"%").css("float","left");
    });

  }

  function initClickEvent(){
		dom.on('click','.course-item',function(){
			var th  = $(this);
			var ptd = th.parents('td');
			var wds = ['','星期一','星期二','星期三','星期四','星期五'];

			dialog.loadDialog('course.dialog-scheduling',{
				params:{html:juicer(dom.find('script[data-tmpl-name=detailDialog]').html(),{
					se_name:wds[parseInt(ptd.attr('data-se'))],
					se:ptd.attr('data-se'),
					se_dt:ptd.attr('data-se-dt'),
					courseName:th.find('.courseName').text(),
					className:th.find('.className').text(),
					placeNameList:th.find('[name=placeNameList]').val()
				})}
			},'');
		});
	}



  return {
    init: init
  };
});
