// 主界面
define(function (require, exports, module) {
  'use strict';
  var base = require("base");
  var dialog = require("dialog");
  var databind = require("databind");
  var listView = require("listView");
  var dom;
  var init = function (opt) {
    dom = $("#dialog-exam-fail");
    initEvent();
    loadData(opt);
  };

  var loadData = function (opt) {
    var nextCanExamDate = opt.params.nextCanExamDate;
    dom.find(".next-can-exam-date").html("下次可考试时间"+ nextCanExamDate);
  };

  var initEvent = function () {
    calculateBgSize();
  };

  var calculateBgSize = function () {
    var winWidth = 0;
    var winHeight = 0;
    // 获取窗口宽度
    if (window.innerWidth)
      winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
      winWidth = document.body.clientWidth;
    // 获取窗口高度
    if (window.innerHeight)
      winHeight = window.innerHeight;
    else if ((document.body) && (document.body.clientHeight))
      winHeight = document.body.clientHeight;
    // 通过深入 Document 内部对 body 进行检测，获取窗口大小
    if (document.documentElement && document.documentElement.clientHeight && document.documentElement.clientWidth) {
      winHeight = document.documentElement.clientHeight;
      winWidth = document.documentElement.clientWidth;
    }

    var dialogMaxWidth = winWidth * 0.8;
    var minHeight = winWidth * 0.8 / 1.18;
    var closeImgWidthAndHeight = winWidth * 0.1;
    var fontSize = winWidth / 25;

    dom.css("width",dialogMaxWidth);
    dom.css("min-height",minHeight);
    dom.find(".dialog-exam-close").css("height",closeImgWidthAndHeight);
    dom.find(".dialog-exam-close").css("width",closeImgWidthAndHeight);
    dom.find(".next-can-exam-date").css("font-size",fontSize);
  };

  return {
    init: init
  };
});
