// 主界面
define(function (require, exports, module) {
  'use strict';
  var base = require("base");
  var dialog = require("dialog");
  var databind = require("databind");
  var listView = require("listView");
  var dom;
  var init = function (opt) {
    dom = $("#dialog-exam-pass");
    initEvent();
    loadData(opt);
  };

  var loadData = function (opt) {
    var reward = opt.params.reward;
    dom.find(".reward-content").html(reward+"分");
  };

  var initEvent = function () {
    calculateBgSize();
  };

  var calculateBgSize = function () {
    var winWidth = 0;
    var winHeight = 0;
    // 获取窗口宽度
    if (window.innerWidth)
      winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
      winWidth = document.body.clientWidth;
    // 获取窗口高度
    if (window.innerHeight)
      winHeight = window.innerHeight;
    else if ((document.body) && (document.body.clientHeight))
      winHeight = document.body.clientHeight;
    // 通过深入 Document 内部对 body 进行检测，获取窗口大小
    if (document.documentElement && document.documentElement.clientHeight && document.documentElement.clientWidth) {
      winHeight = document.documentElement.clientHeight;
      winWidth = document.documentElement.clientWidth;
    }

    var dialogMaxWidth = winWidth;
    var minHeight = winWidth  / 1.42;
    var rewardImgWidthAndHeight = winWidth * 0.07;
    var closeImg = winWidth * 0.1;
    var fontSize = winWidth / 20;

    dom.css("width",dialogMaxWidth);
    dom.css("min-height",minHeight);
    dom.find(".dialog-exam-reward").css("height",rewardImgWidthAndHeight);
    dom.find(".dialog-exam-reward").css("width",rewardImgWidthAndHeight);
    dom.find(".dialog-exam-close").css("height",closeImg);
    dom.find(".dialog-exam-close").css("width",closeImg);
    dom.find(".reward-content").css("font-size",fontSize);
  };

  return {
    init: init
  };
});
