// 主界面
define(function (require, exports, module) {
  'use strict';
  var base = require("base");
  var dialog = require("dialog");
  var databind = require("databind");
  var listView = require("listView");
  var dom;
  var init = function (opt) {
    dom = $("#dialog-obtain-diploma");
    initEvent();
    initJuicer();
    loadData(opt);
  };

  var loadData = function (opt) {
    var diplomaData = opt.params.diplomaData;
    var html = juicer(dom.find("#diploma-detail-tpl").html(), diplomaData);
    dom.find(".content").html(html);
  };

  var initEvent = function () {
    $(".dialog-container").on("dialogLoaded", function () {
      dom.find(".dialog-obtain-diploma-bg").css("height", dom.find(".dialog-obtain-diploma-bg").width() + 24 + "px");
      var dialogDomHeight = $(".dialog-container").height();
      var marTop = ($(window).height() - dialogDomHeight) / 2;
      $(".dialog-container").css("margin-top",  marTop + "px");
    });

    dom.on("click", ".download", function () {
      var diplomaId = dom.find(".diploma").attr("diplomaId");
      var imgUuid = dom.find(".diploma").attr("imgUuid");
      if(imgUuid){
        try {
          base.savePictureToAlbum(imgUuid);
        } catch (e) {
          if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
            base.alert(2,"请更新App到最新版本！")
          }
        }
        return;
      }
      html2canvas(document.getElementById('diploma-content')).then(function(canvas) {
        var imgCxt = canvas.toDataURL("image/png");
        var $Blob= getBlobBydataURI(imgCxt,'image/png');
        var timestamp = new Date().getTime();
        var formData = new FormData();
        formData.append("file", $Blob, timestamp + '.png');
        formData.append('name',timestamp + '.png');//得到以当前时间命名的图片文件
        $.ajax({
          type: "POST",
          url: CONFIG.fsPath+"v1.0/uploadFile.json",
          async: true,
          data: formData,
          dataType: "json",
          processData: false,
          contentType: false,
          success: function (data) {
            if (data.data.length > 0) {
              var ret = data.data[0];
              try {
                base.savePictureToAlbum(ret.fileUuid);
              } catch (e) {
                if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
                  base.alert(2,"请更新App到最新版本！")
                }
              }
              //把奖状生成为图片的存起来 避免重复生成
              databind.submit([], {
                action: "saveReadingDiplomaImgAccount",
                version: "v1.0",
                data: {
                  diplomaId: diplomaId,
                  imgUuid:ret.fileUuid
                },
                success: function (data) {
                }
              });
            }
          },
          error: function (err) {
          }
        });
      });
    });
  };

  var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("getYear", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      if (date.getMonth() == 0) {
        return date.getFullYear() - 1;
      }
      return date.getFullYear();
    });

    juicer.register("getMonth", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      return date.getMonth() == 0 ? "12" : date.getMonth();
    });
  };

  function getBlobBydataURI(dataURI,type){
    var binary = atob(dataURI.split(',')[1]);
    var array = [];
    for(var i = 0; i < binary.length; i++) {
      array.push(binary.charCodeAt(i));
    }
    return new Blob([new Uint8Array(array)], {type:type });
  }

  return {
    init: init
  };
});
