// 主界面
define(function (require, exports, module) {
  'use strict';
  var base = require("base");
  var dialog = require("dialog");
  var databind = require("databind");
  var listView = require("listView");
  var dom;
  var bookTotalPage;
  var init = function (opt) {
    dom = $("#dialog-update-reading-progress");
    $(document).ready(function () {
      loadData(opt);
      initEvent();
    });
  };

  var loadData = function (opt) {
    var currentReadingPage = opt.params.currentReadingPage || 0;
    bookTotalPage = opt.params.bookTotalPage || 0;
    var length = (bookTotalPage + "").length;
    dom.find("input[name='readingPage']").attr("maxlength", length + 1);
    dom.find(".book-total-page").html(bookTotalPage + "页");
    dom.find("input[name='readingPage']").val(currentReadingPage);
    calculateBgSize(length);
  };

  var initEvent = function () {
    $(".dialog-container").on("dialogLoaded", function () {
      $('#readingPage').trigger('focus');
      $('#readingPage').select();
    });

    //强制修改数据为最大页码
    dom.find("input[name='readingPage']").bind('input porpertychange',function(){
      if(parseInt(dom.find("input[name='readingPage']").val())>parseInt(bookTotalPage)){
        dom.find("input[name='readingPage']").val(bookTotalPage);
      }
    })
  };

  var calculateBgSize = function (length) {
    var winWidth = 0;
    var winHeight = 0;
    // 获取窗口宽度
    if (window.innerWidth)
      winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
      winWidth = document.body.clientWidth;
    // 获取窗口高度
    if (window.innerHeight)
      winHeight = window.innerHeight;
    else if ((document.body) && (document.body.clientHeight))
      winHeight = document.body.clientHeight;
    // 通过深入 Document 内部对 body 进行检测，获取窗口大小
    if (document.documentElement && document.documentElement.clientHeight && document.documentElement.clientWidth) {
      winHeight = document.documentElement.clientHeight;
      winWidth = document.documentElement.clientWidth;
    }

    var fontSize = winWidth / 14;

    dom.find(".book-total-page").css("font-size",fontSize + "px");
    dom.find("#readingPage").css("font-size",fontSize - 2 + "px");
    dom.find("#readingPage").css("height",fontSize + "px");
    dom.find("#readingPage").css("width",length * fontSize  + "px");
    dom.find(".dialog-content-split").css("font-size",fontSize - 2 + "px");
    dom.find(".dialog-content-split").css("height",fontSize + "px");
  };

  return {
    init: init
  };
});
