// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var appbase = require("android_base");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var databind = require("databind");
  var permission = require("permission");
  var parameter;

  var defaultLoader = function () {
    router.loadPage("studentPage/tab")
  }

  var loadDiplomaTabForPerson = function (diplomaId) {
    base.removeData("pushType");
    base.removeData("diplomaId");
    base.saveData("pushType", "2001");
    base.saveData("diplomaId", diplomaId);
    router.setDefaultLoader(defaultLoader);
  };

  var loadDiplomaTabForClass = function (diplomaId) {
    base.removeData("pushType");
    base.removeData("diplomaId");
    base.saveData("pushType", "2002");
    base.saveData("diplomaId", diplomaId);
    router.setDefaultLoader(defaultLoader);
  };

  var loadPage = function () {
  };
  var init = function () {
    initEvent();
    parameter = base.getUrlParam("parameter");
    var pushType = base.getUrlParam("pushType");
    switch(pushType){
      //获得奖状的 2001个人奖状，2002班级奖状
      case "2001" :  loadDiplomaTabForPerson(parameter); break;
      case "2002" :  loadDiplomaTabForClass(parameter); break;
      default : router.setDefaultLoader(defaultLoader);break;
    }

    router.init();
    initSchoolReadingPermissionsTenant();
    // inquireCurrentAccountInfo();
    // loadPermission();
  };
  var loadPermission = function () {
    databind.submit([], {
      action: "inquireOperationCodeListAccount",
      version: "v1.0",
      // path:"/home/",
      async: false,
      success: function (ret) {
        var operationCodes = ret.datas[0].operationCode;
        for (var i = 0; i < operationCodes.length; i++) {
          $("#permissions").append('<div class="operation" operation="' + operationCodes[i] + '"></div>');
        }
        permission.permissionControl($("#permissions"), $("body"));
        loadPage();
        $(document).on("page-load", function () {
          permission.permissionControl($("#permissions"), $("body"));
        });
      }
    });
  };

  var initSchoolReadingPermissionsTenant = function () {
    databind.submit([], {
      action: "initSchoolReadingPermissionsTenant",
      version: "v1.0",
      success: function () {
      }
    });
  }; 

  var inquireCurrentAccountInfo = function () {
    databind.submit([], {
      action: "inquireCurrentAccountEmployeeInfo",
      version: "v1.0",
      success: function (data) {
        base.saveData("accountName", data.datas[0].name);
      }
    });
  };

  var initEvent = function () {
    initJuicer();

    // FastClick.attach(document.body);

    window._android_on_resume = function () {
      $("#pages>*").trigger("on-resume");
      $("#pages").find(".onresume").trigger("on-resume");
      console.log($("#pages").find(".onresume").length);
    };

    // document.body.addEventListener('touchstart', function () {
    //   return false;
    // });

    $("body").on("click", ".backBtn", function () {
      stopAllAudio();
      base.back();
      return false;
    });

    $("body").on("click", "[page-router]", function () {
      var t = $(this);
      router.route(t.attr("href"));
      return false;
    });

    var stopAllAudio = function (){
      var allAudioList = $(".content").find('audio');
      for (var i = 0; i < allAudioList.length; i++) {
        var audioItem = allAudioList[i];
        audioItem.pause();
        audioItem.currentTime = 0;
        $(audioItem).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
      }
    };


  };

  var initJuicer = function(){
    juicer.register("reading", function() {
      return CONFIG.reading;
    });
  };

  return {
    init: init
  };
});
