/**
 *Copyright 2015 | build time: 2015-4-20
 */
define(function(require, exports, module) {
	var cookieStorage = {
		getCookieVal: function(offset) {
			var endstr = document.cookie.indexOf(";", offset);
			if (endstr == -1) {
				endstr = document.cookie.length;
			}
			return unescape(document.cookie.substring(offset, endstr));
		},
		getItem: function(name) {
			var arg = name + "=";
			var alen = arg.length;
			var clen = document.cookie.length;
			var i = 0;
			while (i < clen) {
				var j = i + alen;
				if (document.cookie.substring(i, j) == arg) {
					return this.getCookieVal(j);
				}
				i = document.cookie.indexOf(" ", i) + 1;
				if (i == 0) break;
			}
			return null;
		},
		setItem: function(name, value) {
			document.cookie = name + "=" + escape(value) +
				"; path=/" +
				"; expires=" + new Date((new Date()).getTime() + 30 * 24 * 3600000);;
		},
		removeItem: function(name) {
			if (this.getItem(name)) {
				document.cookie = name + "=" +
					"; path=/" +
					"; expires=Thu, 01-Jan-1970 00:00:01 GMT";
			}
		},
		clear: function() {
			document.cookie = "";
		}
	}


	var storage = (function() {
		var ret;
		try {
			ret = window.localStorage;
		} catch (e) {

		}
		if (!ret) {
			ret = cookieStorage;
		}
		return ret;
	})();
	var _location = window.location;
	var $body = $(top).find("body");
	var _$body = $("body");


	var dev_base;
	var android_base = require("android_base");


	var T = {
		//版本号
		"version": "1.0",
		//数据请求锁
		"fnAjaxLock": false,
		//存储时间
	};

	if (android_base.init(T)) {
		dev_base = android_base;
	}

	T.cleanHistory = function() {
		if (dev_base) {
			dev_base.cleanHistory();
		}
	}
	T.back = function() {
//		console.log("on base back");
		window.history.back();
	}
	T.go = function(num) {
			window.history.go(num);
		}
		// 方法:地址参数获取
	T.getUrlParam = function(name) {
		var reg = new RegExp("(^|[?&])" + name + "=([^&]*)(&|$)");
		var r = _location.href.replace(/.*?[\?#](.*)/, "$1").match(reg);
		if (r != null) return decodeURIComponent(r[2]);
		return null;
	};

	T.parseUriParam = function(uri, name) {
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
		var r = uri.substr(1).match(reg);
		if (r != null) return unescape(r[2]);
		return null;
	}

	T.getSessionUuid = function() {
		return this.getData(CONFIG.SessionUuidKey ? CONFIG.SessionUuidKey : "sessionUuid");
	}
	T.setSessionUuid = function(sessionUuid) {
		this.saveData(CONFIG.SessionUuidKey ? CONFIG.SessionUuidKey : "sessionUuid", sessionUuid);
	}
	T.removeSessionUuid = function() {
		this.removeData(CONFIG.SessionUuidKey ? CONFIG.SessionUuidKey : "sessionUuid");
	}


	T.removeData = function(k) {
			storage.removeItem(k);
		}
		// 方法:本地数据保存方式
	T.saveData = function(n, d) {
		storage.setItem(n, d);
	};
	//获取
	T.getData = function(n) {
		return storage.getItem(n);
	};
	//清除数据保存
	T.clearData = function(item) {
		if (!item) {
			storage.clear();
		} else {
			storage.clear(item);
		}
	};
	//打开新窗口
	T.openUrl = function(url, settings) {
		if (settings == "" || settings == "new") {
			window.open(url);
			return;
		}
		_location.href = url;
	};

    T.adaptHeight = function(domData) {
        var screenHeight = document.documentElement.clientHeight - 67;
        var adapt = domData.find(".kcb td > div");
        adapt.css("min-height", screenHeight * (80 / 600) + "px");
        adapt.css("padding-top", screenHeight * (18 / 600) + "px");
        var whiteRow = domData.find(".whiteRow");
        whiteRow.css("line-height", screenHeight * (15 / 605) + "px");
    };

	//提示信息 1,success 2.alert 3.error
	T.alert = function(type, c, timeout) {
			// $("#mes-alert-"+type).remove();
			var $mesCommon = $("<div>").addClass("mesCommon").attr("id", "mes-alert-" + type);
			var $mesCon = $("<p>").addClass("mesCon").html(c);
			$mesCommon.append($mesCon);
			_$body.append($mesCommon);
    	$mesCommon.css("z-index", "10001");
			var mesComWideh = $mesCommon.width() + 14;
			var ml = ($(window).width() - mesComWideh) / 2;
			$mesCommon.css("margin-left", ml + "px");
			var ti = timeout ? timeout : 1500;
			setTimeout(function() {
				$(".mesCommon").remove();
			}, ti);
		}
		// 方法:服务端数据请求
	T.fnAjax = function(oArg) {
		if (T.fnAjaxLock) {
			return;
		}
		//请求路径
		var Path = oArg.path;
		if (!Path) {
			Path = CONFIG.ApiPath + "/";
		} else {
			Path += "/api/"
		}
		Path = Path.replace(/\/{2,}/g, "/");
		if (oArg.product) {
			Path = Path + oArg.product + "/";
		}

		var re = /[\u4e00-\u9fa5]+/,
			oData = "",
			n, v; // 处理oArg.oData中的数组


		if (!oArg.oData) {
			oArg.oData = {};
		}

		//请求参数oData
		if (typeof oArg.oData == 'string') {
			oData = oArg.oData;
		} else {
			var strForms = [];
			for (n in oArg.oData) {
				if (oArg.oData[n] instanceof Array) {

					for (var k in oArg.oData[n]) {
						strForms.push(encodeURIComponent(n) + "=" + encodeURIComponent(oArg.oData[n][k]));
					}
				} else {
					v = oArg.oData[n];
					v = $.isFunction(v) ? v() : v; // if value is fn, invoke it
					strForms.push(encodeURIComponent(n) + "=" + encodeURIComponent(v));
				}
			}
			oData = strForms.join("&");
		}
		var additionData = ((CONFIG.AdditonData && typeof(CONFIG.AdditonData) == "function" && CONFIG.AdditonData()) ? CONFIG.AdditonData() : "");
		//  oData = oData+"&sessionUuid="+T.getSessionUuid()+""+(CONFIG.AppKey?"&appKey="+CONFIG.AppKey:"")+ additionData;
		oData = oData + "&sessionUuid=" + T.getSessionUuid();

		//版本号
		var ApiVersion = oArg.version || CONFIG.ApiVersion;
		//参数组合
		var opts = {
			url: Path + ApiVersion + "/" + oArg.action + "",
			type: oArg.stype || "POST",
			async: oArg.async == false ? false : true, //默认异步
			dataType: oArg.dataType || 'json',
			data: oData,
			success: function(oRes) {
				if (oRes && oRes.flag == "UNLOGIN") {
					T.removeData("sessionUuid");
					top.window.location = CONFIG.LoginPath;
					return;
				}
				oArg.fnSuccess && oArg.fnSuccess(oRes);
			},
			error: function(jqXHR, textStatus, errorThrown) {
				T.alert(3, "服务器异常,请稍后再试", 2000);
				oArg.error && oArg.error();
			}
		};

		$.ajax(opts);
	};

	// 方法:表格分页
	T.myPage = function(page_dom, t, n, p, callback) {
			var page_text = page_dom.find("#page_text");
			var page_tol = page_dom.find("#page_tol");
			var page_prev = page_dom.find("#page_prev");
			var page_next = page_dom.find("#page_next");
			if (t) {
				var tpage = Math.ceil(t / p);
				var now_page = n;
				page_text.html('共<span>' + t + '</span>条记录 当前每页显示<span>' + p + '</span>条').show();
				page_tol.html('<input type="text" id="junmpage" class="input" value="' + n + '">/' + tpage + '页  <a href="javascript:void(0);">确定</a>');
				page_tol.show();
				if (n == 1) {
					page_prev.hide();
				} else {
					page_prev.show();
				}
				if (n < tpage) {
					page_next.show();
				} else {
					page_next.hide();
				}
				var junmpage = page_tol.find("#junmpage");
				var cpage = function(p) {
					junmpage.val(p);
					now_page = p;
					if (now_page == 1) {
						page_prev.hide();
					} else {
						page_prev.show();
					}
					if (now_page < tpage) {
						page_next.show();
					} else {
						page_next.hide();
					}
					callback(p);
				}
				junmpage.unbind().keypress(function(e) {
					e.keyCode == 13 && page_tol.find("a").click();
				});
				page_tol.find("a").unbind().bind('click', function() {
					var _v = junmpage.val();
					if (!_v.match(new RegExp("^[0-9]*[1-9][0-9]*$"))) {
						junmpage.val(now_page);
						return;
					} //非正整数
					if (_v > tpage) {
						junmpage.val(now_page);
						return;
					} //不大于总页数
					if (_v == now_page) {
						return;
					} //当前页不请求
					cpage(parseInt(_v));
				});
				page_prev.unbind().bind('click', function() {
					cpage(--now_page);
				});
				page_next.unbind().bind('click', function() {
					cpage(++now_page);
				});
			} else {
				page_tol.hide();
				page_prev.hide();
				page_next.hide();
				page_text.hide();
			}
		}
		//方法：数字分页(page_dom是占位的分页节点，t是数据总条数，n是当前页，p是分页的大小，callback是分页的回调函数)
	T.pageControl = function(page_dom, t, n, p, callback) {
		var _p = $(page_dom);
		_p.unbind();
		var page_num = $("<ul>").addClass("pagenation");
		var page_text = $("<div>").addClass("page_text");
		var page_tol = $("<div>").addClass("page_tol");
		_p.html("").append(page_num).append(page_text).append(page_tol);

		var now_page = n;
		var tpage = Math.ceil(t / p);

		if (tpage >= 1) { //总页码大于1
			page_text.html("共" + t + "条，" + tpage + "页，到第");
			var junmpageId = _p.attr("id") + "junmpage";
			page_tol.html('<input type="number" id="' + junmpageId + '" class="input junmpage" value="' + n + '">/' + tpage + '页  <a class="button">确定</a>');

			var draw = function(tpage, n) {
				var now_page = n; //当前页
				var pgCt = tpage; //总页数

				var html = [];
				html.push('<li class="pagenation-first">首页</li>');
				html.push('<li class="pagenation-pre">&lt;上一页</li>');
				$.each(T.genPage(now_page, pgCt), function(idx, itm) {
					if (itm == now_page) {
						html.push('<li class="pagenation-num active" data-page="' + itm + '">' + itm + '</li>');
					} else {
						html.push('<li class="pagenation-num" data-page="' + itm + '">' + itm + '</li>');
					}
				});
				html.push('<li class="pagenation-next" title="下一页">下一页&gt;</li>');
				html.push('<li class="pagenation-last">末页</li>');

				page_num.html(html.join(""));
			}
			draw(tpage, n); //生成数字

			var junmpageIdStr = "#" + junmpageId;
			var junmpage = page_tol.find(junmpageIdStr);
			var cpage = function(p) {
				junmpage.val(p);
				now_page = p;
				callback(p);
				draw(tpage, p);
			}
			junmpage.unbind().keypress(function(e) {
				e.keyCode == 13 && page_tol.find("a").click();
			});
			page_tol.find("a").unbind().bind('click', function() {
				var _v = junmpage.val();
				if (!_v.match(new RegExp("^[0-9]*[1-9][0-9]*$"))) {
					junmpage.val(now_page);
					return;
				} //非正整数
				if (_v > tpage) {
					junmpage.val(now_page);
					return;
				} //不大于总页数
				if (_v == now_page) {
					return;
				} //当前页不请求
				cpage(parseInt(_v));
			});

			_p.on("click", ".pagenation-num", function(e) {
				e.preventDefault();
				if (now_page == $(this).attr("data-page")) {
					return;
				}
				now_page = $(this).attr("data-page"); //获取页码
				cpage(parseInt($(this).attr("data-page")));
			});


			_p.on("click", ".pagenation-first", function(e) {
				e.preventDefault();
				cpage(1)
			});
			_p.on("click", ".pagenation-pre", function(e) {
				e.preventDefault();
				if (now_page > 1) {
					cpage(now_page - 1);
				}
			});

			_p.on("click", ".pagenation-next", function(e) {
				e.preventDefault();
				if (tpage > now_page) {
					cpage(now_page + 1);
				}

			});

			_p.on("click", ".pagenation-last", function(e) {
				e.preventDefault();
				if (n != tpage) {
					cpage(tpage);
				}
			});
		}
	};
	//辅助数字分页
	T.genPage = function(currentpage, TotalPage) {
			var ret = [];
			currentpage = parseInt(currentpage);
			TotalPage = parseInt(TotalPage);

			var min, max;
			if (TotalPage > 10) {
				if (currentpage < 6) {
					min = 1;
					max = 10;
				} else {
					if (TotalPage - currentpage < 4) {
						max = TotalPage;
						min = TotalPage - 9 < 1 ? 1 : TotalPage - 9;
					} else {
						min = (currentpage - 5) > 1 ? currentpage - 5 : 1;
						max = (currentpage + 4) > TotalPage ? TotalPage : currentpage + 4
					}
				}
			} else {
				min = 1;
				max = TotalPage;
			}
			for (var i = min; i <= max; i++) {
				ret.push(i);
			}

			return ret;
		}
		//生成参数对象
	T.parseForm = function(dom) {
		if (!dom) {
			dom = document;
		}
		var _d = $(dom);
		var ins = _d.find("input,textarea,select");
		var form = {};
		$.each(ins, function(idx, item) {
			var _t = $(item);
			if (_t.attr("type") == "checkbox" || _t.attr("type") == "radio") {
				if (!_t.is(":checked")) {
					return;
				}
			}
			var name = _t.attr("name");
			if (!name) {
				return;
			}
			var val = _t.val();
			if (val) {
				val = val.replace(/^\s+/, "").replace(/\s+$/, "")
			}
			var exists = form[name];
			if (!exists) {

			} else {
				if (exists.push) {
					exists.push(val);
					val = exists;
				} else {
					var nv = [];
					nv.push(exists);
					nv.push(val)
					val = nv;
				}

			}
			form[name] = val;
		});
		return form;
	}


	// 方法:返回格式化日期 TODO:需要加上时分吗
	// ==================
	T.nowDate = function(hm) {
		var now = hm ? new Date(hm) : new Date();
		var ydd = [now.getFullYear(), now.getMonth() + 1, now.getDate()];
		return [ydd[0], ydd[1] > 9 ? ydd[1] : '0' + ydd[1], ydd[2] > 9 ? ydd[2] : '0' + ydd[2]];
	};

	//表格获取数据方法
	T.listView = function(tabledom, lineHandler, after_callback) {
		var t = T;
		var data = t.parseForm(tabledom);
		var _td = $(tabledom);

		var actionName = _td.attr("data-action-name");
		var actionVersion = _td.attr("data-action-version");

		t.fnAjax({
			action: actionName,
			async: false,
			version: actionVersion,
			oData: data,
			fnSuccess: function(data) {
				var dta = data.datas;
				if (data.status == 200) {
					var lines = [];
					$.each(dta, function(idx, item) {
						lines.push(lineHandler(item));
					});
					_td.find(".table-header").after(lines.join(""));
				} else {
					T.alert(3, "服务器异常,请稍后再试", 2000);
					oArg.error && oArg.error();
				}
			},
			error: function(data) {
				T.alert(3, data.message);
			}
		});
	};

	T.findInput = function(dom, name) {
		var ins = $(dom).find("input,select,textarea");
		var ret = [];
		$.each(ins, function(idx, item) {
			if ($(item).attr("name") == name) {
				ret.push(item);
			}
		});
		return ret;
	};
	T.socialShare = function(text, picurl) {}
	T.selectImageFile = function(callback, opt) {}
	T.selectFile = function(callback, opt) {}
	T.captureImage = function(callback, opt) {
		this.alert(3, "暂不支持");
	}
	T.inquireDownloadUrlPath = function() {};
	if (dev_base) {
		for (var k in dev_base) {
			T[k] = dev_base[k];
		}
	}
	T.cookieStorage = cookieStorage;
	module.exports = T;
	window._base = T;
});
