// 主界面
;define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var validator = require("validate");
  var constant  = require("constant");

  var  initedEvent = false;

  var E = {};
  E.loadData = function(callback){
    $(".load-list").each(function(idx,itm){
      E.loadList(itm,callback);
    });
  }

  E.disableInput = function(dom){
    $(dom).find("input,textarea,select").attr("readonly","readonly");
    $(dom).find("select").attr("disabled","disabled");
  }
  E.enableInput = function(dom){
    $(dom).find("input,textarea,select").removeAttr("readonly");
    $(dom).find("select").removeAttr("disabled");
  }

  E.createOrUpdateInput = function(dom,name,value){
    var d = $(dom);
    var node = d.find("input[name="+name+"]");
    if(node.length == 0 ){
      if(!value&&typeof(value)=="undefined"){
        return ;
      }
      node ="";
      if(!value.push){
        node  = $('<input type="hidden" name="'+name+'" value="'+value+'">');
      }else{
        var vs = [];
        for(var idx in value){
          vs.push('<input type="hidden" name="'+name+'" value="'+value[idx]+'">')
        }
        node = vs.join("");
      }

      d.prepend(node);
    }else{
      node.val(value);
    }
  }
  
  E.fillForm = function(dom,data){
    var d = $(dom);
    $.each(d.find("input,textarea,select,.data"),function(idx,itm){
      var it = $(itm);
      var val  = undefined
      var path = it.attr("path");
      if(path){
        ps = path.split(".");
        var obj = data;
        $.each(ps,function(idx,itm){
          obj  = obj[itm];
          if(!obj){
            return false;
          }
        });
        val = obj;
      }else{
        val = data[it.attr("name")];
      }
      if(typeof(val)=="undefined"){
        return ;
      }
      if(it.hasClass("data")){
        it.html(val);
      }else{
        if(it.attr("type")=="radio" || it.attr("type")=="checkbox"){
          if(it.val() == val){
            it.attr("checked","checked");
          }
        }else{
          it.val(val);
        }
      }
    });
    d.trigger("data-change");
  }


  E.fillInput = function(dom,opt){
    var d = $(dom);
    var action = opt.action;
    var version = opt.version;
    var extInput = d.attr("ext-input");
    var product = opt.product;
    var useCache = opt.useCache;
    var path = opt.path;

    var innerForm = base.parseForm(dom);
    var extendForm = base.parseForm($(extInput));
    var oData  = $.extend(innerForm,extendForm);

    base.fnAjax({
      action:action,
      product:product,
      useCache:useCache,
      path:path,
      version:version,
      oData: oData, //传递参数
      fnSuccess: function(data) {
        if (data.status == 200) {
          E.fillForm(d,data.datas[0]);
          if(opt&&opt.callback){
            opt.callback();
          }
        } else {
          base.alert(3,data.message);
        }
      }
    });
  }



  E.submitDom = function(dom,callback){
    var d = $(dom);
    var action = d.attr("action")+".json";
    var version = d.attr("version");
    var extInput = d.attr("ext-input");
    var product = d.attr("product");
    var useCache = d.attr("useCache");
    var path = d.attr("path");

    var innerForm = base.parseForm(dom);
    var extendForm = base.parseForm($(extInput));
    var oData  = $.extend(innerForm,extendForm);

    var promptDialog  = undefined;

    promptDialog = validator.validateInput(dom);
    if (promptDialog.length != 0) {
      base.alert(3,promptDialog);
      return
    }
    promptDialog =validator.validateInput($(extInput));
    if (promptDialog.length != 0) {
      base.alert(3,promptDialog);
      return
    }
    base.fnAjax({
      action:action,
      version:version,
      product:product,
      path:path,
      useCache:useCache,
      oData: oData, //传递参数
      fnSuccess: function(data) {
        if (data.status == 200) {
          if(callback){
            callback(data);
          }
        } else {
          base.alert(3,data.message);
        }
      }
    });
  }



  E.loadList = function(dom,callback){
    var d = $(dom);
    var action = d.attr("action")+".json";
    var version = d.attr("version");
    var tplId = d.attr("tpl-id");
    var extInput = d.attr("ext-input");
    var path = d.attr("path");
    var useCache = d.attr("useCache");
    var product = d.attr("product");
    var innerForm = base.parseForm(dom);
    var extendForm = base.parseForm($(extInput));
    var oData  = $.extend(innerForm,extendForm);

    base.fnAjax({
      action:action,
      version:version,
      oData: oData, //传递参数
      path: path,
      useCache:useCache,
      product:product,
      // product: product,
      fnSuccess: function(data) {
        if (data.status == 200) {
          //分页参数填充
          if(data.pageIndex){
            E.createOrUpdateInput(d,"pageIndex",data.pageIndex);
            E.createOrUpdateInput(d,"pageSize",data.pageSize);
            E.createOrUpdateInput(d,"totalPageCount",data.totalPageCount);
            E.createOrUpdateInput(d,"totalRecordCount",data.totalRecordCount);
          }
          //模板填充
          if(tplId){
            //console.log
            var tpl = $("#"+tplId).html();
            //console.log
            if(constant&&constant.getValueByKey){
              juicer.register("dict", constant.getValueByKey);
            }
            //console.log
            var html = juicer(tpl, data);
              //console.log
            var body;
            if(d.hasClass("list-body")){
              body = d;
            }else{
              body = d.find(".list-body");
            }
            //console.log
            body.html(html);
            //console.log
            $(dom).trigger("data-change");
            //console.log
          }
          var totalPageCount = data.totalPageCount;
          var totalRecordCount = data.totalRecordCount;
          base.pageControl(d.find("div.pagenation,#pagenation"),
          totalRecordCount,
          data.pageIndex,
          data.pageSize,
          function(p) {
            E.fillForm(dom,{pageIndex:p});
            E.loadList(dom,data);
          });
          if(callback){
            callback(data);
          }
        } else {
          base.alert(3,data.message);
        }
      }
    });
  }

  E.initEventListener=function(){

    $(document).off("click",".submit").on("click",".submit",function(){
      var _t = $(this);



      //提交参数准备
      var input_data = {};
      var input_dom=undefined;
      var input_select = _t.attr("form");
      if(!input_select){
        input_dom = _t.parents(".form");
      }else{
        input_dom = $(input_select);
      }
      if(input_dom){
        //输入验证
        var validateMsg  = undefined;

        validateMsg = validator.validateInput(input_dom);
        if (validateMsg.length != 0) {
          base.alert(3,validateMsg);
          return
        }

        input_data = base.parseForm(input_dom);
      }
      //接口路径 /{path}/api/{product}/{version}/{action}.json
      var path = _t.attr("path");
      var action = _t.attr("action")+".json";
      var version = _t.attr("version");
      var product = _t.attr("product");
      var useCache = _t.attr("useCache");


      base.fnAjax({
        product:product,
        path:path,
        action:action,
        version:version,
        useCache:useCache,
        oData: input_data, //传递参数
        fnSuccess: function(data) {
          if (data.status == 200) {

          } else {
            base.alert(3,data.message);
          }
          _t.trigger("call-"+data.flag.toLowerCase(),data);
        }
      });

    });
  }

  E.submit = function(dom,opt){
    var d = $(dom);
    var action = opt.action+".json";
    var version = opt.version;
    var path = opt.path;
    var product = opt.product;
    var useCache = opt.useCache
    var exdata  = opt.data;
		var async = opt.async;
    var success = opt.success;
    var fail = opt.fail;



    if(!validator.validate(dom)){
      return ;
    }


    var data = base.parseForm(dom);
    data = $.extend(data,exdata);

    base.fnAjax({
      action:action,
      version:version,
      path:path,
      product:product,
      useCache:useCache,
      async:async,
      oData: data, //传递参数
      fnSuccess: function(data) {
        if (data.status == 200) {
          if(success){
            success(data);
          }
        } else {
          if(fail){
            fail(data);
          }else{
            base.alert(3,data.message);
          }
        }
      }
    });
  }



  E.init=function(){
    E.loadData();
  }
  return E;
});
