;define(function (require, exports, module) {
  'use strict';

  var base = require('base');

  var loadDialogSmall = function(url,opt){
    loadDialog(url,opt,"large");
  }
  var loadDialogLarge = function(url,opt){
    loadDialog(url,opt,"small");
  }
  var loadDialog = function(url,opt,sizeSuffix){
    if(!sizeSuffix){
      sizeSuffix = "large";
    }
    var  dc = $(".dialog-container");
    dc.empty();
    dc.addClass("none");
    $("#fullBg").addClass("none");
    // var pageName = url
    var pageName=url.replace(/\./g,"/").replace(/(.*?)\?.*/,"$1");
    var params = opt?opt.params:{};
    var page = CONFIG.HtmlPath + pageName + ".html";
    var jsName = CONFIG.HtmlPath + pageName;
    require.async([page, jsName], function(html, js){
      html = "<div>" + html + "</div>";
      // 隐藏其他页面
      var pageContent = '<div class="dialog dialog-'+sizeSuffix+'"><div class="row"'+html+'</div></div>';
      var callbackParam = {"params" : params, "url":url, "jsModule" : js};
      $(".dialog-container").append(pageContent);
      if(js){
        js.init(callbackParam);
      }
      var okFn = function(){}
      if(opt&&opt.okFn){
        okFn = opt.okFn;
      }
      var closeFn = function(){};
      if(opt&&opt.closeFn){
        closeFn = opt.closeFn;
      }
      $(".dialog-container").unbind("close").bind('close',function(){
        closeFn();
      });
      showDialog($(".dialog-container"),okFn);
    });




  }
  //obj dialog节点对象，确定按钮触发事件
  var showDialog = function (obj, okFn) {
//  obj.css("margin-top","-"+obj.height()/2+"px");
//  obj.css("margin-left","-"+obj.width()/2+"px");
    obj.removeClass("none");
    obj.show();
    $("#fullBg").removeClass("none");
    var $handBtn = obj.find(".btn-diaolog-confirm");
    var $cancelBtn = obj.find(".btn-diaolog-cancle");
    $handBtn.click(function(){
      okFn();
    })
    $cancelBtn.click(function () {
      hideDialog(obj);
    });
    $(".closeDiv").click(function(){
      hideDialog(obj);
    })
  };
  var hideDialog = function () {
    var obj = $(".dialog-container");
    obj.hide();
    obj.trigger("close");
    obj.html("");
    $("#fullBg").addClass("none");
    dialogClear(obj);
  };
  //普通确认框
  var showConfirmDialog = function (title,con,okFn) {
    var obj = $("#confirmDialog");
    obj.find(".dialogTitle").html(title);
    obj.find(".dialogContent").html(con);
    obj.removeClass("none");
    $("#fullBg").removeClass("none");
    var $handBtn = obj.find(".dialogHandlerBtn");
    var $cancelBtn = obj.find(".dialogCancelBtn");
    var $closeBtn = obj.find(".closeDiv");
    $handBtn.click(function(){
      obj.addClass("none");
      $("#fullBg").addClass("none");
      okFn();
    })
    $cancelBtn.click(function () {
      hideDialog(obj);
    });
    $closeBtn.click(function () {
      hideDialog(obj);
    });
  };
  //清除输入框内容
  var dialogClear = function(obj){
    var inputs = obj.find("input[type=text],input[type=password]");
    for(var i = 0;i<inputs.length;i++){
      inputs[i].value = "";
    }
    obj.find("form .error").html("");
  };
  return {
    showDialog:showDialog,
    hideDialog:hideDialog,
    showConfirmDialog:showConfirmDialog,
    dialogClear:dialogClear,
    loadDialog:loadDialog
  };
});
