;define(function (require, exports, module) {
  'use strict';

  var base = require('base');

  var loadDialogSmall = function(url,opt){
    loadDialog(url,opt,"large");
  };
  var loadDialogLarge = function(url,opt){
    loadDialog(url,opt,"small");
  };
  var loadDialog = function(url,opt,sizeSuffix){
    if(!sizeSuffix){
      sizeSuffix = "";
    }
    var dialogs = $("#dialog-box");
    var  dc =$('<div class=""><div class="dialog-bg"></div><div class="dialog-content-box"></div></div>');
    dialogs.append(dc);

    dialogs.find(".dialog-bg").bind("touchstart", function() {
       return false;
    });


    // var pageName = url
    var pageName=url.replace(/\./g,"/").replace(/(.*?)\?.*/,"$1");
    var params = opt?opt.params:{};
    var page = CONFIG.HtmlPath + pageName + ".html";
    var jsName = CONFIG.HtmlPath + pageName;
    require.async([page, jsName], function(html, js){

      html = "<div>" + html + "</div>";
      // 隐藏其他页面
      var pageContent = $('<div class="dialog" ><div class="row"'+html+'</div></div>');
      if(sizeSuffix){
        pageContent.addClass('dialog-'+sizeSuffix);
      }

      dc.find(".dialog-content-box").html(pageContent);
      dialogs.append(dc);
      var callbackParam = {"params" : params, "url":url, "jsModule" : js};
      if(js){
        js.init(callbackParam,dc);
      }

      var dcb = dc.find(".dialog-content-box");
      // setTimeout(function(){
        // debugger
        dcb.css("top",(dc.height()-dcb.height())/2);
        dcb.css("left",(dc.width()-dcb.width())/2);
      // },1);

      var okFn = function(){};
      if(opt&&opt.okFn){
        okFn = opt.okFn;
      }
      var closeFn = function(){};
      if(opt&&opt.closeFn){
        closeFn = opt.closeFn;
      }
      dc.unbind("close").bind('close',function(){
        closeFn();
      });
      showDialog(dc,okFn);
    });




  };
  //obj dialog节点对象，确定按钮触发事件
  var showDialog = function (obj, okFn) {
    $("body").css("overflow","hidden");
    obj.removeClass("none");
    obj.show();
    // $("#fullBg").removeClass("none");
    var $handBtn = obj.find(".btn-dialog-confirm");
    var $cancelBtn = obj.find(".btn-diaolog-cancle");

    $handBtn.click(function(){
      okFn(obj);
    });
    $cancelBtn.click(function () {
      hideDialog(obj);
    });
    $(".closeDiv").click(function(){
      hideDialog(obj);
    });
  };
  var closeAllDialog=function(){
    $("#dialog-box").empty();
    $("body").css("overflow","");
  };
  var hideDialog = function () {
    var obj = $("#dialog-box").children();
    if(obj.length == 1 ){
      //最外层关闭
      $("body").css("overflow","");
    }
    obj = $(obj[obj.length-1]);
    obj.hide();
    obj.trigger("close");
    obj.remove();
  };
  //清除输入框内容
  return {
    hideDialog:hideDialog,
    closeAllDialog:closeAllDialog,
    loadDialog:loadDialog
  };
});
