;
define(function(require) {
	'use strict';

	var base = require("base");
	var android_base = require("android_base");
	var dev_base;
	var default_loader;
	if(android_base.init(base)) {
		dev_base = android_base;
	}

	var init = function() {
		initEvent();
	};
	var base = require("base");
	var onPageBeforeLoad = {},
		onPageAfterLoad = {};
	var initEvent = function() {

		window.onhashchange = function() {
			if(dev_base) {
				dev_base.locationChange(location.href);
			}
			var actualUrl = parseHash(location.hash);
			//    console.log("on hash change "+actualUrl);
			loadPage(actualUrl);
		}
		window.onload = function() {
				var actualUrl = parseHash(location.hash);
				//    console.log("on load "+actualUrl);
				loadPage(actualUrl);
			}
			// 拦截所有a标签的跳转事件，改变hash值，使用location.replace 跳转
			// $("a").on("click", function(event){
			// 	// 只有包含link类的a标签才需要拦截
			// 	if ($(this).hasClass("link")) {
			// 		event.preventDefault();
			// 		var url = $(this).attr("href");
			// 		changeHash(url);
			// 	}
			//
			// });
	}

	var route = function(url) {
		var actualUrl = parseHash(url);
		window.location.hash = url;
		// loadPage(actualUrl);
	}

	var changeHash = function(url, forceLoad) {
		if(!forceLoad)
			forceLoad = true;
		var pageName = url.substring(0, url.indexOf("."));
		var params = getQueryParams(url);
		if(forceLoad)
			params.forceLoad = forceLoad;
		base.saveData(pageName, JSON.stringify(params));
		var currentHash = window.location.hash;
		currentHash = currentHash.replace("#", "").replace(/\./g, "/");
		if(currentHash == pageName) {
			// 如果hash值没有变化，直接刷新页面
			loadPage(parseHash(currentHash));
		} else
			window.location.hash = pageName;
	}

	var parseHash = function(hash) {
		if(!hash) {
			hash = "";
		}
		var hash = hash.replace("#", "").replace(/(.*?)\?.*/, "$1");
		if(hash === "") {
			return undefined;
		}
		var url = hash.replace(/\./g, "/");
		// 获取参数
		// var params = base.getData(hash);
		// params = JSON.parse(params);
		// var url = hash.replace(/\./g,"/") + ".html" ;
		// if (params)
		// 	url += (getJsonObjLength(params) > 0 ? "?" : "");
		// for ( var key in params ) {
		// 	url += (key + "=" + params[key] + "&");
		// }
		// if (url.indexOf("?") != -1)
		// 	url = url.substring(0, url.length - 1);
		return url;
	}

	// ajax 加载页面跳转
	// ajax 加载页面跳转
	var loadPage = function(url) {
			if(!url) {
				if(default_loader && typeof(default_loader) == 'function') {
					default_loader();
				}
				return;
			}
			var pageName = url.replace(/(.+?)\?.*/, "$1");
			var page = CONFIG.HtmlPath + pageName + ".html";
			var jsName = CONFIG.HtmlPath + pageName;

			$(document).find("#loadingToast").removeClass("none");
			require.async([page, jsName], function(html, js) {
				$("div.page").hide();
				var pageContent = html;
				var callbackParam = {
					"url": url,
					"jsModule": js
				};
				$(".pages").empty();
				$(".pages").append(pageContent);
				$(".dialog-container").html("");
				$("#fullBg").addClass("none");
				if(onPageAfterLoad[pageName])
					onPageAfterLoad[pageName](callbackParam);
				if(js)
					js.init(callbackParam);
				var s = setTimeout('$(document).find("#loadingToast").addClass("none");', 1000);

			});
		}
		// 获取url参数
	var getQueryParams = function(url) {
		var params = {};
		if(url.indexOf("?") != -1) {
			var str = url.substring(url.indexOf("?") + 1, url.length);
			var strs = str.split("&");
			for(var i = 0; i < strs.length; i++) {
				params[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
			}
		}
		return params;
	}

	var onPageBeforeLoad = function(pageName, callback) {
		onPageBeforeLoad[pageName] = callback;
	}

	var onPageAfterLoad = function(pageName, callback) {
		onPageAfterLoad[pageName] = callback;
	}

	var getJsonObjLength = function(jsonObj) {
		var length = 0;
		for(var key in jsonObj)
			length++;
		return length;
	}

	var setDefaultLoader = function(ss) {
		default_loader = ss;
	}

	return {
		init: init,
		route: route,
		loadPage: loadPage,
		onPageBeforeLoad: onPageBeforeLoad,
		onPageAfterLoad: onPageAfterLoad,
		setDefaultLoader: setDefaultLoader
	};
});
