;define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var validator = require("validate");
  var constant  = require("constant");
  var formatDate=function(date, format) {
	//格式化日期输出
    if (!date) return;
    if (!format) format = "yyyy-MM-dd";
    switch(typeof date) {
      case "string":
      date = new Date(date.replace(/-/g, "/"));
      break;
      case "number":
      date = new Date(date);
      break;
    }
    if (!date instanceof Date) return;
    var dict = {
      "yyyy": date.getFullYear(),
      "M": date.getMonth() + 1,
      "d": date.getDate(),
      "H": date.getHours(),
      "m": date.getMinutes(),
      "s": date.getSeconds(),
      "MM": ("" + (date.getMonth() + 101)).substr(1),
      "dd": ("" + (date.getDate() + 100)).substr(1),
      "HH": ("" + (date.getHours() + 100)).substr(1),
      "mm": ("" + (date.getMinutes() + 100)).substr(1),
      "ss": ("" + (date.getSeconds() + 100)).substr(1)
    };
    return format.replace(/(yyyy|MM?|dd?|HH?|ss?|mm?)/g, function() {
      return dict[arguments[0]];
    });
  };
  //字符串转化日期
  var parseStringToDate = function(dateString){
  	var dt  = new Date();
        dt.setTime = 0 ;
        var numbers =  dateString.match(/\d+/g);
        var k ;
        for ( k in numbers){

            var v = parseInt(numbers[k],10);
            var idx = parseInt(k);
            switch(idx){
                case 0:
                    dt.setFullYear(v);
                    break;
                case 1:
                    dt.setMonth(v-1);
                    break;
                case 2:
                    dt.setDate(v);
                    break;
                case 3:
                    dt.setHours(v);
                    break;
                case 4:
                    dt.setMinutes(v);
                    break;
                case 5:
                    dt.setSeconds(v);
                    break;
                default:
                    break;
            }
        }
        return dt ;
  };
 	//根据时间返回显示的字串
  var getShowDate = function(dateString){
  	var dt = parseStringToDate(dateString);
  	var now = new Date();

  	var dis = now.getTime()/1000 - dt.getTime()/1000; //获取相差的秒数
  	if(dis<60){
  		return "刚刚";
  	}else if(dis>=60&&dis<60*60){
  		var minute = parseInt(dis/60);
  		return minute+"分钟前";
  	}else if(dis>=60*60&&dis<24*60*60){
  		var hour = parseInt(dis/60/60);
  		return hour+"小时前";
  	}else if(dis>=24*60*60&&dis<8760*60*60){
  		return parseInt(dis/24/60/60)+"天前";
  	}else{
  		return dt;
  	}
  };
  
  //获取当前年月日
  var getNowDate = function() {
  	var date = new Date();
		this.year = date.getFullYear();
		this.month = date.getMonth() + 1;
		this.date = date.getDate();
		var currentTime = this.year + "-" + this.month + "-" + this.date;
		return currentTime;
  };
  
  //获取当前年月日星期
  var getNowWeekDate = function() {
  	var date = new Date();
		this.year = date.getFullYear();
		this.month = date.getMonth() + 1;
		this.date = date.getDate();
		this.day = new Array("星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六")[date.getDay()];
		var currentTime = this.year + "年" + this.month + "月" + this.date + "日 " +  " " + this.day;
		return currentTime;
  };
  
  return {
    formatDate:formatDate,
    parseStringToDate:parseStringToDate,
    getShowDate:getShowDate,
    getNowDate:getNowDate,
    getNowWeekDate:getNowWeekDate
  };
});
