define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var myChart;
	var pageIndex = 1;
	var pageSize = 5;
	var isOpen;

	var init = function() {
		dom = $("#markTrack");
		isOpen = base.getData("isOpen");
		initEvent();
		inquireStudentMarkListTraceMMAccount(1);
	};

	var initEvent = function(){
		dom.on("click",".test_list",function(){
			// dom.find(".data").removeClass("none");
			// dom.find(".test_list").addClass("none");
			inquireStudentMarkListTraceMMAccount(pageIndex + 1);
			inquireStudentMarkListTraceMMAccount(pageIndex + 1);
		});

		dom.on("click", ".data", function(){
			var examId = $(this).attr("Id");
			var examUnitType = $(this).attr("examUnitType");
			var examProjectType = $(this).attr("examProjectType");
			if(examUnitType == 2){
				router.route("markManage.singleYes?examId=" + examId);
			}else{
				if(examProjectType == 1){
					router.route("markManage.manyProject?examId=" + examId);
				}else{
					router.route("markManage.singleNo?examId=" + examId);
				}
			}
		});
	}

	var inquireStudentMarkListTraceMMAccount = function(page){
		pageIndex = page;
		var briefCourseName;
		var courseName;
		if (base.getData("selectedId") != "多学科") {
			briefCourseName = base.getData("selectedId");
			courseName = base.getData("courseName");
			var classRank = [];
			var examDate = [];
			var examName = [];
			databind.submit({}, {
				action: "inquireStudentMarkListTraceMMAccount",
				data: {
					courseName:courseName,
					briefCourseName:briefCourseName,
					pageIndex:pageIndex,
					pageSize:pageSize,
				},
				success: function(data) {
					var html = juicer(dom.find("#test-set").html(), data);
					dom.find("#test").append(html);
					if (isOpen == "false") {
						dom.find(".layoutRight").remove();
						dom.find(".classesT").remove();
						dom.find(".layoutLeft").css("width","100%");
						dom.find(".layoutLeft").css("text-align","right");
						dom.find(".mark").css("margin-right","15px");
					}
					var j = 5;
					var minRank = 0;
					var maxRank = 9999999999;
					if(data.datas.length != 0 && pageIndex ==1){
						for(var i = data.datas.length-1;i >-1 && classRank.length<6; i--){
							if (isOpen == "false") {
								if(data.datas[i].mark != null){
									classRank.push(data.datas[i].mark);
									if (data.datas[i].mark > minRank) {
										minRank = parseInt(data.datas[i].mark);
									}
									if (data.datas[i].mark < maxRank) {
										maxRank = parseInt(data.datas[i].mark);
									}
									examDate.push(data.datas[i].examDateTime.substring(5,10));
									examName.push(data.datas[i].examName);
								}else {
									j++;
								}
							}else {
								if(data.datas[i].classNo != 0){
									classRank.push(data.datas[i].classNo);
									if (data.datas[i].classNo > minRank) {
										minRank = parseInt(data.datas[i].classNo);
									}
									if (data.datas[i].classNo < maxRank) {
										maxRank = parseInt(data.datas[i].classNo);
									}
									examDate.push(data.datas[i].examDateTime.substring(5,10));
									examName.push(data.datas[i].examName);
								}else {
									j++;
								}
							}
						}
						if (maxRank < 4 || maxRank ==4) {
							maxRank = 0;
						} else {
							for (var n = 1; n > 0; n++) {
								if(((maxRank + n)/4)%1 ===0){
									maxRank = maxRank - n;
									break;
								}
							}
						}
						if ((minRank/4)%1 === 0) {
							minRank = minRank + 4;
						} else {
							for (var n = 1; n > 0; n++) {
								if(((minRank - n)/4)%1 ===0){
									minRank = minRank + n;
									break;
								}
							}
						}
						myChart = initEcharts(examDate,maxRank,minRank,examName);
						echartData(classRank);
					}

					if (pageIndex < data.totalPageCount) {
						dom.find(".test_list").removeClass("none");
					}else {
						dom.find(".test_list").addClass("none");
					}
					if (data.datas.length == 0 && data.totalRecordCount ==0) {
						dom.find(".empty-view").removeClass("none");
						dom.find(".echartStyle").addClass("none");
						dom.find(".title").addClass("none");
					}
				}
			});
		}else {
			var classRank = [];
			var examDate = [];
			databind.submit({}, {
				action: "inquireStudentMarkListTraceMMAccount",
				data: {
					pageIndex:pageIndex,
					pageSize:pageSize,
				},
				success: function(data) {
					var html = juicer(dom.find("#test-set").html(), data);
					dom.find("#test").append(html);
					if (isOpen == "false") {
						dom.find(".layoutRight").remove();
						dom.find(".classesT").remove();
						dom.find(".layoutLeft").css("width","100%");
						dom.find(".layoutLeft").css("text-align","right");
						dom.find(".mark").css("margin-right","15px");
					}
					var j = 5;
					var minRank= 0;
					var maxRank = 9999999999;
					var examName = [];
					if(data.datas.length != 0 && pageIndex ==1){
						for(var i = data.datas.length-1;i >-1 && classRank.length<6; i--){
							if (isOpen == "false") {
								dom.find(".echartStyle").addClass("none");
							}else {
								if(data.datas[i].classNo != 0){
									classRank.push(data.datas[i].classNo);
									if (data.datas[i].classNo > minRank) {
										minRank = parseInt(data.datas[i].classNo);
									}
									if (data.datas[i].classNo < maxRank) {
										maxRank = parseInt(data.datas[i].classNo);
									}
									examDate.push(data.datas[i].examDateTime.substring(5,10));
									examName.push(data.datas[i].examName);
								}else {
									j++;
								}
							}
						}
						if (maxRank < 4 || maxRank ==4) {
							maxRank = 0;
						} else {
							for (var n = 1; n > 0; n++) {
								if(((maxRank + n)/4)%1 ===0){
									maxRank = maxRank - n;
									break;
								}
							}
						}
						if ((minRank/4)%1 === 0) {
							minRank = minRank + 4;
						} else {
							for (var n = 1; n > 0; n++) {
								if(((minRank - n)/4)%1 ===0){
									minRank = minRank + n;
									break;
								}
							}
						}
						myChart = initEcharts(examDate,maxRank,minRank,examName);
						echartData(classRank);
					}

					if (pageIndex < data.totalPageCount) {
						dom.find(".test_list").removeClass("none");
					}else {
						dom.find(".test_list").addClass("none");
					}
					if (data.datas.length == 0 && data.totalRecordCount ==0) {
						dom.find(".empty-view").removeClass("none");
						dom.find(".echartStyle").addClass("none");
						dom.find(".title").addClass("none");
					}
				}
			});
		}
	}

	var show = function(s) {
        var re= '';
        var length = s.length;
        for (var i = 0,j=1; i < length; i++,j++) {
            if (j&&j % 25 == 0) {
                re += '<br />';
            } else {
                re += s[i];
            }
        }
        return re;
    }

	var initEcharts = function(examDate,maxRank,minRank,examName) {
		// 基于准备好的dom，初始化echarts实例
		var myChart = echarts.init(document.getElementById('myecharts'));

		var option = {
			tooltip: {
				trigger: 'axis',
				position: [3,3],
				formatter: function(params) {
					var value = params[0].value;
					var temp = examName[params[0].dataIndex];
					temp = show(temp);
					return "<div style=''>"+temp+"<br/>"+"<div style='color:#FF864A;'>"+"班级排名:"+value+"</div>"+"</div>";
				}
			},
			legend: {},
			calculable : true,
			xAxis: {
				data: examDate,
				type: 'category',
				boundaryGap: false,
				axisLine: {onZero: false},
				// show: false,
			},
			yAxis: [{
				type: 'value',
			 	inverse:(isOpen == "false") ? false : true,
				axisLine:{show:false},
				splitLine:{show:true},
				axisTick:{show: false},
				axisLabel:{show: false},
				max:maxRank,
				min:minRank,
				interval:(minRank-maxRank)/4,
				splitNumber:4,
			},{
	        name: (isOpen == "false") ? '分数':'班级排名',
	        nameLocation: 'start',
	        nameTextStyle:{
	        fontSize:'13',
	        color:'#19B76F',
	        },
			type: 'value',
		 	inverse:true,
			axisLine:{show:false},
			splitLine:{show:true},
			axisTick:{show: false},
			axisLabel:{show: false}
			}]
		};
		// 使用刚指定的配置项和数据显示图表。
		myChart.setOption(option);
		return myChart;
	}

	var echartData = function(classRank) {
    myChart.setOption({
      series : [{
          name:(isOpen == "false") ? '分数':'班级排名',
          type:'line',
					color:'1BC376',
					label: {
                normal: {
                    show: true,
                    position: 'top'
                }
            },
					itemStyle: {
            normal: {
              //好，这里就是重头戏了，定义一个list，然后根据所以取得不同的值，这样就实现了，
              color: function(params) {
                // build a color map as your need.
                var colorList = [
                  '#1BC376','#1BC376','#1BC376','#1BC376','#1BC376'
                ];
                return colorList[params.dataIndex]
              },
            }
          },
					lineStyle: {
            normal: {
              color:'#1BC376'
              }
            },
          data:classRank
        }]
    });
  }

	return {
		init: init
	};
});
