// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var dom;
	var index = 1;
	var init = function() {
		dom = $("#container");
		router.init();
		initJuicer();
		loadData();
		initEvent();
	};
	
	
	var parseDateStr = function(str){
        var dt  = new Date();
        dt.setTime = 0 ;
        var numbers =  str.match(/\d+/g);
        var k ;
        for ( k in numbers){

            var v = parseInt(numbers[k],10);
            var idx = parseInt(k);
            switch(idx){
                case 0:
                    dt.setFullYear(v);
                    break;
                case 1:
                    dt.setMonth(v-1);
                    break;
                case 2:
                    dt.setDate(v);
                    break;
                case 3:
                    dt.setHours(v);
                    break;
                case 4:
                    dt.setMinutes(v);
                    break;
                case 5:
                    dt.setSeconds(v);
                    break;
            }

        }
        return dt ;
    }


	var initJuicer=function(){
		juicer.register("getPicUrl",function(fileUuid){
			return CONFIG.fsPath+"v1.0/viewPic.file?fileUuid="+fileUuid;
		});
		juicer.register("getDate",function(createDate){
			var dt =  parseDateStr(createDate);
			var now = new Date();
			var span =  now.getTime()/1000 - dt.getTime()/1000;
			if(span<3600){
				return parseInt(span/60)+"分钟前";
			}
			if(span<24*3600){
				return parseInt(span/3600)+"小时前";
			}
			if(span<7*24*3600){
				return parseInt(span/(24*3600))+"天前";
			}

			var mon = dt.getMonth()+1;
			if(mon<10){mon="0"+mon;}
			var date = dt.getDate();
			if(date<10){date="0"+date;}
			var hour = dt.getHours();
			if(hour<10){hour="0"+hour;}
			var min = dt.getMinutes();
			if(min<10){min="0"+min;}

			if(dt.getFullYear()!=now.getFullYear()){
				return dt.getFullYear()+"-"+mon+"-"+date+" "+hour+":"+min;
			}else{
				return mon+"-"+date+" "+hour+":"+min;
			}
		});
	};
	
	
	var initEvent = function() {
//		$(".list-search-area>*").on("click", function() {
//			router.route("collection.informationSearch");
//		});

		$("#go_more").on("click",function() {
			$("#_more").hide();
			$("#go_loading").show();
			index = index + 1;
			loadData();
		});
	};
	
	
	var loadData = function() {
		databind.submit({}, {
			action: "inquireMyMarkedArticleList",
			version: "v1.0",
			useCache: index==1,
			data: {
				"markType":"cms_article_collection",
				"pageIndex":index
			},
			success: function(data) {
				if(!data.datas||data.datas.length===0){
					if(data.pageIndex===1){
						dom.find(".main").html('<div class="noDataContent subheadStyle">暂无信息</div>');
					}
					return ;
				}

				var str = "";
				if(data.pageIndex==1){
					dom.find(".main").empty();
				}
				dom.find(".main").append(juicer($("#itemTmpl").html(),data));
				dom.find(".main img").each(function(idx,itm){
					// console.log(itm);
					 itm.onload=function(){
						 var t = $(this);
						 t.css("margin-top",(parseInt(t.parent().css("height"))-parseInt(t.css("height")))/2);
					 };
				});
				$("#go_loading").hide();
				var count = data.totalPageCount;
				if (articleIndex >= count) {
					$("go_more").hide();
				} else {
					$("go_more").show();
				}
			}
		});
		
	};
	return {
		init: init
	};
});