// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var docPreview = require("docPreview");
	var dom;
	var domDels;
	var fileUuids;
	var main;
	var index = 1;
	var likeNumber;
	var collectionNumber;
	var articleId;
	var siteId;
	
	var init = function() {
		if(base.getUrlParam("parameter")){
			articleId = base.getUrlParam("parameter");
		}else{
			articleId = base.getUrlParam("articleId");
		}
		domDels = $("#page-delete");
		dom = $("#page-detail-information");
		main = $("#main");
		$(".commentBtn").attr("href", "index.html#news.comment?articleId=" + articleId);
		router.init();
		getSiteId();
		inquireCmsFeedbackList();
		getLikeNumber();
		initEvent();
	};

	var getSiteId = function() {
			databind.submit([],{
				action:"inquireCurrentAccountInfo",
				version:"v1.0",
				success:function(ret){
					var dt = ret.datas[0];
					var domain=dt.domain;
					databind.submit([],{
						action:"inquireSiteIdByDomain",
						version:"v1.0",
						data:{
							type:2,
							domain:domain
						},
						success:function(data){
							//		  	$("#siteId").val(data.datas[0].siteId);
							siteId = data.datas[0].siteId;
							loadData(data.datas[0].siteId);
							if (base.getData("siteId") == undefined || base.getData("siteId") == null) {
								base.saveData("siteId", siteId);
							}
						}
					});
				}
			});

		// databind.submit({}, {
		// 	action: "inquireSiteListByAll",
		// 	version: "v1.0",
		// 	data: {
		// 		pageIndex: 1,
		// 		pageSize: 1
		// 	},
		// 	success: function(data) {
		// 		//		  	$("#siteId").val(data.datas[0].siteId);
		// 		siteId = data.datas[0].siteId;
		// 		loadData(data.datas[0].siteId);
		// 		if (base.getData("siteId") == undefined || base.getData("siteId") == null) {
		// 			base.saveData("siteId", siteId);
		// 		}
		// 	}
		// });
	}

	var initEvent = function() {
		$(".header").on("click",".backBtn",function(){
			base.back();
			return false;
		});
		
		dom.on("click", ".openFile", function() {
			var path = $(this).attr("path");
			if (!path) {
				return;
			}
			base.openUri("file://" + path);
		});

		//		$(".backBtn").on("click",function() {
		//			router.route("news.information");
		//		});

		//		$(".commentBtn").on("click",function() {
		//			router.route("news.comment?articleId="+base.getUrlParam("articleId"));
		//		});

		$("#go_more").on("click", function() {
			$("#go_more").hide();
			$("#go_loading").show();
			index = index + 1;
			inquireCmsFeedbackList();
		});

		$(".news-footer").on("click", "#no_like", function() {
			clickLike();
		});

		$(".news-footer").on("click", "#had_like", function() {
			clickNoLike();
		});

		$(".news-footer").on("click", "#no_collection", function() {
			clickCollection();
		});

		$(".news-footer").on("click", "#had_collection", function() {
			clickNoCollection();
		});

		$(".news-footer").on("click", ".footer_comment", function() {
			dialog.showDialog($(".dialog"));
		});

		$(".dialog_text").bind("input", function() {
			var resule = $(".dialog_text").val().replace(/(^\s*)|(\s*$)/g, "");
			if (resule.length == 0) {
				$("#okBtn").addClass("dialog_nookbtn");
				$("#okBtn").removeClass("dialog_okbtn");
				$("#okBtn").removeClass("comment_okbtn");
			}
			if (resule.length > 0) {
				$("#okBtn").addClass("dialog_okbtn");
				$("#okBtn").addClass("comment_okbtn");
				$("#okBtn").removeClass("dialog_nookbtn");
			}
		});

		$(".dialog_canclebtn").on("click", function() {
			dialog.hideDialog($(".dialog"));
			$(".dialog").hide();
			$(".dialog_text").val("");
			$("#okBtn").addClass("dialog_nookbtn");
			$("#okBtn").removeClass("comment_okbtn");
			$("#okBtn").removeClass("dialog_okbtn");
		});

		$(".dialog").on("click", ".comment_okbtn", function() {
			var content = $(".dialog_text").val();
			databind.submit({}, {
				action: "createArticleCommentAccount",
				version: "v1.0",
				data: {
					"content": content,
					"siteId": base.getData("siteId"),
					"pushFlag": 0,
					"articleId": articleId
				},
				success: function(data) {
					collectionNumber = collectionNumber + 1;
					$(".comment_number").html(collectionNumber + "评论");
					dialog.hideDialog($(".dialog"));
					$(".dialog").hide();
					$(".dialog_text").val("");
					$("#okBtn").addClass("dialog_nookbtn");
					$("#okBtn").removeClass("comment_okbtn");
					$("#okBtn").removeClass("dialog_okbtn");
				}
			});
		});

	};

	var inquireCmsFeedbackList = function() {
		databind.submit({}, {
			action: "inquireTargetMarkDetailEmpList",
			version: "v1.0",
			useCache: index == 1,
			data: {
				"targetId": articleId,
				"targetType": "cms_article_read",
				"pageIndex": index,
				"pageSize": 20
			},
			success: function(data) {
				$(".record").show();
				if (data.datas == "") {
					var str = "";
					str += "<div class='feedback-none'>暂无人阅读</div>";
					$(".feedback").html(str);
				} else {
					var str = "";
					if (data.pageIndex == 1) {
						dom.find(".feedback").empty();
					}
					for (var i = 0; i < data.datas.length; i++) {
						str += "<div class='read-all'>";
						if (data.datas[i].headerUuid) {
							str += "<img src='" + CONFIG.fsPath + "v1.0/viewPic.file?fileUuid=" + data.datas[i].headerUuid + "&size=150" + "' class='read-img'/>";
						} else {
							str += "<img src='res/png/touxiang.png' class='read-img'/>";
						}
						str += "<div>" + data.datas[i].name + "</div>";
						str += "<div class='clear'></div>";
						str += "</div>";
					}
					if(data.pageIndex==1){
						dom.find(".feedback").html(str);
					}else{
						dom.find(".feedback").append(str);
					}
					$("#go_loading").hide();
					var count = data.totalPageCount;
					if (index >= count) {
						$("#go_more").hide();
					} else {
						$("#go_more").show();
					}
				}
			}
		});
	}

	var clickLike = function() {
		databind.submit({}, {
			action: "updateMyMark",
			version: "v1.0",
			useCache: true,
			data: {
				"state": 1,
				"targetType": "cms_article_like",
				"targetId": articleId
			},
			success: function(data) {
				$("#had_like").show();
				$("#no_like").hide();
				//				likeNumber = likeNumber + 1;
				//				$("#like_number").html(likeNumber + "赞");
				getLikeNumber();
				$("#like_number").removeClass("footer_nolike_color");
				base.alert(1, "点赞成功");
			}
		});
	}

	var clickNoLike = function() {
		databind.submit({}, {
			action: "updateMyMark",
			version: "v1.0",
			useCache: true,
			data: {
				"state": 0,
				"targetType": "cms_article_like",
				"targetId": articleId
			},
			success: function(data) {
				$("#had_like").hide();
				$("#no_like").show();
				getLikeNumber();
				//				likeNumber = likeNumber - 1;
				//				$("#like_number").html(likeNumber + "赞");
				$("#like_number").addClass("footer_nolike_color");
				base.alert(1, "取消点赞");
			}
		});
	}

	var clickCollection = function() {
		databind.submit({}, {
			action: "updateMyMark",
			version: "v1.0",
			useCache: true,
			data: {
				"state": 1,
				"targetType": "cms_article_collection",
				"targetId": articleId
			},
			success: function(data) {
				$("#had_collection").show();
				$("#no_collection").hide();
				base.alert(1, "收藏成功");
			}
		});
	}

	var clickNoCollection = function() {
		databind.submit({}, {
			action: "updateMyMark",
			version: "v1.0",
			useCache: true,
			data: {
				"state": 0,
				"targetType": "cms_article_collection",
				"targetId": articleId
			},
			success: function(data) {
				$("#had_collection").hide();
				$("#no_collection").show();
				base.alert(1, "取消收藏");
			}
		});
	}

	var getLikeNumber = function() {
		databind.submit({}, {
			action: "inquireTargetMarkSaticis",
			version: "v1.0",
			useCache: true,
			data: {
				"targetType": "cms_article_like",
				"targetId": articleId
			},
			success: function(ret) {
				var dt = ret.datas[0];
				$("#like_number").html(dt.markCount + "赞");
			}
		});
	}

	var loadData = function(siteId) {
		databind.submit({}, {
			action: "inquireArticleDetailAccount",
			version: "v1.0",
			useCache: true,
			async: false,
			data: {
				"siteId": siteId,
				"articleId": articleId
			},
			success: function(data) {
				//判断推送是否删除 0 - 否、1 - 是
				if(data.datas[0].deleted === 1){
					domDels.removeClass("none");
					dom.addClass("none");
					$(document).find("body").attr("style","background-color:white;");
				}else{
					dom.removeClass("none");
					domDels.addClass("none");
					$(document).find("body").removeAttr("style");
					
					var str = "";
					var content = data.datas[0].content;
					content = content.replace(/＜/g, "<");
					content = content.replace(/＞/g, ">");
					content = content.replace(new RegExp("/fs/api/", "gm"), CONFIG.fsPath);
	
					str += "<div class='headline bixheadStyle'>" + data.datas[0].articleTitle + "</div>";
					str += "<div class='publishDetail promptStyle'><span>" + data.datas[0].authorName + "&nbsp;</span>发布于 <span>" + data.datas[0].createDate + "</span></div>";
					if (data.datas[0].picUrl != "") {
						str += "<div style='width:100%;text-align:center;'><img src='" + CONFIG.fsPath + "v1.0/viewPic.file?fileUuid=" + data.datas[0].picUrl + "&size=720' style='max-width:100%;padding-top:1rem;' /></div>";
					}
					str += "<div class='noticeContent contentStyle' style='border:none;'>" + content + "</div>";
					str += "</div>";
					var tmpDom = $(str);
	
					tmpDom.find("table").css("width", "").attr("width", "");
					tmpDom.find("img").css("max-width", "100%");
					tmpDom.find("*").css("position", "relative").css("z-index", "");
					tmpDom.css("max-width", "100%").css("overflow-x", "hidden");
					dom.find(".main").html(tmpDom);
					dom.find(".main .video-preview-block").each(function(idx, itm) {
						var t = $(itm);
						t.attr("id", "preview-temp-id" + new Date().getTime() + "-" + idx);
						docPreview.filePreview(4, {
							id: t.attr("id"),
							fileUuid: t.attr("fileUuid")
						});
					});
				}
			}
		});
		
		databind.submit({}, {
			action: "inquireArticleAttachments",
			version: "v1.0",
			useCache: true,
			data: {
				"articleId": articleId
			},
			success: function(data) {
				var str = "";
				var attachments = data.datas;
				if (attachments.length > 0) {
					str += "<div class='attachmentLabel subheadStyle'><div class='attachmentLogo'></div>附件</div>";
					for (var i = 0; i < attachments.length; i++) {
						attachments[i].fileSize = (attachments[i].fileSize / 1000 / 1024).toFixed(2);
						str += "<div class='attachmentList attachmentStyle'>";
						str += "<div class='attachment clearfix'>";
						str += "<a href='fileView/view.html?uuid="+attachments[i].fileUuid+"&fn="+attachments[i].fileName+"'  target='_blank' class='fileName'>" + attachments[i].fileName + "<span class='promptStyle'>(" + attachments[i].fileSize + "M)</span></a>";
//						var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + attachments[i].fileUuid);
						var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + attachments[i].fileUuid);
						if (path) {
							str += "<button class='blueButton readBtn openFile' path='" + path + "' fileUuid='" + attachments[i].fileUuid + "' filename='" + attachments[i].fileName + "'>查看</button></div>";
						} else {
							str += "<button class='blueButton attachmentButton' url='" + CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + attachments[i].fileUuid + "' fileUuid='" + attachments[i].fileUuid + "' filename='" + attachments[i].fileName + "'>下载</button></div>";
						}
					}
				}

				dom.find(".att").html(str);
				downloadFile();
			}
		});

//		databind.submit({}, {
//			action: "updateMyMark",
//			version: "v1.0",
//			useCache: true,
//			data: {
//				"state": 1,
//				"targetType": "cms_article_read",
//				"targetId": articleId
//			},
//			success: function(data) {}
//		});
//
//		databind.submit({}, {
//			action: "inquireMyMarkState",
//			version: "v1.0",
//			useCache: true,
//			data: {
//				"targetType": "cms_article_like",
//				"targetId": articleId
//			},
//			success: function(ret) {
//				var dt = ret.datas[0];
//				if (dt.markState == 1) {
//					$("#had_like").show();
//					$("#no_like").hide();
//					$("#like_number").removeClass("footer_like_color");
//				} else {
//					$("#had_like").hide();
//					$("#no_like").show();
//					$("#like_number").addClass("footer_like_color");
//				}
//			}
//		});
//
//		databind.submit({}, {
//			action: "inquireMyMarkState",
//			version: "v1.0",
//			useCache: true,
//			data: {
//				"targetType": "cms_article_collection",
//				"targetId": articleId
//			},
//			success: function(ret) {
//				var dt = ret.datas[0];
//				if (dt.markState == 1) {
//					$("#had_collection").show();
//					$("#no_collection").hide();
//				} else {
//					$("#had_collection").hide();
//					$("#no_collection").show();
//				}
//			}
//		});

//		databind.submit({}, {
//			action: "inquireArticleCommentListAccount",
//			version: "v1.0",
//			useCache: true,
//			data: {
//				"siteId": siteId,
//				"articleId": articleId
//			},
//			success: function(ret) {
//				if (!ret.datas || ret.datas.length === 0) {
//					collectionNumber = 0;
//					$(".comment_number").html(collectionNumber + "评论");
//					return;
//				} else {
//					collectionNumber = ret.totalRecordCount;
//					$(".comment_number").html(collectionNumber + "评论");
//					return;
//				}
//
//			}
//		});

		$("#main").on("click", "img", function() {
			fileUuids = [];

			var l = $(this).attr("src");
			
			if (l.indexOf("viewPic") == -1 && l.indexOf("downloadFile") == -1) {
				return false;
			}
			main.find("img").each(function(idx, itm) {
				var strs = [];
				$(itm).attr("picindex", idx);
				var url = itm.src;
				if (url.indexOf("viewPic") == -1 && url.indexOf("downloadFile") == -1) {
					return false;
				}
				var strs = url.split("=")
				fileUuids.push(strs[1]);
			});

			base.callGallery(fileUuids, $(this).attr("picindex"));

		});
	};

	var downloadFile = function() {
		dom.find(".attachmentButton").on("click", function() {
			var _t = $(this);
			var fileuuid = _t.attr("fileuuid");
			var filename = _t.attr("filename");
			var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid);
			console.log("path:" + path);
			if (path) {
				_t.off("click").on("click", function() {
					base.openUri("file://" + path);
				});
				_t.html("查看");
				return;
			}
			var opt = {
				url: CONFIG.fsPath + "v1.0/downloadFile.file?fileUuid=" + fileuuid,
				filename: filename
			};
			base.downloadFileToSDCard(opt);
		});
		$(document).on("download_complete", function(e, url_complete) {
			console.log("download_complete:" + url_complete);
			dom.find(".attachmentButton").each(function(idx, itm) {
				var _t = $(itm);
				var url = $(itm).attr("url");
				if (!url || url != url_complete) {
					return;
				}
				var path = base.inquireDownloadUrlPath(url);
				if (!path) {
					return;
				}
				_t.off("click").on("click", function() {
					base.openUri("file://" + path);
				});
				_t.html("查看");
				_t.removeAttr("url");
			});
		});
		$(document).on("download_progress", function(e, data) {
			var url_complete = data.url;
			var percent = data.percent;
			dom.find(".attachmentButton").each(function(idx, itm) {
				var _t = $(itm);
				var url = $(itm).attr("url");
				if (!url || url != url_complete) {
					return;
				}
				_t.html(percent + "%");
				//                              if(percent == 100) {
				//                                  _t.html("查看");
				//                              }
			});
		});
	}
	return {
		init: init
	};
});
