// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var dom;
	var pictureIndex = 1;
	var articleIndex = 1;
	var index = 1;
	var siteId;
	var init = function() {
		dom = $("#page-information-list");
		getSiteId();
		router.init();
		initJuicer();
		initEvent();
	};

	var getSiteId = function(){
		databind.submit([],{
			action:"inquireCurrentAccountInfo",
			version:"v1.0",
			success:function(ret){
				var dt = ret.datas[0];
				var domain=dt.domain;
				databind.submit([],{
					action:"inquireSiteIdByDomain",
					version:"v1.0",
					data:{
						type:2,
						domain:domain
					},
					success:function(data){
						base.saveData("siteId",data.datas[0].siteId);
						loadForum(data.datas[0].siteId);
					}
				});
			}
		});

	};


	var parseDateStr = function(str){
		var dt  = new Date();
		dt.setTime = 0 ;
		var numbers =  str.match(/\d+/g);
		var k ;
		for ( k in numbers){

			var v = parseInt(numbers[k],10);
			var idx = parseInt(k);
			switch(idx){
				case 0:
				dt.setFullYear(v);
				break;
				case 1:
				dt.setMonth(v-1);
				break;
				case 2:
				dt.setDate(v);
				break;
				case 3:
				dt.setHours(v);
				break;
				case 4:
				dt.setMinutes(v);
				break;
				case 5:
				dt.setSeconds(v);
				break;
			}

		}
		return dt ;
	}


	var initJuicer=function(){
		juicer.register("getPicUrl",function(fileUuid){
			return CONFIG.fsPath+"v1.0/viewPic.file?fileUuid="+fileUuid+"&size=360";
		});
		juicer.register("getDate",function(createDate){
			var dt =  parseDateStr(createDate);
			var now = new Date();
			var span =  now.getTime()/1000 - dt.getTime()/1000;
			if(span<3600){
				return parseInt(span/60)+"分钟前";
			}
			if(span<24*3600){
				return parseInt(span/3600)+"小时前";
			}
			if(span<7*24*3600){
				return parseInt(span/(24*3600))+"天前";
			}

			var mon = dt.getMonth()+1;
			if(mon<10){mon="0"+mon;}
			var date = dt.getDate();
			if(date<10){date="0"+date;}
			var hour = dt.getHours();
			if(hour<10){hour="0"+hour;}
			var min = dt.getMinutes();
			if(min<10){min="0"+min;}

			if(dt.getFullYear()!=now.getFullYear()){
				return dt.getFullYear()+"-"+mon+"-"+date+" "+hour+":"+min;
			}else{
				return mon+"-"+date+" "+hour+":"+min;
			}
		});
		
	};


	var loadForum = function(siteId){
		databind.submit({},{
			action:"inquireForumList",
			version:"v1.0",
			useCache: 1,
			data:{
				siteId:siteId,
				forumId:0,
				pageIndex:1
			},
			success:function(data){
				var dt =data.datas;
				var str = "";
				var con_str="";
				if(data.pageIndex==1){
					dom.find("#news_title").empty();
				}
				for (var i = 0; i < data.datas.length; i++) {
					if (i == 0) {
						str += "<div class='swiper-slide swiper-slide-visible active-nav'>"+data.datas[i].title+"</div>";
						con_str += "<div class='swiper-slide blue-slide swiper-slide-prev'>";
						con_str +=	"<div id='"+data.datas[i].forumId+"'></div></div>";
						//					con_str +=	"<div class='more' id='go_more' style='display: none;' code='"+data.datas[i].code+"'>加载更多</div>";
						//					con_str +=	"<div class='more' id='go_loading' style='display: none;'>加载中....</div></div>";
						var index = 1;
						getNewsList(data.datas[i].forumId,index,siteId);
					} else {
						str += "<div class='swiper-slide swiper-slide-visible'>"+data.datas[i].title+"</div>";
						con_str += "<div class='swiper-slide blue-slide'>";
						con_str +=	"<div id='"+data.datas[i].forumId+"'></div></div>";
						//					con_str +=	"<div class='more' id='go_more' style='display: none;' code='"+data.datas[i].code+"'>加载更多</div>";
						//					con_str +=	"<div class='more' id='go_loading' style='display: none;'>加载中....</div></div>";
						var aindex = 1;
						getNewsList(data.datas[i].forumId,aindex,siteId);
					}
				}
				dom.find("#news_title").html(str);
				dom.find("#news_content").html(con_str);


				var mySwiper2 = new Swiper('#swiper-container2', {
					watchSlidesProgress: true,
					watchSlidesVisibility: true,
					slidesPerView: 4,
					onTap: function() {
						mySwiper3.slideTo(mySwiper2.clickedIndex)
					}
				})
				var mySwiper3 = new Swiper('#swiper-container3', {
					onSlideChangeStart: function() {
						updateNavPosition()
					}
				})

				function updateNavPosition() {
					$('#swiper-container2 .active-nav').removeClass('active-nav')
					var activeNav = $('#swiper-container2 .swiper-slide').eq(mySwiper3.activeIndex).addClass('active-nav');
					if (!activeNav.hasClass('swiper-slide-visible')) {
						console.log(1);
						if (activeNav.index() > mySwiper2.activeIndex) {
							console.log(2);
							var thumbsPerNav = Math.floor(mySwiper2.width / activeNav.width()) - 1
							mySwiper2.slideTo(activeNav.index() - thumbsPerNav)
						} else {
							console.log(3);
							mySwiper2.slideTo(activeNav.index())
						}
					}
				}
			}
		});
	}

	var initEvent = function() {
		
		$(".header").on("click",".backBtn",function(){
			base.back();
			return false;
		});
		//列表点击
		$(".container").on("click", ".listItem", function() {
			router.route("news.detail-information?articleId=" + $(this).attr("articleId"));
		});

		//		$(".backBtn").on("touchend",function() {
		//			base.close();
		//		});

		$("#news_content").on("click",".go_more",function() {
			var id = $(this).parent().attr("id");
			var old_index = parseInt($(this).attr("index"));
			var now_index = old_index + 1;
			$(this).html("加载中...");
			$(this).removeClass("go_more");
			//			console.log($(this).parent().find("#go_loading").attr("id"));
			//			$(this).parent().find("#go_loading").show();
			//			pictureIndex = pictureIndex + 1;

			getNewsList(id,now_index,base.getData("siteId"));
		});

		$("#article_go_more").on("click",function() {
			$("#article_go_more").hide();
			$("#article_go_loading").show();
			articleIndex = articleIndex + 1;
			getArticleList();
		});


	};

	//	window._android_on_back_pressed = function(){
	//		base.close();
	//	}

	var getNewsList = function(forumId,pageIndex,siteId){
		databind.submit({}, {
			action: "inquireArticleListByCondition",
			version: "v1.0",
			useCache: pageIndex==1,
			data: {
				"siteId":siteId,
				"forumId": forumId,
				"pageIndex":pageIndex,
				"pageSize":20
			},
			success: function(data) {
				if(!data.datas||data.datas.length===0){
					if(data.pageIndex===1){
						dom.find("#"+forumId).html('<div class="noDataContent subheadStyle">暂无信息</div>');
					}
					return ;
				}
				
//				var dt = data.datas;
//				for(var i in dt){
//					dt[i].basepath = CONFIG.BasePath;
//				}
//				
				var str = "";
				if(data.pageIndex==1){
					dom.find("#"+forumId).empty();
				}
				dom.find("#"+forumId).append(juicer($("#itemTmpl").html(),data));
				var forDom = $("#"+forumId);
				forDom.find("img").each(function(idx,itm){
					// console.log(itm);
					itm.onload=function(){
						var t = $(this);
						t.css("margin-top",(parseInt(t.parent().css("height"))-parseInt(t.css("height")))/2);
					};
				});
				forDom.find(".more").remove();
				var more_str = "";
				more_str +=	"<div class='more go_more' index='"+data.pageIndex+"'>加载更多</div>";
				//				more_str +=	"<div class='more' id='go_loading' style='display: none;'>加载中....</div>";

				var count = data.totalPageCount;
				if (pageIndex >= count) {
					//					$("#go_more").hide();
				} else {
					forDom.append(more_str);
					//					$("#go_more").show();
				}
			}
		});
	}


	var getArticleList = function() {
		databind.submit({}, {
			action: "inquireArticleListByCondition",
			version: "v1.0",
			useCache: articleIndex==1,
			data: {
				"siteId":1,
				"forumId": 2,
				"pageIndex":articleIndex
			},
			success: function(data) {
				if(!data.datas||data.datas.length===0){
					if(data.pageIndex===1){
						dom.find("#list-article").html('<div class="noDataContent subheadStyle">暂无信息</div>');
					}
					return ;
				}

				var str = "";
				if(data.pageIndex==1){
					dom.find("#list-article").empty();
				}
				dom.find("#list-article").append(juicer($("#itemTmpl").html(),data));
				dom.find("#list-article img").each(function(idx,itm){
					// console.log(itm);
					itm.onload=function(){
						var t = $(this);
						t.css("margin-top",(parseInt(t.parent().css("height"))-parseInt(t.css("height")))/2);
					};
				});
				$("#go_loading").hide();
				var count = data.totalPageCount;
				if (articleIndex >= count) {
					$("#go_more").hide();
				} else {
					$("#go_more").show();
				}
			}
		});

	};
	return {
		init: init
	};
});
