define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var timeFormat = require("timeFormat");
	var dom;
	var className;
	var classId;
	var teacherType;

	var init = function() {
		classId=base.getUrlParam("classId");
		dom = $("#abnormal-attendance");
		$("body").removeClass("overflowHidden");
		$("body").removeClass("noScoll");
		router.init();
		dom.find("input[name=punch-card-date]").val(getNowDate()+" "+"(今天)");
		loadData();

		setInterval(function() {
			getNTime();
		}, 1000);

		dom.find("input[name=punch-card-date]").val(getNowDate()+"(今天)");

		initEvent();
		className=base.getUrlParam("className");

		teacherType="1";
		if(teacherType=="1"){
			dom.find(".mySelectRadio").hide();
		}

		$('#semesterVal').mobiscroll().select({
		    lang: 'zh',
			display: 'bottom',
        	minWidth: 200,
    	});
	};

	var initEvent = function() {
		//重新绑定实体按键返回事件
		window._android_on_back_pressed = function() {
			back();
			return false;
		};
		//学期选择
		dom.find(".semesterBtn").on("click", function() {
			dom.find("#semesterVal_dummy").trigger("click");
		});

		dom.find(".contentItem").on("click", function() {
			var classDateTimeNoWeek = $(this).attr("classDateTimeNoWeek");
			base.saveData("classDateTime", classDateTimeNoWeek);
			router.route("#parent.student-attendance-detail");
		});
	}

	var loadData = function() {
		inquireSchoolSemesterListTenant();
	};

	var inquireSchoolSemesterListTenant = function() {
		databind.submit([], {
			action: "inquireSchoolSemesterListTenant",
			version: "v1.0",
			data: {},
			success: function(data) {
				if(data.datas) {
					for(var i = 0; i < data.datas.length; i++) {
						if(data.datas[i].currentFlag == 1) {
							if(data.datas[i].semesterType == 1) {
								data.datas[i].schoolYear = data.datas[i].schoolYear + "上学期（本学期）";
							} else {
								data.datas[i].schoolYear = data.datas[i].schoolYear + "下学期（本学期）";
							}
							dom.find(".semesterText").text(data.datas[i].schoolYear);
							inquireStudentAttendanceListBySemCodeSAAccount(data.datas[i].semesterCode);
                            inquireParentStudentSectionStatisticsDetailSATenant(data.datas[i].startDate, data.datas[i].endDate);
						} else {
							if(data.datas[i].semesterType == 1 && data.datas[i].currentFlag != 1) {
								data.datas[i].schoolYear = data.datas[i].schoolYear + " " + "上学期";
							} else {
								data.datas[i].schoolYear = data.datas[i].schoolYear + " " + "下学期";
							}
						}
					}
				}

				var html = juicer($("#semesterListTpl").html(), data);
				dom.find(".semesterSelect").append(html);
				$('#semesterVal').mobiscroll().select({
						theme: 'ios',
				    lang: 'zh',
						display: 'bottom',
		        minWidth: 200,
			    	onSet: function (event, inst) {
		        	 	dom.find(".semesterText").text(event.valueText);
		        	 	inquireStudentAttendanceListBySemCodeSAAccount(inst._wheelArray[0]);
		        	 	for(var j = 0; j < data.datas.length; j++) {
		        	 		if(data.datas[j].semesterCode == inst._wheelArray[0]){
                                inquireParentStudentSectionStatisticsDetailSATenant(data.datas[j].startDate, data.datas[j].endDate);
		        	 		}
		        	 	}
		        	 	console.log(inst._wheelArray[0]);
        			}
		    	});
			}
		});
	};

	var inquireStudentAttendanceListBySemCodeSAAccount = function(semesterCode) {
		databind.submit([], {
			action: "inquireStudentAttendanceListBySemCodeSAAccount",
			version: "v1.0",
			data: {
				semesterCode: semesterCode
			},
			success: function(data) {
				dom.find(".attendance-day").empty();
				var html = juicer(dom.find("#doneListTpl").html(), data);
				dom.find(".attendance-day").append(html);
				
				dom.find(".itemBottom").each(function() {
					$(this).find(".sign:last").addClass("none");
				});
				
				initEvent();
			},
			fail: function(error) {
				base.alert(3, "请求失败,请检查网络连接");
			}
		});
	};

	//现在时间
	var getNTime = function() {
		var nowDate = new Date();
		var nH = nowDate.getHours();
		var nM = nowDate.getMinutes();
		var nS = nowDate.getSeconds();
		if(nH < 10) {
			nH = "0" + nH;
		}
		if(nM < 10) {
			nM = "0" + nM;
		}

		if(nS < 10) {
			nS = "0" + nS;
		}
		var nD = nH + ":" + nM + ":" + nS;
		dom.find(".now-date").removeClass("none");
		dom.find("#now-date ").text(nD);
	}

	var getNowDate = function() {
		var date = new Date();
		var month = date.getMonth() + 1;
		var year = date.getFullYear();
		var day = date.getDate();
		if(month < 10) {
			month = "0" + month;
		}
		if(day < 10) {
			day = "0" + day;
		}
		var nowDate = year + "-" + month + "-" + day+"";
		return nowDate;
	}
	
	var inquireParentStudentSectionStatisticsDetailSATenant  = function(startTime, endTime){
		if(startTime == null || startTime == undefined){
			startTime = getNowDate();
		}
		if(endTime == null || endTime == undefined || endTime > getNowDate()){
			endTime = getNowDate();
		}
		if(startTime > getNowDate()){
			dom.find(".common-item-list").addClass("none");
			dom.find(".noExceptionAttendance").removeClass("none");
			return false;
		}
		
		databind.submit({}, {
			action: "inquireParentStudentSectionStatisticsDetailSATenant",
			version: "v1.0",
			data: {
				isParent:1,
				searchClassId: classId,
				searchStartDate: startTime,
				searchEndDate: endTime
			},
			success: function(data) {
				var studentSectionStatisticsList = data.datas[0].studentSectionStatisticsList;
				var statisticsData = getPeriodDayStatisticsData(data);
				loadOverview(dom.find(".attendance-total"),statisticsData);
				if(studentSectionStatisticsList.length > 0){
					dom.find(".common-item-list").removeClass("none");
					dom.find(".noExceptionAttendance").addClass("none");
				}else{
					dom.find(".common-item-list").addClass("none");
					dom.find(".noExceptionAttendance").removeClass("none");
				}
    			
			}
		});
	};
	
	var getPeriodDayStatisticsData = function (data) {
    	var statisticsData = {
      		absenteeismCount: 0, // 旷课
      		earlyLeaveCount: 0, //早退
      		illInClassCount: 0, //带病出勤
      		lateCount: 0, //迟到
      		leaveCount: 0, //请假
   		 };
    	for (var i = 0; i < data.datas[0].studentSectionStatisticsList.length; i++) {
      		var obj = data.datas[0].studentSectionStatisticsList[i];
      		statisticsData.absenteeismCount += obj.absenteeismCount;
      		statisticsData.earlyLeaveCount += obj.earlyLeaveCount;
      		statisticsData.illInClassCount += obj.illInClassCount;
      		statisticsData.lateCount += obj.lateCount;
      		statisticsData.leaveCount += obj.leaveCount;
   	 	}
//  	statisticsData.abnormalCount = statisticsData.absenteeismCount + statisticsData.earlyLeaveCount + statisticsData.illInClassCount + statisticsData.lateCount + statisticsData.leaveCount;
    	statisticsData.totalSection = data.datas[0].totalSection;
    	
    	if(statisticsData.totalSection == 0){
    		statisticsData.attendanceRate = 0;
    	}else{
    		statisticsData.attendanceRate = parseFloat((1 - (statisticsData.absenteeismCount + statisticsData.leaveCount) / statisticsData.totalSection)*100).toFixed(2);
    	}
    	return statisticsData;
  	};
  	
  	var loadOverview = function (overviewDom, statisticsData) {
    	var showData = {
      		attendanceRate: statisticsData.attendanceRate,
      		leaveAndAbsent: "",
      		lateAndEarlyAndIll: ""
    	};
		
		showData.leaveAndAbsent = "旷课" + statisticsData.absenteeismCount + "节课，";
//  	if (statisticsData.leaveCount) {
     	showData.leaveAndAbsent = showData.leaveAndAbsent + "请假" + statisticsData.leaveCount + "节课，";
// 		 }

//  	if (showData.leaveAndAbsent) {
      	showData.leaveAndAbsent = showData.leaveAndAbsent.slice(0,-1);
//  	}

//  	if (statisticsData.lateCount) {
      		showData.lateAndEarlyAndIll = "迟到" + statisticsData.lateCount + "节课，";
//  	}
//  	if (statisticsData.earlyLeaveCount) {
      		showData.lateAndEarlyAndIll = showData.lateAndEarlyAndIll + "早退" + statisticsData.earlyLeaveCount + "节课，";
//  	}
//  	if (statisticsData.illInClassCount) {
      		showData.lateAndEarlyAndIll = showData.lateAndEarlyAndIll + "带病出勤" + statisticsData.illInClassCount + "天，";
//  	}
//  	if (showData.lateAndEarlyAndIll) {
      		showData.lateAndEarlyAndIll = showData.lateAndEarlyAndIll.slice(0,-1);
//  	}

    	databind.fillForm(overviewDom,showData);
  	};
	
	var back = function() {
		var source = base.getUrlParam("source");
		if(source) {
			base.close();
			return false;
		}
		base.back();
		return false;
	}

	return {
		init: init
	};
});
