define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var android_base = require("android_base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var timeFormat = require("timeFormat");
	var dom;
	var itemArray = new Array();
	var describeText = "";
	var startDate, endDate;
	var leaveId;
	var mobiscrollOnShow = 0;
	var startDateMobiShow = 0;
	var endDateMobiShow = 0;

	var init = function() {
		dom = $("#create-leave");
		leaveId = base.getUrlParam("leaveId");
		router.init();
        initFunction();
		initEvent();
		dateEvent();
		loadMobiscroll();
		loadData();
	};
	
	var initEvent = function() {
		//重新绑定实体按键返回事件
		window._android_on_back_pressed = function() {
			if (mobiscrollOnShow == 1) {
				$('.commonType').mobiscroll('hide');
				return false;
			}
			
			if (startDateMobiShow == 1 || endDateMobiShow == 1) {
				if (startDateMobiShow == 1) {
					$('#startDate').mobiscroll('hide');
				}else{
					$('#endDate').mobiscroll('hide');
				}
				return false;
			}
			
			dialog.showDialog($("#alertDialog"));
			return false;
		};
		
		dom.find(".selectStudent").on("click", function() {
			base.callEmployeeSelector({ isCross: 0, subOrSup: "sub", showArea: 0, showGroup: 0,allowSelect:1 }, function(datas) {
				var data = datas[0];
				if(data) {
					dom.find("#studentName").text(data.name);
				}
			});
		});
		
		dom.find(".ifNotice").on("click", function() {
			dom.find(".ifNotice").removeClass("labelActive");
			$(this).addClass("labelActive");
			if($(this).text() == "病假") {
				dom.find(".symptomType").css("display", "block");
				dom.find(".describe").val("");
			} else {
				dom.find(".symptomType").css("display", "none");
				dom.find(".describe").val("");
			}
		});
		
		dom.find(".symptomType").on("click", function() {
			$('.commonType').mobiscroll('show');
			return false;
		});
		
		dom.find(".createBtn").on("click", function() {
			dialog.showDialog($("#submitDialog"));
			return false;
		});
		
		dom.find(".typeItem").on("click", function() {
			if($(this).hasClass("selectFont")) {
				$(this).removeClass("selectFont");
			} else {
				$(this).addClass("selectFont");
			}
		});
		
		dom.find(".backBtn").unbind().on("click", function() {
			dialog.showDialog($("#alertDialog"));
			return false;
		});
		
		dom.find(".dialog_ok_btn").unbind("click").on("click", function() {
			dialog.hideDialog($("#alertDialog"));
			startDate = "";
			endDate	= "";
			base.back();
            // window.location.replace("#parent.leave-record");
			return false;
		});
		
		dom.find(".dialog_cancel_btn").on("click", function() {
			dialog.hideDialog($("#alertDialog"));
			$("#alertDialog").hide();
		});
		
		dom.find(".dialog_submit_btn").on("click", function() {
			dialog.hideDialog($("#submitDialog"));
			$("#submitDialog").hide();
			
			if(leaveId) {
				updateLeaveSAAccount();
			} else {
				createLeaveSAAccount();
			}
		});
		
		dom.find(".dialog_close_btn").on("click", function() {
			dialog.hideDialog($("#submitDialog"));
			$("#submitDialog").hide();
		});
		
		$(".fullBg").on("click", function() {
			dialog.hideDialog($("#submitDialog"));
			$("#submitDialog").hide();
			dialog.hideDialog($("#alertDialog"));
			$("#alertDialog").hide();
		});

        // 附件上传按钮，调用原生附件上传
        dom.find("#add-img2").on("click", function() {
            base.selectImageFileAndCaptureImage(function(data) {
                showAttendanceList(data);
            },{"maxcount":"1", "isSelectFile": false});
        });
	};
	
	var createLeaveSAAccount = function() {
		var beginDateTime = dateFormat(dom.find("input[name='beginDateTime']").val());
		var endDateTime = dateFormat(dom.find("input[name='endDateTime']").val());
		if(beginDateTime == "" || endDateTime == "") {
			base.alert(2, "请先选择时间");
			return false;
		}
		
		if(beginDateTime > endDateTime || beginDateTime == endDateTime) {
			base.alert(2, "开始时间应小于结束时间");
			return false;
		}
		
		var leaveType = dom.find(".labelActive").attr("num");
		var leaveReason = dom.find("textarea[name=leaveReason]").val();
		if (leaveReason == "") {
			if (leaveType == 1) {
				base.alert(2, "请输入病症");
				return;
			}else{
				base.alert(2, "请输入请假事由");
				return;
			}
		}

        var attachments = [];
        dom.find(".fileName").each(function(index, domEle) {
            var item = {
                attachmentUuid: $(this).attr("fileUuid"),
                attachmentName: $(this).attr("fileName"),
                attachmentSize: $(this).attr("fileSize"),
                attachmentFormat: resolveSuffix($(this).attr("fileName")),
            };
            attachments.push(JSON.stringify(item));
        });
		
		databind.submit(dom, {
			action: "createLeaveParentSAAccount",
			version: "v1.0",
			data: {
				studentName : dom.find("span[name='studentName']").text(),
				days : dom.find("span[name='days']").text(),
				classNum : dom.find(".classSectionNum").text(),
				beginDateTime : beginDateTime + ":00",
				endDateTime : endDateTime + ":00",
				leaveType : leaveType,
				leaveReason: leaveReason,
                attachments: attachments,
			},
			success: function(data) {
				base.alert(1, "提交成功");
				startDate = "";
				endDate	= "";
                window.location.replace("#parent.leave-record");
				// base.back();
				return false;
			}
		});
	};
	
	var updateLeaveSAAccount = function() {
		var beginDateTime = dateFormat(dom.find("input[name='beginDateTime']").val());
		var endDateTime = dateFormat(dom.find("input[name='endDateTime']").val());
		if(beginDateTime == "" || endDateTime == "") {
			base.alert(2, "请先选择时间");
			return false;
		}
		
		if(beginDateTime > endDateTime || beginDateTime == endDateTime) {
			base.alert(2, "开始时间应小于结束时间");
			return false;
		}
		
		var leaveType = dom.find(".labelActive").attr("num");
		var leaveReason = dom.find("textarea[name=leaveReason]").val();
		if (leaveReason == "") {
			if (leaveType == 1) {
				base.alert(2, "请输入病症");
				return;
			}else{
				base.alert(2, "请输入请假事由");
				return;
			}
		}

        var attachments = [];
        dom.find(".fileName").each(function(index, domEle) {
            var item = {
                attachmentUuid: $(this).attr("fileUuid"),
                attachmentName: $(this).attr("fileName"),
                attachmentSize: $(this).attr("fileSize"),
                attachmentFormat: resolveSuffix($(this).attr("fileName")),
            };
            attachments.push(JSON.stringify(item));
        });
		
		databind.submit(dom, {
			action: "updateLeaveSAAccount",
			version: "v1.0",
			data: {
				leaveId : leaveId,
				studentName : dom.find("span[name='studentName']").text(),
				days : dom.find("span[name='days']").text(),
				classNum : dom.find(".classSectionNum").text(),
				beginDateTime : beginDateTime + ":00",
				endDateTime : endDateTime + ":00",
				leaveType : leaveType,
				leaveReason: leaveReason,
                attachments: attachments,
			},
			success: function(data) {
				base.alert(1, "编辑成功");
				startDate = "";
				endDate	= "";
                window.location.replace("#parent.leave-record");
				// base.back();
				return false;
			}
		});
	};
	
	var loadData = function() {
		if(leaveId != null) {
			inquireLeaveDetailSAAccount();
		}
		
		inquireStudentDetailParentSAAccount();
	};
	
	var inquireLeaveDetailSAAccount = function() {
		databind.submit([], {
			action: "inquireLeaveDetailSAAccount",
			version: "v1.0",
			data: {
				leaveId: leaveId
			},
			success: function(data) {
				var dt = data.datas[0];
				dt.beginDateTime = timeFormat.formatDate(dt.beginDateTime, "yyyy-MM-dd HH:mm");
				dt.endDateTime = timeFormat.formatDate(dt.endDateTime, "yyyy-MM-dd HH:mm");
				if(dt.leaveType == 2) {
					dom.find("label[num='1']").removeClass("labelActive");
					dom.find("label[num='2']").addClass("labelActive");
					dom.find(".symptomType").css("display", "none");
				}
				var attendanceAttachments = dt.attendanceAttachments;
				if (attendanceAttachments.length > 0) {
					var attendanceList = [];
                    attendanceAttachments.forEach(function (attendance) {
                        var every = {};
                        every.fileUuid = attendance.attachmentUuid;
                        every.fileName = attendance.attachmentName;
                        every.fileSize = attendance.attachmentSize;
                        attendanceList.push(every);
                    });
                    showAttendanceList({data: attendanceList});
				}
				databind.fillForm(dom, dt);
			}
		});
	}
	
	var inquireStudentDetailParentSAAccount = function() {
		databind.submit([], {
			action: "inquireStudentDetailParentSAAccount",
			version: "v1.0",
			data: {},
			success: function(data) {
				var dt = data.datas[0];
				databind.fillForm(dom, dt);
			}
		});		
	};
	
	var inquireLeaveDaysAndClassSectionNum = function(startDate, endDate) {
		if(startDate != undefined && endDate != undefined && startDate != "" && endDate != "") {
			if(startDate < endDate) {
				databind.submit([], {
					action: "inquireLeaveDaysAndClassSectionNum",
					version: "v1.0",
					data: {
						beginDateTime: startDate+":00",
						endDateTime: endDate+":00"
					},
					success: function(data) {
						dom.find(".dayCount").text(data.datas[0].days);
						dom.find(".classSectionNum").text(data.datas[0].classSectionNum);
					}
				});	
			}
		}
	};
	
	var dateEvent = function() {
		var now = new Date(),
        minDate = new Date(now.getFullYear() - 10, now.getMonth(), now.getDate()),
        maxDate = new Date(now.getFullYear() + 10, now.getMonth(), now.getDate());

	    $('#startDate').mobiscroll().datetime({
	        theme: 'ios',
	        lang: 'zh',
	        display: 'bottom',
	        min: minDate,
	        max: maxDate,
	        dateFormat: 'yyyy-mm-dd',
	        onSet: function (event, inst) {
	        	startDate = dateFormat(event.valueText);
	        	inquireLeaveDaysAndClassSectionNum(startDate, endDate);
        	},
	        onShow: function(event, inst){
				startDateMobiShow = 1;
			},
			onClose: function(event, inst){
				startDateMobiShow = 0;
			}
	    });
	    
	    $('#endDate').mobiscroll().datetime({
	        theme: 'ios',
	        lang: 'zh',
	        display: 'bottom',
	        min: minDate,
	        max: maxDate,
	        dateFormat: 'yyyy-mm-dd',
	        onSet: function (event, inst) {
	        	endDate = dateFormat(event.valueText);
	        	inquireLeaveDaysAndClassSectionNum(startDate, endDate);
        	},
        	onShow: function(event, inst){
				endDateMobiShow = 1;
			},
			onClose: function(event, inst){
				endDateMobiShow = 0;
			}
	    });
	};
	
	var dateFormat = function(date) {
		var reg = new RegExp("/", "g");
		var dateStr = date.replace(reg, "-");
		return dateStr;
	};
	
	var loadMobiscroll = function() {
		var describeText = "";
		$('.commonType').mobiscroll().widget({
			theme: 'ios',
	        lang: 'zh',
	        display: 'bottom',
	        anchor: $('#commonType'),
	        buttons: [{
	            text: '确定',
	            handler: 'set'
	        }, {
	            text: '取消',
	            handler: 'cancel'
	        }],
	        onMarkupReady: function (event, inst) {
	            dom.find(".typeItem").removeClass("selectFont");
	        },
	        onShow: function (event, inst) {
	        	var test = $(".typeItem");
	        	test.each(function(){
	        		$(this).removeClass("selectFont");
	        	});
	        	mobiscrollOnShow = 1;
	        },
	        onClose: function (event, inst) {
	            if(describeText) {
	            	dom.find(".describe").val(dom.find(".describe").val() + describeText.substring(0, describeText.length - 1));
	            }
	            
	            describeText = "";
	            dom.find(".typeItem").removeClass("selectFont");
	            mobiscrollOnShow = 0;
	            console.log("onClose");
	        },
	        onCancel: function (event, inst) {
	            $(".typeItem").removeClass("selectFont");
	            describeText = "";
	        },
	        onBeforeClose: function (event, inst) {
	            itemArray.length = 0;
	            $(".typeItem").each(function(index, element) {
	            	if($(element).hasClass("selectFont")) {
	            		itemArray.push($(element).text());
	            	}
	            });
	            if(dom.find(".describe").val() == "" && itemArray.length != 0) {
	            	for(var i = 0; i < itemArray.length; i++) {
	            		describeText = describeText + itemArray[i] + "，";
	            	}
	            } else if(dom.find(".describe").val() != "" && itemArray.length != 0) {
	            	describeText = "，";
	            	for(var i = 0; i < itemArray.length; i++) {
	            		describeText = describeText + itemArray[i] + "，";
	            	}
	            }
	        }
	    });
	}

    var initFunction = function() {
        juicer.register("fsPath", function() {
            return CONFIG.fsPath;
        });

        juicer.register("getcode", function(fileName) {
            return encodeURIComponent(fileName);
        });

        juicer.register("fileIcon", function(fileName) {
            var icon = "res/images/ficon/unknow_icon_16px.png";
            var ext = fileName.replace(/.*\.(\w+)/, "$1");
            if(!ext) {
                return icon;
            }
            ext = ext.toLowerCase();
            var extMap = {
                "apk": "apk_icon_16px",
                "xls": "excel_icon_16px",
                "csv": "excel_icon_16px",
                "xlsx": "excel_icon_16px",
                "ods": "excel_icon_16px",
                "ppt": "ppt_icon_16px",
                "pptx": "ppt_icon_16px",
                "odp": "ppt_icon_16px",
                "pdf": "pdf_icon_16px",
                "jpg": "pic_icon_16px",
                "png": "pic_icon_16px",
                "jpeg": "pic_icon_16px",
                "gif": "pic_icon_16px",
                "tif": "pic_icon_16px",
                "tiff": "pic_icon_16px",
                "psd": "ps_icon_16px",
                "txt": "txt_icon_16px",
                "mp4": "video_icon_16px",
                "avi": "video_icon_16px",
                "flv": "video_icon_16px",
                "rmvb": "video_icon_16px",
                "rm": "video_icon_16px",
                "3gp": "video_icon_16px",
                "mov": "video_icon_16px",
                "asf": "video_icon_16px",
                "wmv": "video_icon_16px",
                "mp3": "audio_icon_16px",
                "wav": "audio_icon_16px",
                "flac": "audio_icon_16px",
                "ape": "audio_icon_16px",
                "ogg": "audio_icon_16px",
                "doc": "word_icon_16px",
                "docx": "word_icon_16px",
                "odt": "word_icon_16px",
                "zip": "zip_icon_16px",
                "7z": "zip_icon_16px",
                "rar": "zip_icon_16px",
                "gz": "zip_icon_16px",
                "bz": "zip_icon_16px",
                "tar": "zip_icon_16px",
            };
            var pic = extMap[ext];
            if(pic) {
                icon = "res/images/ficon/" + pic + ".png";
            }

            return icon;
        });
    };

    var downloadFile = function() {
        // dom.find(".attachments").find(".fileName").each(function(idx, itm) {
        //     var _t = $(itm);
        //     var url = $(itm).attr("url");
        //     var path = base.inquireDownloadUrlPath(url);
        //     if(path) {
        //         _t.off("click").on("click", function() {
        //             base.openUri("file://" + path);
        //         });
        //         _t.removeAttr("url");
        //     } else {
        //         _t.on("click", function() {
        //             var _t = $(this);
        //             var fileuuid = _t.attr("fileuuid");
        //             var filename = _t.attr("filename");
        //             var path = base.inquireDownloadUrlPath(CONFIG.fsPath + "v1.0//downloadFile.file?fileUuid=" + fileuuid);
        //             if(path) {
        //                 _t.off("click").on("click", function() {
        //                     base.openUri("file://" + path);
        //                 });
        //                 return;
        //             }
        //             var opt = {
        //                 url: CONFIG.fsPath + "v1.0//downloadFile.file?fileUuid=" + fileuuid,
        //                 filename: filename
        //             };
        //             base.downloadFileToSDCard(opt);
        //         });
        //     }
        // });
        dom.find(".attachments .btn-del").on("click", function() {
            $(this).parents('.feedback_list_attachment').remove();
            if(dom.find(".attachment").length==0){
                dom.find(".attachments").hide();
                dom.find("#item-btn-attachAdd").removeClass("none");
            }
            event.cancelBubble = true; // 取消触发外层的点击事件
        });
    };

    var resolveSuffix = function(fileName){
        if (!fileName) {
            return '';
        }
        return fileName.substring(fileName.lastIndexOf('.') + 1);
    };

    var showAttendanceList = function (data) {
        var attacheshtml = juicer($('.atts').html(), data);
        dom.find(".attachments").append(attacheshtml);
        dom.find(".attachments").show();
        if (data.data.length > 0) {
            dom.find("#item-btn-attachAdd").addClass("none");
        }
        // 点击查看详情
        downloadFile();
    }

	return {
		init: init
	};
});
