define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var timeFormat = require("timeFormat");
	var dom;
	var i = 1;
	var classId, className;
	var isLeave; //0-无请假单 1-有请假单 
	var classDateTime;
	var isDialog = 0;

	var init = function() {
		dom = $("#student-attendance-detail");
		$("body").removeClass("overflowHidden");
//		$(".wrapper").removeClass("noScoll");
		$("body").removeClass("noScoll");
		classDateTime = base.getData("classDateTime");
		console.log(classDateTime);
		loadMobiscroll();
		
		router.init();
		initJuicer();
		initEvent();
		loadData();
	};

	var initJuicer = function() {
		juicer.register("fsPath", function() {
			return CONFIG.fsPath;
		});
		
		juicer.register("getDateFormat", function(date) {
			return timeFormat.formatDate(date, "yyyy-MM-dd HH:mm");
		});
	};
	
	var initEvent = function() {
		$(".backBtn").unbind();
		$(".backBtn").bind("click", function() {
			back();
			return false;
		});
		dom.find(".bottomContentItem").on("click", function() {
			$(this).next(".moreContent").toggle();
			var idx = $(this).attr("idx");
			openOneItem(idx);
			 
			if($(this).find(".pullImg").attr("src") == "./res/png/up_pull.png") {
				var attendanceId = $(this).attr("attendanceId");
				inquireAttendanceRecordListSAAccount($(this), attendanceId);
			}
		});
		
		dom.find(".dialog_cancel").on("click", function() {
			isDialog = 0;
			dialog.hideDialog($("#leaveDialog"));
			$("#leaveDialog").hide();
			$("body").removeClass("overflowHidden");
//			$(".wrapper").removeClass("noScoll");
			$("body").removeClass("noScoll");
		});
		
		dom.find(".dialog_ok_btn").on("click", function() {
			isDialog = 0;
			dialog.hideDialog($("#leaveDialog"));
			$("#leaveDialog").hide();
			$("body").removeClass("overflowHidden");
//			$(".wrapper").removeClass("noScoll");
			$("body").removeClass("noScoll");
		});
		
		dom.find(".createLeave").on("click", function() {
			router.route("#parent.create-leave");
		});
		
		dom.find(".inquireBtn").on("click", function() {
			isDialog = 1;
			dialog.showDialog($("#leaveDialog"));
//			$(".wrapper").addClass("noScoll");
			$("body").addClass("noScoll");
//			$("body").addClass("overflowHidden");
		});
		
		dom.find(".moreListBtn").on("click", function() {
			isDialog = 1;
			dialog.showDialog($("#moreDiv"));
//			$(".wrapper").addClass("noScoll");
			$("body").addClass("noScoll");
//			$("body").addClass("overflowHidden");
		});
		
		//请假记录点击
		dom.find(".leaveRecord").on("click", function() {
			router.route("#parent.leave-record");
		});

		//异常明细点击
		dom.find(".exceptionDetail").on("click", function() {
			router.route("#parent.abnormal-attendance");
		});
		
		$(".fullBg").on("click", function() {
			isDialog = 0;
			dialog.hideDialog($("#moreDiv"));
			$("#moreDiv").hide();
			dialog.hideDialog($("#leaveDialog"));
			$("#leaveDialog").hide();
			$("body").removeClass("overflowHidden");
			$("body").removeClass("noScoll");
//			$(".wrapper").removeClass("noScoll");
		});

		//重新绑定实体按键返回事件
		window._android_on_back_pressed = function() {
			if(isDialog == 1) {
				isDialog = 0;
				dialog.hideDialog($("#moreDiv"));
				$("#moreDiv").hide();
				dialog.hideDialog($("#leaveDialog"));
				$("#leaveDialog").hide();
				$('.headButton').mobiscroll('hide');
				$("body").removeClass("noScoll");
				$("body").removeClass("overflowHidden");
				return false;
			} else {
				back();
				return false;
			}
		};
	};
	
	var back = function() {
		var source = base.getUrlParam("source");
		if(source) {
			base.close();
			return false;
		}
		base.back();
		return false;
	}
	
	var openOneItem = function(idx) {
		dom.find(".bottomContentItem").each(function() {
			var current = $(this).attr("idx");
			if(current != idx) {
				$(this).next(".moreContent").css("display", "none");
			}
			
			if($(this).next(".moreContent").css("display") == "none") {
				$(this).find(".pullImg").attr("src", "./res/png/pull.png");
			} else {
				$(this).find(".pullImg").attr("src", "./res/png/up_pull.png");
			}
		});
	};
	
	var loadData = function() {
		inquireStudentLeaveListParentSAAccount();
		inquireStudentAttendanceDetailParentSAAccount();
	};
	
	var inquireStudentLeaveListParentSAAccount = function() {
		databind.submit([], {
			action: "inquireStudentLeaveListParentSAAccount",
			version: "v1.0",
			data: {
				classDateTime: classDateTime
			},
			success: function(data) {
				if(data.datas.length) {
					isLeave = 1;
					dom.find(".leaveCount").text(data.datas.length);
					var html = juicer(dom.find("#leaveDialogTpl").html(), data);
					dom.find(".dialog_center").html(html);
				} else {
					isLeave = 0;
				}
			},
			fail: function(error) {
				base.alert(3, "请求失败,请检查网络连接");
			}	
		});
	};
	
	var inquireStudentAttendanceDetailParentSAAccount = function() {
		databind.submit([], {
			action: "inquireStudentAttendanceDetailParentSAAccount",
			version: "v1.0",
			data: {
				classDateTime: classDateTime
			},
			success: function(data) {
				var html = juicer(dom.find("#detailTpl").html(), data);
				dom.find(".content").html(html);
				var html = juicer(dom.find("#listTpl").html(), data.datas[0]);
				dom.find(".bottomContent").html(html);
				if(classDateTime) {
					dom.find(".attendanceDate").text(getWeek(classDateTime));
				} else {
					dom.find(".attendanceDate").text(getWeek(new Date()));
				}
				
				if(isLeave && getWeek(classDateTime).split(" ")[1] != "星期六" && getWeek(classDateTime).split(" ")[1] != "星期日") {
					dom.find(".inquireBtn").removeClass("none");
				} else {
					dom.find(".inquireBtn").addClass("none");
				}
				
				if(getWeek(classDateTime).split(" ")[1] == "星期六" || getWeek(classDateTime).split(" ")[1] == "星期日"){
					dom.find(".bottomContent").addClass("none");
					dom.find(".headBottom").addClass("none");
					dom.find(".empty-content").removeClass("none");
				}else{
					dom.find(".bottomContent").removeClass("none");
					dom.find(".headBottom").removeClass("none");
					dom.find(".empty-content").addClass("none");
				}
				
				initEvent();
				initListCss();
			}
		});
	};
	
	var initListCss = function() {
		dom.find(".bottomContentItem").each(function(index, element) {
			if($(this).attr("nowsection") == "true") {
				$(this).children(".nowFont").removeClass("none");
				$(this).trigger("click");
			}
			
			if($(this).attr("classbegin") == "false") {
				$(this).children(".courseNum").css("color", "#E1E1E1");
				$(this).children(".state").css("color", "#E1E1E1");
				$(this).unbind("click");
			}
		});
	};
	
	var loadMobiscroll = function() {
		var max = new Date(getNowDate());
		
		$('.headButton').mobiscroll().calendar({
			theme: 'ios',
			lang: 'zh',
			display: 'center',
			dateFormat: "yy-mm-dd",
			max: max,
			onSet: function(event, inst) {
				var queryDay = event.valueText;
				classDateTime = timeFormat.formatDate(new Date(queryDay), "yyyy-MM-dd");
				loadData();
			},
			onShow: function(event, inst){
				isDialog = 1;
			},
			onClose: function(event, inst){
				isDialog = 0;
			}
		});
	};
	
	var inquireAttendanceRecordListSAAccount = function(className, attendanceId) {
		databind.submit([], {
			action: "inquireAttendanceRecordListSAAccount",
			version: "v1.0",
			data: {
				attendanceId: attendanceId
			},
			success: function(data) {
				if(data.datas.length) {
					var html = juicer(dom.find("#moreDetailTpl").html(), data);
					dom.find(className).next().html(html);
				} else {
					dom.find(className).next().text("暂无修改历史")
				}
			}
		});
	};
	
	var getWeek = function(date) {
		var dateText = new Date(date);
		var week = dateText.getDay();
		var weekStr = "";
		if(week == 0) {
			weekStr = "星期日";
		} else if(week == 1) {
			weekStr = "星期一";
		} else if(week == 2) {
		 	weekStr = "星期二";
		} else if(week == 3) {
		weekStr = "星期三";
		} else if(week == 4) {
			weekStr = "星期四";
		} else if(week == 5) {
			weekStr = "星期五";
		} else if(week == 6) {
			weekStr = "星期六";
		}
		
		return timeFormat.formatDate(dateText, "yyyy-MM-dd") + " " + weekStr;
	}
	
	//获取现在时间
	var getNowDate = function() {
		var date = new Date();
		var month = date.getMonth() + 1;
		var year = date.getFullYear();
		var day = date.getDate();
		if(month < 10) {
			month = "0" + month;
		}
		if(day < 10) {
			day = "0" + day;
		}

		var nowDate = year + "-" + month + "-" + day;
		return nowDate;
	}
	
	return {
		init: init
	};
});