// 主界面
;
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var readingUtil = require("readingUtil");
  var dom;
  var bookId;
  var bookName;
  var author;
  var ISBN;
  var pageIndex;

  var init = function() {
    dom = $("#book-active-detail");
    router.init();
    initEvent();
    initJuicer();
    loadData();
  };

  var initEvent = function() {
    bookId = base.getUrlParam("bookId");
    bookName = decodeURIComponent(base.getUrlParam("bookName"));
    ISBN = base.getUrlParam("ISBN");
    author = decodeURIComponent(base.getUrlParam("author"));
    pageIndex = 1;
    var reg = new RegExp( '&nbsp;' , "g" )
    author = author.replace( reg , ' ' );
    var dic = {};
    dic.bookName = bookName;
    dic.ISBN = ISBN;
    dic.author = author;
    var bookTpl = juicer(dom.find("#book-tpl").html(),dic);
    dom.find(".integralPersonal").before(bookTpl);

    dom.on("click", ".headToInfo", function(){
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      router.route("#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId);
    });

    dom.on("click", ".personal-rank", function(){
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      router.route("#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId);
    });

    //更多
    dom.on("click", ".more", function(){
      pageIndex++;

      inquireReadingActiveListGlobalMore();
    });
  };

  var initJuicer = function(){
    juicer.register("getReadingLevel", function (level) {
      return readingUtil.getReadingLevelDom(level);
    });

    juicer.register("schoolAndGradeIntegral", function(dt){
      return dt.schoolName+" "+dt.gradeName
    });

    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("index", function (idx) {
      if (pageIndex == 1){
        return parseInt(idx)+4;
      } else {
        return parseInt(idx)+1+(pageIndex-1)*20;
      }
    });
  };

  var loadData = function() {
    inquireReadingActiveListGlobal();
    inquireReadingStudentActiveRankAccount();
  };

  //查询书友活跃榜
  var inquireReadingActiveListGlobal = function(){
    var data = {
      bookId: bookId
    };
    showLoading();
    databind.submit([], {
      action: "inquireReadingActiveListGlobal",
      version: "v1.0",
      data: data,
      success:function(data){
        hideLoading();
        dom.find(".nodata").addClass("none");
        dom.find(".integralPersonal").addClass("none");
        dom.find(".personalLeft").addClass("none");
        dom.find(".personalMid").addClass("none");
        dom.find(".personalRight").addClass("none");
        var ret = data.datas;
        if (ret.length == 0) {
          dom.find(".nodata").removeClass("none");
        }
        for (var i = 0; i < ret.length; i++) {
          var dic = ret[i];
          if (i == 0) {
            dom.find(".integralPersonal").removeClass("none");
            var top1Dom = dom.find(".personalMid");
            top1Dom.removeClass("none");
            top1Dom.find(".name").html(dic.studentName);
            top1Dom.find(".personalTopHead").attr("studentId", dic.studentId);
            top1Dom.find(".personalTopHead").attr("schoolId", dic.schoolId);
            top1Dom.find(".school").html(dic.schoolName+" "+dic.gradeName);
            top1Dom.find(".integralPoint").html(dic.integral+"分");
            if (dic.photoUuid !== ""){
              top1Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }
          }else if (i == 1) {
            var top2Dom = dom.find(".personalLeft");
            top2Dom.removeClass("none");
            top2Dom.find(".name").html(dic.studentName);
            top2Dom.find(".personalHead").attr("studentId", dic.studentId);
            top2Dom.find(".personalHead").attr("schoolId", dic.schoolId);
            top2Dom.find(".school").html(dic.schoolName+" "+dic.gradeName);
            top2Dom.find(".integralPoint").html(dic.integral+"分");
            if (dic.photoUuid !== ""){
              top2Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }
          }else if (i == 2) {
            var top3Dom = dom.find(".personalRight");
            top3Dom.removeClass("none");
            top3Dom.find(".name").html(dic.studentName);
            top3Dom.find(".personalHead").attr("studentId", dic.studentId);
            top3Dom.find(".personalHead").attr("schoolId", dic.schoolId);
            top3Dom.find(".school").html(dic.schoolName+" "+dic.gradeName);
            top3Dom.find(".integralPoint").html(dic.integral+"分");
            if (dic.photoUuid !== ""){
              top3Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }
          }
        }
        data.datas = data.datas.slice(3, data.datas.length);
        var html = juicer(dom.find("#personal-rank-tpl").html(), data);
        dom.find(".rank-list-other").html(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

  var inquireReadingActiveListGlobalMore = function(){
    var data = {
      bookId: bookId,
      pageIndex: pageIndex
    };
    showLoading();
    databind.submit([], {
      action: "inquireReadingActiveListGlobal",
      version: "v1.0",
      data: data,
      success:function(data){
        hideLoading();
        dom.find(".more").remove();
        var html = juicer(dom.find("#personal-rank-tpl").html(), data);
        dom.find(".rank-list-other").append(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

  var inquireReadingStudentActiveRankAccount = function () {
    databind.submit([], {
      action: "inquireReadingStudentActiveRankAccount",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success:function(data){
        // data.datas[0].rank = "0";
        var html = juicer(dom.find("#my-rank-tpl").html(), data.datas[0]);
        dom.find(".myRank").html(html);
      }
    });
  };

  //转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

  return {
    init: init
  };
});
