// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var bookId;

  var init = function () {
    bookId = base.getUrlParam("bookId");
    dom = $("#book-introduction-detail");
    router.init();
    initEvent();
    loadData();
  };

  var initEvent = function () {

    //首次加载把头部弄成透明
    dom.find(".header").css("background-color", "transparent");
    $(window).scroll(function () {
      var scrollTop = Math.max(document.body.scrollTop || document.documentElement.scrollTop);
      if (scrollTop > 18) {
        dom.find(".header").css("background-color", "#25C75E");
      } else {
        dom.find(".header").css("background-color", "transparent");
      }
    });

  };

  var loadData = function () {
    inquireReadingStudentBookDetailAccount(bookId);
  };

  //查询书籍详情
  var inquireReadingStudentBookDetailAccount = function (bookId) {
    databind.submit([], {
      action: "inquireReadingBookDetailGlobal",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success: function (data) {
        dom.find(".header-title").html(data.datas[0].bookName);
        data.datas[0].wordsQty = (data.datas[0].wordsQty / 10000).toFixed(1);
        var gradeCodeArray = data.datas[0].gradeCode.split(",");
        if(gradeCodeArray.length>1){
          data.datas[0].gradeCode = gradeCodeArray[0] + "-" + gradeCodeArray[gradeCodeArray.length - 1];
        }else{
          data.datas[0].gradeCode = gradeCodeArray[0];
        }
        var html = juicer(dom.find("#book-introduction-detail-tpl").html(), data);
        dom.find(".book").html(html);
      }
    });
  };

  return {
    init: init
  };
});
