// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var recommendId;
	var recommendName;
	var recommendSource;
	var pageIndex;
	var bookIdList;
	var bookNameList;
	var ISBNList;

	var init = function() {
		dom = $("#book-recommend");
		router.init();
		initEvent();
		loadData();
	};

	var initEvent = function() {
	    dom.find(".onresume").bind("on-resume", function () {
	      loadData();
	    });

		bookIdList = base.getData("bookIdList");
		bookNameList = base.getData("bookNameList");
		ISBNList = base.getData("ISBNList");
		if (bookIdList !== undefined && bookIdList !== null && bookIdList.length > 0) {
			base.removeData("bookIdList");
			base.removeData("bookNameList");
			base.removeData("ISBNList");
			bookIdList = bookIdList.split(",");
			bookNameList = bookNameList.split(",");
			ISBNList = ISBNList.split(",");
		}else{
			bookIdList = [];
			bookNameList = [];
			ISBNList = [];
		}
		dom.find(".bookCount").html(bookIdList.length+"本");

		recommendId = base.getUrlParam("recommendId");
		recommendName = decodeURIComponent(base.getUrlParam("recommendName"));
		recommendSource = base.getUrlParam("recommendSource");
		dom.find(".header-title").html(recommendName);
		pageIndex = 1;

		dom.on("click", ".bookSelect", function(){
			if ($(this).attr("checked") == "checked") {
				$(this).attr("checked",false);
				var index = bookIdList.indexOf($(this).attr("bookId"));
				if (index > -1) {
				    bookIdList.splice(index, 1);
				    bookNameList.splice(index, 1);
				    ISBNList.splice(index, 1);
				}
				$(this).find(".bookSelectImg").attr("src","./res/newImages/unselected.png");
			}else{
				$(this).attr("checked",true);
				bookIdList.push($(this).attr("bookId"));
				bookNameList.push($(this).attr("bookName"));
				ISBNList.push($(this).attr("ISBN"));
				$(this).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
			}
			dom.find(".bookCount").html(bookIdList.length+"本");
		});

		//确定
		dom.on("click", ".selectBtn", function(){
			if (bookIdList.length == 0) {
				base.alert(2, "请选择书籍！");
				return;
			}
			base.saveData("bookIdList", bookIdList.join(","));
			base.saveData("bookNameList", bookNameList.join(","));
			base.saveData("ISBNList", ISBNList.join(","));
			router.route("#teacherPage.task-create?fromBookList=1");
		});

		//书籍详情
		dom.on("click", ".bookContent", function(){
			var bookId = $(this).attr("bookId");
			// router.route("#teacherPage.book-detail?bookId="+bookId);
			base.openUrl("index.html#studentPage.task-book-detail?bookId="+bookId, "YX_READING_STUDENT_APP");
		});

		//更多
		dom.on("click", ".more", function(){
			pageIndex++;
			if (recommendId == "0") {
				inquireReadingRecentBookListAccountMore();
			}else{
				inquireReadingRecommendBookListAccountMore();
			}
		});

		//全选
		dom.on("click", ".selectAll", function(){
			dom.find(".bookSelect").each(function(idx, itm){
				if ($(itm).attr("checked") !== "checked"){
					$(itm).attr("checked",true);
					$(itm).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
					bookIdList.push($(this).attr("bookId"));
					bookNameList.push($(this).attr("bookName"));
					ISBNList.push($(this).attr("ISBN"));
				}
			});
			dom.find(".bookCount").html(bookIdList.length+"本");
		});

		//选择书单
		dom.on("click", ".book-list-select", function(){
			dom.find('#book_list_select').mobiscroll('show');
		});
		//已选的书
		dom.on("click", ".selected", function(){
			if (bookIdList.length == 0) {
				base.alert(2, "请选择书籍！");
				return;
			}
			base.saveData("bookIdList", bookIdList.join(","));
			base.saveData("bookNameList", bookNameList.join(","));
			base.saveData("ISBNList", ISBNList.join(","));
			router.route("#teacherPage.selected-book?bookIdList="+bookIdList);
		});
		//加入书架
		dom.on("click", ".addButton", function(e){
			var bookId = $(this).parent().parent().attr("bookId");
			addToReadingBookrackAccount(bookId, $(this));
			e.stopPropagation();
		});
    dom.on("click", ".addTo", function(e){
      var bookId = $(this).parent().parent().attr("bookId");
      addToReadingBookrackAccount(bookId, $(this));
      e.stopPropagation();
    });
	};
	
	var loadData = function() {
		if (recommendId == "0") {
			dom.find(".header-title").html("新书上架");
			inquireReadingRecentBookListAccount();
		}else{
			inquireReadingRecommendBookListAccount();
			dom.find(".book-list-select").removeClass("none");
		}	
	};
	
	var inquireReadingRecommendBookListAccount = function(){
		databind.submit([], {
            action: "inquireReadingRecommendBookListAccount",
            version: "v1.0",
            data: {
                recommendId:recommendId
            },
            success:function(data){
            	// dom.find(".header-title").html(data.datas[0].recommendName);
            	dom.find(".book-list-name").html(data.datas[0].recommendName);
            	dom.find(".more").remove();
				var html = juicer(dom.find("#book-tpl").html(), data);
				dom.find(".bookSection").html(html);
				dom.find(".bookSelect").each(function(idx, itm){
					var index = bookIdList.indexOf($(itm).attr("bookId"));
					if (index > -1) {
					   	$(itm).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
					   	$(itm).attr("checked",true);
					}
				});
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}
				inquireReadingRecommendListTenant(data.datas[0].recommendName);
            }
        });
	}

	var inquireReadingRecommendBookListAccountMore = function(){
		var data = {};
		data.pageIndex = pageIndex;
		data.recommendId = recommendId;
		databind.submit([], {
			action: "inquireReadingRecommendBookListAccount",
			version: "v1.0",
			data: data,
			success:function(data){
				dom.find(".more").remove();
				var html = juicer(dom.find("#book-tpl").html(), data);
				dom.find(".bookSection").append(html);
				dom.find(".bookSelect").each(function(idx, itm){
					var index = bookIdList.indexOf($(itm).attr("bookId"));
					if (index > -1) {
					   	$(itm).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
					   	$(itm).attr("checked",true);
					}
				});
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}else{
					dom.find(".more").addClass("none");
				}
			}
		});
	};

	var inquireReadingRecentBookListAccount = function(){
		databind.submit([], {
            action: "inquireReadingRecentBookListAccount",
            version: "v1.0",
            data: {
            },
            success:function(data){
            	dom.find(".more").remove();
				var html = juicer(dom.find("#new-book-tpl").html(), data);
				dom.find(".bookSection").html(html);
				dom.find(".bookSelect").each(function(idx, itm){
					var index = bookIdList.indexOf($(itm).attr("bookId"));
					if (index > -1) {
					   	$(itm).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
					   	$(itm).attr("checked",true);
					}
				});
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}
            }
        });
	};

	var inquireReadingRecentBookListAccountMore = function(){
		var data = {};
		data.pageIndex = pageIndex;
		databind.submit([], {
            action: "inquireReadingRecentBookListAccount",
            version: "v1.0",
            data: data,
            success:function(data){
            	dom.find(".more").remove();
				var html = juicer(dom.find("#new-book-tpl").html(), data);
				dom.find(".bookSection").append(html);
				dom.find(".bookSelect").each(function(idx, itm){
					var index = bookIdList.indexOf($(itm).attr("bookId"));
					if (index > -1) {
					   	$(itm).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
					   	$(itm).attr("checked",true);
					}
				});
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}else{
					dom.find(".more").addClass("none");
				}
            }
        });
	};

	var inquireReadingRecommendListTenant = function(recommendName){
		databind.submit([], {
            action: "inquireReadingRecommendListBySourceTenant",
            version: "v1.0",
            data: {
            	recommendSource: recommendSource
            },
            success:function(data){
            	var html = juicer(dom.find("#book-list-tpl").html(), data);
            	dom.find("#book_list_select").html(html);
            	initBookListTreeList(data, recommendName, recommendName);
            }
        });
	}

	var initBookListTreeList = function(data, recommendName) {
		var datas = data.datas;
		var defaultValue = 0;
		for (var i = 0; i < datas.length; i++) {
			var dic = datas[i];
			if (dic.recommendName == recommendName) {
				defaultValue = i;
			}
		}
		$('#book_list_select').mobiscroll().treelist({
			theme: 'ios',
			mode: 'scroller',
			display: 'bottom',
			lang: 'zh',
			showInput: false,
			circular: false,
			defaultValue: [defaultValue],
			onSet: function(event, inst) {
				var tmpRecommendId = datas[event.valueText].recommendId;
				var recommendName = datas[event.valueText].recommendName;
				dom.find(".book-list-name").html(recommendName);
				recommendId = tmpRecommendId;
				inquireReadingRecommendBookListAccount();
			}
		});
	}

	var addToReadingBookrackAccount = function(bookId, dom){
    $(".loader").removeClass("none");
    $(".fullBg").removeClass("none");
		databind.submit([], {
			action: "addToReadingBookrackAccount",
			version: "v1.0",
			data: {
				bookId: bookId
			},
			success:function(data){
        $(".loader").addClass("none");
        $(".fullBg").addClass("none");
				base.alert(1, "加入成功！");
        		dom.parent().find(".addTo").addClass("none");
       		 	dom.parent().find(".exist").removeClass("none");
				dom.parent().find(".addToContent").html("已在书架");
			}
		});
	};

	return {
		init: init
	};
});
