// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var classId;
	var schoolId;

	var init = function() {
		dom = $("#class-info");
		router.init();
		initEvent();
    initJuicer();
		loadData();
	};

	var initEvent = function() {
    dom.find(".header").css("background-color", "transparent");
    classId = base.getUrlParam("classId");
		schoolId = base.getUrlParam("schoolId");
		dom.on("click", ".passBook", function(){
			// router.route("#teacherPage.pass-book");
			var classId = $(this).attr("classId");
			var schoolId = $(this).attr("schoolId");
			base.openUrl("index.html#studentPage.class-pass-book?classId="+classId+"&schoolId="+schoolId, "");
		});

    dom.on("click", ".moments", function(){
      var classId = $(this).attr("classId");
      if (classId !== "") {
        base.openUrl("index.html#studentPage.student-moments-count-list?classId="+classId+"&schoolId=" + schoolId, "");
      }
    });

    dom.on("click", ".diploma-detail", function () {
      var diplomaId = $(this).attr("diplomaId");
      var imgUuid = $(this).attr("imgUuid");
      base.openUrl("index.html#studentPage.diploma-detail?diplomaId=" + diplomaId + "&imgUuid=" + imgUuid, "");
    });
	};
	
	var loadData = function() {
		inquireReadingClassInfoGlobal();
	};
	
	var inquireReadingClassInfoGlobal = function(){
		databind.submit([], {
            action: "inquireReadingClassInfoGlobal",
            version: "v1.0",
            data: {
            	classId: classId,
            	schoolId: schoolId
            },
            success:function(data){
            	var ret =data.datas[0];
            	dom.find(".className").html(ret.className);
            	dom.find(".schoolNameContent").text(ret.schoolName);
            	dom.find(".passBookAvg").text(ret.passBookAvg);
            	dom.find(".readWordsAvg").text((ret.wordsAvg/10000).toFixed(1));
            	dom.find(".passRateAvg").text(ret.passRateAvg+"%");
            	dom.find(".passBookCountNum").text(ret.passBookCount);
            	dom.find(".passBook").attr("classId", ret.classId);
            	dom.find(".passBook").attr("schoolId", schoolId);
              dom.find(".momentsCountNum").text(ret.postCount);
              dom.find(".moments").attr("classId", ret.classId);
              dom.find(".moments").attr("schoolId", schoolId);

              if (ret.classId !== "") {
                inquireReadingDiplomaList(ret.classId, data.datas[0].className); //复用教师端的接口
              }
            }
        });
	};

  var inquireReadingDiplomaList = function (classId, className) {
    databind.submit([], {
      action: "inquireReadingDiplomaList",
      version: "v1.0",
      data: {
        classId: classId
      },
      success: function (data) {
        if (data.datas.length > 0) {
          dom.find(".diploma").removeClass("none");
          var diplomaList = data.datas[0].diplomaList;
          for (var i = 0; i < diplomaList.length; i++) {
            var dic = diplomaList[i];
            if (dic.diplomaType == 1) {
              dic.className = className;
            }
          }
          data.datas[0].diplomaList = diplomaList;
          data.datas[0].isMyClass = false;
          var html = juicer(dom.find("#diploma-tpl").html(), data);
          dom.find(".diplomaSection").html(html);

          //计算是否够一页，不足时用荣誉墙来撑开
          var residueHeight = $(window).height();
          residueHeight -= dom.find(".contentHeader").height();
          residueHeight -= dom.find(".readStat").height();
          residueHeight -= dom.find(".passBook").height();
          residueHeight -= dom.find(".moments").height();
          residueHeight -= dom.find(".readStatTitle").height();
          //17：过关书目margin-top   16：荣誉墙title margin-top  70：时间轴top 70px
          residueHeight -= (17 + 16 + 70);
          dom.find(".diplomaSection").css("min-height",residueHeight + "px");
        } else {
          dom.find(".diplomaSection").html("");
        }
      }
    });
  };

  var initJuicer = function () {
    juicer.register("formatDate", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      if (date.getMonth() == 0) {
        return (date.getFullYear() - 1) + "年12月";
      }
      return date.getFullYear()+"年"+(date.getMonth()+1)+"月";
    });

    juicer.register("getMonth", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      if (date.getMonth() == 0) {
        return 12;
      }
      return date.getMonth()+1;
    });

    juicer.register("continueDiploma", function (data) {
      var createDate = data.createDate;
      var diplomaList = data.diplomaList;
      var studentDiplomaCount = 0;
      for (var i=0; i<diplomaList.length; i++){
        var dic = diplomaList[i];
        if (dic.diplomaType == 2){
          studentDiplomaCount++;
        }
      }
      var formatDateString = createDate.replace(/-/g,"/");
      var date = new Date(formatDateString);
      var now = new Date();
      var lastMonth = now.getMonth();
      if ((date.getMonth() + 1) == lastMonth && studentDiplomaCount < 3){
        return true;
      }else{
        return false;
      }
    });
  };

	return {
		init: init
	};
});
