// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var classId;
	var schoolId;

	var init = function() {
		dom = $("#class-pass-book");
		router.init();
		initJuicer();
		initEvent();
		loadData();
	};

	var initEvent = function() {
		classId = base.getUrlParam("classId");
		schoolId = base.getUrlParam("schoolId");
		dom.on("click", ".personal-rank", function(){
			var studentId = $(this).attr("studentId");
			var studentName = $(this).attr("studentName");
			router.route("#studentPage.personal-pass-book?studentId="+studentId+"&studentName="+encodeURIComponent(studentName));
		});
	};

	var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });
  };

	var loadData = function() {
		inquireReadingBookPassListByClassIdTenant();
	};
	
	var inquireReadingBookPassListByClassIdTenant = function(){
		databind.submit([], {
            action: "inquireReadingBookPassListByClassIdTenant",
            version: "v1.0",
            data: {
            	schoolId: schoolId,
            	classId: classId
            },
            success:function(data){
            	var html = juicer(dom.find("#student-tpl").html(), data);
            	dom.find(".passList").html(html);
            }
        });
	};

	return {
		init: init
	};
});
