// 主界面
;
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var diplomaId;
  var imgUuid;

  var init = function() {
    dom = $("#diploma-detail");
    router.init();
    initEvent();
    initJuicer();
    loadData();
  };

  var initEvent = function() {
    diplomaId = base.getUrlParam("diplomaId");
    imgUuid = base.getUrlParam("imgUuid");

    dom.on("click", ".download", function () {
      if(imgUuid){
        try {
          base.savePictureToAlbum(imgUuid);
        } catch (e) {
          if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
            base.alert(2,"请更新App到最新版本！")
          }
        }
        return;
      }
      var height = dom.find("#diploma-content").height();
      var width = dom.find("#diploma-content").width();
      var devicePixelRatio = window.devicePixelRatio || 1;
      html2canvas(document.getElementById('diploma-content'),
        {
          allowTaint:true,
          taintTest:false,
          width:width,
          height:height,//放大倍数增加清晰度
          dpi:devicePixelRatio
        })
        .then(function(canvas) {
        var imgCxt = canvas.toDataURL("image/png");
        var $Blob= getBlobBydataURI(imgCxt,'image/png');
        var timestamp = new Date().getTime();
        var formData = new FormData();
        formData.append("file", $Blob, timestamp + '.png');
        formData.append('name',timestamp + '.png');//得到以当前时间命名的图片文件
        $.ajax({
          type: "POST",
          url: CONFIG.fsPath+"v1.0/uploadFile.json",
          async: true,
          data: formData,
          dataType: "json",
          processData: false,
          contentType: false,
          success: function (data) {
            if (data.data.length > 0) {
              var ret = data.data[0];
              try {
                base.savePictureToAlbum(ret.fileUuid);
              } catch (e) {
                if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
                  base.alert(2,"请更新App到最新版本！")
                }
              }
              //把奖状生成为图片的存起来 避免重复生成
              databind.submit([], {
                action: "saveReadingDiplomaImgAccount",
                version: "v1.0",
                data: {
                  diplomaId: diplomaId,
                  imgUuid:ret.fileUuid
                },
                success: function (data) {
                }
              });
            }
          },
          error: function (err) {
          }
        });
      });
    });
  };

  var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("getYear", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      if (date.getMonth() == 0) {
        return date.getFullYear() - 1;
      }
      return date.getFullYear();
    });

    juicer.register("getMonth", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      return date.getMonth() == 0 ? "12" : date.getMonth();
    });
  };

  function getBlobBydataURI(dataURI,type){
    var binary = atob(dataURI.split(',')[1]);
    var array = [];
    for(var i = 0; i < binary.length; i++) {
      array.push(binary.charCodeAt(i));
    }
    return new Blob([new Uint8Array(array)], {type:type });
  }

  var loadData = function() {
    databind.submit([], {
      action: "inquireReadingDiplomaDetail",
      version: "v1.0",
      data: {
        diplomaId: diplomaId
      },
      success: function (data) {
        var html = juicer(dom.find("#diploma-tpl").html(), data);
        dom.find(".content").html(html);
      }
    });
  };

  return {
    init: init
  };
});
