// 主界面
;
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var pageIndex;

  var init = function() {
    dom = $("#diploma-wall");
    router.init();
    initEvent();
    initJuicer();
    loadData();
  };

  var initEvent = function() {
    pageIndex = 1;

    dom.on("click", ".diploma", function () {
      var diplomaId = $(this).attr("diplomaId");
      base.openUrl("index.html#studentPage.diploma-detail?diplomaId="+diplomaId, "");
    });

    //更多
    dom.on("click", ".more", function(){
      pageIndex++;
      loadMoreData();
    });
  };

  var initJuicer = function () {
    juicer.register("type", function (dt) {
      var formatDateString = dt.createDate.replace(/-/g,"/");
      var date = new Date(formatDateString);
      var month = date.getMonth();
      if (month == 0) {
        month = 12
      }
      if (dt.type == "1"){
        return "获得"+month+"月份“书香班级”。";
      } else {
        return "获得"+month+"月份“阅读之星”。";
      }
    });
  };

  var loadData = function() {
    inquireReadingDiplomaWallListAccount();
  };

  var loadMoreData = function () {
    databind.submit([], {
      action: "inquireReadingDiplomaWallListAccount",
      version: "v1.0",
      data: {
      },
      success:function(data) {
        var html = juicer(dom.find("#wall-tpl").html(), data);
        dom.find(".content").append(html);
        var contentHeaderBgImgHeight = dom.width() * 0.515;
        dom.find(".contentHeader").css("height", contentHeaderBgImgHeight + "px");
        dom.find(".contentHeader").css("background-size", "cover");
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }else{
          dom.find(".more").addClass("none");
        }
      }
    });
  };

  var inquireReadingDiplomaWallListAccount = function () {
    databind.submit([], {
      action: "inquireReadingDiplomaWallListAccount",
      version: "v1.0",
      data: {
        pageIndex: pageIndex
      },
      success:function(data) {
        var html = juicer(dom.find("#wall-tpl").html(), data);
        dom.find(".content").html(html);
        var contentHeaderBgImgHeight = dom.width() * 0.515;
        dom.find(".contentHeader").css("height", contentHeaderBgImgHeight + "px");
        dom.find(".contentHeader").css("background-size", "cover");
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

  return {
    init: init
  };
});
