// 主界面
;
define(function(require, exports, module) {
    'use strict';
    var util = require("util");
    var base = require("base");
    var databind = require("databind");
    var listView = require("listView");
    var router = require("pageRouter");
    var dialog = require("dialog");
    var constant = require("constant");
    var readingUtil = require("readingUtil");
    var dom;
    var type;
    var pageIndex;
    var selectPostId;
    var deleteDom;

    var init = function(id) {
        dom = $("#discovery-content");
        router.init();
        initEvent();
        initJuicer();
        if (id == "hot"){
            type = 1;
        } else if (id == "class"){
            type = 2;
        } else if (id == "school"){
            type = 3;
        } else if (id == "mine"){
            type = 4;
        } else if (id == "follow"){
            type = 5;
        }
        androidBackButtonEvent();
        loadData();
    };

    var initEvent = function() {
      pageIndex = 1;

      $(window).scroll(function () {
        var scrollTop = Math.max(document.body.scrollTop || document.documentElement.scrollTop);
        var messageDOM = $(".message");
        if (messageDOM.length == 0) {
          return;
        }
        if (scrollTop > 0) {
          //59 由 103（tab margin-top 值） - 44(父级tab margin-top 的值) 想减得到
          var needTop = scrollTop < 59 ? 103 - scrollTop : 44;
          $(".mbsc-ms-top").css("top", needTop + "px");
        } else {
          $(".mbsc-ms-top").css("top", "103px");
        }
      });

      dom.find(".onresume").bind("on-resume", function () {
        stopAllAudio();
        //接收消息
        var isReceiveMessage = base.getData("receiveMessage");
        if(isReceiveMessage){
          $(".mbsc-ms-top").css("top","44px");
          base.removeData("receiveMessage");
          loadData();
          return;
        }
        loadDataByPostId();
      });

      //加入书架
      dom.on("click", ".addButton", function(e){
        var bookId = $(this).parent().attr("bookId");
        addToReadingBookrackAccount(bookId, $(this));
        e.stopPropagation();
      });

      //停止播放所有audio
      dom.on("click", ".backBtn", function () {
        stopAllAudio();
        base.back();
        return false;
      });

        dom.find(".postWords").each(function (idx, itm) {
            var slideHeight = 40;
            var defHeight = $(itm).height();
            if(defHeight > slideHeight){
                $(itm).css('height' , slideHeight + 'px');
                $('.read-more').append("查看");
            }
        });
        dom.on("click", ".read-more", function () {
            var defHeight = 60;
            var slideHeight = 40;
            var curHeight = $(this).parent().find('.postWords').height();
            if(curHeight == slideHeight){
                $(this).parent().find('.postWords').animate({
                    height: defHeight
                }, "normal");
                $(this).html('点击隐藏');
            }else{
                $(this).parent().find('.postWords').animate({
                    height: slideHeight
                }, "normal");
                $(this).html('查看');
            }
            return false;
        });

        dom.on("click", ".postContent", function () {
            stopAllAudio();
            var postId = $(this).attr("postId");
            selectPostId = postId;
            base.openUrl("index.html#studentPage.discovery-detail?postId="+postId, "");
        });

        //操作菜单栏
        dom.on("click", ".headerRight", function(e){
            if ($(this).find(".edit").hasClass("none")) {
                $(this).find(".edit").removeClass("none");
            }else{
                $(this).find(".edit").addClass("none");
            }
            e.stopPropagation();
        });

        //书籍详情
        dom.on("click", ".book", function (e) {
            var bookId = $(this).attr("bookId");
            var postId = $(this).attr("postId");
            selectPostId = postId;
            base.openUrl("index.html#studentPage.task-book-detail?bookId="+bookId, "YX_READING_STUDENT_APP");
            e.stopPropagation();
        });

        //图片预览
        dom.on("click", ".book-detail-post-img", function (e) {
          var uuidArr = [];
          var idx = $(this).attr("index");
          if ($(this).hasClass("w")){
            $(this).parent().parent().parent().find(".book-detail-post-img").each(function (idx, item) {
              var fileUuid = $(this).attr("fileUuid");
              uuidArr.push(fileUuid);
            });
          } else {
            $(this).parent().find(".book-detail-post-img").each(function (idx, item) {
              var fileUuid = $(this).attr("fileUuid");
              uuidArr.push(fileUuid);
            });
          }
          base.callGallery(uuidArr, idx);
          e.stopPropagation();
        });

        //点赞
        dom.on("click", ".thumb", function (e) {
            var postId = $(this).attr("postId");
            var thumbUpDiv = $(this).find(".thumbUp");
            thumbUpReadingPostAccount(postId, thumbUpDiv);
            e.stopPropagation();
        });

      //删除
      dom.on("click", ".delete-post", function (e) {
        var postId = $(this).attr("postId");
        deleteDom = $(this).parents(".postContent");
        dialog.loadDialog("dialog.confirmDialog", {
          params: {
            tips: "确定删除该作品吗？"
          },
          okFn: function () {
            databind.submit([], {
              action: "deleteReadingPostStudentAccount",
              version: "v1.0",
              data: {
                postId: postId
              },
              success: function (data) {
                base.alert(1,"删除成功");
                dialog.hideDialog();
                deleteDom.remove();
              }
            });
          }
        }, "medium");
        e.stopPropagation();
      });

        dom.on("click", ".audioPlayer", function (e) {
            //重置当前页面所有audio（除点击的这个）为停止播放状态，且播放时间归零
            var allAudioList = $(".content").find('audio');
            for (var i = 0; i < allAudioList.length; i++) {
                var audioItem = allAudioList[i];
                if (audioItem == $(this).find('audio')[0]) {
                    continue;
                }
                audioItem.pause();
                audioItem.currentTime = 0;
                $(audioItem).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
            }
            var audio = $(this).find('audio')[0];
            audio.loop = false;
            audio.onpause = function () {
              $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
            };
            if (audio.paused) {
                // 开始播放当前点击的音频
                audio.play();
                audio.onended = function () {
                  $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
                };
                $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record_playing.gif");
            } else {
                audio.pause();
                audio.currentTime = 0;
                $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
            }
            e.stopPropagation();
        });

      dom.on("click", ".headToInfo", function(e){
        stopAllAudio();
        var studentId = $(this).attr("studentId");
        var schoolId = $(this).attr("schoolId");
        base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId, "");
        e.stopPropagation();
      });

      //更多
      dom.on("click", ".more", function(){
        pageIndex++;
        loadMoreData();
      });
    };

    var initJuicer = function () {
      juicer.register("getReadingLevel", function (level) {
        return readingUtil.getReadingLevelDom(level);
      });
        juicer.register("fsPath", function () {
            return CONFIG.fsPath;
        });

      juicer.register("decode", function (replyContent) {
        return uncodeUtf16(decodeURIComponent(replyContent));
      });
    };

    var thumbUpReadingPostAccount = function (postId, thumbUpDiv) {
        databind.submit([], {
            action: "thumbUpReadingPostStudentAccount",
            version: "v1.0",
            async: false,
            data: {
                postId: postId
            },
            success:function(){
                var thumbUp = thumbUpDiv.attr("thumbUp");
                var count = thumbUpDiv.parent().find(".thumbUpCount").text();
                if (thumbUp == "1"){
                    thumbUpDiv.attr("src","./res/png/thumbUp_gray.png");
                    thumbUpDiv.attr("thumbUp", "0");
                    thumbUpDiv.parent().find(".thumbUpCount").text(parseInt(count)-1);
                } else {
                    thumbUpDiv.attr("src","./res/png/thumbUp.png");
                    thumbUpDiv.attr("thumbUp", "1");
                    thumbUpDiv.parent().find(".thumbUpCount").text(parseInt(count)+1);
                }
            }
        });
    };

    var loadData = function() {
        var data = {
            type: type
        };
        databind.submit([], {
            action: "inquireReadingPostListAccount",
            version: "v1.0",
            data: data,
            success:function(data){
                //计算帖子内容一行容纳多少个字
                var oneLineMaxWordsNum = parseInt(($(".content").width() - 25) / 15);

                for (var i=0;i<data.datas.length;i++){
                    var dic = data.datas[i];
                    var imgArr = dic.imageAttachmentUuid.split(",");
                    var audioTime = transTime(dic.audioTime);
                    dic.imgArr = imgArr;
                    dic.audioTime = audioTime;

                    if (uncodeUtf16(decodeURIComponent(dic.postContent)).length > oneLineMaxWordsNum * 4) {
                      dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent)).substring(0, (oneLineMaxWordsNum * 4 - 6)) + "...";
                      dic.showFullTextBtn = 1;
                    }else {
                      dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent));
                    }
                    data.datas[i] = dic;
                }
                var html = juicer(dom.find("#post-tpl").html(), data);
                dom.find(".content").html(html);
                if (data.datas.length == 0){
                    dom.find(".nodata").removeClass("none");
                    dom.find(".content").css("padding-bottom","0px");
                    //1 热门、2 班级、3 学校、4 我的 、5 关注
                    switch (type){
                      case 1:
                      case 4:
                        dom.find(".discovery-mine").removeClass("none");
                        dom.find(".no-data-content-common").html("还没有发表作品哦!<br>快去书籍详情页发表作品吧!");break;
                      case 2:
                        dom.find(".discovery-nodata").removeClass("none");
                        dom.find(".no-data-content-common").html("快来发表班级的第一个作品吧!");break;
                      case 3:
                        dom.find(".discovery-nodata").removeClass("none");
                        dom.find(".no-data-content-common").html("快来发表第一个作品吧!");break;
                      case 5:
                      dom.find(".discovery-nodata").removeClass("none");
                      dom.find(".no-data-content-common").html("你关注的同学还没有发表作品哦!");break;
                      default:
                        dom.find(".discovery-nodata").removeClass("none");
                        dom.find(".no-data-content-common").html("快来发表作品");break;
                    }
                }else {
                    dom.find(".nodata").addClass("none");
                    // dom.find(".content").css("padding-bottom","60px");
                    //todo 加载更多
                }
                if (data.totalPageCount > pageIndex) {
                  dom.find(".more").removeClass("none");
                }
                adaptiveImageHeight();
              getNotReceivedMessageQty();
            }
        });
    };

  var loadDataByPostId = function() {
    if (selectPostId == undefined){
      return;
    }
    var index;
    dom.find(".postContent").each(function (idx, item) {
      var postId = $(this).attr("postId");
      if (postId == selectPostId){
        index = idx;
      }
    });
    var yu;
    if ((index+1)%20 == 0){
      yu = parseInt((index+1)/20);
    } else {
      yu = parseInt((index+1)/20) + 1;
    }
    var data = {
      type: type
    };
    data.pageIndex = yu;
    databind.submit([], {
      action: "inquireReadingPostListAccount",
      version: "v1.0",
      data: data,
      success:function(data){
        var ret = data.datas;
        var selectDic;
        for (var i = 0; i<ret.length;i++){
          var dic = ret[i];
          if (dic.postId == selectPostId){
            selectDic = dic;
            break;
          }
        }
        dom.find(".postContent").each(function (item, idx) {
          var postId = $(this).attr("postId");
          if (postId == selectPostId){
            //已经被删除
            if (selectDic == undefined || selectDic == null){
              $(this).remove();
            }else {
              if (selectDic.isThumbUp == true){
                $(this).find(".thumbUp").attr("src", "./res/png/thumbUp.png");
              }else {
                $(this).find(".thumbUp").attr("src", "./res/png/thumbUp_gray.png");
              }
              $(this).find(".thumbUpCount").html(selectDic.thumbUpCount);
              $(this).find(".commentCount").text(selectDic.commentCount);
              if (selectDic.excellentCount > 0){
                $(this).find(".excellentDiv").remove();
                var html = juicer(dom.find("#excellent-tpl").html(), selectDic);
                $(this).find(".studentName").append(html);
              }else {
                $(this).find(".excellentDiv").remove();
              }
              $(this).find(".participationCount").html(selectDic.participationCount+"人参与");
              var bookHtml = juicer(dom.find("#book-detail-tpl").html(), selectDic);
              $(this).find(".book-info-btn-area-right").html(bookHtml);
            }
          }
        });
      }
    });
  };

    var loadMoreData = function () {
      var data = {
        type: type
      };
      data.pageIndex = pageIndex;
      databind.submit([], {
        action: "inquireReadingPostListAccount",
        version: "v1.0",
        data: data,
        success:function(data){
          dom.find(".more").remove();
          //计算帖子内容一行容纳多少个字
          var oneLineMaxWordsNum = parseInt(($(".content").width() - 25) / 15);

          for (var i=0;i<data.datas.length;i++){
            var dic = data.datas[i];
            var imgArr = dic.imageAttachmentUuid.split(",");
            var audioTime = transTime(dic.audioTime);
            dic.imgArr = imgArr;
            dic.audioTime = audioTime;

            if (uncodeUtf16(decodeURIComponent(dic.postContent)).length > oneLineMaxWordsNum * 4) {
              dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent)).substring(0, (oneLineMaxWordsNum * 4 - 6)) + "...";
              dic.showFullTextBtn = 1;
            }else {
              dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent));
            }
            data.datas[i] = dic;
          }
          var html = juicer(dom.find("#post-tpl").html(), data);
          dom.find(".content").append(html);
          if (data.datas.length == 0){
            dom.find(".nodata").removeClass("none");
            dom.find(".content").css("padding-bottom","0px");
          }else {
            dom.find(".nodata").addClass("none");
            // dom.find(".content").css("padding-bottom","60px");
            //todo 加载更多
          }
          if (data.totalPageCount > pageIndex) {
            dom.find(".more").removeClass("none");
          }else{
            dom.find(".more").addClass("none");
          }
          adaptiveImageHeight();
        }
      });
    };

    var adaptiveImageHeight = function () {
      $(".img-overflow-style").css("height", $(".img-width-control").width() + "px");
      $(".img-overflow-style").css("line-height", $(".img-width-control").width() + "px");
      var width = parseInt($(".add-to-bookrack-position").width()) - parseInt($(".addToBookRackText").width()) - 1;
      $(".book-info-btn-area-left").css("width", width + "px");
    };

    /**
     * 音频播放时间换算
     * @param {number} value - 音频当前播放时间，单位秒
     */
    var transTime = function (value) {
        var time = "";
        var h = parseInt(value / 3600);
        value %= 3600;
        var m = parseInt(value / 60);
        var s = parseInt(value % 60);
        if (h > 0) {
            time = formatTime(h + ":" + m + ":" + s);
        } else {
            time = formatTime(m + ":" + s);
        }
        return time;
    };
    /**
     * 格式化时间显示，补零对齐
     * eg：2:4  -->  02:04
     * @param {string} value - 形如 h:m:s 的字符串
     */
    var formatTime = function (value) {
        var time = "";
        var s = value.split(':');
        var i = 0;
        for (; i < s.length - 1; i++) {
            time += s[i].length == 1 ? ("0" + s[i]) : s[i];
            time += ":";
        }
        time += s[i].length == 1 ? ("0" + s[i]) : s[i];
        return time;
    };

  var stopAllAudio = function (){
    var allAudioList = $(".content").find('audio');
    for (var i = 0; i < allAudioList.length; i++) {
      var audioItem = allAudioList[i];
      audioItem.pause();
      audioItem.currentTime = 0;
      $(audioItem).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
    }
  };

  var androidBackButtonEvent = function () {
    window._android_on_back_pressed = function () {
      stopAllAudio();
      base.back();
    }
  };

  var addToReadingBookrackAccount = function(bookId, dom){
    showLoading();
    databind.submit([], {
      action: "addToReadingBookrackAccount",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success:function(data){
        hideLoading();
        base.alert(1, "加入成功！");
        dom.parent().find(".addTo").addClass("none");
        dom.parent().find(".exist").removeClass("none");
        dom.parent().find(".addButton").html("已在书架");
      },
      fail:function (error) {
        base.alert(3, error.message);
        hideLoading();
      }
    });
  };

  var uncodeUtf16 = function (str) {
    var reg = /\&#.*?;/g;
    var result = str.replace(reg,function(char){
      var H,L,code;
      if(char.length == 9 ){
        code = parseInt(char.match(/[0-9]+/g));
        H = Math.floor((code-0x10000) / 0x400)+0xD800;
        L = (code - 0x10000) % 0x400 + 0xDC00;
        return unescape("%u"+H.toString(16)+"%u"+L.toString(16));
      }else{
        return char;
      }
    });
    return result;
  };

  var getNotReceivedMessageQty = function () {
    databind.submit([], {
      action: "inquireReadingDiscoveryMessageQtyAccount",
      version: "v1.0",
      data: {},
      success:function(data){
        //每次获取消息之前先remove掉,否则切换tab的时候会一直拼多个重复
        $("#discovery-message").remove();
        if (data.datas[0].notReceivedQty != 0) {
          if (data.datas[0].notReceivedQty > 99){
            $("#tab").find(".number").html("99+");
            $("#tab").find(".red").css("width", "29px");
            $("#tab").find(".red").css("padding-left", "5px");
            $("#tab").find(".red").css("border-radius", "7px");
          }else{
            $("#tab").find(".number").html(data.datas[0].notReceivedQty);
          }
          $("#tab").find(".red").removeClass("none");
          var html = juicer(dom.find("#message-tpl").html(), data.datas[0]);
          $(".header").after(html);
          $(".mbsc-ms-top").css("top","103px");
          $("#discovery").on("click", ".message-content", function () {
            //记录查看消息
            base.saveData("receiveMessage","1");
            stopAllAudio();
            base.openUrl("index.html#studentPage.message-list", "");
          });
        }else {
          $("#tab").find(".red").addClass("none");
        }
      }
    });
  };

    //转菊花
    var showLoading = function(){
        $(".fullBg").removeClass("none");
        $(".loader").removeClass("none");
    };
    //隐藏菊花
    var hideLoading = function(){
        $(".fullBg").addClass("none");
        $(".loader").addClass("none");
    };

    return {
        init: init
    };
});
