// 主界面
;
define(function(require, exports, module) {
    'use strict';
    var util = require("util");
    var base = require("base");
    var databind = require("databind");
    var listView = require("listView");
    var router = require("pageRouter");
    var dialog = require("dialog");
    var constant = require("constant");
    var readingUtil = require("readingUtil");
    var dom;
    var postId;

    var init = function() {
        dom = $("#discovery-detail");
        router.init();
        initEvent();
        initJuicer();
        androidBackButtonEvent();
        loadData();
    };

    var initEvent = function() {
        postId = base.getUrlParam("postId");

        dom.on("click", ".backBtn", function () {
            var audio = dom.find('audio')[0];
            audio.currentTime = 0;
            audio.pause();
            base.back();
        });

        dom.on("mousedown", ".commit", function () {
            replayReadingPostAccount();
        });

        dom.on("click", ".reply", function () {
            dom.find(".bottomInput").removeClass("none");
            dom.find("textarea[name=reply]").focus();
            dom.find(".bottomButton").addClass("none");
            dom.find(".header").css("position", "initial");
            dom.find(".content").css("margin-top", "0px");
            dom.find(".content").css("padding-bottom", "0px");
        });

        dom.on("click", ".excellent", function () {
            thumbUpReadingPostAccount(null, 3);
        });

        dom.on("click", ".thumbUpDiv", function () {
            var thumbUp = $(this).find(".thumbUp").attr("thumbUp");
            thumbUpReadingPostAccount(thumbUp);
        });

        dom.on("blur", "textarea[name=reply]", function () {
            dom.find(".bottomButton").removeClass("none");
            dom.find(".header").css("position", "fixed");
            dom.find(".content").css("margin-top", "44px");
            dom.find(".content").css("padding-bottom", "60px");
            if ($(this).val() == ""){
              dom.find(".bottomInput").addClass("none");
            }
        });

        dom.on("focus", "textarea[name=reply]", function () {
          dom.find(".bottomButton").addClass("none");
        });

        //点赞列表
        dom.on("click", ".thumbUpSection", function () {
            router.route("#studentPage.discovery-thumbUp-list?postId="+postId);
        });

        //书籍详情
        dom.on("click", ".bookInfo", function () {
            var bookId = $(this).attr("bookId");
            // router.route("#teacherPage.book-detail?bookId="+bookId);
            base.openUrl("index.html#studentPage.task-book-detail?bookId="+bookId, "YX_READING_STUDENT_APP");
        });

        dom.on("click", ".audioPlayer", function () {
            var audio = $(this).find('audio')[0];
            audio.loop = false;
            audio.onpause = function () {
              $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
            };
            if (audio.paused) {
                // 开始播放当前点击的音频
                audio.play();
                audio.onended = function () {
                $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
            };
                $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record_playing.gif");
            } else {
                audio.pause();
                audio.currentTime = 0;
                $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
            }
        });

        //加入书架
        dom.on("click", ".addButton", function(e){
          var bookId = $(this).parent().attr("bookId");
          addToReadingBookrackAccount(bookId, $(this));
          e.stopPropagation();
        });

        //操作菜单栏
        dom.on("click", ".headerRight", function(e){
            if ($(this).find(".edit").hasClass("none")) {
                $(this).find(".edit").removeClass("none");
            }else{
                $(this).find(".edit").addClass("none");
            }
            e.stopPropagation();
        });

      //删除
      dom.on("click", ".delete-post", function (e) {
        var postId = $(this).attr("postId");
        dialog.loadDialog("dialog.confirmDialog", {
          params: {
            tips: "确定删除该作品吗？"
          },
          okFn: function () {
            databind.submit([], {
              action: "deleteReadingPostStudentAccount",
              version: "v1.0",
              data: {
                postId: postId
              },
              success: function (data) {
                base.alert(1,"删除成功");
                dialog.hideDialog();
                setTimeout(function () {
                  base.back();
                },1000);
              }
            });
          }
        }, "medium");
        e.stopPropagation();
      });

      //删除评论
      dom.on("click", ".delete-reply", function () {
        var replyId = $(this).attr("replyId");
        var replyType = $(this).attr("replyType");
        dialog.loadDialog("dialog.confirmDialog", {
          params: {
            tips: "确定删除该评论吗？"
          },
          okFn: function () {
            databind.submit([], {
              action: "deleteReadingPostReply",
              version: "v1.0",
              data: {
                replyId: replyId,
                replyType:replyType
              },
              success: function (data) {
                base.alert(1, "删除成功!");
                dialog.hideDialog();
                loadData();
              }
            });
          }
        }, "medium");
      });

      dom.on("click", ".headToInfo", function(){
        stopAllAudio();
        var studentId = $(this).attr("studentId");
        var schoolId = $(this).attr("schoolId");
        if (schoolId !== undefined && schoolId !== null && schoolId !== "undefined"){
          router.route("#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId);
        }
      });

      //图片预览
      dom.on("click", ".book-detail-post-img", function (e) {
        var uuidArr = [];
        var idx = $(this).attr("index");
        $(this).parent().find(".book-detail-post-img").each(function (idx, item) {
          var fileUuid = $(this).attr("fileUuid");
          uuidArr.push(fileUuid);
        });
        base.callGallery(uuidArr, idx);
        e.stopPropagation();
      });

      var winHeight = $(window).height();   //获取当前页面高度
      $(window).resize(function(){
        var thisHeight=$(this).height();
        if(winHeight - thisHeight >50){
          //当软键盘弹出，在这里面操作
        }else{
          //当软键盘收起，在此处操作
          // dom.find(".bottomButton").removeClass("none");
          // if ($(this).val() == ""){
          //   dom.find(".bottomInput").addClass("none");
          // }
          dom.find("textarea[name=reply]").blur();
          dom.find(".header").css("position", "fixed");
          dom.find(".content").css("margin-top", "44px");
          dom.find(".content").css("padding-bottom", "60px");
        }
      });
    };

  var androidBackButtonEvent = function () {
    window._android_on_back_pressed = function () {
      stopAllAudio();
      base.back();
    }
  };

    var initJuicer = function () {
      juicer.register("getReadingLevel", function (level) {
        return readingUtil.getReadingLevelDom(level);
      });
        juicer.register("fsPath", function () {
            return CONFIG.fsPath;
        });

      juicer.register("decode", function (replyContent) {
        return uncodeUtf16(decodeURIComponent(replyContent));
      });
    };

    var loadData = function() {
        inquireReadingPostDetailTenant();
    };

    var replayReadingPostAccount = function () {
        var reply = dom.find("textarea[name=reply]").val();
        if (reply == ""){
            base.alert(2,"请输入评论！");
            return;
        }
      var str = encodeURIComponent(utf16toEntities(reply));
        databind.submit([], {
            action: "replayReadingPostStudentAccount",
            version: "v1.0",
            data: {
                postId: postId,
                reply: str
            },
            success:function(){
                base.alert(1, "评论成功！");
                dom.find(".bottomInput").addClass("none");
                loadData();
            }
        });
    };

    var thumbUpReadingPostAccount = function (thumbUp) {
        databind.submit([], {
            action: "thumbUpReadingPostStudentAccount",
            version: "v1.0",
            async: false,
            data: {
                postId: postId
            },
            success:function(){
                // if (thumbUp == "1"){
                //     dom.find(".thumbUp").attr("src","./res/newImages/thumbUp_gray.png");
                //     dom.find(".thumbUp").attr("thumbUp", "0");
                // } else {
                //     dom.find(".thumbUp").attr("src","./res/newImages/thumbUp.png");
                //     dom.find(".thumbUp").attr("thumbUp", "1");
                // }
                loadData();
            }
        });
    };

  var stopAllAudio = function (){
    var allAudioList = $(".content").find('audio');
    for (var i = 0; i < allAudioList.length; i++) {
      var audioItem = allAudioList[i];
      audioItem.pause();
      audioItem.currentTime = 0;
    }
  };

  var addToReadingBookrackAccount = function(bookId, dom){
    showLoading();
    databind.submit([], {
      action: "addToReadingBookrackAccount",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success:function(data){
        hideLoading();
        base.alert(1, "加入成功！");
        dom.parent().find(".addTo").addClass("none");
        dom.parent().find(".exist").removeClass("none");
        dom.parent().find(".addButton").html("已在书架");
      }
    });
  };


    var inquireReadingPostDetailTenant = function () {
        databind.submit([], {
            action: "inquireReadingPostDetailAccount",
            version: "v1.0",
            data: {
                postId: postId
            },
            success:function(data){
                if (data.datas[0].isThumbUp){
                    dom.find(".thumbUp").attr("src","./res/png/thumbUp.png");
                    // dom.find(".thumbUp").attr("thumbUp", "1");
                }else {
                    dom.find(".thumbUp").attr("src","./res/png/thumbUp_gray.png");
                }
                for (var i=0;i<data.datas.length;i++){
                    var dic = data.datas[i];
                    var imgArr = dic.imageAttachmentUuid.split(",");
                    var audioTime = transTime(dic.audioTime);
                    dic.imgArr = imgArr;
                    dic.audioTime = audioTime;
                    data.datas[i] = dic;
                }
                var html = juicer(dom.find("#post-tpl").html(), data.datas[0]);
                dom.find(".content").html(html);
                if (data.datas[0].thumbUper !== ""){
                    dom.find(".thumbUpSection").removeClass("none");
                }
                var width = parseInt($(".add-to-bookrack-position").width()) - parseInt($(".addToBookRackText").width()) - 1;
                $(".book-info-btn-area-left").css("width", width + "px");
            }
        });
    };

    /**
     * 音频播放时间换算
     * @param {number} value - 音频当前播放时间，单位秒
     */
    var transTime = function (value) {
        var time = "";
        var h = parseInt(value / 3600);
        value %= 3600;
        var m = parseInt(value / 60);
        var s = parseInt(value % 60);
        if (h > 0) {
            time = formatTime(h + ":" + m + ":" + s);
        } else {
            time = formatTime(m + ":" + s);
        }
        return time;
    };

    /**
     * 格式化时间显示，补零对齐
     * eg：2:4  -->  02:04
     * @param {string} value - 形如 h:m:s 的字符串
     */
    var formatTime = function (value) {
        var time = "";
        var s = value.split(':');
        var i = 0;
        for (; i < s.length - 1; i++) {
            time += s[i].length == 1 ? ("0" + s[i]) : s[i];
            time += ":";
        }
        time += s[i].length == 1 ? ("0" + s[i]) : s[i];
        return time;
    };

  var utf16toEntities = function (str) {
    var patt=/[\ud800-\udbff][\udc00-\udfff]/g; // 检测utf16字符正则
    str = str.replace(patt, function(char){
      var H, L, code;
      if (char.length===2) {
        H = char.charCodeAt(0); // 取出高位
        L = char.charCodeAt(1); // 取出低位
        code = (H - 0xD800) * 0x400 + 0x10000 + L - 0xDC00; // 转换算法
        return "&#" + code + ";";
      } else {
        return char;
      }
    });
    return str;
  };

  var uncodeUtf16 = function (str) {
    var reg = /\&#.*?;/g;
    var result = str.replace(reg,function(char){
      var H,L,code;
      if(char.length == 9 ){
        code = parseInt(char.match(/[0-9]+/g));
        H = Math.floor((code-0x10000) / 0x400)+0xD800;
        L = (code - 0x10000) % 0x400 + 0xDC00;
        return unescape("%u"+H.toString(16)+"%u"+L.toString(16));
      }else{
        return char;
      }
    });
    return result;
  };

  //转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

    return {
        init: init
    };
});
