// 主界面
;
define(function(require, exports, module) {
    'use strict';
    var util = require("util");
    var base = require("base");
    var databind = require("databind");
    var listView = require("listView");
    var router = require("pageRouter");
    var dialog = require("dialog");
    var constant = require("constant");
    var dom;
    var pageIndex;
    var selectedId;
    var discoveryContent = require("./discovery-content.html");
    var discoveryContentJs = require("./discovery-content.js");

    var init = function() {
        dom = $("#discovery");
        router.init();
        initEvent();
        initMenu();
    };
    var initEvent = function() {

      try {
        var only = base.isOnlyReadingStudentApp();
        if (only){
          dom.find(".backBtn").addClass("none");
        }
      }catch (e) {
        console.log(e);
      }

        pageIndex = 1;
        //更多
        dom.on("click", ".more", function(){
            pageIndex++;
            var keyWord = dom.find("input[name=book]").val();
            // inquireReadingBookListTenantMore(keyWord);
        });

        dom.on("click", ".header-ops", function(){
            // base.openUrl("index.html#studentPage.search-book-list", "");
            base.openUrl("index.html#studentPage.find", "");
        });

        $("input[name='book']").bind('input propertychange',function(){
            //做一些事情
            var val = $(this).val();
            console.log(val);
            if (val !== "") {
                // inquireReadingBookListTenant(val);
            }
        })

      dom.on("click", ".search-right", function (e) {
        try{
          base.getISBNCode();
        }catch (e){
          if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
            base.alert(2,"使用扫一扫,请更新App到最新版本!")
          }
        }
        e.stopPropagation();
      });

        //搜索
        dom.on("click", ".header-search", function(e){
            base.openUrl("index.html#studentPage.search-book", "");
          e.stopPropagation();
        });

      window._android_on_back_pressed = function() {
        try {
          var only = base.isOnlyReadingStudentApp();
          if (only){
            dialog.loadDialog("dialog.confirmDialog", {
              params: {
                tips: "确认退出程序？"
              },
              okFn: function() {
                $(".dialog-container").addClass("none");
                base.exitProgram();
              }
            }, "small");
          }
        }catch (e) {
          console.log(e);
        }
        return false;
      };
    };

    var initMenu = function(){
        dom.find("#list-content").empty();
        var html = juicer(dom.find('#menustripTpl').html(), null);
        dom.find('#menustripTabs').append(html);
        // var tempSelected = base.getData("selectedId");
        // if (tempSelected !== null && tempSelected !== undefined) {
        // 	selectedId = tempSelected;
        // }
        if (selectedId) {
            dom.find("#" + selectedId).attr("data-selected", true);
            dom.find("#list-content").append(discoveryContent);
            discoveryContentJs.init(selectedId);
        } else {
            dom.find("#hot").attr("data-selected", true);
            dom.find("#list-content").append(discoveryContent);
            discoveryContentJs.init("hot");
        }
        base.removeData("selectedId");
        $('#menustrip').mobiscroll().menustrip({
            theme: 'mobiscroll',
            display: 'top',
            type: 'tabs',
            onItemTap: function (event, inst) {
                //
                var itemId = event.target.id;
                selectedId = itemId;
                base.saveData("selectedId",selectedId);
                dom.find("#list-content").empty();
                dom.find("#list-content").append(discoveryContent);
                discoveryContentJs.init(itemId);
            },
            onMarkupReady: function (event, inst) {

            },
        });
    };

    var loadData = function() {
    };

    return {
        init: init
    };
});
