// 主界面
;
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;

  var init = function() {
    dom = $("#find");
    router.init();
    initEvent();
    loadData();
  };

  var initEvent = function() {
    dom.on("click", ".search-middle", function(){
      base.openUrl("index.html#studentPage.search-book?fromBookList=1", "");
    });

    dom.on("click", ".bookListHeader", function(){
      var recommendId = $(this).attr("recommendId");
      var recommendName = $(this).attr("recommendName");
      var recommendSource = $(this).attr("recommendSource");
      base.openUrl("index.html#studentPage.book-recommend?recommendId="+recommendId+"&recommendName="+encodeURIComponent(recommendName)+"&recommendSource="+recommendSource, "");
    });

    dom.on("click", ".bookType", function(){
      base.openUrl("index.html#studentPage.search-book-list?bookType="+encodeURIComponent($(this).html()), "");
    });

    dom.on("click", ".book", function(){
      var bookId = $(this).attr("bookId");
      base.openUrl("index.html#studentPage.task-book-detail?bookId="+bookId, "");
    });

    dom.on("click", ".search-right", function () {
      try{
        base.getISBNCode();
      }catch (e){
        if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
          base.alert(2,"使用扫一扫,请更新App到最新版本!")
        }
      }
    });

    databind.submit([], {
      action: "inquireReadingCyclePermissionsStateTenant",
      version: "v1.0",
      success: function (data) {
        if(data.datas[0].readingCircleSwitch == 0){
          dom.find('.readingCircleTip').removeClass('none');
          if(data.datas[0].burTag == 1){
            dom.find('.tip')[0].innerHTML = '教育局已关闭悦读圈功能，无法查看阅读作品';
          }else{
            dom.find('.tip')[0].innerHTML = '学校已关闭悦读圈功能，无法查看阅读作品';
          }      
        }
      }
    });

    window._android_on_isbn_select = function (isbn) {
      base.openUrl("index.html#studentPage.search-book?fromBookList=1&isbn="+isbn, "");
    };
  };
  
  var loadData = function() {
    // inquireReadingRecommendListTenant();
    inquireReadingRecommendBookListBySourceTenant(1);
    inquireReadingRecommendBookListBySourceTenant(2);
    inquireReadingRecommendBookListBySourceTenant(3);
    inquireReadingRecentBookListAccount();
  };
  
  var inquireReadingRecommendListTenant = function(){
    databind.submit([], {
            action: "inquireReadingRecommendListTenant",
            version: "v1.0",
            data: {
            },
            success:function(data){
              var html = juicer(dom.find("#book-list-tpl").html(), data);
              dom.find(".bookListSection").html(html);
              inquireReadingRecentBookListAccount();
            }
        });
  };

  var inquireReadingRecentBookListAccount = function () {
    databind.submit([], {
      action: "inquireReadingRecentBookListAccount",
      version: "v1.0",
      data: {},
      success: function (data) {
        if (data.datas.length > 0) {
          var dic = {};
          var datas = [];
          var newBookDic = {};
          newBookDic.recommendName = "新书上架";
          newBookDic.recommendId = "0";
          newBookDic.bookList = data.datas;
          datas.push(newBookDic);
          dic.datas = datas;
          var html = juicer(dom.find("#book-list-tpl").html(), dic);
          dom.find(".famousTeacher").after(html);
        }
      }
    });
  };

  var inquireReadingRecommendBookListBySourceTenant = function(recommendSource){
    databind.submit([], {
            action: "inquireReadingRecommendBookListBySourceAccount",
            version: "v1.0",
            data: {
              recommendSource: recommendSource
            },
            success:function(data){
              var html = juicer(dom.find("#book-tpl").html(), data.datas[0]);
              var bookList = data.datas[0].bookList;
              if (recommendSource == 1) {
                dom.find(".newStandard").find(".bookListContent").append(html);
                dom.find(".newStandard").find(".bookListHeader").attr("recommendId",data.datas[0].recommendId);
                if (bookList.length > 0) {dom.find(".newStandard").removeClass("none")}
              }else if (recommendSource == 2) {
                dom.find(".famousTeacher").find(".bookListContent").append(html);
                dom.find(".famousTeacher").find(".bookListHeader").attr("recommendId",data.datas[0].recommendId);
                if (bookList.length > 0) {dom.find(".famousTeacher").removeClass("none")}
              }else{
                dom.find(".famousSchool").find(".bookListContent").append(html);
                dom.find(".famousSchool").find(".bookListHeader").attr("recommendId",data.datas[0].recommendId);
                if (bookList.length > 0) {dom.find(".famousSchool").removeClass("none")}
              }
            }
        });
  };

  return {
    init: init
  };
});
