// 主界面
;
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var readingUtil = require("readingUtil");
  var dom;
  var follow;
  var studentId;
  var schoolId;
  var fromMy;
  var isClick;

  var init = function() {
    dom = $("#follow");
    router.init();
    initJuicer();
    initEvent();
    loadData();
  };

  var initJuicer = function () {
    juicer.register("getReadingLevel", function (level) {
      return readingUtil.getReadingLevelDom(level);
    });

    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });
  };

  var initEvent = function() {
    isClick = true;
    follow = base.getUrlParam("follow");
    fromMy = base.getUrlParam("fromMy");
    studentId = base.getUrlParam("studentId");
    schoolId = base.getUrlParam("schoolId");
    if (fromMy == 1){
      if (follow == 1){
        dom.find(".header-title").html("我的关注");
      } else {
        dom.find(".header-title").html("我的粉丝");
      }
    } else {
      if (follow == 1){
        dom.find(".header-title").html("TA的关注");
      } else {
        dom.find(".header-title").html("TA的粉丝");
      }
    }

    dom.on("click", ".followBtn", function () {
      if (isClick){
        isClick = false;
        //定时器
        setTimeout(function(){
          isClick = true;
        }, 500);
        var follow = $(this).attr("follow");
        var schoolId = $(this).attr("schoolId");
        var studentId = $(this).attr("studentId");
        showLoading();
        if (follow == 1){
          deleteReadingFollowAccount(schoolId, studentId, $(this));
        } else {
          createReadingFollowAccount(schoolId, studentId, $(this));
        }
      }
    });

    dom.on("click", ".headToInfo", function(e){
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId, "");
      e.stopPropagation();
    });
  };

  var loadData = function() {
    if (follow == 1){
      inquireReadingFollowListAccount();
    }else {
      inquireReadingFollowedListAccount();
    }
  };

  var inquireReadingFollowListAccount = function () {
    var data = {pageSize: 20};
    if (studentId !== undefined && studentId !== null && studentId !== "undefined"){
      data.studentId = studentId;
      data.schoolId = schoolId;
    }
    databind.submit([], {
      action: "inquireReadingFollowListAccount",
      version: "v1.0",
      data: data,
      success:function(data){
        var html = juicer(dom.find("#student-tpl").html(), data);
        dom.find(".content").html(html);
      }
    });
  };

  var inquireReadingFollowedListAccount = function () {
    var data = {pageSize: 20};
    if (studentId !== undefined && studentId !== null && studentId !== "undefined"){
      data.studentId = studentId;
      data.schoolId = schoolId;
    }
    databind.submit([], {
      action: "inquireReadingFollowedListAccount",
      version: "v1.0",
      data: data,
      success:function(data){
        var html = juicer(dom.find("#follow-tpl").html(), data);
        dom.find(".content").html(html);
      }
    });
  };

  var createReadingFollowAccount = function (schoolId, studentId, followDom) {
    databind.submit([], {
      action: "createReadingFollowAccount",
      version: "v1.0",
      async: false,
      data: {
        studentId: studentId,
        schoolId: schoolId
      },
      success: function (data) {
        hideLoading();
        followDom.attr("follow", "1");
        followDom.removeClass("follow");
        followDom.addClass("followed");
        followDom.html("已关注");
      }
    });
  };

  var deleteReadingFollowAccount = function (schoolId, studentId, followDom) {
    databind.submit([], {
      action: "deleteReadingFollowAccount",
      version: "v1.0",
      data: {
        studentId: studentId,
        schoolId: schoolId
      },
      success: function (data) {
        hideLoading();
        followDom.attr("follow", "0");
        followDom.removeClass("followed");
        followDom.addClass("follow");
        followDom.html("关注");
      }
    });
  };

  //转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

  return {
    init: init
  };
});
