// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var pageIndex = 1;

  var init = function () {
    dom = $("#message-list");
    router.init();
    initEvent();
    loadData();
    initJuicer();
  };

  var initEvent = function () {
    dom.find(".onresume").bind("on-resume", function () {
      // loadData();
    });

    dom.on("click", ".message-item", function (e) {
      var postId = $(this).attr("postId");
      var actionType = $(this).attr("actionType");
      //1学生点赞、2教师点赞、3学生回复、4教师回复、5评优、7评论被删除
      if (actionType == 1 || actionType == 2 || actionType == 3 || actionType == 4 || actionType == 5 || actionType == 7) {
        base.openUrl("index.html#studentPage.discovery-detail?postId=" + postId, "");
      }
      e.stopPropagation();
    });

    //个人主页
    dom.on("click", ".profile-img", function(e){
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      var actionType = $(this).parents(".message-item").attr("actionType");
      //教师类型的无法跳个人主页
      if (actionType == "2" || actionType == "4" || actionType == "5" || actionType == "7" || actionType == "6") {
        return false;
      }
      base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId, "");
      e.stopPropagation();
    });

    //更多
    dom.on("click", ".more", function(){
      loadMoreData();
    });
  };

  var loadData = function () {
    inquireReadingDiscoveryMessageListAccount(pageIndex);
  };

  var inquireReadingDiscoveryMessageListAccount = function (pageIndex) {
    databind.submit([], {
      action: "inquireReadingDiscoveryMessageListAccount",
      version: "v1.0",
      data: {
        pageIndex:pageIndex,
        page: 20
      },
      success: function (data) {
        if (pageIndex > 1){
          dom.find(".more").remove();
        }
        var messageIdList = [];
        for (var i = 0; i < data.datas.length; i++) {
          messageIdList.push(data.datas[i].messageId);
          if(data.datas[i].postContent != ""){
            data.datas[i].postContent = data.datas[i].postContent.replace(" ", "");
          }
          if (data.datas[i].imageAttachmentUuid != "") {
            data.datas[i].imageAttachmentUuid = data.datas[i].imageAttachmentUuid.split(",")[0];
          }
        }
        var html = juicer(dom.find("#message-content-tpl").html(), data);
        dom.find(".content").append(html);
        readingReceiveMessageAccount(messageIdList);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }else{
          dom.find(".more").addClass("none");
        }
      }
    });
  };

  var loadMoreData = function () {
    pageIndex++;
    inquireReadingDiscoveryMessageListAccount(pageIndex);
  }

  var readingReceiveMessageAccount = function (messageIdList) {
    databind.submit([], {
      action: "readingReceiveMessageAccount",
      version: "v1.0",
      data: {
        messageIdList: messageIdList
      },
      success: function (data) {
      }
    });
  };

  var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("decode", function (replyContent) {
      return decodeUtf16(decodeURIComponent(replyContent));
    });
  };

  var decodeUtf16 = function (str) {
    var reg = /\&#.*?;/g;
    var result = str.replace(reg, function (char) {
      var H, L, code;
      if (char.length == 9) {
        code = parseInt(char.match(/[0-9]+/g));
        H = Math.floor((code - 0x10000) / 0x400) + 0xD800;
        L = (code - 0x10000) % 0x400 + 0xDC00;
        return unescape("%u" + H.toString(16) + "%u" + L.toString(16));
      } else {
        return char;
      }
    });
    return result;
  };

  return {
    init: init
  };
});
