// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var readingUtil = require("readingUtil")
	var dom;
	var studentName;
	var studentId;

	var init = function() {
		dom = $("#my-tmp");
		router.init();
		initEvent();
		loadData();
	};

	var initEvent = function() {

    dom.find(".onresume").bind("on-resume", function () {
      loadData();
    });

    databind.submit([], {
      action: "inquireReadingCyclePermissionsStateTenant",
      version: "v1.0",
      success: function (data) {
        if(data.datas[0].readingCircleSwitch == 0){
          dom.find('.postArea').addClass('none');
          dom.find('.followArea').addClass('none');
          dom.find('.followedArea').addClass('none');
        }
      }
    });

    try {
      var only = base.isOnlyReadingStudentApp();
      if (only){
        dom.find(".backBtn").addClass("none");
      }
    }catch (e) {
      console.log(e);
    }

    //首次加载把头部弄成透明
    dom.find(".header").css("background-color", "transparent");
		dom.on("click", ".passBook", function(){
			base.openUrl("index.html#studentPage.pass-book", "YX_READING_STUDENT_APP");
		});

    dom.on("click", ".moments", function(){
      base.openUrl("index.html#studentPage.my-moments", "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".diploma", function () {
      var studentDiplomaQty = $(this).attr("studentDiplomaQty");
      var classDiplomaQty = $(this).attr("classDiplomaQty");
      base.openUrl("index.html#studentPage.diploma?studentDiplomaQty=" + studentDiplomaQty + "&classDiplomaQty=" + classDiplomaQty, "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".level", function () {
      base.openUrl("index.html#studentPage.student-level", "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".postArea", function () {
      base.openUrl("index.html#studentPage.my-moments", "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".followArea", function () {
      base.openUrl("index.html#studentPage.follow?follow=1&fromMy=1", "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".followedArea", function () {
      base.openUrl("index.html#studentPage.follow?follow=0&fromMy=1", "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".my-message", function () {
      base.openUrl("index.html#studentPage.history-message-list", "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".setting", function () {
      base.openUrl("index.html#studentPage.setting?studentName="+encodeURIComponent(studentName), "YX_READING_STUDENT_APP");
    });

    // dom.on("click", ".describe-img", function () {
    //   var fileUuid = $(this).attr("fileUuid");
    //   if (fileUuid){
    //     $(this).attr("href", "fileView/view.html?uuid="+fileUuid+"&fn=头像.png");
    //   }
    // });

    dom.on("click", ".change", function () {
      base.jumpToSettingControllerWithIndex("1");
    });

    dom.on("click", ".headPhoto", function () {
      if (!studentId){
        return;
      }
      base.selectImageFileAndCaptureImage(function (data) {
        var ret = data.data[0];
        updateStudentPhoto(ret.fileUuid, studentId);
      }, {
        "isSelectFile": false,
        "maxcount": 1,
        "isCrop": true
      });
    });

    window._android_on_back_pressed = function() {
      try {
        var only = base.isOnlyReadingStudentApp();
        if (only){
          dialog.loadDialog("dialog.confirmDialog", {
            params: {
              tips: "确认退出程序？"
            },
            okFn: function() {
              $(".dialog-container").addClass("none");
              base.exitProgram();
            }
          }, "small");
        }
      }catch (e) {
        console.log(e);
      }
      return false;
    };
	};

	var loadData = function() {
		inquireReadingAccountInfoAccount();
    inquireReadingFollowCountAccount();
	};

	var updateStudentPhoto = function (fileUuid, studentId) {
    databind.submit([], {
      action: "updateStudentPhoto",
      version: "v1.0",
      data: {
        picUuid: fileUuid,
        studentId: studentId
      },
      success: function () {
        inquireReadingAccountInfoAccount();
      }
    });
  };

	var inquireReadingAccountInfoAccount = function(){
		 databind.submit([], {
          action: "inquireReadingAccountInfoAccount",
          version: "v1.0",
          data: {
          },
          success: function (data) {
          	var ret = data.datas[0];
          	studentName = ret.userName;
          	studentId = ret.studentId;
          	var levelDom = readingUtil.getReadingLevelDom(ret.level);
          	dom.find(".level").html(levelDom);
          	dom.find(".studentName").text(ret.userName);
          	dom.find(".school").html(ret.schoolName + " " + ret.className);
          	dom.find(".integral").text(ret.integralQTY);
          	dom.find(".readQty").text((ret.readingQTY/10000).toFixed(1));
          	dom.find(".passRate").text(ret.passRate+"%");
          	dom.find(".passBookCountNum").text(ret.passQTY);
          	dom.find(".momentsCountNum").text(ret.postQTY);
            dom.find(".post").html(ret.postQTY);
            dom.find(".diplomaCountNum").text(ret.diplomaQTY);
            dom.find(".diploma").attr("studentDiplomaQty",ret.studentDiplomaQTY);
            dom.find(".diploma").attr("classDiplomaQty",ret.classDiplomaQTY);
            if (ret.photoUuid !== ""){
              dom.find(".headPhotoImg").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid="+ret.photoUuid + "&view=1&size=120");
              dom.find(".headPhotoImg").parent().attr("fileUuid", ret.photoUuid);
            }

            //加载是否需要弹窗提示奖状
						var pushType = base.getData("pushType");
						var diplomaId = base.getData("diplomaId");
						if(diplomaId){
              diplomaId = JSON.parse(diplomaId);
						}
            if(pushType){
            	pushType = JSON.parse(pushType);//JSON parse 会转成 数字 getUrlParam 的则是字符串
              base.removeData("pushType");
              base.removeData("diplomaId");
              switch (pushType){
                case 2001:
                  var studentDiplomaQty = $(".diploma").attr("studentDiplomaQty");
                  var classDiplomaQty = $(".diploma").attr("classDiplomaQty");
                  base.openUrl("index.html#studentPage.diploma?studentDiplomaQty=" + studentDiplomaQty + "&classDiplomaQty=" + classDiplomaQty + "&pushType=2001" + "&diplomaId=" + diplomaId, "YX_READING_STUDENT_APP");
                  break;
                case 2002:
                  var studentDiplomaQty = $(".diploma").attr("studentDiplomaQty");
                  var classDiplomaQty = $(".diploma").attr("classDiplomaQty");
                  base.openUrl("index.html#studentPage.diploma?studentDiplomaQty=" + studentDiplomaQty + "&classDiplomaQty=" + classDiplomaQty + "&pushType=2002" + "&diplomaId=" + diplomaId, "YX_READING_STUDENT_APP");
                  break;
								default:break;
              }
            }
          }
      });
	};

	var inquireReadingFollowCountAccount = function () {
    databind.submit([], {
      action: "inquireReadingFollowCountAccount",
      version: "v1.0",
      data: {
      },
      success: function (data) {
      	dom.find(".follow").html(data.datas[0].followCount);
      	dom.find(".followed").html(data.datas[0].followedCount);
			}
    });
  };

	return {
		init: init
	};
});
