// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var classId;
  var winWidth;

  var init = function() {
		dom = $("#personal-pass-book");
		classId = base.getUrlParam("classId");
		router.init();
		initEvent();
		loadData();
	};

	var initEvent = function() {
		dom.on("click", ".book", function(){
			var bookId = $(this).attr("bookId");
			router.route("#studentPage.task-book-detail?bookId="+bookId, "");
		});
	};
	
	var loadData = function() {
		if (classId) {
			inquireReadingPassedBookListTenant();
		}else{
			inquireReadingPassedBookListAccount();
		}
	};

	var inquireReadingPassedBookListAccount = function(){
		databind.submit([], {
			action: "inquireReadingPassedBookListAccount",
			version: "v1.0",
			data: {},
			success:function(data){
				var html = juicer(dom.find("#book-tpl").html(), data);
            	dom.find(".bookListContent").html(html);
            	dom.find(".bookNum").html("共"+data.datas.length+"本");
        			adaptFontSize();
			}
		});
	};

	var inquireReadingPassedBookListTenant = function(){
		databind.submit([], {
			action: "inquireReadingPassedBookListTenant",
			version: "v1.0",
			data: {
				classId: classId
			},
			success:function(data){
				var html = juicer(dom.find("#book-tpl").html(), data);
            	dom.find(".bookListContent").html(html);
            	dom.find(".bookNum").html("共"+data.datas.length+"本");
        			adaptFontSize();
			}
		});
	};

  var adaptFontSize = function () {
    // 获取窗口宽度
    if (window.innerWidth)
      winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
      winWidth = document.body.clientWidth;
    if (document.documentElement && document.documentElement.clientWidth) {
      winWidth = document.documentElement.clientWidth;
    }

    var fontSize = winWidth / 30;
    dom.find(".bookName").css("font-size",fontSize + "px");
    dom.find(".bookNum").css("font-size",fontSize + "px");
    dom.find(".author").css("font-size", fontSize - 4 + "px");
  };

	return {
		init: init
	};
});
