// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var readingUtil = require("readingUtil");
  var dom;
  var pageIndex = 1;
  var onlyShowExcellence;
  var deleteDom;
  var schoolId;
  var studentId;

  var init = function (tSchoolId, tStudentId, tOnlyShowExcellence) {
    dom = $("#book-detail-post");
    router.init();
    initEvent();
    initJuicer();
    schoolId = tSchoolId;
    studentId = tStudentId;
    onlyShowExcellence = tOnlyShowExcellence;
    loadData(schoolId, studentId, onlyShowExcellence);
  };

  var initEvent = function () {
    //停止播放所有audio
    dom.on("click", ".backBtn", function () {
      stopAllAudio();
      base.back();
    });

    //悦读圈点击帖子进详情（复用发现页的帖子详情）
    dom.on("click", ".postContent", function () {
      var postId = $(this).attr("postId");
      base.openUrl("index.html#studentPage.discovery-detail?postId=" + postId, "");
    });

    //录音播放
    dom.on("click", ".audioPlayer", function (e) {
      //重置当前页面所有audio（除点击的这个）为停止播放状态，且播放时间归零
      var allAudioList = $(".content").find('audio');
      for (var i = 0; i < allAudioList.length; i++) {
        var audioItem = allAudioList[i];
        if (audioItem == $(this).find('audio')[0]) {
          continue;
        }
        audioItem.pause();
        audioItem.currentTime = 0;
        $(audioItem).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
      }
      var audio = $(this).find('audio')[0];
      audio.loop = false;
      audio.onpause = function () {
        $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
      };
      if (audio.paused) {
        // 开始播放当前点击的音频
        audio.play();
        audio.onended = function () {
          $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
        };
        $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record_playing.gif");
      } else {
        audio.pause();
        audio.currentTime = 0;
        $(this).parent().find(".record-icon").attr("src","./res/images/icon/icon_record.png");
      }
      e.stopPropagation();
    });

    //点赞
    dom.on("click", ".thumb", function (e) {
      var postId = $(this).attr("postId");
      var thumbUpDiv = $(this).find(".thumbUp");
      thumbUpReadingPostAccount(postId, thumbUpDiv, 2);
      e.stopPropagation();
    });

    dom.on("click", ".headToInfo", function(e){
      stopAllAudio();
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId, "");
      e.stopPropagation();
    });

    //操作菜单栏
    dom.on("click", ".headerRight", function(e){
      if ($(this).find(".edit").hasClass("none")) {
        $(this).find(".edit").removeClass("none");
      }else{
        $(this).find(".edit").addClass("none");
      }
      e.stopPropagation();
    });

    //删除
    dom.on("click", ".del", function(){
      var postId = $(this).attr("postId");
      deleteDom = $(this).parents(".postContent");
      dialog.loadDialog("dialog.confirmDialog", {
        params: {
          tips: "确定删除该作品吗？"
        },
        okFn: function() {
          databind.submit([], {
            action: "deleteReadingPostStudentAccount",
            version: "v1.0",
            data: {
              postId: postId
            },
            success:function(data){
              base.alert(1, "删除成功");
              dialog.hideDialog();
              // loadData(bookId,postType, filtrationType, onlyShowExcellence);
              deleteDom.remove();
            }
          });
        }
      }, "medium");
    });

    //图片预览
    dom.on("click", ".book-detail-post-img", function (e) {
      // var fileUuid = $(this).attr("fileUuid");
      // var fileName = "详情.jpg";

      // base.openUrl("fileView/view.html?uuid=" + fileUuid + "&fn=" + encodeURIComponent(fileName), "");
      var uuidArr = [];
      var idx = $(this).attr("index");
      if ($(this).hasClass("w")){
        $(this).parent().parent().parent().find(".book-detail-post-img").each(function (idx, item) {
          var fileUuid = $(this).attr("fileUuid");
          uuidArr.push(fileUuid);
        });
      } else {
        $(this).parent().find(".book-detail-post-img").each(function (idx, item) {
          var fileUuid = $(this).attr("fileUuid");
          uuidArr.push(fileUuid);
        });
      }
      base.callGallery(uuidArr, idx);
      e.stopPropagation();
    });

    //更多
    dom.on("click", ".more", function(){
      loadMoreData();
    });
  };

  var loadMoreData = function () {
    pageIndex++;
    databind.submit([], {
      action: "inquireReadingStudentPostListAccount",
      version: "v1.0",
      data: {
        studentId: studentId,
        schoolId: schoolId,
        onlyShowExcellence:onlyShowExcellence,
        pageIndex:pageIndex,
        page: 20
      },
      success: function (data) {
        dom.find(".more").remove();
        //计算帖子内容一行容纳多少个字
        var oneLineMaxWordsNum = parseInt(($(".content").width() - 25) / 15);

        for (var i = 0; i < data.datas.length; i++) {
          var dic = data.datas[i];
          var imgArr = dic.imageAttachmentUuid.split(",");
          var audioTime = transTime(dic.audioTime);
          dic.imgArr = imgArr;
          dic.audioTime = audioTime;
          data.datas[i] = dic;

          if (uncodeUtf16(decodeURIComponent(dic.postContent)).length > oneLineMaxWordsNum * 4) {
            dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent)).substring(0, (oneLineMaxWordsNum * 4 - 6)) + "...";
            dic.showFullTextBtn = 1;
          }else {
            dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent));
          }
        }
        var html = juicer(dom.find("#post-tpl").html(), data);
        dom.find(".content").append(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }else{
          dom.find(".more").addClass("none");
        }
        if (data.datas.length == 0){
          dom.find(".nodata").removeClass("none");
          dom.find(".content").css("padding-bottom","0px");
        }else {
          dom.find(".nodata").addClass("none");
        }
        adaptiveImageHeight();
      }
    });
  };

  var initJuicer = function () {
    juicer.register("getReadingLevel", function (level) {
      return readingUtil.getReadingLevelDom(level);
    });

    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("decode", function (replyContent) {
      return uncodeUtf16(decodeURIComponent(replyContent));
    });
  };

  var loadData = function (schoolId, studentId, onlyShowExcellence) {
    //悦读圈
    databind.submit([], {
      action: "inquireReadingStudentPostListAccount",
      version: "v1.0",
      data: {
        schoolId: schoolId,
        studentId: studentId,
        onlyShowExcellence:onlyShowExcellence
      },
      success: function (data) {
        //计算帖子内容一行容纳多少个字
        var oneLineMaxWordsNum = parseInt(($(".content").width() - 25) / 15);

        for (var i = 0; i < data.datas.length; i++) {
          var dic = data.datas[i];
          var imgArr = dic.imageAttachmentUuid.split(",");
          var audioTime = transTime(dic.audioTime);
          dic.imgArr = imgArr;
          dic.audioTime = audioTime;
          data.datas[i] = dic;

          if (uncodeUtf16(decodeURIComponent(dic.postContent)).length > oneLineMaxWordsNum * 4) {
            dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent)).substring(0, (oneLineMaxWordsNum * 4 - 6)) + "...";
            dic.showFullTextBtn = 1;
          }else {
            dic.postContent = uncodeUtf16(decodeURIComponent(dic.postContent));
          }
        }
        var html = juicer(dom.find("#post-tpl").html(), data);
        dom.find(".content").html(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }else{
          dom.find(".more").addClass("none");
        }
        if (data.datas.length == 0){
          dom.find(".nodata").removeClass("none");
          dom.find(".content").css("padding-bottom","0px");
        }else {
          dom.find(".nodata").addClass("none");
        }
        adaptiveImageHeight();
      }
    });
  };

  var thumbUpReadingPostAccount = function (postId, thumbUpDiv, type) {
    databind.submit([], {
      action: "thumbUpReadingPostStudentAccount",
      version: "v1.0",
      data: {
        postId: postId,
        type: type
      },
      success:function(){
        var thumbUp = thumbUpDiv.attr("thumbUp");
        var count = thumbUpDiv.parent().find(".thumbUpCount").text();
        if (thumbUp == "1"){
          thumbUpDiv.attr("src","./res/png/thumbUp_gray.png");
          thumbUpDiv.attr("thumbUp", "0");
          thumbUpDiv.parent().find(".thumbUpCount").text(parseInt(count)-1);
        } else {
          thumbUpDiv.attr("src","./res/png/thumbUp.png");
          thumbUpDiv.attr("thumbUp", "1");
          thumbUpDiv.parent().find(".thumbUpCount").text(parseInt(count)+1);
        }
      }
    });
  };

  /**
   * 音频播放时间换算
   * @param {number} value - 音频当前播放时间，单位秒
   */
  var transTime = function (value) {
    var time = "";
    var h = parseInt(value / 3600);
    value %= 3600;
    var m = parseInt(value / 60);
    var s = parseInt(value % 60);
    if (h > 0) {
      time = formatTime(h + ":" + m + ":" + s);
    } else {
      time = formatTime(m + ":" + s);
    }
    return time;
  };

  var stopAllAudio = function (){
    var allAudioList = $(".content").find('audio');
    for (var i = 0; i < allAudioList.length; i++) {
      var audioItem = allAudioList[i];
      audioItem.pause();
      audioItem.currentTime = 0;
    }
  };

  /**
   * 格式化时间显示，补零对齐
   * eg：2:4  -->  02:04
   * @param {string} value - 形如 h:m:s 的字符串
   */
  var formatTime = function (value) {
    var time = "";
    var s = value.split(':');
    var i = 0;
    for (; i < s.length - 1; i++) {
      time += s[i].length == 1 ? ("0" + s[i]) : s[i];
      time += ":";
    }
    time += s[i].length == 1 ? ("0" + s[i]) : s[i];
    return time;
  };

  //转菊花
  var showLoading = function () {
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function () {
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

  var adaptiveImageHeight = function () {
    $(".img-overflow-style").css("height", $(".img-width-control").width() + "px");
    $(".img-overflow-style").css("line-height", $(".img-width-control").width() + "px");
  };

  var uncodeUtf16 = function (str) {
    var reg = /\&#.*?;/g;
    var result = str.replace(reg,function(char){
      var H,L,code;
      if(char.length == 9 ){
        code = parseInt(char.match(/[0-9]+/g));
        H = Math.floor((code-0x10000) / 0x400)+0xD800;
        L = (code - 0x10000) % 0x400 + 0xDC00;
        return unescape("%u"+H.toString(16)+"%u"+L.toString(16));
      }else{
        return char;
      }
    });
    return result;
  };

  return {
    init: init
  };
});
