// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var readingUtil = require("readingUtil");
	var dom;
	var studentId;
	var schoolId;
  var winWidth;
  var studentName;
  var isClick;
  var searchPostType;
  var _bookDetailPostHtml = require("./personal-detail-post.html");
  var _bookDetailPostJs = require("./personal-detail-post.js");

  var init = function() {
		dom = $("#personal");
		router.init();
		initEvent();
		loadData();
	};

	var initEvent = function() {
	  isClick = true;
    dom.find(".header").css("background-color", "transparent");
		studentId = base.getUrlParam("studentId");
		schoolId = base.getUrlParam("schoolId");

    dom.on("click", ".moments", function(){
			base.openUrl("index.html#studentPage.student-moments?studentId="+studentId+"&schoolId=" + schoolId + "&studentName=" + encodeURIComponent(studentName), "");
    });

    dom.on("click", ".postArea", function () {
      base.openUrl("index.html#studentPage.student-moments?studentId="+studentId+"&schoolId=" + schoolId + "&studentName=" + encodeURIComponent(studentName), "");
    });

    dom.on("click", ".followArea", function () {
      base.openUrl("index.html#studentPage.follow?follow=1&studentId="+studentId+"&schoolId=" + schoolId, "");
    });

    dom.on("click", ".followedArea", function () {
      base.openUrl("index.html#studentPage.follow?follow=0&studentId="+studentId+"&schoolId=" + schoolId, "");
    });

		dom.on("click", ".book", function(){
			var bookId = $(this).attr("bookId");
			router.route("#studentPage.task-book-detail?bookId="+bookId, "");
		});

		dom.on("click", ".recent", function () {
			if (!$(this).find(".momentsCount").hasClass("none")){
				router.route("#studentPage.recent-book?studentId="+studentId);
			}
    });

    dom.on("click", ".diplomaArea", function () {
      var studentDiplomaQty = $(this).attr("studentDiplomaQty");
      var classDiplomaQty = $(this).attr("classDiplomaQty");
      base.openUrl("index.html#studentPage.student-diploma?studentId=" + studentId + "&schoolId=" + schoolId + "&studentDiplomaQty=" + studentDiplomaQty + "&classDiplomaQty=" + classDiplomaQty, "YX_READING_STUDENT_APP");
    });

    dom.on("click", ".onlyShowExcellence", function () {
      var onlyShowExcellence = $(this).attr("onlyShowExcellence");
      if(onlyShowExcellence=="true"){
        $(this).find(".selected").addClass("none");
        $(this).find(".unselect").removeClass("none");
        $(this).attr("onlyShowExcellence",false);
        initPostListContent(1);
      }else{
        $(this).find(".unselect").addClass("none");
        $(this).find(".selected").removeClass("none");
        $(this).attr("onlyShowExcellence",true);
        initPostListContent(1);
      }
    });

    dom.on("click", ".followBtn", function () {
      if (isClick){
        isClick= false;
        //定时器
        setTimeout(function(){
          isClick = true;
        }, 500);
        var follow = $(this).attr("follow");
        showLoading();
        if (follow == "1"){
          deleteReadingFollowAccount();
        } else {
          createReadingFollowAccount();
        }
      }
    });

    dom.on("click", ".describe-img", function () {
      var fileUuid = $(this).attr("fileUuid");
      if (fileUuid){
        $(this).attr("href", "fileView/view.html?uuid="+fileUuid+"&fn=头像.png");
      }
    });

    window._android_on_back_pressed = function() {
      base.back();
      return false;
    }
	};

	var loadData = function() {
		inquireReadingAccountInfoByStudentIdAccount();
    inquireReadingFollowCountAccount();
    inquireReadingFollowInfoAccount();
	};

	var inquireReadingAccountInfoByStudentIdAccount = function(){
		databind.submit([], {
			action: "inquireReadingAccountInfoByStudentIdAccount",
			version: "v1.0",
			data: {
				studentId: studentId,
				schoolId: schoolId
			},
			success:function(data){
				var ret = data.datas[0];
        var levelDom = readingUtil.getReadingLevelDom(ret.level);
        dom.find(".level").html(levelDom);
				dom.find(".studentName").text(ret.userName);
        studentName = ret.userName;
				dom.find(".school").html(ret.schoolName + " " + ret.className);
				dom.find(".integral").text(ret.integralQTY);
				dom.find(".readQty").text((ret.readingQTY/10000).toFixed(1));
				dom.find(".passRate").text(ret.passRate+"%");
        dom.find(".momentsCountNum").html(ret.postQTY);
        dom.find(".post").html(ret.postQTY);
        if (ret.photoUuid !== ""){
          dom.find(".headPhotoImg").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid="+ret.photoUuid + "&view=1&size=120");
          dom.find(".headPhotoImg").parent().attr("fileUuid", ret.photoUuid);
        }
        if (parseInt(ret.postQTY) > 0){
        	dom.find(".moments").removeClass("none");
          dom.find(".moments-area").removeClass("none");
          initPostListContent();
				}
        if (ret.bookList.length > 0) {
					dom.find(".recent").removeClass("none");
					dom.find(".bookList").removeClass("none");
					var html = juicer(dom.find("#book-tpl").html(), ret);
					dom.find(".bookList").html(html);
					if (ret.bookList.length > 3){
						dom.find(".recent").find(".momentsCount").removeClass("none");
					}
				}
				if(parseInt(ret.diplomaQTY) > 0){
          dom.find(".diploma").removeClass("none");
          dom.find(".diplomaArea").attr("studentDiplomaQty",ret.studentDiplomaQTY);
          dom.find(".diplomaArea").attr("classDiplomaQty",ret.classDiplomaQTY);
          dom.find(".diplomaCountNum").text(ret.diplomaQTY);

        }
        if (ret.bookList.length == 0 && ret.postQTY == 0){
					dom.find(".rookie").removeClass("none");
				}
			}
		});
	};

  var inquireReadingFollowCountAccount = function () {
    databind.submit([], {
      action: "inquireReadingFollowCountAccount",
      version: "v1.0",
      data: {
        studentId: studentId,
        schoolId: schoolId
      },
      success: function (data) {
        dom.find(".follow").html(data.datas[0].followCount);
        dom.find(".followed").html(data.datas[0].followedCount);
      }
    });
  };

  var inquireReadingFollowInfoAccount = function () {
    databind.submit([], {
      action: "inquireReadingFollowInfoAccount",
      version: "v1.0",
      data: {
        studentId: studentId,
        schoolId: schoolId
      },
      success: function (data) {
				var state = data.datas[0].followState;
				if (state == "0"){
					dom.find(".followBtn").html("关注");
          dom.find(".followBtn").attr("follow","0");
          dom.find(".followBtn").removeClass("none");
				} else if (state == "1") {
					dom.find(".followBtn").html("已关注");
          dom.find(".followBtn").attr("follow","1");
          dom.find(".followBtn").removeClass("none");
				}
      }
    });
  };

  var initPostListContent = function (bookId) {
    dom.find("#list-content").empty();

    var onlyShowExcellence;//是否只看优秀

    if (searchPostType) {
      $(".onlyShowExcellence").attr("onlyShowExcellence") == "true" ? onlyShowExcellence = 1 : onlyShowExcellence = 0;
      dom.find("#list-content").append(_bookDetailPostHtml);
      _bookDetailPostJs.init(schoolId, studentId, onlyShowExcellence);
    } else {
      $(".onlyShowExcellence").attr("onlyShowExcellence") == "true" ? onlyShowExcellence = 1 : onlyShowExcellence = null;
      dom.find("#all").attr("data-selected", true);
      $(".onlyShowExcellence").attr("onlyShowExcellence") == "true" ? onlyShowExcellence = 1 : onlyShowExcellence = 0;
      dom.find("#list-content").append(_bookDetailPostHtml);
      _bookDetailPostJs.init(schoolId, studentId, onlyShowExcellence);
    }
  };

  var createReadingFollowAccount = function () {
    databind.submit([], {
      action: "createReadingFollowAccount",
      version: "v1.0",
      async: false,
      data: {
        studentId: studentId,
        schoolId: schoolId
      },
      success: function (data) {
        hideLoading();
				inquireReadingFollowInfoAccount();
				inquireReadingFollowCountAccount();
      }
    });
  };

  var deleteReadingFollowAccount = function () {
    databind.submit([], {
      action: "deleteReadingFollowAccount",
      version: "v1.0",
      data: {
        studentId: studentId,
        schoolId: schoolId
      },
      success: function (data) {
        hideLoading();
        inquireReadingFollowInfoAccount();
        inquireReadingFollowCountAccount();
      }
    });
  };

  var adaptFontSize = function () {
    // 获取窗口宽度
    if (window.innerWidth)
      winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
      winWidth = document.body.clientWidth;
    if (document.documentElement && document.documentElement.clientWidth) {
      winWidth = document.documentElement.clientWidth;
    }

    var fontSize = winWidth / 25;
    dom.find(".bookName").css("font-size",fontSize + "px");
  };

  //转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

	return {
		init: init
	};
});
