// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var bookId;
  var postId;
  var token = "";
  var audioAttachmentUuid = "";
  var audioFilePath = "";
  var postType;
  var isDraft = "";
  var needAskSaveDraft = false;
  var audio;
  var recording = "false";
  var recordClockTimer;
  var recordCurrentTime;
  var audioTotalTime = 0;
  var recordAgainFlag = 0;
  var canvas;
  var canvasContext;
  var centerX;
  var centerY;
  var rad = 2 * Math.PI / 180; //将360度分成180份，那么每一份就是rad度
  var offsetRad = rad * 90 / 2; //默认canvas的圆弧从x轴开始画 所以周长2PI*r 忽略掉 r 向上旋转 90度时要除以 rad 2
  var isHaveMicroPhonePermission = false;

  var init = function () {
    bookId = base.getUrlParam("bookId");
    postType = base.getUrlParam("postType");
    isDraft = base.getUrlParam("isDraft");
    dom = $("#post-create");
    router.init();
    initEvent();
    loadData();
  };

  var initEvent = function () {
    //初始化fsPath
    initJuicer();
    //重写安卓实体返回键事件
    androidBackButtonEvent();
    dom.on("click", ".btn-cancel", function () {
      askSaveDraftBefore();
      return false;
    });

    //点击删除附件
    dom.on("click", ".btn-delete", function (e) {
      $(this).parents(".attaches").remove();
      checkAttachmentReachTheLimit();
      e.stopPropagation();
    });

    //点击发表
    dom.on("click", ".btn-release", function () {
      var isCanRelease = checkIsCanRelease();
      if (isCanRelease) {
        releaseBefore();
      }
    });

    dom.on("click", ".attaches", function (e) {
      // var fileUuid = $(this).attr("fileUuid");
      // var fileName = encodeURIComponent($(this).attr("fileName"));
      // fileName == "" ? fileName = "UnKnowName.jpg" : "";
      // base.openUrl("index.html#fileView.view?uuid=" + fileUuid + "&fn=" + fileName, "YX_READING_STUDENT_APP");
      var uuidArr = [];
      var idx = $(this).attr("index");
      $(this).parent().find(".attaches").each(function (idx, item) {
        var fileUuid = $(this).attr("fileUuid");
        uuidArr.push(fileUuid);
      });
      base.callGallery(uuidArr, idx);
      e.stopPropagation();
    });

    //附件上传按钮，调用原生附件上传
    dom.on("click", ".add-btn", function () {
      var currentCount = 0;
      dom.find(".attaches").each(function () {
        currentCount++;
      });
      var limitCount;
      if (currentCount == 9) {
        limitCount = -1;
      } else {
        limitCount = 9 - currentCount;
      }
      base.selectImageFileAndCaptureImage(function (data) {
        var attacheshtml = juicer(dom.find("#createImg-tpl").html(), data);
        dom.find(".add-btn-area").before(attacheshtml);
        checkAttachmentReachTheLimit();
        adaptiveImageHeight();
      }, {
        "isSelectFile": false,
        "maxcount": limitCount
      });
    });

    //感想字数实时监控
    dom.find("textarea[name='postContent']").bind('input porpertychange', function () {
      var wardsCount = $(this).val().length;
      dom.find(".current-words").html(wardsCount);
    });

    if(postType=="3"){
      initRecordBtnEvent();
    }
  };

  var askSaveDraftBefore = function () {
    stopAllAudio();
    //是否正在录音
    if (recording == "true") {
      $(".btn-end-record-img").trigger("click");
      clearInterval(recordClockTimer);
      if(recordCurrentTime < 10){
        base.alert(1, "录音时间不足10秒",1500);
        setTimeout(function () {
          base.back();

        }, 1500);
        return;
      }
      dialog.loadDialog("dialog.is-save-draft", {
        params: {
          tips: "将此次编辑保留？"
        },
        okFn: function () {
          saveToDraft(postType);
        },
        closeFn: function () {
          if (isDraft == "true") {
            deleteDraft();
          } else {
            base.back();
          }
        }
      }, "small");
      return;
    }
    getNeedAskSaveDraft();
    if (needAskSaveDraft) {
      askIsSaveDraft();
    } else {
      base.back();
    }
  };

  var loadData = function () {
    if (postType == "1") {
      $(".post-attachment-area").addClass("none");
      $(".record-area").addClass("none");
      if (isDraft == "true") {
        var datasJsonString = base.getData("postDraftData");
        var datas = JSON.parse(datasJsonString);
        var data = {};
        data.datas = datas;
        useDraft(data);
      }
    }
    if (postType == "2") {
      $(".record-area").addClass("none");
      if (isDraft == "true") {
        var datasJsonString = base.getData("postDraftData");
        var datas = JSON.parse(datasJsonString);
        var data = {};
        data.datas = datas;
        useDraft(data);
      } else {
        var datasJsonString = base.getData("postImageData");
        var imageDataArray = JSON.parse(datasJsonString);
        var data = {};
        data.data = imageDataArray;
        var attacheshtml = juicer(dom.find("#createImg-tpl").html(), data);
        dom.find(".add-btn-area").before(attacheshtml);
        checkAttachmentReachTheLimit();
        adaptiveImageHeight();
      }
    }
    if (postType == "3") {
      try {
        base.checkMicroPhonePermissions(checkOpenMicroPhonePermission);
      } catch (e) {
        if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
          base.alert(2,"使用录音功能，请更新App到最新版本！");
          setTimeout(function () {
            base.back();
          }, 1500);
        }
      }
      $(".post-content").addClass("none");
      $(".post-attachment-area").addClass("none");
      dom.find(".content").css("padding", 0 + "px");
      dom.find(".header").css("background-color", "transparent");
      dom.find(".btn-release").addClass("none");
      if (isDraft == "true") {
        var datasJsonString = base.getData("postDraftData");
        var datas = JSON.parse(datasJsonString);
        var data = {};
        data.datas = datas;
        useDraft(data);
        calculateBgSize();
      } else {
        //绑定录音按钮的点击事件，显示的逻辑
        calculateBgSize();
        // initRecordBtnEvent();
        initCircleProgress();
      }
    }
  };


  /**
   * 草稿相关部分
   * @returns {boolean}
   */
  var getNeedAskSaveDraft = function () {
    switch (postType) {
      case "1":
      case "2":
        $(".post-content-text").val().length > 0 ? needAskSaveDraft = true : needAskSaveDraft = false;
        if (needAskSaveDraft) {
          return needAskSaveDraft;
        }
        $(".attaches").length > 0 ? needAskSaveDraft = true : needAskSaveDraft = false;
        if (needAskSaveDraft) {
          return needAskSaveDraft;
        }
        return needAskSaveDraft;
        break;
      case "3":
        if (isDraft == "true") {
          audioAttachmentUuid != "" ? needAskSaveDraft = true : needAskSaveDraft = false;
          return needAskSaveDraft;
        } else {
          audioFilePath != "" ? needAskSaveDraft = true : needAskSaveDraft = false;
          if (audioTotalTime < 10) {
            needAskSaveDraft = false;
          }
        }
        return needAskSaveDraft;
        break;
      default:
        return needAskSaveDraft;
    }
  };

  var askIsSaveDraft = function () {
    dialog.loadDialog("dialog.is-save-draft", {
      params: {
        tips: "将此次编辑保留？"
      },
      okFn: function () {
        saveToDraft(postType);
      },
      closeFn: function () {
        if (isDraft == "true") {
          deleteDraft();
        } else {
          base.back();
        }
      }
    }, "small");
  };

  //渲染草稿
  var useDraft = function (data) {
    if (postType == "1" || postType == "2") {
      dom.find(".content").empty();
      isDraft = "true";
      postId = data.datas[0].postId;
      var attachmentList = [];
      var attachmentUuidList;
      var attachmentNameList;
      //文件Uuid
      if (data.datas[0].imageAttachmentUuid != "" && data.datas[0].imageAttachmentUuid) {
        attachmentUuidList = data.datas[0].imageAttachmentUuid.split(",");
        for (var i = 0; i < attachmentUuidList.length; i++) {
          var attachItem = {};
          attachItem.fileUuid = attachmentUuidList[i] || "";
          attachmentList.push(attachItem);
        }
      }
      //文件名
      if (data.datas[0].imageAttachmentName != "" && data.datas[0].imageAttachmentName) {
        attachmentNameList = data.datas[0].imageAttachmentName.split(",");
        for (var i = 0; i < attachmentNameList.length; i++) {
          attachItem = attachmentList[i];
          attachItem.fileName = attachmentNameList[i] || "";
        }
      }
      data.datas[0].attachmentList = attachmentList;
      var draftHtml = juicer(dom.find("#post-draft-tpl").html(), data);
      dom.find(".content").html(draftHtml);
      // if (postType == "1") {
      //   $(".post-attachment-area").addClass("none");
      // }
      checkAttachmentReachTheLimit();
      adaptiveImageHeight();
    }
    if (postType == "3") {
      dom.find(".content").empty();
      postId = data.datas[0].postId;
      var draftHtml = juicer(dom.find("#post-record-draft-tpl").html(), data);
      dom.find(".content").html(draftHtml);
      calculateBgSize();
      // initRecordBtnEvent();
      audioAttachmentUuid = data.datas[0].audioAttachmentUuid;
      audioTotalTime = data.datas[0].audioTime;
      dom.find(".btn-event").addClass("none");
      dom.find(".btn-play-img").removeClass("none");
      dom.find(".btn-record-again-img").removeClass("none");
      dom.find(".btn-record-release-img").removeClass("none");
      //初始化播放器事件
      initPlayerEvent();
      clearInterval(recordClockTimer);
      //放出播放界面，隐藏录音界面
      $(".play-interface").removeClass("none");
      $(".record-interface").addClass("none");
      $(".audio-length-total").html(formatRecordTime(audioTotalTime));
    }
  };

  //保存草稿
  var createDraft = function () {
    showLoading();
    var attachmentUuidString = getAttachmentUuidString();
    var attachmentNameString = getAttachmentNameString();
    databind.submit([], {
      action: "createReadingPostAccount",
      version: "v1.0",
      data: {
        bookId: bookId,
        postType: postType,
        postContent: encodeURIComponent(utf16toEntities($(".post-content-text").val()||"")),
        imageAttachmentUuid: attachmentUuidString,
        audioAttachmentUuid: audioAttachmentUuid,
        attachmentName: attachmentNameString,
        audioTime: audioTotalTime,
        token: token,
        postState: 1
      },
      success: function (data) {
        hideLoading();
        $(".dialog-container").addClass("none");
        base.back();
      }
    });
  };

  //更新草稿
  var updateDraft = function () {
    showLoading();
    var attachmentUuidString = getAttachmentUuidString();
    var attachmentNameString = getAttachmentNameString();
    databind.submit([], {
      action: "updateReadingPostDraftAccount",
      version: "v1.0",
      data: {
        bookId: bookId,
        postType: postType,
        postContent: encodeURIComponent(utf16toEntities($(".post-content-text").val()||"")),
        imageAttachmentUuid: attachmentUuidString,
        audioAttachmentUuid: audioAttachmentUuid,
        attachmentName: attachmentNameString,
        audioTime: audioTotalTime,
        token: token,
        postState: 1,
        postId: postId
      },
      success: function (data) {
        hideLoading();
        $(".dialog-container").addClass("none");
        base.back();
      }
    });
  };

  //帖子存为草稿
  var saveToDraft = function (postType) {
    //不是草稿
    if(isDraft == "false"){
      //但是类型为录音,则需要上传录音
      if (postType == "3") {
        draftRecord();
        return;
      }
      createDraft();
    }
    else{
      //有草稿时只有用户重新录音过才重新上传录音
      if (postType == "3" && recordAgainFlag == 1) {
        draftRecord();
        return;
      }
      updateDraft();
    }
  };

  //录音文件存草稿
  var draftRecord = function () {
    showLoading();
    base.uploadFile(audioFilePath, function (data) {
      audioAttachmentUuid = data.data[0].fileUuid;
      if (audioAttachmentUuid == "") {
        base.alert(1, "录音文件上传失败，请重试");
        hideLoading();
        dialog.hideDialog();
        return;
      }
      isDraft == "false" ? createDraft() : updateDraft();
    });
  };

  //删除草稿
  var deleteDraft = function () {
    base.removeData("postImageData");
    databind.submit([], {
      action: "deleteReadingPostAccount",
      version: "v1.0",
      data: {
        postId: postId
      },
      success: function (data) {
        $(".dialog-container").addClass("none");
        base.back();
      }
    });
  };

  /**
   * 发布相关
   * @returns {boolean}
   */
    //是否可发表
  var checkIsCanRelease = function () {
      switch (postType) {
        case "1":
        case "2":
          var currentCount = 0;
          dom.find(".attaches").each(function () {
            currentCount++;
          });
          if (currentCount > 0) {
            return true;
          }
          if ($(".post-content-text").val().length == 0) {
            base.alert(1, "请填写你的感想哦");
            return false;
          } else {
            return true;
          }
        case "3":
          //有草稿的可以发布
          if (isDraft == "true") {
            return true;
          }
          //不是草稿的则走以下验证流程
          if (audioFilePath == "") {
            base.alert(1, "请完成录音再发布");
            return false;
          }
          if (audioTotalTime < 10) {
            base.alert(1, "录音不足10秒");
            return false;
          }
          return true;
        default:
          base.alert(1, "未知错误无法发布");
          return false;
      }
    };

  //发表之前的事件
  var releaseBefore = function () {
    showLoading();
    stopAllAudio();
    if (isDraft == "true") {
      //是草稿时如果用户有重新录制录音则再次上传再发布
      if (recordAgainFlag == 1) {
        uploadRecord();
        return;
      }
      updateDraftToReleaseState();
    } else {
      //如果新建直接发布的是录音帖子比较特殊要先上传录音文件
      if(postType=="3"){
        releaseAudioPost();
        return;
      }
      releasePost();
    }
  };

  //录音比较特殊，原生返回的是文件绝对路径，需要再单独上传
  var uploadRecord = function () {
    base.uploadFile(audioFilePath, function (data) {
      audioAttachmentUuid = data.data[0].fileUuid;
      if (audioAttachmentUuid == "") {
        base.alert(1, "录音文件上传失败，请重试");
        hideLoading();
        return;
      }
      updateDraftToReleaseState();
    });
  };

  //草稿->发表
  var updateDraftToReleaseState = function () {
    var attachmentUuidString = getAttachmentUuidString();
    var attachmentNameString = getAttachmentNameString();
    databind.submit([], {
      action: "updateReadingPostDraftAccount",
      version: "v1.0",
      data: {
        bookId: bookId,
        postType: postType,
        postContent: encodeURIComponent(utf16toEntities($(".post-content-text").val()||"")),
        imageAttachmentUuid: attachmentUuidString,
        imageAttachmentName: attachmentNameString,
        audioAttachmentUuid: audioAttachmentUuid,
        audioTime: audioTotalTime,
        postState: 2,
        isRelease: 1,//标识要改成发布
        postId: postId
      },
      success: function (data) {
        // hideLoading();
        base.alert(1, "发表成功!");
        $(".dialog-container").addClass("none");
        base.back();
      }
    });
  };

  //新建的发表
  var releaseAudioPost = function () {
    showLoading();
    base.uploadFile(audioFilePath, function (data) {
      audioAttachmentUuid = data.data[0].fileUuid;
      if (audioAttachmentUuid == "") {
        base.alert(1, "录音文件上传失败，请重试");
        hideLoading();
        dialog.hideDialog();
        return;
      }
      releasePost();
    });
  };

  //新建的发表
  var releasePost = function () {
    var attachmentUuidString = getAttachmentUuidString();
    var attachmentNameString = getAttachmentNameString();
    databind.submit([], {
      action: "createReadingPostAccount",
      version: "v1.0",
      data: {
        bookId: bookId,
        postType: postType,
        postContent: encodeURIComponent(utf16toEntities($(".post-content-text").val()||"")),
        imageAttachmentUuid: attachmentUuidString,
        imageAttachmentName: attachmentNameString,
        audioAttachmentUuid: audioAttachmentUuid,
        audioTime: audioTotalTime,
        postState: 2 //1草稿 ，2发布
      },
      success: function (data) {
        // hideLoading();
        base.alert(1, "发布成功!", 1500);
        $(".dialog-container").addClass("none");
        setTimeout(function () {
          base.back();
        }, 1500)
      }
    });
  };

  //获得插件Uuid
  var getAttachmentUuidString = function () {
    var attachmentUuidString = "";
    var attachmentList = $(".attaches");
    attachmentList.each(function (index, element) {
      attachmentUuidString = attachmentUuidString + $(element).attr("fileUuid") + ",";
    });
    attachmentUuidString = attachmentUuidString.slice(0, -1);
    return attachmentUuidString;
  };

  //获得插件名
  var getAttachmentNameString = function () {
    var attachmentNameString = "";
    var attachmentList = $(".attaches");
    attachmentList.each(function (index, element) {
      attachmentNameString = attachmentNameString + $(element).attr("fileName") + ",";
    });
    attachmentNameString = attachmentNameString.slice(0, -1);
    return attachmentNameString;
  };


  /**
   * 自适应以及一些限制样式相关
   */
  var checkAttachmentReachTheLimit = function () {
    var currentAttrCount = $(".post-attachment-area").children().length;
    if (currentAttrCount > 9) {
      $(".add-btn").parent(".post-attachment-item").addClass("none");
    } else {
      $(".add-btn").parent(".post-attachment-item").removeClass("none");
    }
  };

  //计算背景样式大小
  var calculateBgSize = function () {
    var winWidth = 0;
    var winHeight = 0;
    // 获取窗口宽度
    if (window.innerWidth)
      winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
      winWidth = document.body.clientWidth;
    // 获取窗口高度
    if (window.innerHeight)
      winHeight = window.innerHeight;
    else if ((document.body) && (document.body.clientHeight))
      winHeight = document.body.clientHeight;
    // 通过深入 Document 内部对 body 进行检测，获取窗口大小
    if (document.documentElement && document.documentElement.clientHeight && document.documentElement.clientWidth) {
      winHeight = document.documentElement.clientHeight;
      winWidth = document.documentElement.clientWidth;
    }
    var bgTopSize = winWidth * 0.5815; //由图片分辨率得出
    var bgBottomSize = winWidth * 0.912; //由图片分辨率得出
    //撑开屏幕总高度
    // var newWinHeight = winHeight > bgTopSize + bgBottomSize ? winHeight : bgTopSize + bgBottomSize;
    var bgRepeat = winHeight - bgTopSize - bgBottomSize;
    //背景
    dom.find(".record-bg").css("min-height", winHeight);
    dom.find(".record-bg-top").css("min-height", bgTopSize);
    dom.find(".record-bg-middle").css("top", (bgTopSize - 1));
    dom.find(".record-bg-middle-img").css("height", bgRepeat);
    dom.find(".record-bg-bottom").css("min-height", bgBottomSize + 1);
    //如果背景图片一个屏幕容纳不下，截掉下面部分
    if (winHeight < bgTopSize + bgBottomSize) {
      dom.find(".record-bg-bottom").css("top", bgTopSize - 1);
    }
    //录音计数器背景图片定位
    var recordClockLeft = (winWidth - 150) / 2;
    dom.find(".record-clock-bg").css("left", recordClockLeft + "px");
  };


  var androidBackButtonEvent = function () {
    window._android_on_back_pressed = function () {
      askSaveDraftBefore();
      return false;
    }
  };

  /**
   * 帖子录音相关
   */
    //初始化录音按钮的时间
  var initRecordBtnEvent = function () {
      //界面初始化
      //所有按钮全部隐藏
      dom.find(".btn-event").addClass("none");
      //录音界面显示
      dom.find(".record-interface").removeClass("none");
      $(".record-clock").html("00:00");
      //播放界面隐藏
      dom.find(".play-interface").addClass("none");

      //开始录音事件
      dom.on("click", ".btn-start-record-img", function () {
        if (isHaveMicroPhonePermission) {
          dom.find(".btn-event").addClass("none");
          dom.find(".btn-end-record-img").removeClass("none");
          startRecord();
          createRecordInterval();
        } else {
          base.alert(2,"请先开启录音权限");
        }
      });

      //结束录音事件
      dom.on("click", ".btn-end-record-img", function () {
        dom.find(".btn-event").addClass("none");
        dom.find(".btn-play-img").removeClass("none");
        dom.find(".btn-record-again-img").removeClass("none");
        dom.find(".btn-record-release-img").removeClass("none");
        endRecord();
        dom.find(".record-interface").addClass("none");
        canvasContext.clearRect(0, 0, canvas.width, canvas.height);
        //初始化播放器事件
        initPlayerEvent();
        clearInterval(recordClockTimer);
        $(".progress-bar-position").removeClass("none");
        $(".audio-time").removeClass("none");
        $(".record-clock").addClass("none");
        $(".record-clock-bg").addClass("none");
      });

      //播放录音事件
      dom.on("click", ".btn-play-img", function () {
        audio.loop = false;
        dom.find(".btn-event").addClass("none");
        dom.find(".btn-pause-play-img").removeClass("none");
        dom.find(".btn-record-again-img").removeClass("none");
        dom.find(".btn-record-release-img").removeClass("none");
      });

      //暂停播放录音事件
      dom.on("click", ".btn-pause-play-img", function () {
        dom.find(".btn-event").addClass("none");
        dom.find(".btn-play-img").removeClass("none");
        dom.find(".btn-record-again-img").removeClass("none");
        dom.find(".btn-record-release-img").removeClass("none");
      });

      //重录事件
      dom.on("click", ".btn-record-again-img", function () {
        if (isHaveMicroPhonePermission) {
          dom.find(".btn-event").addClass("none");
          dom.find(".btn-end-record-img").removeClass("none");
          $(".progress-bar-position").addClass("none");
          $(".audio-time").addClass("none");
          $(".record-clock").removeClass("none");
          $(".record-clock-bg").removeClass("none");
          $(".record-clock").html("00:00");
          createRecordInterval();
          stopAllAudio();
          startRecord();
          recordAgainFlag = 1;//标记有重新录制 如果用户选保留则需要重新上传录音
          initCircleProgress();
          $("#circle-progress").removeClass("none");
        }else{
          base.alert(2,"请开启录音权限")
        }
      });

      //发表录音事件
      dom.on("click", ".btn-record-release-img", function () {
        var isCanRelease = checkIsCanRelease();
        if (isCanRelease) {
          releaseBefore();
        }
      });
    };

  //初始化播放器控制事件
  var initPlayerEvent = function () {
    audio = $('audio')[0];
    $('.btn-play-img').click(function () {
      audio.play();
    });

    $('.btn-pause-play-img').click(function () {
      audio.pause();
    });

    //监听播放器时间变化
    audio.addEventListener('timeupdate', function () {
      updateProgress(audio);
    }, false);

    /**
     * 更新进度条与当前播放时间
     * @param {object} audio - audio对象
     */
    function updateProgress(audio) {
      var value = audio.currentTime / audio.duration;
      $('#progressBar').css('width', value * 100 + '%');
      $('#progressDot').css('left', (value * 100 - 1) + '%');
      $('#audioCurTime').html(transTime(audio.currentTime));
    }

    // 监听播放完成事件
    audio.onended = function () {
      audioEnded();
    };

    /**
     * 播放完成时把进度调回开始的位置
     */
    function audioEnded() {
      $('#progressBar').css('width', 0);
      $('#progressDot').css('left', "-1%");
      $(".btn-pause-play-img").addClass("none");
      $(".btn-play-img").removeClass("none");
      audio.pause();
    }

    $('#progressBarBg').on('mousedown', function (e) {
      // 只有音乐开始播放后才可以调节，已经播放过但暂停了的也可以
      if (!audio.paused || audio.currentTime != 0) {
        var pgsWidth = $('.progress-bar-position').width();
        var rate = e.offsetX / pgsWidth;
        audio.currentTime = parseInt(audio.duration * rate);
        updateProgress(audio);
      }
    });

    //todo 拖动进度暂时还不能用
    // var progressBarBg = document.getElementById("progressBarBg"); //进度条外框背景 用来算最大可拖动距离
    // var progress = document.getElementById("progressBar"); //进度条
    // var dot = document.getElementById('progressDot'); //进度条点  也是拖动的触发点 点住"点"可以拖动
    // var dotMouseMoveDownFlag = false; //进度条点 是否按下后要执行拖动计算的标记
    // var disX,moveX,moveL,max;
    //
    // dot.addEventListener("mousedown",moveDown,false);
    // document.addEventListener("mousemove",moveMove,false);
    // document.addEventListener("mouseup",moveUp,false);
    //
    // function moveDown(e){
    //   // audio.pause();
    //   dotMouseMoveDownFlag = true; //标记拖动
    //   var l = dot.offsetLeft;
    //   var x = e.clientX ;
    //
    //   disX = x-l;  //点击滑块内区域，即鼠标点击点距离元素左边缘的距离
    //   max = progressBarBg.offsetWidth - dot.offsetWidth;  //移动最大距离
    // }
    //
    // function moveMove(e){
    //   if (!dotMouseMoveDownFlag) {   //若没有mousedown滑块，则mousemove不产生距离
    //     return;
    //   }
    //   moveX = e.clientX;
    //   /**
    //    * [moveL 滑块移动总距离]
    //    * moveL = moveX - disX ; //粗略值：滑块移动总距离
    //    * moveL = Math.max(0,moveX - disX); //取0(初始left值)到moveL粗略值的中较大值，避免左侧滑出进度条范围
    //    * moveL = Math.min(max,moveL); //取两者的最小值，避免右侧滑出进度条范围
    //    */
    //
    //   moveL = Math.min(max,Math.max(0,moveX - disX));
    //
    //   var pgsWidth = $('.progress-bar-position').width();
    //   var rate = e.offsetX / pgsWidth;
    //   audio.currentTime = parseInt(audio.duration * rate);
    //   updateProgress(audio);
    //   // handle.style.left = moveL + 'px';  //设置滑块left值
    //   // progress.style.width = moveL + 'px';
    // }
    //
    // function moveUp(e){
    //   dotMouseMoveDownFlag = false;
    // }



    // 鼠标拖动进度点时可以调节进度
    // 只有音乐开始播放后才可以调节，已经播放过但暂停了的也可以
    // 鼠标按下时

    // dot.onmousedown = function (e) {
    //   if (!audio.paused || audio.currentTime != 0) {
    //     var oriLeft = dot.offsetLeft;
    //     var mouseX = e.clientX;
    //     var maxLeft = oriLeft; // 向左最大可拖动距离
    //     var maxRight = document.getElementById('progressBarBg').offsetWidth - oriLeft; // 向右最大可拖动距离
    //
    //     // 禁止默认的选中事件（避免鼠标拖拽进度点的时候选中文字）
    //     if (e.preventDefault) {
    //       e.preventDefault();
    //     } else {
    //       e.returnValue = false;
    //     }
    //
    //     // 禁止事件冒泡
    //     if (e && e.stopPropagation) {
    //       e.stopPropagation();
    //     } else {
    //       window.event.cancelBubble = true;
    //     }
    //
    //     // 开始拖动
    //     dot.onmousemove = function (e) {
    //       var length = e.clientX - mouseX;
    //       if (length > maxRight) {
    //         length = maxRight;
    //       } else if (length < -maxLeft) {
    //         length = -maxLeft;
    //       }
    //       var pgsWidth = $('.progress-bar-bg').width();
    //       var rate = (oriLeft + length) / pgsWidth;
    //       audio.currentTime = audio.duration * rate;
    //       updateProgress(audio);
    //     };
    //
    //     // 拖动结束
    //     dot.onmouseup = function () {
    //       dot.onmousemove = null;
    //       dot.onmouseup = null;
    //     };
    //   }
    // };
  };

  //创建录音定时器
  var createRecordInterval = function () {
    clearInterval(recordClockTimer);
    recordCurrentTime = 0;
    recordClockTimer = setInterval(function () {
      recordCurrentTime = recordCurrentTime + 1;
      if (recordCurrentTime >= 180) {
        clearInterval(recordClockTimer);
        $(".btn-end-record-img").trigger("click");
        return;
      }
      var recordTime = formatRecordTime(recordCurrentTime);
      circleProgress(recordCurrentTime);
      $(".record-clock").html(recordTime);
    }, 1000)
  };

  var formatRecordTime = function (second) {
    var m = parseInt(second / 60);
    var s = parseInt(second - (m * 60));
    var recordSecond = "";
    if (s < 10) {
      recordSecond = "0" + s;
    } else {
      recordSecond = s + "";
    }
    var recordTime = "0" + m + ":" + recordSecond;
    return recordTime;
  };

  /**
   * 音频播放时间换算
   * @param {number} value - 音频当前播放时间，单位秒
   */
  var transTime = function (value) {
    var time = "";
    var h = parseInt(value / 3600);
    value %= 3600;
    var m = parseInt(value / 60);
    var s = parseInt(value % 60);
    if (h > 0) {
      time = formatTime(h + ":" + m + ":" + s);
    } else {
      time = formatTime(m + ":" + s);
    }
    return time;
  };
  /**
   * 格式化时间显示，补零对齐
   * eg：2:4  -->  02:04
   * @param {string} value - 形如 h:m:s 的字符串
   */
  var formatTime = function (value) {
    var time = "";
    var s = value.split(':');
    var i = 0;
    for (; i < s.length - 1; i++) {
      time += s[i].length == 1 ? ("0" + s[i]) : s[i];
      time += ":";
    }
    time += s[i].length == 1 ? ("0" + s[i]) : s[i];
    return time;
  };

  //录音无效重新显示录音界面或者录音草稿界面
  var reloadRecordInterface = function () {
    if (isDraft == "true") {
      loadData();
    } else {
      //无草稿，重新显示新建录音的界面
      calculateBgSize();
      dom.find(".btn-event").addClass("none");
      //录音界面显示
      dom.find(".record-interface").removeClass("none");
      $(".record-clock").html("00:00");
      //播放界面隐藏
      dom.find(".play-interface").addClass("none");
      // initRecordBtnEvent();
      initCircleProgress();
    }
  };

  //录音圆形进度条
  var circleProgress = function (time) {
    canvas = document.getElementById('circle-progress');  //获取canvas元素
    canvasContext = canvas.getContext('2d');  //获取画图环境，指明为2d
    centerX = canvas.width / 2;   //Canvas中心点x轴坐标
    centerY = canvas.height / 2;  //Canvas中心点y轴坐标
    rad = Math.PI / 180 * 2; //将360度分成180份，那么每一份就是rad度
    offsetRad = rad * 90 / 2;
    // speed = 1;
    //绘制进度圈
    function progressCircle(time) {
      //
      var g = canvasContext.createLinearGradient(0, 0, 0, 180);
      g.addColorStop(0, "#fdba4b");
      g.addColorStop(1, "#f37913");

      canvasContext.save();
      canvasContext.strokeStyle = g; //设置描边样式
      canvasContext.lineWidth = 18; //设置线宽
      canvasContext.beginPath(); //路径开始
      canvasContext.arc(centerX, centerY, 100, 1.5 * Math.PI, rad * time - offsetRad, false); //用于绘制圆弧canvasContext.arc(x坐标，y坐标，半径，起始角度，终止角度，顺时针/逆时针)
      canvasContext.stroke(); //绘制
      canvasContext.closePath(); //路径结束
      canvasContext.restore();
    }

    //绘制外圈
    function outerCircle() {
      canvasContext.save();
      canvasContext.beginPath();
      canvasContext.strokeStyle = "#70b22d";
      canvasContext.lineWidth = 25; //设置线宽
      canvasContext.arc(centerX, centerY, 100, -0.5 * Math.PI, Math.PI * 2, false);
      canvasContext.stroke();
      canvasContext.closePath();
      canvasContext.restore();
    }

    //动画循环
    canvasContext.clearRect(0, 0, canvas.width, canvas.height);
    outerCircle();
    if (time != 0) {
      progressCircle(time);
    }
  };

  var initCircleProgress = function () {
    canvas = document.getElementById('circle-progress'); //获取canvas元素
    canvasContext = canvas.getContext('2d');  //获取画图环境，指明为2d
    centerX = canvas.width / 2;  //Canvas中心点x轴坐标
    centerY = canvas.height / 2;  //Canvas中心点y轴坐标

    //绘制白色外圈
    function outerCircle() {
      canvasContext.save();
      canvasContext.beginPath();
      canvasContext.strokeStyle = "#70b22d";
      canvasContext.lineWidth = 25; //设置线宽
      canvasContext.arc(centerX, centerY, 100, -0.5 * Math.PI, Math.PI * 2, false);
      canvasContext.stroke();
      canvasContext.closePath();
      canvasContext.restore();
    }

    outerCircle();
  };

  /**
   * 其他
   */
  var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("decode", function (replyContent) {
      return uncodeUtf16(decodeURIComponent(replyContent));
    });
  };

  var adaptiveImageHeight = function () {
    $(".img-overflow-style").css("height", $(".add-btn").width() + "px");
    $(".img-overflow-style").css("line-height", $(".add-btn").width() + "px");
  };


  /**
   * 与原生相关
   */
  var checkOpenMicroPhonePermission = function (data) {
    if(data=="1"){
      isHaveMicroPhonePermission = true;
    }
  };

  var startRecord = function () {
    recording = "true";
    base.keepScreenOn();
    base.startRecord(recordCallback);
  };

  var endRecord = function () {
    recording = "false";
    base.cancelKeepScreenOn();
    base.endRecord();
  };

  var recordCallback = function (data) {
    audio.ondurationchange = function () {
      $(".audio-length-total").html(formatRecordTime(recordCurrentTime));
      audioTotalTime = parseInt(recordCurrentTime);
    };

    //本方法返回后面带一个"s"要去除 （安卓返回没有s，ios返回有一个"s"）
    var recordMillisecond = parseInt(data.data[0].duration.replace(/[^\d|.]/ig, ""));

    if (recordMillisecond < 10000) {
      base.alert(1, "录音时间不足10秒");
      recordAgainFlag = 0; //本次重录为无效录音把有重新录制标记回无
      reloadRecordInterface();
    } else {
      $(".audio-file-preview").attr("src", data.data[0].filePath);
      audioTotalTime = parseInt(recordCurrentTime);
      audioFilePath = data.data[0].filePath;
      audio.load();
      audio.loop = false;
    }
  };

  var stopAllAudio = function (){
    var allAudioList = $(".content").find('audio');
    for (var i = 0; i < allAudioList.length; i++) {
      var audioItem = allAudioList[i];
      audioItem.pause();
      audioItem.currentTime = 0;
    }
  };

  //转菊花
  var showLoading = function () {
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function () {
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

  var utf16toEntities = function (str) {
    var patt=/[\ud800-\udbff][\udc00-\udfff]/g; // 检测utf16字符正则
    str = str.replace(patt, function(char){
      var H, L, code;
      if (char.length===2) {
        H = char.charCodeAt(0); // 取出高位
        L = char.charCodeAt(1); // 取出低位
        code = (H - 0xD800) * 0x400 + 0x10000 + L - 0xDC00; // 转换算法
        return "&#" + code + ";";
      } else {
        return char;
      }
    });
    return str;
  };

  var uncodeUtf16 = function (str) {
    var reg = /\&#.*?;/g;
    var result = str.replace(reg,function(char){
      var H,L,code;
      if(char.length == 9 ){
        code = parseInt(char.match(/[0-9]+/g));
        H = Math.floor((code-0x10000) / 0x400)+0xD800;
        L = (code - 0x10000) % 0x400 + 0xDC00;
        return unescape("%u"+H.toString(16)+"%u"+L.toString(16));
      }else{
        return char;
      }
    });
    return result;
  };

  return {
    init: init
  };
});
