// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var readingUtil = require("readingUtil");
	var dom;
	var studentType;
	var timeType;
	var fromClass;
	var pageIndex;

	var init = function(c, s, t) {
		dom = $("#rank-list-integral");
		fromClass = c;
		studentType = s;
		timeType = t;
		pageIndex = 1;
		router.init();
		initEvent();
		initJuicer();
		initType();
		fromClassMethod(fromClass);
		// inquireIntegralTotalListTenant();
	};

	var initEvent = function() {
		initTimeTreeList();

    //更多
    dom.on("click", ".more", function(){
      pageIndex++;

      if (fromClass == 1){
      	inquireClassTotalListTenantMore();
			} else {
        inquireIntegralTotalListTenantMore();
			}
    });

		dom.on("click", ".classSelect", function(){
			dom.find('#type_select').mobiscroll('show');
			dom.find('#type_select_class').mobiscroll('show');
		});

		dom.on("click", ".timeSelect", function(){
			dom.find('#time_select').mobiscroll('show');
		});

		dom.on("click", ".headToInfo", function(){
            var studentId = $(this).attr("studentId");
            var schoolId = $(this).attr("schoolId");
            base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId,"");
        });

        dom.on("click", ".classToInfo", function(){
            var classId = $(this).attr("classId");
            var schoolId = $(this).attr("schoolId");
            base.openUrl("index.html#studentPage.class-info?classId="+classId+"&schoolId="+schoolId,"");
        });

        dom.on("click", ".personal-rank", function(){
            var studentId = $(this).attr("studentId");
            var schoolId = $(this).attr("schoolId");
            base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId,"");
        });

        dom.on("click", ".class-rank", function(){
            var classId = $(this).attr("classId");
            var schoolId = $(this).attr("schoolId");
           base.openUrl("index.html#studentPage.class-info?classId="+classId+"&schoolId="+schoolId,"");
        });
	};

	var initJuicer = function(){
		juicer.register("getReadingLevel", function (level) {
			return readingUtil.getReadingLevelDom(level);
		});

		juicer.register("schoolAndGrade", function(dt){
			if (studentType == 2 || studentType == 3) {
				return dt.grade+dt.className;
			}else if (studentType == 4) {
				return dt.schoolName + " " +dt.grade+dt.className;
			}else{
				return "";
			}
		});

		juicer.register("school", function(dt){
			if (studentType == 4) {
				return dt.schoolName;
			}else{
				return "";
			}
		});

		juicer.register("integralType", function(){
			if (timeType == 1) {
				return "周积分";
			}else if (timeType == 2) {
				return "月积分";
			}else if (timeType == 3) {
				return "学期积分";
			}else if (timeType == 4) {
				return "总积分"
			} else if (timeType == 5){
				return "周积分";
			}
		});

		juicer.register("classIntegralType", function(){
			if (timeType == 1) {
				return "人均周积分";
			}else if (timeType == 2) {
				return "人均月积分";
			}else if (timeType == 3) {
				return "人均学期积分";
			}else if (timeType == 4) {
				return "人均总积分"
			}else if (timeType == 5){
				return "人均周积分";
			}
		});

    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("index", function (idx) {
    	if (pageIndex == 1){
    		return parseInt(idx)+4;
			} else {
    		return parseInt(idx)+1+(pageIndex-1)*20;
			}
    });
	};

	var loadData = function() {

	};

	var initType = function(){
		switch(studentType){
			case "1":
			dom.find(".classSelectContent").text("全班");
			break;
			case "2":
			dom.find(".classSelectContent").text("全年级");
			break;
			case "3":
			dom.find(".classSelectContent").text("全校");
			break;
			case "4":
			dom.find(".classSelectContent").text("全平台");
			break;
		}
		switch(timeType){
			case "1":
			dom.find(".timeSelectContent").text("本周");
			break;
			case "2":
			dom.find(".timeSelectContent").text("本月");
			break;
			case "3":
			dom.find(".timeSelectContent").text("本学期");
			break;
			case "4":
			dom.find(".timeSelectContent").text("总榜");
			break;
			case "5":
			dom.find(".timeSelectContent").text("上周");
			break;
		}
	};

	//查询个人积分榜单
	var inquireIntegralTotalListTenant = function(){
		showLoading();
		databind.submit([], {
			action: "inquireIntegralTotalListTenant",
			version: "v1.0",
			data: {
				studentType: studentType,
				timeType: timeType
			},
			success:function(data){
				hideLoading();
				dom.find(".nodata").addClass("none");
				dom.find(".integralPersonal").addClass("none");
				dom.find(".personalLeft").addClass("none");
				dom.find(".personalMid").addClass("none");
				dom.find(".personalRight").addClass("none");
				var ret = data.datas;
				if (ret.length == 0) {
					dom.find(".nodata").removeClass("none");
				}
				for (var i = 0; i < ret.length; i++) {
					var dic = ret[i];
					if (i == 0) {
						dom.find(".integralPersonal").removeClass("none");
						var top1Dom = dom.find(".personalMid");
						top1Dom.find(".personalTopHead").attr("studentId", dic.studentId);
						top1Dom.find(".personalTopHead").attr("schoolId", dic.schoolId);
						top1Dom.removeClass("none");
						top1Dom.find(".name").html(dic.studentName);
						if (studentType == 2 || studentType == 3) {
							top1Dom.find(".school").html(dic.grade+dic.className);
						}else if (studentType == 4) {
							top1Dom.find(".school").html(dic.schoolName + " " +dic.grade+dic.className);
						}else{
							top1Dom.find(".school").html("");
						}
						if (dic.proFilePhotoUuid !== ""){
              top1Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.proFilePhotoUuid + "&view=1&size=120");
            }
						top1Dom.find(".integralPoint").html(dic.integral+"分");
					}else if (i == 1) {
						var top2Dom = dom.find(".personalLeft");
						top2Dom.removeClass("none");
						top2Dom.find(".name").html(dic.studentName);
						top2Dom.find(".personalHead").attr("studentId", dic.studentId);
						top2Dom.find(".personalHead").attr("schoolId", dic.schoolId);
						if (studentType == 2 || studentType == 3) {
							top2Dom.find(".school").html(dic.grade+dic.className);
						}else if (studentType == 4) {
							top2Dom.find(".school").html(dic.schoolName + " " +dic.grade+dic.className);
						}else{
							top2Dom.find(".school").html("");
						}
            if (dic.proFilePhotoUuid !== ""){
              top2Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.proFilePhotoUuid + "&view=1&size=120");
            }
						top2Dom.find(".integralPoint").html(dic.integral+"分");
					}else if (i == 2) {
						var top3Dom = dom.find(".personalRight");
						top3Dom.removeClass("none");
						top3Dom.find(".name").html(dic.studentName);
						top3Dom.find(".personalHead").attr("studentId", dic.studentId);
						top3Dom.find(".personalHead").attr("schoolId", dic.schoolId);
						if (studentType == 2 || studentType == 3) {
							top3Dom.find(".school").html(dic.grade+dic.className);
						}else if (studentType == 4) {
							top3Dom.find(".school").html(dic.schoolName + " " +dic.grade+dic.className);
						}else{
							top3Dom.find(".school").html("");
						}
            if (dic.proFilePhotoUuid !== ""){
              top3Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.proFilePhotoUuid + "&view=1&size=120");
            }
						top3Dom.find(".integralPoint").html(dic.integral+"分");
					}
				}
				data.datas = data.datas.slice(3, data.datas.length);
				var html = juicer(dom.find("#personal-rank-tpl").html(), data);
				dom.find(".rank-list-other").html(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
			}
		});
	};

  //查询个人积分榜单
  var inquireIntegralTotalListTenantMore = function(){
    showLoading();
    databind.submit([], {
      action: "inquireIntegralTotalListTenant",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType,
				pageIndex: pageIndex
      },
      success:function(data){
        hideLoading();
        dom.find(".more").remove();
        var html = juicer(dom.find("#personal-rank-tpl").html(), data);
        dom.find(".rank-list-other").append(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

	var inquireReadingStudentIntegralRankAccount = function () {
    databind.submit([], {
      action: "inquireReadingStudentIntegralRankAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType
      },
      success:function(data){
        var html = juicer(dom.find("#my-rank-tpl").html(), data.datas[0]);
        dom.find(".myRank").html(html);
      }
    });
  };

	var inquireReadingClassRankAccount = function () {
    databind.submit([], {
      action: "inquireReadingClassRankAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType
      },
      success:function(data){
      	// data.datas[0].rank = "0";
        var html = juicer(dom.find("#my-class-rank-tpl").html(), data.datas[0]);
        dom.find(".classRank").html(html);
      }
    });
  };

	//查询班级积分榜单
	var inquireClassTotalListTenant = function(){
		showLoading();
		databind.submit([], {
			action: "InquireClassTotalListTenant",
			version: "v1.0",
			data: {
				studentType: studentType,
				timeType: timeType
			},
			success:function(data){
				hideLoading();
				dom.find(".nodata").addClass("none");
				dom.find(".integralClass").addClass("none");
				dom.find(".personalLeft").addClass("none");
				dom.find(".personalMid").addClass("none");
				dom.find(".personalRight").addClass("none");
				var ret = data.datas;
				if (ret.length == 0) {
					dom.find(".nodata").removeClass("none");
				}
				for (var i = 0; i < ret.length; i++) {
					var dic = ret[i];
					if (i == 0) {
						dom.find(".integralClass").removeClass("none");
						var top1Dom = dom.find(".personalMid");
						top1Dom.removeClass("none");
						top1Dom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
						top1Dom.find(".classTopHead").attr("classId", dic.classId);
						top1Dom.find(".classTopHead").attr("schoolId", dic.schoolId);
						if (studentType == 4) {
                             top1Dom.find(".school").html(dic.schoolName);
                        }
						top1Dom.find(".avgIntegral").text(dic.avgIntegral+"分");
					}else if (i == 1) {
						var top2Dom = dom.find(".personalLeft");
						top2Dom.removeClass("none");
						top2Dom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
						top2Dom.find(".classHead").attr("classId", dic.classId);
						top2Dom.find(".classHead").attr("schoolId", dic.schoolId);
						if (studentType == 4) {
                             top2Dom.find(".school").html(dic.schoolName);
                        }
						top2Dom.find(".avgIntegral").text(dic.avgIntegral+"分");
					}else if (i == 2) {
						var top3Dom = dom.find(".personalRight");
						top3Dom.removeClass("none");
						top3Dom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
						top3Dom.find(".classHead").attr("classId", dic.classId);
						top3Dom.find(".classHead").attr("schoolId", dic.schoolId);
						if (studentType == 4) {
                             top3Dom.find(".school").html(dic.schoolName);
                        }
						top3Dom.find(".avgIntegral").text(dic.avgIntegral+"分");
					}
				}
				data.datas = data.datas.slice(3, data.datas.length);
				var html = juicer(dom.find("#class-rank-tpl").html(), data);
				dom.find(".rank-list-other").html(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
			}
		});
	};

  var inquireClassTotalListTenantMore = function(){
    showLoading();
    databind.submit([], {
      action: "InquireClassTotalListTenant",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType,
				pageIndex: pageIndex
      },
      success:function(data){
        hideLoading();
        dom.find(".more").remove();
        var html = juicer(dom.find("#class-rank-tpl").html(), data);
        dom.find(".rank-list-other").append(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

	var initTypeTreeList = function(data) {
		$('#type_select').mobiscroll().treelist({
			theme: 'ios',
			mode: 'scroller',
			display: 'bottom',
			lang: 'zh',
			showInput: false,
			circular: false,
			defaultValue: [studentType],
			onSet: function(event, inst) {
				switch(event.valueText){
					case "1":
					dom.find(".classSelectContent").text("全班");
					studentType = 1;
					break;
					case "2":
					studentType = 2;
					dom.find(".classSelectContent").text("全年级");
					break;
					case "3":
					studentType = 3;
					dom.find(".classSelectContent").text("全校");
					break;
					case "4":
					studentType = 4;
					dom.find(".classSelectContent").text("全平台");
					break;
				}
				var studentTypeDic = {};
				studentTypeDic.studentType = studentType;
				base.saveData("studentType", JSON.stringify(studentTypeDic));
				inquireIntegralTotalListTenant();
        inquireReadingStudentIntegralRankAccount();
			}
		});
	}

	var initClassTypeTreeList = function(data) {
		$('#type_select_class').mobiscroll().treelist({
			theme: 'ios',
			mode: 'scroller',
			display: 'bottom',
			lang: 'zh',
			showInput: false,
			circular: false,
			defaultValue: [studentType],
			onSet: function(event, inst) {
				switch(event.valueText){
					case "2":
					studentType = 2;
					dom.find(".classSelectContent").text("全年级");
					break;
					case "3":
					studentType = 3;
					dom.find(".classSelectContent").text("全校");
					break;
					case "4":
					studentType = 4;
					dom.find(".classSelectContent").text("全平台");
					break;
				}
				var studentTypeDic = {};
				studentTypeDic.studentType = studentType;
				base.saveData("studentType", JSON.stringify(studentTypeDic));
				inquireClassTotalListTenant();
        inquireReadingClassRankAccount();
			}
		});
	}

	var initTimeTreeList = function(data) {
		$('#time_select').mobiscroll().treelist({
			theme: 'ios',
			mode: 'scroller',
			display: 'bottom',
			lang: 'zh',
			showInput: false,
			circular: false,
			defaultValue: [timeType],
			onSet: function(event, inst) {
				switch(event.valueText){
					case "1":
					dom.find(".timeSelectContent").text("本周");
					timeType = 1;
					break;
					case "2":
					dom.find(".timeSelectContent").text("本月");
					timeType = 2;
					break;
					case "3":
					dom.find(".timeSelectContent").text("本学期");
					timeType = 3;
					break;
					case "4":
					dom.find(".timeSelectContent").text("总榜");
					timeType = 4;
					break;
					case "5":
					dom.find(".timeSelectContent").text("上周");
					timeType = 5;
					break;
				}
				if (fromClass == 1) {
					inquireClassTotalListTenant();
          inquireReadingClassRankAccount();
				}else{
					inquireIntegralTotalListTenant();
          inquireReadingStudentIntegralRankAccount();
				}
				var timeTypeDic = {};
				timeTypeDic.timeType = timeType;
				base.saveData("timeType", JSON.stringify(timeTypeDic));
			}
		});
	}

	var fromClassMethod = function(fromClass){
		if (fromClass == 1) {
			dom.find(".integralPersonal").addClass("none");
			// dom.find(".integralClass").removeClass("none");
			initClassTypeTreeList();
			inquireClassTotalListTenant();
      inquireReadingClassRankAccount();
		}else{
			// dom.find(".integralPersonal").removeClass("none");
			dom.find(".integralClass").addClass("none");
			initTypeTreeList();
			inquireIntegralTotalListTenant();
      inquireReadingStudentIntegralRankAccount();
		}
	};

	//转菊花
    var showLoading = function(){
        $(".fullBg").removeClass("none");
        $(".loader").removeClass("none");
    };
    //隐藏菊花
    var hideLoading = function(){
        $(".fullBg").addClass("none");
        $(".loader").addClass("none");
    };

	return {
		init: init
	};
});
