// 主界面
;
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var readingUtil = require("readingUtil");
  var dom;
  var fromClass;
  var studentType;
  var timeType;
  var pageIndex;

  var init = function(c, s, t) {
    fromClass = c;
    studentType = s;
    timeType = t;
    pageIndex = 1;
    dom = $("#rank-list-read");
    fromClassMethod(fromClass);
    router.init();
    initEvent();
    initType();
    initJuicer();
  };

  var initEvent = function() {
    initTimeTreeList();

    //更多
    dom.on("click", ".more", function(){
      pageIndex++;

      if (fromClass == 1){
        inquireReadingClassPostRankListAccountMore();
      } else {
        inquireReadingStudentPostRankListAccountMore();
      }
    });

    dom.on("click", ".classSelect", function(){
      dom.find('#type_select').mobiscroll('show');
      dom.find('#type_select_class').mobiscroll('show');
    });

    dom.on("click", ".timeSelect", function(){
      dom.find('#time_select').mobiscroll('show');
    });

    dom.on("click", ".headToInfo", function(){
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId,"");
    });

    dom.on("click", ".classToInfo", function(){
      var classId = $(this).attr("classId");
      var schoolId = $(this).attr("schoolId");
      base.openUrl("index.html#studentPage.class-info?classId="+classId+"&schoolId="+schoolId,"");
    });

    dom.on("click", ".personal-rank", function(){
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId,"");
    });

    dom.on("click", ".class-rank", function(){
      var classId = $(this).attr("classId");
      var schoolId = $(this).attr("schoolId");
      base.openUrl("index.html#studentPage.class-info?classId="+classId+"&schoolId="+schoolId,"");
    });
  };

  var initJuicer = function(){
    juicer.register("getReadingLevel", function (level) {
      return readingUtil.getReadingLevelDom(level);
    });

    juicer.register("schoolAndGradeRead", function(dt){
      if (studentType == 2 || studentType == 3) {
        return dt.className;
      }else if (studentType == 4) {
        return dt.schoolName+dt.className;
      }
    });

    juicer.register("classSchool", function(dt){
      if (studentType == 4) {
        return dt.schoolName;
      }
    });

    juicer.register("integralTypeRead", function(){
      if (timeType == 1) {
        return "周篇数";
      }else if (timeType == 2) {
        return "月篇数";
      }else if (timeType == 3) {
        return "学期篇数";
      }else if (timeType == 4) {
        return "总篇数"
      }else if (timeType == 5){
        return "周篇数";
      }
    });

    juicer.register("classIntegralTypeRead", function(){
      if (timeType == 1) {
        return "人均周篇数";
      }else if (timeType == 2) {
        return "人均月篇数";
      }else if (timeType == 3) {
        return "人均学期篇数";
      }else if (timeType == 4) {
        return "人均总篇数"
      }else if (timeType == 5){
        return "人均周篇数"
      }
    });

    juicer.register("readingWordsQty", function(dt){
      return dt.toFixed(1);
    });

    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("postIndex", function (idx) {
      if (pageIndex == 1){
        return parseInt(idx)+4;
      } else {
        return parseInt(idx)+1+(pageIndex-1)*20;
      }
    });
  };

  var loadData = function() {

  };

  var inquireReadingStudentPostRankListAccount = function(){
    showLoading();
    databind.submit([], {
      action: "inquireReadingStudentPostRankListAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType
      },
      success:function(data){
        hideLoading();
        dom.find(".nodata").addClass("none");
        dom.find(".integralPersonal").addClass("none");
        dom.find(".personalLeft").addClass("none");
        dom.find(".personalMid").addClass("none");
        dom.find(".personalRight").addClass("none");
        var ret = data.datas;
        if (ret.length == 0) {
          dom.find(".nodata").removeClass("none");
        }
        for (var i = 0; i < ret.length; i++) {
          var dic = ret[i];
          if (i == 0) {
            dom.find(".integralPersonal").removeClass("none");
            var top1Dom = dom.find(".personalMid");
            top1Dom.removeClass("none");
            top1Dom.find(".name").html(dic.studentName);
            top1Dom.find(".personalTopHead").attr("studentId", dic.studentId);
            top1Dom.find(".personalTopHead").attr("schoolId", dic.schoolId);
            if (studentType == 2 || studentType == 3) {
              top1Dom.find(".school").html(dic.className);
            }else if (studentType == 1) {
              top1Dom.find(".school").html("");
            }else{
              top1Dom.find(".school").html(dic.schoolName+" "+dic.className);
            }
            if (dic.photoUuid !== ""){
              top1Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }
            top1Dom.find(".integralPoint").html(dic.postQty+"篇");
          }else if (i == 1) {
            var top2Dom = dom.find(".personalLeft");
            top2Dom.removeClass("none");
            top2Dom.find(".name").html(dic.studentName);
            top2Dom.find(".personalHead").attr("studentId", dic.studentId);
            top2Dom.find(".personalHead").attr("schoolId", dic.schoolId);
            if (studentType == 2 || studentType == 3) {
              top2Dom.find(".school").html(dic.className);
            }else if (studentType == 1) {
              top2Dom.find(".school").html("");
            }else{
              top2Dom.find(".school").html(dic.schoolName+" "+dic.className);
            }
            if (dic.photoUuid !== ""){
              top2Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }
            top2Dom.find(".integralPoint").html(dic.postQty+"篇");
          }else if (i == 2) {
            var top3Dom = dom.find(".personalRight");
            top3Dom.removeClass("none");
            top3Dom.find(".name").html(dic.studentName);
            top3Dom.find(".personalHead").attr("studentId", dic.studentId);
            top3Dom.find(".personalHead").attr("schoolId", dic.schoolId);
            if (studentType == 2 || studentType == 3) {
              top3Dom.find(".school").html(dic.className);
            }else if (studentType == 1) {
              top3Dom.find(".school").html("");
            }else{
              top3Dom.find(".school").html(dic.schoolName+" "+dic.className);
            }
            if (dic.photoUuid !== ""){
              top3Dom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }
            top3Dom.find(".integralPoint").html(dic.postQty+"篇");
          }
        }
        data.datas = ret.slice(3, ret.length);
        var html = juicer(dom.find("#personal-rank-tpl").html(), data);
        dom.find(".rank-list-other").html(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

  var inquireReadingStudentPostRankListAccountMore = function(){
    showLoading();
    databind.submit([], {
      action: "inquireReadingStudentPostRankListAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType,
        pageIndex: pageIndex
      },
      success:function(data){
        hideLoading();
        dom.find(".more").remove();
        var html = juicer(dom.find("#personal-rank-tpl").html(), data);
        dom.find(".rank-list-other").append(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

  var inquireReadingStudentPostRankAccount = function () {
    databind.submit([], {
      action: "inquireReadingStudentPostRankSituationAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType
      },
      success:function(data){
        var html = juicer(dom.find("#my-rank-tpl").html(), data.datas[0]);
        dom.find(".myRank").html(html);
      }
    });
  };

  var inquireReadingClassPostRankListAccount = function(){
    showLoading();
    databind.submit([], {
      action: "inquireReadingClassPostRankListAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType
      },
      success:function(data){
        hideLoading();
        dom.find(".nodata").addClass("none");
        dom.find(".integralClass").addClass("none");
        dom.find(".personalLeft").addClass("none");
        dom.find(".personalMid").addClass("none");
        dom.find(".personalRight").addClass("none");
        var ret = data.datas;
        if (ret.length == 0) {
          dom.find(".nodata").removeClass("none");
        }
        for (var i = 0; i < ret.length; i++) {
          var dic = ret[i];
          if (i == 0) {
            dom.find(".integralClass").removeClass("none");
            var top1Dom = dom.find(".personalMid");
            top1Dom.removeClass("none");
            top1Dom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
            top1Dom.find(".classTopHead").attr("classId", dic.classId);
            top1Dom.find(".classTopHead").attr("schoolId", dic.schoolId);
            if (studentType == 4) {
              top1Dom.find(".school").html(dic.schoolName);
            }
            top1Dom.find(".classReadingWordsQtyAvg").text("人均"+dic.classPostQtyAvg+"篇");
          }else if (i == 1) {
            var top2Dom = dom.find(".personalLeft");
            top2Dom.removeClass("none");
            top2Dom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
            top2Dom.find(".classHead").attr("classId", dic.classId);
            top2Dom.find(".classHead").attr("schoolId", dic.schoolId);
            if (studentType == 4) {
              top2Dom.find(".school").html(dic.schoolName);
            }
            top2Dom.find(".classReadingWordsQtyAvg").text("人均"+dic.classPostQtyAvg+"篇");
          }else if (i == 2) {
            var top3Dom = dom.find(".personalRight");
            top3Dom.removeClass("none");
            top3Dom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
            top3Dom.find(".classHead").attr("classId", dic.classId);
            top3Dom.find(".classHead").attr("schoolId", dic.schoolId);
            if (studentType == 4) {
              top3Dom.find(".school").html(dic.schoolName);
            }
            top3Dom.find(".classReadingWordsQtyAvg").text("人均"+dic.classPostQtyAvg+"篇");
          }
        }
        data.datas = ret.slice(3, ret.length);
        var html = juicer(dom.find("#class-rank-tpl").html(), data);
        dom.find(".rank-list-other").html(html);
        if (data.totalPageCount > pageIndex) {
          dom.find(".more").removeClass("none");
        }
      }
    });
  };

  var inquireReadingClassPostRankListAccountMore = function(){
    showLoading();
    databind.submit([], {
      action: "inquireReadingClassPostRankListAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType,
        pageIndex: pageIndex
      },
      success:function(data){
        hideLoading();
        dom.find(".more").remove();
        var html = juicer(dom.find("#class-rank-tpl").html(), data);
        dom.find(".rank-list-other").append(html);
      }
    });
  };

  var inquireReadingClassPostRankAccount = function () {
    databind.submit([], {
      action: "inquireReadingClassPostRankSituationAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType
      },
      success:function(data){
        var html = juicer(dom.find("#my-class-rank-tpl").html(), data.datas[0]);
        dom.find(".classRank").html(html);
      }
    });
  };

  var initType = function(){
    switch(studentType){
      case "1":
        dom.find(".classSelectContent").text("全班");
        break;
      case "2":
        dom.find(".classSelectContent").text("全年级");
        break;
      case "3":
        dom.find(".classSelectContent").text("全校");
        break;
      case "4":
        dom.find(".classSelectContent").text("全平台");
        break;
    }
    switch(timeType){
      case "1":
        dom.find(".timeSelectContent").text("本周");
        break;
      case "2":
        dom.find(".timeSelectContent").text("本月");
        break;
      case "3":
        dom.find(".timeSelectContent").text("本学期");
        break;
      case "4":
        dom.find(".timeSelectContent").text("总榜");
        break;
      case "5":
        dom.find(".timeSelectContent").text("上周");
        break;
    }
  };

  var fromClassMethod = function(fromClass){
    if (fromClass == 1) {
      initClassTypeTreeList();
      dom.find(".integralPersonal").addClass("none");
      dom.find(".integralClass").removeClass("none");
      inquireReadingClassPostRankListAccount();
      inquireReadingClassPostRankAccount();

    }else{
      initTypeTreeList();
      dom.find(".integralPersonal").removeClass("none");
      dom.find(".integralClass").addClass("none");
      inquireReadingStudentPostRankListAccount();
      inquireReadingStudentPostRankAccount();
    }
  };

  var initTypeTreeList = function(data) {
    $('#type_select').mobiscroll().treelist({
      theme: 'ios',
      mode: 'scroller',
      display: 'bottom',
      lang: 'zh',
      showInput: false,
      circular: false,
      defaultValue: [studentType],
      onSet: function(event, inst) {
        switch(event.valueText){
          case "1":
            dom.find(".classSelectContent").text("全班");
            studentType = 1;
            break;
          case "2":
            studentType = 2;
            dom.find(".classSelectContent").text("全年级");
            break;
          case "3":
            studentType = 3;
            dom.find(".classSelectContent").text("全校");
            break;
          case "4":
            studentType = 4;
            dom.find(".classSelectContent").text("全平台");
            break;
        }
        var studentTypeDic = {};
        studentTypeDic.studentType = studentType;
        base.saveData("studentType", JSON.stringify(studentTypeDic));
        if (fromClass == 1) {
          inquireReadingClassPostRankListAccount();
          inquireReadingClassPostRankAccount();
        }else{
          inquireReadingStudentPostRankListAccount();
          inquireReadingStudentPostRankAccount();
        }
      }
    });
  }

  var initClassTypeTreeList = function(data) {
    $('#type_select_class').mobiscroll().treelist({
      theme: 'ios',
      mode: 'scroller',
      display: 'bottom',
      lang: 'zh',
      showInput: false,
      circular: false,
      defaultValue: [studentType],
      onSet: function(event, inst) {
        switch(event.valueText){
          case "2":
            studentType = 2;
            dom.find(".classSelectContent").text("全年级");
            break;
          case "3":
            studentType = 3;
            dom.find(".classSelectContent").text("全校");
            break;
          case "4":
            studentType = 4;
            dom.find(".classSelectContent").text("全平台");
            break;
        }
        var studentTypeDic = {};
        studentTypeDic.studentType = studentType;
        base.saveData("studentType", JSON.stringify(studentTypeDic));
        inquireReadingClassPostRankListAccount();
        inquireReadingClassPostRankAccount();
      }
    });
  }

  var initTimeTreeList = function(data) {
    $('#time_select').mobiscroll().treelist({
      theme: 'ios',
      mode: 'scroller',
      display: 'bottom',
      lang: 'zh',
      showInput: false,
      circular: false,
      defaultValue: [timeType],
      onSet: function(event, inst) {
        switch(event.valueText){
          case "1":
            dom.find(".timeSelectContent").text("本周");
            timeType = 1;
            break;
          case "2":
            dom.find(".timeSelectContent").text("本月");
            timeType = 2;
            break;
          case "3":
            dom.find(".timeSelectContent").text("本学期");
            timeType = 3;
            break;
          case "4":
            dom.find(".timeSelectContent").text("总榜");
            timeType = 4;
            break;
          case "5":
            dom.find(".timeSelectContent").text("上周");
            timeType = 5;
            break;
        }
        var timeTypeDic = {};
        timeTypeDic.timeType = timeType;
        base.saveData("timeType", JSON.stringify(timeTypeDic));
        if (fromClass == 1) {
          inquireReadingClassPostRankListAccount();
          inquireReadingClassPostRankAccount();
        }else{
          inquireReadingStudentPostRankListAccount();
          inquireReadingStudentPostRankAccount();
        }
      }
    });
  }

  //转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

  return {
    init: init
  };
});
