// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var selectedId;
	var integral = require("./rank-list-integral.html");
	var integralJs = require("./rank-list-integral.js");
	var read = require("./rank-list-read.html");
	var readJs = require("./rank-list-read.js");
	var post = require("./rank-list-post.html");
	var postJs = require("./rank-list-post.js");
	var fromClass;
	var fromIntegral;
	var studentType;
	var timeType;

	var init = function() {
		dom = $("#rank-list");
		router.init();
		initEvent();
		initMenu();
		loadData();
	};

	var initEvent = function() {
		fromClass = base.getUrlParam("fromClass");
		fromIntegral = base.getUrlParam("fromIntegral");
		studentType = base.getUrlParam("studentType");
		timeType = base.getUrlParam("timeType");
		if (fromClass == 1) {
			dom.find(".header-title").html("班级榜单");
		}else{
			dom.find(".header-title").html("个人榜单");
		}
	};
	
	var loadData = function() {

	};
	
	var initMenu = function(){
		dom.find("#list-content").empty();

		var html = juicer(dom.find('#menustripTpl').html(), null);
		dom.find('#menustripTabs').append(html);
		// var tempSelected = base.getData("selectedId");
		// if (tempSelected !== null && tempSelected !== undefined) {
		// 	selectedId = tempSelected;
		// }
		if (fromIntegral == 1) {
			selectedId = "integral";
		}else if (fromIntegral == 2){
      selectedId = "post";
		} else{
			selectedId = "read";
		}
		if (selectedId) {
			dom.find("#" + selectedId).attr("data-selected", true);
			if (selectedId == "integral") {
				dom.find("#list-content").append(integral);
				integralJs.init(fromClass, studentType, timeType);
			} else if (selectedId == "read") {
				dom.find("#list-content").append(read);
				readJs.init(fromClass, studentType, timeType);
			} else if (selectedId == "post"){
        dom.find("#list-content").append(post);
        postJs.init(fromClass, studentType, timeType);
			}
		} else {
			dom.find("#integral").attr("data-selected", true);
			dom.find("#list-content").append(integral);
			integralJs.init(fromClass, studentType, timeType);
		}
		base.removeData("selectedId");
		$('#menustrip').mobiscroll().menustrip({
			theme: 'mobiscroll',
			display: 'top',
			type: 'tabs',
			onItemTap: function (event, inst) {
				var itemId = event.target.id;
				selectedId = itemId;
				base.saveData("selectedId",selectedId);
				//
				var tmpStudentType = base.getData("studentType");
				var tmpTimeType = base.getData("timeType");
				if (tmpStudentType !== undefined && tmpStudentType !== null) {
					var studentTypeDic = JSON.parse(tmpStudentType);
					if (studentTypeDic !== null) {
						studentType = studentTypeDic.studentType+"";
					}
				}
				if (tmpTimeType !== undefined && tmpTimeType !== null) {
					var timeTypeDic = JSON.parse(tmpTimeType);
					if (timeTypeDic !== null) {
						timeType = timeTypeDic.timeType+"";
					}
				}
				//
				dom.find("#list-content").empty();
				if (itemId == "integral") {
					dom.find("#list-content").append(integral);
					integralJs.init(fromClass, studentType, timeType);
				}else if (itemId == "read") {
					dom.find("#list-content").append(read);
					readJs.init(fromClass, studentType, timeType);
				}else if (selectedId == "post"){
          dom.find("#list-content").append(post);
          postJs.init(fromClass, studentType, timeType);
        }
      },
			onMarkupReady: function (event, inst) {

			},
		});
	};

	return {
		init: init
	};
});
