// 主界面
;
define(function (require, exports, module) {
    'use strict';
    var util = require("util");
    var base = require("base");
    var databind = require("databind");
    var listView = require("listView");
    var router = require("pageRouter");
    var dialog = require("dialog");
    var constant = require("constant");
    var dom;
    var studentType;
    var timeType;
    //屏幕奖状滚动
  var area;
  var con1;
  var con2;
  var mytimer;
  var mytimer1;
  var time;

    var init = function () {
        dom = $("#rank");
        router.init();
        initEvent();
        loadData();
        initJuicer();
    };

    var initEvent = function () {
      try {
        var only = base.isOnlyReadingStudentApp();
        if (only){
          dom.find(".backBtn").addClass("none");
        }
      }catch (e) {
        console.log(e);
      }

        studentType = 2;
        timeType = 1;
        initTypeTreeList();
        initTimeTreeList();

        databind.submit([], {
          action: "inquireReadingCyclePermissionsStateTenant",
          version: "v1.0",
          success: function (data) {
            if(data.datas[0].readingCircleSwitch == 0){
              dom.find('.postRankDiv').addClass('none');
              dom.find('.readRankDiv')[0].style.marginBottom = '76px';
            }else{
              dom.find('.postRankDiv').removeClass('none');
              dom.find('.readRankDiv')[0].style.marginBottom = '';
            }
          }
        });

        dom.on("click", ".classSelect", function(){
            dom.find('#type_select').mobiscroll('show');
        });

        dom.on("click", ".timeSelect", function(){
            dom.find('#time_select').mobiscroll('show');
        });

        dom.on("click", ".more", function(){
            var fromClass = $(this).attr("fromClass");
            var fromIntegral = $(this).attr("fromIntegral");
            base.removeData("studentType");
            base.removeData("timeType");
            base.openUrl("index.html#studentPage.rank-list?fromClass="+fromClass+"&fromIntegral="+fromIntegral+"&studentType="+studentType+"&timeType="+timeType, "");
        });

        dom.on("click", ".timeSelect", function(){
            dom.find('#time_select').mobiscroll('show');
        });

        dom.on("click", ".headToInfo", function(){
            var studentId = $(this).attr("studentId");
            var schoolId = $(this).attr("schoolId");
            base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId, "");
        });

        dom.on("click", ".classToInfo", function(){
            var classId = $(this).attr("classId");
            var schoolId = $(this).attr("schoolId");
            base.openUrl("index.html#studentPage.class-info?classId="+classId+"&schoolId="+schoolId, "");
        });

        dom.on("click", "#slide", function () {
          base.openUrl("index.html#studentPage.diploma-wall", "");
        });

      window._android_on_back_pressed = function() {
        try {
          var only = base.isOnlyReadingStudentApp();
          if (only){
            dialog.loadDialog("dialog.confirmDialog", {
              params: {
                tips: "确认退出程序？"
              },
              okFn: function() {
                $(".dialog-container").addClass("none");
                base.exitProgram();
              }
            }, "small");
          }
        }catch (e) {
          console.log(e);
        }
        return false;
      };
    };

    var initJuicer = function () {
      juicer.register("type", function (dt) {
        var formatDateString = dt.createDate.replace(/-/g,"/");
        var date = new Date(formatDateString);
        var month = date.getMonth();
        if (month == 0) {
          month = 12
        }
        if (dt.type == "1"){
          return "获得"+month+"月份“书香班级”。";
        } else {
          return "获得"+month+"月份“阅读之星”。";
        }
      });
    };

    var loadData = function () {
        inquireAllTenantList();
        inquireReadingClassReadingRankAccount();
        inquireReadingPostRankAccount();
        inquireReadingDiplomaWallListAccount();
    };

    var initTypeTreeList = function(data) {
        $('#type_select').mobiscroll().treelist({
            theme: 'ios',
            mode: 'scroller',
            display: 'bottom',
            lang: 'zh',
            showInput: false,
            circular: false,
            defaultValue: [2],
            onSet: function(event, inst) {
                switch(event.valueText){
                    case "1":
                    dom.find(".classSelectContent").text("全班");
                    studentType = 1;
                    break;
                    case "2":
                    studentType = 2;
                    dom.find(".classSelectContent").text("全年级");
                    break;
                    case "3":
                    studentType = 3;
                    dom.find(".classSelectContent").text("全校");
                    break;
                    case "4":
                    studentType = 4;
                    dom.find(".classSelectContent").text("全平台");
                    break;
                }
                inquireAllTenantList();
                inquireReadingClassReadingRankAccount();
                inquireReadingPostRankAccount();
            }
        });
    }

    var initTimeTreeList = function(data) {
      var defaultValue = ["1"];
      var day = new Date().getDay();
      if (day == 1){
        dom.find(".timeSelectContent").text("上周");
        dom.find(".rankAlert").html("");
        timeType = 5;
        defaultValue = ["5"];
      }
        $('#time_select').mobiscroll().treelist({
            theme: 'ios',
            mode: 'scroller',
            display: 'bottom',
            lang: 'zh',
            showInput: false,
            circular: false,
            defaultValue: defaultValue,
            onSet: function(event, inst) {
                switch(event.valueText){
                    case "1":
                    dom.find(".timeSelectContent").text("本周");
                    dom.find(".rankAlert").html("榜单每天00:00更新数据，每周日24:00清空哦~");
                    timeType = 1;
                    break;
                    case "2":
                    dom.find(".timeSelectContent").text("本月");
                    dom.find(".rankAlert").html("榜单每天00:00更新数据，每月末24:00清空哦~");
                    timeType = 2;
                    break;
                    case "3":
                    dom.find(".timeSelectContent").text("本学期");
                    dom.find(".rankAlert").html("榜单每天00:00更新数据，每学期末24:00清空哦~");
                    timeType = 3;
                    break;
                    case "4":
                    dom.find(".timeSelectContent").text("总榜");
                    dom.find(".rankAlert").html("");
                    timeType = 4;
                    break;
                    case "5":
                    dom.find(".timeSelectContent").text("上周");
                    dom.find(".rankAlert").html("");
                    timeType = 5;
                    break;
                }
                inquireAllTenantList();
                inquireReadingClassReadingRankAccount();
                inquireReadingPostRankAccount();
            }
        });
    }

    var inquireAllTenantList = function(){
        showLoading();
        databind.submit([], {
            action: "inquireAllTenantList",
            version: "v1.0",
            data: {
                studentType: studentType,
                timeType: timeType
            },
            success:function(data){
                hideLoading();
                var ret = data.datas[0];
                dom.find(".integralRankEmpty").addClass("none");
                if (ret.classRankList.length == 0 && ret.studentRankList.length == 0) {
                    dom.find(".integralRankEmpty").removeClass("none");
                }
                dom.find(".classRank").text(ret.classRank);
                dom.find(".myRank").text(ret.myRank);
                var studentRankList = ret.studentRankList;
                var classRankList = ret.classRankList;
                var integralRankDom = dom.find(".integralRank").find(".integralPersonal").find(".personalMid");
                var integralRankLeftDom = dom.find(".integralRank").find(".integralPersonal").find(".personalLeft");
                var integralRankRightDom =  dom.find(".integralRank").find(".integralPersonal").find(".personalRight");
                var classRankDom = dom.find(".integralRank").find(".integralClass").find(".personalMid");
                var classRankLeftDom = dom.find(".integralRank").find(".integralClass").find(".personalLeft");
                var classRankRightDom =  dom.find(".integralRank").find(".integralClass").find(".personalRight");
                //隐藏相应的标签
                dom.find(".integralRank").find(".integralClass").addClass("none");
                dom.find(".integralRank").find(".integralPersonal").addClass("none");
                integralRankDom.addClass("none");
                integralRankLeftDom.addClass("none");
                integralRankRightDom.addClass("none");
                classRankDom.addClass("none");
                classRankLeftDom.addClass("none");
                classRankRightDom.addClass("none");
                //积分榜-学生
                for (var i = 0; i < studentRankList.length; i++) {
                    var dic = studentRankList[i];
                    if (i == 0) {
                        dom.find(".integralRank").find(".integralPersonal").removeClass("none");
                        integralRankDom.removeClass("none");
                        integralRankDom.find(".personalTopHead").attr("studentId", dic.studentId);
                        integralRankDom.find(".personalTopHead").attr("schoolId", dic.schoolId);
                        integralRankDom.find(".name").html(dic.fullName);
                        if (studentType == 2 || studentType == 3) {
                            integralRankDom.find(".school").html(dic.className);
                        }else if (studentType == 4) {
                            integralRankDom.find(".school").html(dic.schoolName + " " + dic.className);
                        }
                        if (dic.proFilePhotoUuid !== ""){
                          integralRankDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.proFilePhotoUuid + "&view=1&size=120");
                        }else {
                          integralRankDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
                        }
                        integralRankDom.find(".integralPoint").html(dic.integral+"分");
                    }else if (i == 1) {
                        integralRankLeftDom.find(".personalHead").attr("studentId", dic.studentId);
                        integralRankLeftDom.find(".personalHead").attr("schoolId", dic.schoolId);
                        integralRankLeftDom.removeClass("none");
                        integralRankLeftDom.find(".name").html(dic.fullName);
                        if (studentType == 2 || studentType == 3) {
                            integralRankLeftDom.find(".school").html(dic.className);
                        }else if (studentType == 4) {
                            integralRankLeftDom.find(".school").html(dic.schoolName + " " + dic.className);
                        }
                        if (dic.proFilePhotoUuid !== ""){
                          integralRankLeftDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.proFilePhotoUuid + "&view=1&size=120");
                        }else {
                          integralRankLeftDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
                        }
                        integralRankLeftDom.find(".integralPoint").html(dic.integral+"分");
                    }else if (i == 2) {
                        integralRankRightDom.find(".personalHead").attr("studentId", dic.studentId);
                        integralRankRightDom.find(".personalHead").attr("schoolId", dic.schoolId);
                        integralRankRightDom.removeClass("none");
                        integralRankRightDom.find(".name").html(dic.fullName);
                        if (studentType == 2 || studentType == 3) {
                            integralRankRightDom.find(".school").html(dic.className);
                        }else if (studentType == 4) {
                            integralRankRightDom.find(".school").html(dic.schoolName + " " + dic.className);
                        }
                        if (dic.proFilePhotoUuid !== ""){
                          integralRankRightDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.proFilePhotoUuid + "&view=1&size=120");
                        }else {
                          integralRankRightDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
                        }
                        integralRankRightDom.find(".integralPoint").html(dic.integral+"分");
                    }
                }
                //积分榜-班级
                for (var i = 0; i < classRankList.length; i++) {
                    var dic = classRankList[i];
                    if (i == 0) {
                        dom.find(".integralRank").find(".integralClass").removeClass("none");
                        classRankDom.find(".classTopHead").attr("classId", dic.classId);
                        classRankDom.find(".classTopHead").attr("schoolId", dic.schoolId);
                        classRankDom.removeClass("none");
                        classRankDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
                        if (studentType == 4) {
                             classRankDom.find(".school").html(dic.schoolName);
                        }else {
                             classRankDom.find(".school").html("");
                        }
                        classRankDom.find(".avgIntegral").html(dic.avgIntegral+"分");
                    }else if (i == 1) {
                        classRankLeftDom.removeClass("none");
                        classRankLeftDom.find(".classHead").attr("classId", dic.classId);
                        classRankLeftDom.find(".classHead").attr("schoolId", dic.schoolId);
                        classRankLeftDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
                        if (studentType == 4) {
                             classRankLeftDom.find(".school").html(dic.schoolName);
                        }else {
                             classRankLeftDom.find(".school").html("");
                        }
                        classRankLeftDom.find(".avgIntegral").html(dic.avgIntegral+"分");
                    }else if (i == 2) {
                        classRankRightDom.removeClass("none");
                        classRankRightDom.find(".classHead").attr("classId", dic.classId);
                        classRankRightDom.find(".classHead").attr("schoolId", dic.schoolId);
                        classRankRightDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
                        if (studentType == 4) {
                             classRankRightDom.find(".school").html(dic.schoolName);
                        }else {
                             classRankRightDom.find(".school").html("");
                        }
                        classRankRightDom.find(".avgIntegral").html(dic.avgIntegral+"分");
                    }
                }
            },
            fail:function () {
              hideLoading();
            },
        });
    };

    var inquireReadingClassReadingRankAccount = function(){
        showLoading();
        databind.submit([], {
            action: "inquireReadingClassReadingRankAccount",
            version: "v1.0",
            data: {
                studentType: studentType,
                timeType: timeType
            },
            success:function(data){
                hideLoading();
                var ret = data.datas[0];
                dom.find(".readRankEmpty").addClass("none");
                if (ret.classReadingList.length == 0 && ret.studentPassList.length == 0) {
                    dom.find(".readRankEmpty").removeClass("none");
                }
                dom.find(".readClassRank").text(ret.myClassRank);
                dom.find(".myReadRank").text(ret.myRank);
                var studentRankList = ret.studentPassList;
                var classRankList = ret.classReadingList;
                var integralRankDom = dom.find(".readRank").find(".integralPersonal").find(".personalMid");
                var integralRankLeftDom = dom.find(".readRank").find(".integralPersonal").find(".personalLeft");
                var integralRankRightDom =  dom.find(".readRank").find(".integralPersonal").find(".personalRight");
                var classRankDom = dom.find(".readRank").find(".integralClass").find(".personalMid");
                var classRankLeftDom = dom.find(".readRank").find(".integralClass").find(".personalLeft");
                var classRankRightDom =  dom.find(".readRank").find(".integralClass").find(".personalRight");
                //隐藏相应的标签
                dom.find(".readRank").find(".integralClass").addClass("none");
                dom.find(".readRank").find(".integralPersonal").addClass("none");
                integralRankDom.addClass("none");
                integralRankLeftDom.addClass("none");
                integralRankRightDom.addClass("none");
                classRankDom.addClass("none");
                classRankLeftDom.addClass("none");
                classRankRightDom.addClass("none");
                //积分榜-学生
                for (var i = 0; i < studentRankList.length; i++) {
                    var dic = studentRankList[i];
                    if (i == 0) {
                        dom.find(".readRank").find(".integralPersonal").removeClass("none");
                        integralRankDom.removeClass("none");
                        integralRankDom.find(".personalTopHead").attr("studentId", dic.studentId);
                        integralRankDom.find(".personalTopHead").attr("schoolId", dic.schoolId);
                        integralRankDom.find(".name").html(dic.studentName);
                        if (studentType == 2 || studentType == 3) {
                            integralRankDom.find(".school").html(dic.className);
                        }else if (studentType == 4) {
                            integralRankDom.find(".school").html(dic.schoolName + " " + dic.className);
                        }
                        if (dic.photoUuid !== ""){
                          integralRankDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
                        }else {
                          integralRankDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
                        }
                        integralRankDom.find(".integralPoint").html((dic.readingWordsQty/10000).toFixed(1)+"万字");
                    }else if (i == 1) {
                        integralRankLeftDom.find(".personalHead").attr("studentId", dic.studentId);
                        integralRankLeftDom.find(".personalHead").attr("schoolId", dic.schoolId);
                        integralRankLeftDom.removeClass("none");
                        integralRankLeftDom.find(".name").html(dic.studentName);
                        if (studentType == 2 || studentType == 3) {
                            integralRankLeftDom.find(".school").html(dic.className);
                        }else if (studentType == 4) {
                            integralRankLeftDom.find(".school").html(dic.schoolName + " " + dic.className);
                        }
                        if (dic.photoUuid !== ""){
                          integralRankLeftDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
                        }else {
                          integralRankLeftDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
                        }
                        integralRankLeftDom.find(".integralPoint").html((dic.readingWordsQty/10000).toFixed(1)+"万字");
                    }else if (i == 2) {
                        integralRankRightDom.find(".personalHead").attr("studentId", dic.studentId);
                        integralRankRightDom.find(".personalHead").attr("schoolId", dic.schoolId);
                        integralRankRightDom.removeClass("none");
                        integralRankRightDom.find(".name").html(dic.studentName);
                        if (studentType == 2 || studentType == 3) {
                            integralRankRightDom.find(".school").html(dic.className);
                        }else if (studentType == 4) {
                            integralRankRightDom.find(".school").html(dic.schoolName + " " + dic.className);
                        }
                        if (dic.photoUuid !== ""){
                          integralRankRightDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
                        }else {
                          integralRankRightDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
                        }
                        integralRankRightDom.find(".integralPoint").html((dic.readingWordsQty/10000).toFixed(1)+"万字");
                    }
                }
                //积分榜-班级
                for (var i = 0; i < classRankList.length; i++) {
                    var dic = classRankList[i];
                    if (i == 0) {
                        if (studentType !== 1) {
                            dom.find(".readRank").find(".integralClass").removeClass("none");
                        }
                        classRankDom.find(".classTopHead").attr("classId", dic.classId);
                        classRankDom.find(".classTopHead").attr("schoolId", dic.schoolId);
                        classRankDom.removeClass("none");
                        classRankDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
                        if (studentType == 4) {
                             classRankDom.find(".school").html(dic.schoolName);
                        }else{
                            classRankDom.find(".school").html("");
                        }
                        classRankDom.find(".avgRead").html("人均"+(dic.classReadingWordsQtyAvg/10000).toFixed(1)+"万字");
                    }else if (i == 1) {
                        classRankLeftDom.removeClass("none");
                        classRankLeftDom.find(".classHead").attr("classId", dic.classId);
                        classRankLeftDom.find(".classHead").attr("schoolId", dic.schoolId);
                        classRankLeftDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
                        if (studentType == 4) {
                             classRankLeftDom.find(".school").html(dic.schoolName);
                        }else{
                            classRankLeftDom.find(".school").html("");
                        }
                        classRankLeftDom.find(".avgRead").html("人均"+(dic.classReadingWordsQtyAvg/10000).toFixed(1)+"万字");
                    }else if (i == 2) {
                        classRankRightDom.removeClass("none");
                        classRankRightDom.find(".classHead").attr("classId", dic.classId);
                        classRankRightDom.find(".classHead").attr("schoolId", dic.schoolId);
                        classRankRightDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
                        if (studentType == 4) {
                             classRankRightDom.find(".school").html(dic.schoolName);
                        }else{
                            classRankRightDom.find(".school").html("");
                        }
                        classRankRightDom.find(".avgRead").html("人均"+(dic.classReadingWordsQtyAvg/10000).toFixed(1)+"万字");
                    }
                }
            },
            fail:function () {
              hideLoading();
            },
        });
    };

  var inquireReadingPostRankAccount = function(){
    showLoading();
    databind.submit([], {
      action: "inquireReadingPostRankAccount",
      version: "v1.0",
      data: {
        studentType: studentType,
        timeType: timeType
      },
      success:function(data){
        hideLoading();
        var ret = data.datas[0];
        dom.find(".postRankEmpty").addClass("none");
        if (ret.classPostList.length == 0 && ret.studentPostList.length == 0) {
          dom.find(".postRankEmpty").removeClass("none");
        }
        dom.find(".postClassRank").text(ret.myClassRank);
        dom.find(".myPostRank").text(ret.myRank);
        var studentRankList = ret.studentPostList;
        var classRankList = ret.classPostList;
        var integralRankDom = dom.find(".postRank").find(".integralPersonal").find(".personalMid");
        var integralRankLeftDom = dom.find(".postRank").find(".integralPersonal").find(".personalLeft");
        var integralRankRightDom =  dom.find(".postRank").find(".integralPersonal").find(".personalRight");
        var classRankDom = dom.find(".postRank").find(".integralClass").find(".personalMid");
        var classRankLeftDom = dom.find(".postRank").find(".integralClass").find(".personalLeft");
        var classRankRightDom =  dom.find(".postRank").find(".integralClass").find(".personalRight");
        //隐藏相应的标签
        dom.find(".postRank").find(".integralClass").addClass("none");
        dom.find(".postRank").find(".integralPersonal").addClass("none");
        integralRankDom.addClass("none");
        integralRankLeftDom.addClass("none");
        integralRankRightDom.addClass("none");
        classRankDom.addClass("none");
        classRankLeftDom.addClass("none");
        classRankRightDom.addClass("none");
        //积分榜-学生
        for (var i = 0; i < studentRankList.length; i++) {
          var dic = studentRankList[i];
          if (i == 0) {
            dom.find(".postRank").find(".integralPersonal").removeClass("none");
            integralRankDom.removeClass("none");
            integralRankDom.find(".personalTopHead").attr("studentId", dic.studentId);
            integralRankDom.find(".personalTopHead").attr("schoolId", dic.schoolId);
            integralRankDom.find(".name").html(dic.studentName);
            if (studentType == 2 || studentType == 3) {
              integralRankDom.find(".school").html(dic.className);
            }else if (studentType == 4) {
              integralRankDom.find(".school").html(dic.schoolName + " " + dic.className);
            }
            if (dic.photoUuid !== ""){
              integralRankDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }else {
              integralRankDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
            }
            integralRankDom.find(".integralPoint").html(dic.postQty+"篇");
          }else if (i == 1) {
            integralRankLeftDom.find(".personalHead").attr("studentId", dic.studentId);
            integralRankLeftDom.find(".personalHead").attr("schoolId", dic.schoolId);
            integralRankLeftDom.removeClass("none");
            integralRankLeftDom.find(".name").html(dic.studentName);
            if (studentType == 2 || studentType == 3) {
              integralRankLeftDom.find(".school").html(dic.className);
            }else if (studentType == 4) {
              integralRankLeftDom.find(".school").html(dic.schoolName + " " + dic.className);
            }
            if (dic.photoUuid !== ""){
              integralRankLeftDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }else {
              integralRankLeftDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
            }
            integralRankLeftDom.find(".integralPoint").html(dic.postQty+"篇");
          }else if (i == 2) {
            integralRankRightDom.find(".personalHead").attr("studentId", dic.studentId);
            integralRankRightDom.find(".personalHead").attr("schoolId", dic.schoolId);
            integralRankRightDom.removeClass("none");
            integralRankRightDom.find(".name").html(dic.studentName);
            if (studentType == 2 || studentType == 3) {
              integralRankRightDom.find(".school").html(dic.className);
            }else if (studentType == 4) {
              integralRankRightDom.find(".school").html(dic.schoolName + " " + dic.className);
            }
            if (dic.photoUuid !== ""){
              integralRankRightDom.find(".headPhoto").attr("src", CONFIG.fsPath+"v1.0/viewPic.file?fileUuid=" + dic.photoUuid + "&view=1&size=120");
            }else {
              integralRankRightDom.find(".headPhoto").attr("src", "./res/png/touxiang.png");
            }
            integralRankRightDom.find(".integralPoint").html(dic.postQty+"篇");
          }
        }
        //积分榜-班级
        for (var i = 0; i < classRankList.length; i++) {
          var dic = classRankList[i];
          if (i == 0) {
            if (studentType !== 1) {
              dom.find(".postRank").find(".integralClass").removeClass("none");
            }
            classRankDom.find(".classTopHead").attr("classId", dic.classId);
            classRankDom.find(".classTopHead").attr("schoolId", dic.schoolId);
            classRankDom.removeClass("none");
            classRankDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
            if (studentType == 4) {
              classRankDom.find(".school").html(dic.schoolName);
            }else{
              classRankDom.find(".school").html("");
            }
            classRankDom.find(".avgRead").html("人均"+dic.classPostQtyAvg+"篇");
          }else if (i == 1) {
            classRankLeftDom.removeClass("none");
            classRankLeftDom.find(".classHead").attr("classId", dic.classId);
            classRankLeftDom.find(".classHead").attr("schoolId", dic.schoolId);
            classRankLeftDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
            if (studentType == 4) {
              classRankLeftDom.find(".school").html(dic.schoolName);
            }else{
              classRankLeftDom.find(".school").html("");
            }
            classRankLeftDom.find(".avgRead").html("人均"+dic.classPostQtyAvg+"篇");
          }else if (i == 2) {
            classRankRightDom.removeClass("none");
            classRankRightDom.find(".classHead").attr("classId", dic.classId);
            classRankRightDom.find(".classHead").attr("schoolId", dic.schoolId);
            classRankRightDom.find(".className").html(dic.gradeName.replace("级","")+dic.className);
            if (studentType == 4) {
              classRankRightDom.find(".school").html(dic.schoolName);
            }else{
              classRankRightDom.find(".school").html("");
            }
            classRankRightDom.find(".avgRead").html("人均"+dic.classPostQtyAvg+"篇");
          }
        }
      },
      fail:function () {
        hideLoading();
      },
    });
  };

  var inquireReadingDiplomaWallListAccount = function () {
    databind.submit([], {
      action: "inquireReadingDiplomaWallListAccount",
      version: "v1.0",
      data: {
        pageSize:3
      },
      success:function(data) {
        if (data.datas.length > 0){
          // var html = juicer(dom.find("#marquee-tpl").html(), data);
          var html = juicer(dom.find("#gun").html(), data);
          dom.find("#slide1").html(html);
          dom.find("#slide").removeClass("none");
          area = document.getElementById('slide');
          con1 = document.getElementById('slide1');
          con2 = document.getElementById('slide2');
          clearInterval(mytimer);
          clearInterval(mytimer1);
          mytimer1 = null;
          mytimer = null;
          time = 1000 / 60;
          con2.innerHTML = con1.innerHTML;
          mytimer = setInterval(scrollUp, time);
        }
      }
    });
  };

  function scrollUp () {
    if (area.scrollTop >= con1.offsetHeight) {
      area.scrollTop = 0;
    } else {
      if (area.scrollTop % 44 == 0) {
        clearInterval(mytimer);
        clearInterval(mytimer1);
        mytimer1 = setTimeout(function () {
          mytimer = setInterval(scrollUp, time);
        }, 1000);
      }
      area.scrollTop++;
    }
  }

    //转菊花
    var showLoading = function(){
        $(".fullBg").removeClass("none");
        $(".loader").removeClass("none");
    };
    //隐藏菊花
    var hideLoading = function(){
        $(".fullBg").addClass("none");
        $(".loader").addClass("none");
    };

    return {
        init: init
    };
});
