// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var gradeCode;
	var bookType;
	var pageIndex;
	var fromBookList;

	var init = function() {
		dom = $("#search-book-list");
		router.init();
		initEvent();
		loadData();
		initGradeTreeList();
		// inquireReadingGradeClassesTenant();
		initTypeTreeList();
	};

	var initEvent = function() {
    dom.find(".onresume").bind("on-resume", function () {
    	// console.log(gradeCode);
    	// console.log(bookType);
      // loadData();
      initGradeTreeList(gradeCode);
      inquireReadingBookListAccount(gradeCode, bookType);
    });

		gradeCode = "0";
		if (base.getUrlParam("bookType")) {
			bookType = decodeURIComponent(base.getUrlParam("bookType"));
			dom.find(".bookTypeName").text(bookType);
		}else{
			bookType = "0";
		}
		pageIndex = 1;
		//选择年级
		dom.on("click", ".gradeCode", function(){
			dom.find('#grade_select').mobiscroll('show');
		});
		//选择类型
		dom.on("click", ".bookType", function(){
			dom.find('#type_select').mobiscroll('show');
		});
		//更多
		dom.on("click", ".more", function(){
			pageIndex++;
			inquireReadingBookListAccountMore(gradeCode, bookType);
		});
		//搜索
		dom.on("click", ".header-search", function(){
			router.route("#studentPage.search-book");
		});
		//书籍详情
		dom.on("click", ".bookContent", function(){
			var bookId = $(this).attr("bookId");
			base.openUrl("index.html#studentPage.task-book-detail?bookId="+bookId, "YX_READING_STUDENT_APP");
		});
		//加入书架
		dom.on("click", ".addButton", function(e){
			var bookId = $(this).parent().parent().attr("bookId");
			addToReadingBookrackAccount(bookId, $(this));
			e.stopPropagation();
		});
    dom.on("click", ".addTo", function(e){
      var bookId = $(this).parent().parent().attr("bookId");
      addToReadingBookrackAccount(bookId, $(this));
      e.stopPropagation();
    });
	};

	var loadData = function() {
		inquireReadingStudentGradeAccount();
		// inquireReadingBookListAccount("0", bookType);
	};
	
	var inquireReadingBookListAccount = function(gradeCode, bookType){
		var data = {};
		if (gradeCode !== "0" && gradeCode !== 0) {
			data.gradeCode = gradeCode-5;
		}
		if (bookType !== "0") {
			data.bookType = bookType;
		}
		databind.submit([], {
			action: "inquireReadingBookListAccount",
			version: "v1.0",
			data: data,
			success:function(data){
        dom.find(".nodata").addClass("none");
				dom.find(".more").remove();
				var html = juicer(dom.find("#book-tpl").html(), data);
				dom.find(".bookSection").html(html);
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}
				if (data.datas.length == 0) {
					dom.find(".nodata").removeClass("none");
				}
			}
		});
	};

	var inquireReadingBookListAccountMore = function(gradeCode, bookType){
		var data = {};
		if (gradeCode !== "0" && gradeCode !== 0) {
			data.gradeCode = gradeCode-5;
		}
		if (bookType !== "0") {
			data.bookType = bookType;
		}
		data.pageIndex = pageIndex;
		databind.submit([], {
			action: "inquireReadingBookListAccount",
			version: "v1.0",
			data: data,
			success:function(data){
				dom.find(".more").remove();
				var html = juicer(dom.find("#book-tpl").html(), data);
				dom.find(".bookSection").append(html);
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}else{
					dom.find(".more").addClass("none");
				}
			}
		});
	};

	var initGradeTreeList = function(defaultValue) {
		$('#grade_select').mobiscroll().treelist({
			theme: 'ios',
			mode: 'scroller',
			display: 'bottom',
			lang: 'zh',
			showInput: false,
			defaultValue: [defaultValue],
			circular: false,
			onSet: function(event, inst) {
				var gradeName;
				switch(event.valueText){
					case "6":
					gradeName = "一年级";
					break;
					case "7":
					gradeName = "二年级";
					break;
					case "8":
					gradeName = "三年级";
					break;
					case "9":
					gradeName = "四年级";
					break;
					case "10":
					gradeName = "五年级";
					break;
					case "11":
					gradeName = "六年级";
					break;
					case "12":
					gradeName = "七年级";
					break;
					case "13":
					gradeName = "八年级";
					break;
					case "14":
					gradeName = "九年级";
					break;
					default:
					gradeName = "全部年级";
					break;
				}
				// gradeName = data[event.valueText].gradeName;
				dom.find(".gradeName").text(gradeName);
				gradeCode = event.valueText;
				// gradeCode = data[event.valueText].gradeEnum;
				pageIndex = 1
				inquireReadingBookListAccount(gradeCode, bookType);
        scrollTop();
      }
		});
	}

	var initTypeTreeList = function(data) {
		$('#type_select').mobiscroll().treelist({
			theme: 'ios',
			mode: 'scroller',
			display: 'bottom',
			lang: 'zh',
			showInput: false,
			circular: false,
			defaultValue: [bookType],
			onSet: function(event, inst) {
				if (event.valueText == "0") {
					dom.find(".bookTypeName").text("全部类型");
				}else{
					dom.find(".bookTypeName").text(event.valueText);
				}
				bookType = event.valueText;
				pageIndex = 1;
				inquireReadingBookListAccount(gradeCode, bookType);
        scrollTop();
      }
		});
	}

	var addToReadingBookrackAccount = function(bookId, dom){
		databind.submit([], {
			action: "addToReadingBookrackAccount",
			version: "v1.0",
			data: {
				bookId: bookId
			},
			success:function(data){
				base.alert(1, "加入成功！");
				dom.parent().find(".addTo").addClass("none");
				dom.parent().find(".exist").removeClass("none");
				dom.parent().find(".addToContent").html("已在书架");
			}
		});
	};

	var inquireReadingGradeClassesTenant = function(){
		databind.submit([], {
			action: "inquireReadingGradeClassesTenant",
			version: "v1.0",
			data: {},
			success:function(data){
				var html = juicer(dom.find("#grade-tpl").html(), data.datas[0]);
				$("#grade_select").html(html);
				initGradeTreeList(data.datas[0].gradeList);
			}
		});
	};

	var inquireReadingStudentGradeAccount = function(){
		databind.submit([], {
			action: "inquireReadingStudentGradeAccount",
			version: "v1.0",
			data: {},
			success:function(data){
				gradeCode = data.datas[0].gradeEnum;
				dom.find(".gradeName").text(data.datas[0].gradeName);
				initGradeTreeList(data.datas[0].gradeEnum);
				inquireReadingBookListAccount(data.datas[0].gradeEnum, bookType);
			}
		});
	};

  var scrollTop = function () {
    setTimeout(function () {
      window.scrollTo(0,0);
    },150);
  };

	return {
		init: init
	};
});
