// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var pageIndex;
	var isbn;
	var registerBookName;
	var registerAuthor;

	var init = function() {
		dom = $("#search-book");
		router.init();
		initEvent();
	};

	var initEvent = function() {
    dom.on("click", ".lack-book-register", function () {
      readingLackBookRegisterAccount();
    });

    setTimeout(function(){
      dom.find("input[name=book]").focus();
    }, 200);

    dom.find(".onresume").bind("on-resume", function () {
      loadData();
    });

		pageIndex = 1;
		// dom.find("input").focus();

		//更多
		dom.on("click", ".more", function(){
			pageIndex++;
			var keyWord = dom.find("input[name=book]").val();
			inquireReadingBookListAccountMore(keyWord);
		});
    
    $(".inputClickImg").bind("input propertychange change",function(event){
      var keyWord = dom.find("input[name=book]").val();
      if (keyWord == ""){
        $('.imageClick').hide();
      }
      if (keyWord !=""){
        $('.imageClick').show();
      }
    });
    
    dom.on("click",".imageClick",function () {
      dom.find(".inputClickImg").val("");
      var keyWord = dom.find("input[name=book]").val();
      if (keyWord == ""){
        $('.imageClick').hide();
      }
      if (keyWord !=""){
        $('.imageClick').show();
      }
    });
		//搜索
		dom.on("click", ".header-ops", function(){
			var keyWord = dom.find("input[name=book]").val();
			if (keyWord == "") {
				base.alert(2, "请输入感兴趣的书目、作者！");
				return;
			}
			inquireReadingBookListAccount(keyWord);
		});
		//书籍详情
		dom.on("click", ".bookContent", function(){
			var bookId = $(this).attr("bookId");
			// router.route("#teacherPage.book-detail?bookId="+bookId);
			base.openUrl("index.html#studentPage.task-book-detail?bookId="+bookId, "YX_READING_STUDENT_APP");
		});
		//加入书架
		dom.on("click", ".addButton", function(e){
			var bookId = $(this).parent().parent().attr("bookId");
			addToReadingBookrackAccount(bookId, $(this));
			e.stopPropagation();
		});

	    dom.on("click", ".addTo", function(e){
	      var bookId = $(this).parent().parent().attr("bookId");
	      addToReadingBookrackAccount(bookId, $(this));
	      e.stopPropagation();
	    });

		$("input[name='book']").bind('input propertychange',function(){
            //做一些事情
            var val = $(this).val();              
            console.log(val);
            if (val !== "") {
            	inquireReadingBookListAccount(val);
			}
        })

    isbn = base.getUrlParam("isbn");
    if (isbn !== null && isbn !== undefined && isbn !== "undefined"){
      dom.find("input[name=book]").val(isbn);
      dom.find(".header-ops").trigger("click");
    }
	};
	
	var loadData = function() {
		inquireReadingBookListAccount();
	};
	
	var inquireReadingBookListAccount = function(keyWord){
		databind.submit([], {
			action: "inquireReadingBookListAccount",
			version: "v1.0",
			async: false,
			data: {
				keyWord: utf16toEntities(keyWord)
			},
			success:function(data){
				dom.find(".nodata").addClass("none");
				dom.find(".more").remove();
				var html = juicer(dom.find("#book-tpl").html(), data);
				dom.find(".bookSection").html(html);
				dom.find(".bookSelect").each(function(idx, itm){
					var index = bookIdList.indexOf($(itm).attr("bookId"));
					if (index > -1) {
					   	$(itm).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
					   	$(itm).attr("checked",true);
					}
				});
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}
				if (data.datas.length == 0) {
					dom.find(".nodata").removeClass("none");
				}
			}
		});
	};

	var inquireReadingBookListAccountMore = function(keyWord){
		var data = {};
		data.pageIndex = pageIndex;
		data.keyWord = utf16toEntities(keyWord);
		databind.submit([], {
			action: "inquireReadingBookListAccount",
			version: "v1.0",
			data: data,
			success:function(data){
				dom.find(".more").remove();
				var html = juicer(dom.find("#book-tpl").html(), data);
				dom.find(".bookSection").append(html);
				dom.find(".bookSelect").each(function(idx, itm){
					var index = bookIdList.indexOf($(itm).attr("bookId"));
					if (index > -1) {
					   	$(itm).find(".bookSelectImg").attr("src","./res/newImages/selected.png");
					   	$(itm).attr("checked",true);
					}
				});
				if (data.totalPageCount > pageIndex) {
					dom.find(".more").removeClass("none");
				}else{
					dom.find(".more").addClass("none");
				}
			}
		});
	};

	var addToReadingBookrackAccount = function(bookId, dom){
		databind.submit([], {
			action: "addToReadingBookrackAccount",
			version: "v1.0",
			data: {
				bookId: bookId
			},
			success:function(data){
				base.alert(1, "加入成功！");
        dom.parent().find(".addTo").addClass("none");
        dom.parent().find(".exist").removeClass("none");
				dom.parent().find(".addToContent").html("已在书架");
			}
		});
	};

  //登记缺书
  var readingLackBookRegisterAccount = function () {
    dialog.loadDialog("dialog.dialog-lack-book-register", {
      params: {
        tips: "缺书登记"
      },
      okFn: function() {
      	registerBookName = $(".register-bookName").val();
				registerAuthor = $(".register-author").val();
				if(checkCanSubmitLackBookRegister()){
          databind.submit("", {
            action: "readingLackBookRegisterAccount",
            version: "v1.0",
            data: {
              bookName:registerBookName,
              author:registerAuthor
            },
            success:function(data){
              base.alert(1, "登记成功");
              dialog.hideDialog();
            }
          });
				};
      }
    }, "");
  };

  var checkCanSubmitLackBookRegister = function () {
    if(isEmojiCharacter(registerBookName)){
      base.alert(3,"书籍名不能含有表情");
      return false;
    }
    if(isEmojiCharacter(registerAuthor)){
      base.alert(3,"作者名不能含有表情");
      return false;
    }
    registerBookName = filteremoji(registerBookName);
    registerAuthor = filteremoji(registerAuthor);
    return true;
  };

  function isEmojiCharacter(substring) {
    for ( var i = 0; i < substring.length; i++) {
      var hs = substring.charCodeAt(i);
      if (0xd800 <= hs && hs <= 0xdbff) {
        if (substring.length > 1) {
          var ls = substring.charCodeAt(i + 1);
          var uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
          if (0x1d000 <= uc && uc <= 0x1f77f) {
            return true;
          }
        }
      } else if (substring.length > 1) {
        var ls = substring.charCodeAt(i + 1);
        if (ls == 0x20e3) {
          return true;
        }
      } else {
        if (0x2100 <= hs && hs <= 0x27ff) {
          return true;
        } else if (0x2B05 <= hs && hs <= 0x2b07) {
          return true;
        } else if (0x2934 <= hs && hs <= 0x2935) {
          return true;
        } else if (0x3297 <= hs && hs <= 0x3299) {
          return true;
        } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030
          || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b
          || hs == 0x2b50) {
          return true;
        }
      }
    }
  }

  //提交前再过滤一次表情包
  var filteremoji = function (content) {
    var ranges = [
      '\ud83c[\udf00-\udfff]',
      '\ud83d[\udc00-\ude4f]',
      '\ud83d[\ude80-\udeff]'
    ];
    if(content){
      return content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
    }
  };

//转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

  var utf16toEntities = function (str) {
    var patt=/[\ud800-\udbff][\udc00-\udfff]/g; // 检测utf16字符正则
    str = str.replace(patt, function(char){
      var H, L, code;
      if (char.length===2) {
        H = char.charCodeAt(0); // 取出高位
        L = char.charCodeAt(1); // 取出低位
        code = (H - 0xD800) * 0x400 + 0x10000 + L - 0xDC00; // 转换算法
        return "&#" + code + ";";
      } else {
        return char;
      }
    });
    return str;
  };

	return {
		init: init
	};
});
