// 主界面
;
define(function(require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var type;
  var schoolId;
  var studentId;

  var init = function(params) {
    dom = $("#student-diploma-content");
    type = params.selectedId;
    schoolId = params.schoolId;
    studentId = params.studentId;
    router.init();
    initEvent();
    initJuicer();
    loadData();
  };

  var initEvent = function() {

  };

  var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });

    juicer.register("getYear", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      if (date.getMonth() == 0) {
        return date.getFullYear() - 1;
      }
      return date.getFullYear();
    });

    juicer.register("getMonth", function (date) {
      var formatDateString = date.replace(/-/g,"/");
      var date = new Date(formatDateString);
      return date.getMonth() == 0 ? "12" : date.getMonth();
    });
  };

  var loadData = function() {
    if (type == "personal"){
      inquireReadingStudentDiplomaListAccount();
    } else {
      inquireReadingStudentClassDiplomaListAccount();
    }
  };

  var inquireReadingStudentDiplomaListAccount = function () {
    databind.submit([], {
      action: "inquireReadingOtherStudentDiplomaListAccount",
      version: "v1.0",
      data: {
        schoolId:schoolId,
        studentId:studentId
      },
      success:function(data){
        var html = juicer(dom.find("#diploma-tpl").html(), data);
        dom.find(".content").html(html);
      }
    });
  };

  var inquireReadingStudentClassDiplomaListAccount = function () {
    databind.submit([], {
      action: "inquireReadingOtherStudentClassDiplomaListAccount",
      version: "v1.0",
      data: {
        schoolId:schoolId,
        studentId:studentId
      },
      success:function(data){
        var html = juicer(dom.find("#diploma-tpl").html(), data);
        dom.find(".content").html(html);
      }
    });
  };

  //转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };

  return {
    init: init
  };
});
