// 主界面
;
define(function(require, exports, module) {
	'use strict';
	var util = require("util");
	var base = require("base");
	var databind = require("databind");
	var listView = require("listView");
	var router = require("pageRouter");
	var dialog = require("dialog");
	var constant = require("constant");
	var dom;
	var classId;
	var schoolId;

	var init = function() {
		dom = $("#student-moments-count-list");
    classId = base.getUrlParam("classId");
    schoolId = base.getUrlParam("schoolId");
		router.init();
		initJuicer();
		initEvent();
		loadData();
	};

  var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });
  };

	var initEvent = function() {
		classId = base.getUrlParam("classId");
		dom.on("click", ".personal-rank", function(){
			var studentId = $(this).attr("studentId");
			var studentName = $(this).attr("studentName");
			var schoolId = $(this).attr("schoolId");
			var searchClassId = $(this).attr("classId");
			var url = "#studentPage.student-moments?studentId="+studentId+"&classId="+ searchClassId +"&studentName="+encodeURIComponent(studentName);
			if(schoolId){
        url = url + "&schoolId=" + schoolId;
			}
			router.route(url);
		});
	};
	
	var loadData = function() {
		inquireReadingBookPassListByClassIdTenant();
	};
	
	var inquireReadingBookPassListByClassIdTenant = function(){
		var data = {
      classId: classId
		};
		if(schoolId){
      data.schoolId = schoolId;
		}
		databind.submit([], {
            action: "inquireReadingStudentPostCountByClassIdTenant",
            version: "v1.0",
            data: data,
            success:function(data){
            	var html = juicer(dom.find("#student-tpl").html(), data);
            	dom.find(".studentPostCountList").html(html);
              dom.find(".personal-rank").attr("schoolId", schoolId);
            }
        });
	};

	return {
		init: init
	};
});
