// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var taskListHtml = require("./task-list.html");
  var taskListJs = require("./task-list.js");
  var findHtml = require("./discovery.html");
  var findJs = require("./discovery.js");
  var otherFindHtml = require("./find.html");
  var otherFindJs = require("./find.js");
  var rankHtml = require("./rank.html");
  var rankJs = require("./rank.js");
  var myHtml = require("./my-tmp.html");
  var myJs = require("./my-tmp.js");
  var dom;
  var parameter;
  var pushType;

  var init = function () {
    dom = $("#tab");
    router.init();
    initEvent();
    
  };

  var initEvent = function () {
    var height = window.screen.height;
    var right = $("#two").width()/2 - 12 - 12;
    if (height > 640){
      $(".red").css("right", right+"px");
    }
    //添加图片
    $("div .subMenu>img").each(function () {
      var name = $(this).attr("data-imgname");
      var src = "./res/tab/" + name + ".png";
      //设置img的属性和值。
      $(this).attr("src", src);
    });

    //点击事件
    $("div .subMenu").click(function () {
      // 取消当前激活状态
      var $img = $(".active>img");
      //返回被选元素的属性值
      var name = $img.attr("data-imgname");
      var src = "./res/tab/" + name + ".png";
      $img.attr("src", src);
      $(".active").removeClass("active");

      // 添加新状态
      $(this).addClass("active");
      //找到所有 div(subMenu) 的子元素(img)
      $img = $(this).children("img");
      name = $img.attr("data-imgname");
      src = "./res/tab/" + name + "_selected.png";
      //设置img的属性和值。
      $img.attr("src", src);

      //content根据点击按钮加载不同的html
      var page = $(this).attr("data-src");
      if (page) {
        if (page == "taskListHtml") {
          $("#content").html(taskListHtml);
          taskListJs.init();
        } else if (page == "findHtml") {
          databind.submit([], {
            action: "inquireReadingCyclePermissionsStateTenant",
            version: "v1.0",
            success: function (data) {
              if(data.datas[0].readingCircleSwitch == 0){
                $("#content").html(otherFindHtml);
                otherFindJs.init();
              }else{
                $("#content").html(findHtml);
                findJs.init();
              }    
            }
          });
        } else if (page == "rankHtml") {
          $("#content").html(rankHtml);
          rankJs.init();
        } else {
          $("#content").html(myHtml);
          myJs.init();
        }
        getNotReceivedMessageQty();
      }
    });

    pushType = base.getData("pushType");
    if(pushType){
      pushType = JSON.parse(pushType);//JSON parse 会转成 数字 getUrlParam 的则是字符串
      switch(pushType){
        case 2001 : $("div .subMenu")[3].click();break;
        case 2002 : $("div .subMenu")[3].click();break;
        default:break;
      }
    }else{
      // 自动点击第一个菜单
      $("div .subMenu")[0].click();
    }
    initSize();
  };

  var loadData = function () {

  };

  var initSize = function () {
    var height = $(window).height() - $("#menu").height() - 10;
    $("#content").height(height + "px");
  }

  var getNotReceivedMessageQty = function () {
    databind.submit([], {
      action: "inquireReadingDiscoveryMessageQtyAccount",
      version: "v1.0",
      data: {},
      success:function(data){
        if (data.datas[0].notReceivedQty != 0) {
          if (data.datas[0].notReceivedQty > 99){
            $("#tab").find(".number").html("99+");
            $("#tab").find(".red").css("width", "29px");
            $("#tab").find(".red").css("padding-left", "5px");
            $("#tab").find(".red").css("border-radius", "7px");
          }else{
            $("#tab").find(".number").html(data.datas[0].notReceivedQty);
          }
          $("#tab").find(".red").removeClass("none");
        }else {
          $("#tab").find(".red").addClass("none");
        }
      }
    });
  };

  return {
    init: init
  };
});
