// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var bookId;
  var bookTotalPage;
  var currentReadingPage;
  var isTimeCanExam = true;
  var searchPostType;
  var _bookDetailPostHtml = require("./book-detail-post.html");
  var _bookDetailPostJs = require("./book-detail-post.js");
  var isAndroid = true;
  var _sdk_int;
  var _version_name = "1.0";
  var _version_code;
  var needUpdateApp = true;
  var systemSupport = false;
  var bookDetailData;
  var isLevelUp = false;
  var newLevel;
  var needGuideFlag;
  var readingCircleSwitch;
  var readingBurTag;
  var emigratedBurTag;
  var emigratedTag;
  var emigratedTimeList;
  
  var init = function () {
    bookId = base.getUrlParam("bookId");
    dom = $("#task-book-detail");
    router.init();
    inquireEmigratedTimePermissionsTenant();
    inquireReadingCyclePermissionsStateTenant();
  };

  var inquireEmigratedTimePermissionsTenant = function(){
    databind.submit([], {
    action: "inquireEmigratedTimePermissionsTenant",
    version: "v1.0",
      success: function (data) {
        emigratedBurTag = data.datas[0].burTag;
        emigratedTag = data.datas[0].emigratedTag;
        emigratedTimeList = data.datas[0].emigratedTimeList;
      }
    });
  }

  var inquireReadingCyclePermissionsStateTenant = function(){
    databind.submit([], {
      action: "inquireReadingCyclePermissionsStateTenant",
      version: "v1.0",
      success: function (data) {
        readingCircleSwitch = data.datas[0].readingCircleSwitch;
        readingBurTag = data.datas[0].burTag;
        initEvent();
        initJuicer();
        loadData();
      }
    });
  }

  var initEvent = function () {
    needGuideFlag = 0;

    dom.find(".onresume").bind("on-resume", function () {
      loadData();
    });

    dom.on("click", ".guideBtn", function () {
      $(".fullBg").addClass("none");
      dom.find(".guide").addClass("none");
      $(this).addClass("none");
    });

    dom.on("click", ".guidePostBtn", function () {
      $(".fullBg").addClass("none");
      dom.find(".guidePost").addClass("none");
      $(this).addClass("none");
    });

    if(readingCircleSwitch == 0){
      dom.find('.readingCircleTip').removeClass('none');
      if(readingBurTag == 1){
        dom.find('.tip')[0].innerHTML = '教育局已关闭悦读圈功能，无法发布阅读作品';
      }else{
        dom.find('.tip')[0].innerHTML = '学校已关闭悦读圈功能，无法发布阅读作品';
      }      
    }

    androidBackButtonEvent();
    $("body").find(".fullBgWhite").off("click");
    $("body").on("click",".fullBgWhite",function () {
      dom.find(".flyout-btn").trigger("click");
      dom.find(".release-close-btn").trigger("click");
    });

    (function () {
      $(".flyout-btn").click(function () {
        if(isAndroid){
          if(androidAppVersionCheck()){
            base.alert(1,"请更新APP至最新版本",2000);
            return false;
          }
          if(!androidSystemVersionCheck()){
            base.alert(1,"系统版本过低,不支持此功能",2000);
            return false;
          }
        }else{
          if(iosAppVersionCheck()){
            base.alert(1,"请更新APP至最新版本",2000);
            return false;
          }
        }
        $(".flyout-btn").toggleClass("btn-rotate");
        $(".flyout-btn").hasClass("btn-rotate") ? showAnimateBtnAndBg() : hideAnimateBtnAndBg();
        $(".flyout").find("a").removeClass();
        return $(".flyout").removeClass("flyout-init fade").toggleClass("expand");
      });

      $(".flyout").find("a").click(function () {
        $(".flyout-wrap").css("height", "0px");
        $(".flyout-btn").toggleClass("btn-rotate");
        $(".flyout").removeClass("expand").addClass("fade");
        $(".fullBgWhite").addClass("none");
        return $(this).addClass("clicked");
      });

    }).call(this);

    var showAnimateBtnAndBg = function () {
      $(".flyout-wrap").css("height", "265px");
      $(".release-text-common-style").removeClass("none");
      $(".fullBgWhite").removeClass("none");
    };

    var hideAnimateBtnAndBg = function () {
      $(".release-text-common-style").addClass("none");
      $(".fullBgWhite").addClass("none");
      $(".flyout-wrap").css("height", "0px");
    };

    initFiltrationTypeTreeList();
    dom.on("click", ".filtrationType", function(){
      dom.find('#filtrationType-select').mobiscroll('show');
    });

    dom.on("click", ".onlyShowExcellence", function () {
      var onlyShowExcellence = $(this).attr("onlyShowExcellence");
      if(onlyShowExcellence=="true"){
        $(this).find(".selected").addClass("none");
        $(this).find(".unselect").removeClass("none");
        $(this).attr("onlyShowExcellence",false);
        initPostListContent(bookId);
      }else{
        $(this).find(".unselect").addClass("none");
        $(this).find(".selected").removeClass("none");
        $(this).attr("onlyShowExcellence",true);
        initPostListContent(bookId);
      }
    });

    //发布按钮绑定事件
    //相机
    dom.on("click", ".release-camera", function () {
      var opt = {
        needOpenCamera:true
      };
      getIsHaveDraft(2,opt);
    });
    //相册
    dom.on("click", ".release-photo", function () {
      var opt = {
        needEnterAlbum:true
      };
      getIsHaveDraft(2,opt);
    });
    //文字
    dom.on("click", ".release-text", function () {
      getIsHaveDraft(2);
    });
    //语音感想
    dom.on("click", ".release-audio", function () {
      getIsHaveDraft(3);
    });
    //朗读者
    dom.on("click", ".release-reading", function () {
      base.alert(1, "功能开发中");
      // base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=4", "YX_READING_STUDENT_APP");
    });

    //更多
    dom.on("click", ".btn-more", function (e) {
      base.openUrl("index.html#studentPage.book-introduction-detail?bookId=" + bookId, "YX_READING_STUDENT_APP");
      e.stopPropagation();
    });
    dom.on("click", ".book-introduction", function (e) {
      base.openUrl("index.html#studentPage.book-introduction-detail?bookId=" + bookId, "YX_READING_STUDENT_APP");
      e.stopPropagation();
    });

    dom.on("click", ".to-exam-btn", function () {
      if (!isTimeCanExam) {
        base.alert(1, "未到可考试时间");
        return;
      }
      if (emigratedTag == 0) {
        dialog.loadDialog("dialog.dialog-tip-confirm", {
          params: {
            emigratedBurTag,
            emigratedTimeList,
          },
          okFn: function () {
            dialog.hideDialog();
            
          }
        }, "medium");
        return;
      }
      showLoading();
      checkTopicIsEnoughExam();
    });

    dom.on("click", ".next-can-exam-date", function (e) {
      dialog.loadDialog("dialog.dialog-examTime-tip-confirm", {
        params: {
        },
        okFn: function () {
          dialog.hideDialog();
        }
      }, "medium");
      e.stopPropagation();
    });

    //更新阅读进度
    dom.on("click", ".update-progress-btn", function () {
      databind.submit([], {
        action: "inquireReadingBookIsReachTheLimit",
        version: "v1.0",
        data: {
          bookId: bookId
        },
        success: function (data) {
          if (!data.datas[0].reachTheLimit) {
            updateReadingProgressAccount(bookId);
          } else {
            base.alert(1, "在读书籍已达上限【3本】，请读完它们再来吧~");
          }
        }
      });
    });

    //加入书架
    dom.on("click", ".add-to-bookrack", function () {
      addToBookrack(bookId);
    });

    dom.on("click", ".headToInfo", function(e){
      var studentId = $(this).attr("studentId");
      var schoolId = $(this).attr("schoolId");
      base.openUrl("index.html#studentPage.personal?studentId="+studentId+"&schoolId="+schoolId,"");
      e.stopPropagation();
    });

    dom.on("click", ".toActiveDetail", function () {
      var bookName = dom.find(".book-name").html();
      var ISBN = dom.find(".book-img").attr("ISBN");
      var author = dom.find(".book-author").html();
      router.route("#studentPage.book-active-detail?bookId="+bookId+"&bookName="+encodeURIComponent(bookName)
        +"&ISBN="+ISBN+"&author="+encodeURIComponent(author));
    });
  };

  var getIsHaveDraft = function (postType,opt) {
    databind.submit([], {
      action: "inquireReadingPostDraftAccount",
      version: "v1.0",
      data: {
        bookId: bookId,
        postType: postType
      },
      success: function (data) {
        //有草稿
        if(data.datas.length>0){
          var draftData = JSON.stringify(data.datas);
          base.removeData("postDraftData");
          base.saveData("postDraftData",draftData);
          switch (postType){
            // case 1:base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=1&isDraft=true", "YX_READING_STUDENT_APP");break;
            case 2:base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=2&isDraft=true", "YX_READING_STUDENT_APP");break;
            case 3:base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=3&isDraft=true", "YX_READING_STUDENT_APP");break;
            default:base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=2&isDraft=true", "YX_READING_STUDENT_APP");break;
          }
        }
        //无草稿
        else{
          var needOpenCamera = false;
          var needEnterAlbum = false;
          if(opt){
            needOpenCamera = opt.needOpenCamera || false;
            needEnterAlbum = opt.needEnterAlbum || false;
          }
          switch (postType){
            // case 1:base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=1&isDraft=false", "YX_READING_STUDENT_APP");break;
            case 2:
              base.removeData("postImageData");
              if(needOpenCamera){
                base.captureImage(function (data) {
                  var imageData = JSON.stringify(data.data);
                  base.saveData("postImageData",imageData);
                  base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=2&isDraft=false", "YX_READING_STUDENT_APP");
                });
              }
              if(needEnterAlbum){
                base.selectImageFile(function (data) {
                  var imageData = JSON.stringify(data.data);
                  base.saveData("postImageData",imageData);
                  base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=2&isDraft=false", "YX_READING_STUDENT_APP");
                }, {
                  "isSelectFile": false,
                  "maxcount": 9
                });
              }
              if (!needOpenCamera && !needEnterAlbum) {
                base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=2&isDraft=false", "YX_READING_STUDENT_APP");
              }
              break;
            case 3:base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=3&isDraft=false", "YX_READING_STUDENT_APP");break;
            default:base.openUrl("index.html#studentPage.post-create?bookId=" + bookId + "&postType=2&isDraft=false", "YX_READING_STUDENT_APP");break;
          }
        }
      }
    });
  };

  var checkTopicIsEnoughExam = function () {
    databind.submit([], {
      action: "inquireReadingTopicListGlobal",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success: function (data) {
        hideLoading();
        var topicIsEnoughExam = false;
        data.datas.length >= 15 ? topicIsEnoughExam = true : topicIsEnoughExam = false;
        if (topicIsEnoughExam) {
          router.route("#studentPage.exam?bookId=" + bookId);
        } else {
          base.alert(1, "本书题目更新中，可以先发悦读圈哦！");
        }
      }
    });
  };

  var loadData = function () {
    inquireReadingStudentBookDetailAccount(bookId);
    initPostListContent(bookId);
    if(readingCircleSwitch == 0){
      dom.find('.moments-area').addClass('none');
      dom.find('.bookContent').removeClass('none');
      inquireReadingBookDetailGlobal(bookId);
    }else{
      dom.find('.moments-area').removeClass('none');
      dom.find('.bookContent').addClass('none');
      inquireReadingActiveListGlobal();
      inquireReadingStudentActiveRankAccount();
    }
  };

    //查询书籍详情
    var inquireReadingBookDetailGlobal = function (bookId) {
      databind.submit([], {
        action: "inquireReadingBookDetailGlobal",
        version: "v1.0",
        data: {
          bookId: bookId
        },
        success: function (data) {
          var gradeCodeArray = data.datas[0].gradeCode.split(",");
          data.datas[0].wordsQty = (data.datas[0].wordsQty / 10000).toFixed(1);
          if(gradeCodeArray.length>1){
            data.datas[0].gradeCode = gradeCodeArray[0] + "-" + gradeCodeArray[gradeCodeArray.length - 1];
          }else{
            data.datas[0].gradeCode = gradeCodeArray[0];
          }
          var html = juicer(dom.find("#book-introduction-detail-tpl").html(), data);
          dom.find(".book").html(html);
        }
      });
    };

  var calculateBgSize = function () {
    //按钮的定位
    $(".book-info-right").css("width", $(".book-info").width() - 70 + "px");
    $(".book-author").css("width", $(".book-info-right-bottom").width() - $(".event-btn-common-img").width() - 20 + "px");
    //
    $(".guide").css("top", 40+$(".book-info-right-top").height()+"px");
  };

  //更新阅读进度
  var updateReadingProgressAccount = function (bookId) {
    //隐藏发帖菜单"+"按钮
    $(".animate-btn-field").addClass("none");
    dialog.loadDialog("dialog.dialog-update-reading-progress", {
      params: {
        tips: "更新阅读进度",
        currentReadingPage: currentReadingPage || 0,
        bookTotalPage: bookTotalPage || 0
      },
      okFn: function () {
        $(".readingPage").blur();
        //非纯数字情况
        var regex = /^\d+$/;
        if (!regex.test($("input[name='readingPage']").val())) {
          base.alert(1, "请输入纯数字");
          return;
        }
        //去除多余无效的0
        var newReadingPageString = $("input[name='readingPage']").val();
        var regex2 = /^[0\b]+/; // 以000开头的数字去除多余无用的0
        if (regex2.test(newReadingPageString)) {
          if (newReadingPageString == 0 || newReadingPageString == "0") {
            base.alert(1, "页数0无效!");
            $("input[name='readingPage']").val(currentReadingPage);
            return;
          }
          newReadingPageString = newReadingPageString.replace(regex2, '');
        }
        //转成格式
        var newReadingPage = parseInt(newReadingPageString);

        //比对数值正确性
        if (newReadingPage <= parseInt(currentReadingPage)) {
          base.alert(1, "页数不能少于或等于上次的记录哦！");
          $("input[name='readingPage']").val(currentReadingPage);
          return;
        }
        databind.submit([], {
          action: "updateReadingProgressAccount",
          version: "v1.0",
          data: {
            bookId: bookId,
            readingPage: $("input[name='readingPage']").val()
          },
          success: function (data) {
            dialog.hideDialog();
            if (data.datas[0].reward != "") {
              setTimeout(function () {
                dialog.loadDialog("dialog.dialog-update-reward", {
                  params: {
                    tips: "更新成功"
                  },
                  okFn: function () {
                    dialog.hideDialog();
                    if(data.datas[0].isLevelUp){
                      showLevelUpDialog(data.datas[0].level);
                    }else {
                      if (needGuideFlag == 1){
                        $(".fullBg").removeClass("none");
                        $(".guidePost").removeClass("none");
                        $(".guidePostBtn").removeClass("none");
                      }
                    }
                    loadData();
                  }
                }, "medium");
              }, 200);
            } else {
              base.alert(1, "更新成功!");
              if (needGuideFlag == 1){
                $(".fullBg").removeClass("none");
                $(".guidePost").removeClass("none");
                $(".guidePostBtn").removeClass("none");
              }
              loadData();
            }
          }
        });
      },
      closeFn: function () {
        if (parseInt(currentReadingPage) > 0) {
          $(".animate-btn-field").removeClass("none");
        }
      }
    }, "medium");
  };

  var showLevelUpDialog = function (newLevel) {
    dialog.loadDialog("dialog.dialog-level-up", {
      params: {
        tips: "升级啦!",
        newLevel:newLevel
      },
      okFn: function () {
        dialog.hideDialog();
        if (needGuideFlag == 1){
          $(".fullBg").removeClass("none");
          $(".guidePost").removeClass("none");
          $(".guidePostBtn").removeClass("none");
        }
      },
    }, "large");
  };

  //查询书籍详情
  var inquireReadingStudentBookDetailAccount = function (bookId) {
    databind.submit([], {
      action: "inquireReadingStudentBookDetailAccount",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success: function (data) {
        bookDetailData = data;
        var html = juicer(dom.find("#task-book-detail-tpl").html(), data);
        dom.find(".book-info-area").html(html);
        bookTotalPage = data.datas[0].pageQty || 0;
        currentReadingPage = data.datas[0].readingPage || 0;
        //计算字数能容纳下"更多"按钮
        var oneLineMaxWordsNum = parseInt($(".book-introduction").width() / 14);
        var collapseHtml = data.datas[0].introduction.substring(0, (oneLineMaxWordsNum * 2) - 7) + "...";
        $(".book-introduction-content").append(collapseHtml);
        
        accordingDataShowButton(bookDetailData);
        calculateBgSize();

        //检测需要升级或者是手机系统版本过低功能无法使用
        checkNeedUpdateAppAndSystemVersion();
        if (data.datas[0].isExist == true){
          inquireReadingStudentNeedGuide();
        }

        if(readingCircleSwitch == 0){
          dom.find('.book-introduction').addClass('none');
          dom.find('.animate-btn-field').addClass('none');
        }else{
          dom.find('.book-introduction').removeClass('none');
        }
      }
    });
  };

  var checkNeedUpdateAppAndSystemVersion = function () {
    console.log("1.验证是否需要升级和系统版本的方法...");
    var u = navigator.userAgent, app = navigator.appVersion;
    var android = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //g
    var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
    if (android) {
      isAndroid = true;
    }
    if (isIOS) {
      isAndroid = false;
    }
    if (android) {
      try {
        console.log("安卓验证...");
        base.getSystemVersionAndAppVersion(getAndroidSdkVersionCallback);
      } catch (e) {
        if (e.message.indexOf("defined") > -1 || e.message.indexOf("phoneManager") > -1 || e.message.indexOf("function") > -1) {
          needUpdateApp = true;
        }
      }
    } else {
      try {
        console.log("苹果验证...");
        base.getSystemVersionAndAppVersion(getIOSAppVersionCallback);
      } catch (e) {
        if (e.message.indexOf("defined") > -1 || e.message.indexOf("phoneManager") > -1 || e.message.indexOf("function") > -1) {
          needUpdateApp = true;
        }
      }
    }
  };

  var inquireReadingActiveListGlobal = function () {
    databind.submit([], {
      action: "inquireReadingActiveListGlobal",
      version: "v1.0",
      data: {
        bookId: bookId,
        pageSize: 4
      },
      success:function(data){
        if (data.datas.length == 0){
          dom.find(".activeRank").addClass("none");
        }else {
          dom.find(".activeRank").removeClass("none");
          dom.find(".total").text(data.totalRecordCount);
        }
        var html = juicer(dom.find("#active-tpl").html(), data);
        dom.find(".activeRankContent").html(html);
      }
    });
  };

  var inquireReadingStudentActiveRankAccount = function () {
    databind.submit([], {
      action: "inquireReadingStudentActiveRankAccount",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success:function(data){
        // data.datas[0].rank = "101";
        if (data.datas[0].rank == "0"){
          dom.find(".rank").text("未上榜");
        } else {
          if (data.datas[0].rank > 100){
            dom.find(".rank").text("100+");
          } else {
            dom.find(".rank").text(data.datas[0].rank);
          }
        }
        dom.find(".myRank").removeClass("none");
      }
    });
  };

  var initPostListContent = function (bookId) {
    dom.find("#list-content").empty();

    var html = juicer(dom.find('#menustripTpl').html(), null);
    dom.find('#menustripTabs').append(html);

    var postType = searchPostType;//帖子类型，0-全部，1-图，2-图文，3-小作家，4-朗读者
    var filtrationType = 1;//1-最新，2-热门,3-本班,4-本校
    var onlyShowExcellence;//是否只看优秀

    if (searchPostType) {
      filtrationType = $(".filtrationType").attr("filtrationType");
      $(".onlyShowExcellence").attr("onlyShowExcellence") == "true" ? onlyShowExcellence = 1 : onlyShowExcellence = 0;
      dom.find("#list-content").append(_bookDetailPostHtml);
      _bookDetailPostJs.init(bookId,postType, filtrationType, onlyShowExcellence);
    } else {
      postType = 0;
      filtrationType = $(".filtrationType").attr("filtrationType");
      $(".onlyShowExcellence").attr("onlyShowExcellence") == "true" ? onlyShowExcellence = 1 : onlyShowExcellence = null;
      dom.find("#all").attr("data-selected", true);
      $(".onlyShowExcellence").attr("onlyShowExcellence") == "true" ? onlyShowExcellence = 1 : onlyShowExcellence = 0;
      filtrationType = $(".filtrationType").attr("filtrationType");
      dom.find("#list-content").append(_bookDetailPostHtml);
      _bookDetailPostJs.init(bookId,postType, filtrationType, onlyShowExcellence);
    }

    $('#menustrip').mobiscroll().menustrip({
      theme: 'mobiscroll',
      display: 'top',
      type: 'tabs',
      onItemTap: function (event, inst) {
        //
        var itemId = event.target.id;
        switch (itemId){
          case "all" : searchPostType = 0;break;
          case "little-writer" : searchPostType = 3;break;
          default : searchPostType = 0;break;
        }
        base.saveData("searchPostType", searchPostType);
        dom.find("#list-content").empty();
        dom.find("#list-content").append(_bookDetailPostHtml);
        filtrationType = $(".filtrationType").attr("filtrationType");
        $(".onlyShowExcellence").attr("onlyShowExcellence") == true ? onlyShowExcellence = 1 : onlyShowExcellence = 0;
        postType = searchPostType;
        _bookDetailPostJs.init(bookId,postType, filtrationType, onlyShowExcellence);
      },
      onMarkupReady: function (event, inst) {

      },
    });
  };

  var initFiltrationTypeTreeList = function() {
    $('#filtrationType-select').mobiscroll().treelist({
      theme: 'ios',
      mode: 'scroller',
      display: 'bottom',
      lang: 'zh',
      showInput: false,
      circular: false,
      defaultValue: 0,
      onSet: function(event, inst) {
        var selectType = inst._tempWheelArray;
        var type = parseInt(selectType[0]) + 1;
        switch (type){
          case 1:dom.find(".filtrationType-type-text").text("最新");dom.find(".filtrationType").attr("filtrationType",type);break;
          case 2:dom.find(".filtrationType-type-text").text("热门");dom.find(".filtrationType").attr("filtrationType",type);break;
          case 3:dom.find(".filtrationType-type-text").text("本班");dom.find(".filtrationType").attr("filtrationType",type);break;
          case 4:dom.find(".filtrationType-type-text").text("本校");dom.find(".filtrationType").attr("filtrationType",type);break;
          default:dom.find(".filtrationType-type-text").text("最新");dom.find(".filtrationType").attr("filtrationType",1);break;
        }
        initPostListContent(bookId);
      }
    });
  };

  var addToBookrack = function (bookId) {
    databind.submit([], {
      action: "addToReadingBookrackAccount",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success: function (data) {
        base.alert(1, "加入成功！");
        inquireReadingStudentBookDetailAccount(bookId);
      }
    });
  };

  var inquireReadingStudentNeedGuide = function () {
    databind.submit([], {
      action: "inquireReadingStudentNeedGuide",
      version: "v1.0",
      data: {
      },
      success: function (data) {
        var needGuide = data.datas[0].needGuide;
        if (needGuide){
          $(".fullBg").removeClass("none");
          dom.find(".guide").removeClass("none");
          dom.find(".guideBtn").removeClass("none");
          needGuideFlag = 1;
        }else {
          needGuideFlag = 0;
        }
      }
    });
  };

  var getAndroidSdkVersionCallback = function (data) {
    console.log("安卓回调执行...");
    _sdk_int = data.data[0].SDK_INT;
    _version_name = data.data[0].VERSION_NAME;
    _version_code = data.data[0].VERSION_CODE;
    compatibilityLowSdkBtn();
  };

  var getIOSAppVersionCallback = function (data) {
    console.log("苹果回调执行...");
    _version_name = data.VERSION_NAME;
  };

  var accordingDataShowButton = function (data) {
    if (data.datas[0].isExist || false) {
      var readingProgress;
      readingProgress = parseInt(data.datas[0].readingPage) * 100 / parseInt(data.datas[0].pageQty);
      readingProgress = readingProgress >= 100 ? 100 : readingProgress;
      //首先判断是否存在书架 已存在才执行后续判断
      //判断考试是否通过
      if (data.datas[0].isPass || false) {
        dom.find(".tips-pass-date").removeClass("none");
        $(".animate-btn-field").removeClass("none");
      }
      //考试未通过但是阅读进度已经100%则执行闯关的判断
      else if (readingProgress == 100 && !data.datas[0].isPass || false) {
        dom.find(".to-exam-btn").removeClass("none");
        $(".animate-btn-field").removeClass("none");
        var nowDate = new Date();
        var nextExamDate = new Date((data.datas[0].nextCanExamDate + " 00:00:00").replace(/-/g,"/"));
        //根据下次可考试时间判断是否显示考试按钮或下次可考试时间
        if (nextExamDate.getTime() > nowDate.getTime()) {
          isTimeCanExam = false;
          dom.find(".next-can-exam-date").append("可闯关时间\n" + data.datas[0].nextCanExamDate);
          dom.find(".next-can-exam-date").removeClass("none");
          dom.find(".button-text").addClass("none");
          dom.find(".to-exam-btn-img").addClass("none");
        }
      }
      //其他情况执行阅读进度相关判断
      else {
        dom.find(".update-progress-btn").removeClass("none");
        //更新过阅读进度的才允许发帖
        if(parseInt(data.datas[0].readingPage)>0){
          $(".animate-btn-field").removeClass("none");
        }
      }
    }
    //不存在书架、显示加入书架的按钮
    else {
      dom.find(".add-to-bookrack").removeClass("none");
    }
  };

  var androidSystemVersionCheck = function () {
    if (parseInt(_sdk_int) < 21) {
      return false;
    }
    return true;
  };

  var androidAppVersionCheck = function () {
    if (parseInt(_version_code) < 600) {
      return true;
    }
    return false;
  };

  //检测App版本是否小于v2.2
  var iosAppVersionCheck = function () {
    var versionInfoList = _version_name.split(".");
    switch (versionInfoList.length){
      case 3://暂时不需要判断到第三位
      case 2:
        var firstVersionCode = parseInt(versionInfoList[0]);
        var secondVersionCode = parseInt(versionInfoList[1]);
        if(firstVersionCode < 2){
          needUpdateApp = true;
          return true;
        }
        if(firstVersionCode == 2){
          if (secondVersionCode < 2) {
            needUpdateApp = true;
            return true;
          }
        }
        return false;
        break;
    }
    return false;
  };

  var compatibilityLowSdkBtn = function () {
    //兼容低版本安卓机sdk
    if (parseInt(_sdk_int) < 21) {
      console.log("该设备安卓版本低于5.0，按钮启用静态模式");
      $(".animate-btn-field").addClass("none");
      $(".compatibility-low-sdk-release-btn").removeClass("none");

      dom.on("click", ".release-btn", function () {
        if(isAndroid){
          if(androidAppVersionCheck()){
            base.alert(1,"请更新APP至最新版本",2000);
            return;
          }
          if(!androidSystemVersionCheck()){
            base.alert(1,"系统版本过低,不支持此功能",2000);
            return;
          }
        }else{
          if(iosAppVersionCheck()){
            base.alert(1,"请更新APP至最新版本",2000);
            return;
          }
        }
        $(this).addClass("none");
        showLowSdkReleaseBtn();
      });

      dom.on("click", ".release-close-btn", function () {
        $(this).addClass("none");
        hideLowSdkReleaseBtn();
      });

      var showLowSdkReleaseBtn = function () {
        $(".release-close-btn").removeClass("none");
        $(".low-sdk-event").removeClass("none");
        $(".fullBgWhite").removeClass("none");
      };

      var hideLowSdkReleaseBtn = function () {
        $(".release-btn").removeClass("none");
        $(".low-sdk-event").addClass("none");
        $(".fullBgWhite").addClass("none");
      };

      //兼容旧版sdk
      //相机
      dom.on("click", ".low-sdk-release-camera", function () {
        var opt = {
          needOpenCamera:true
        };
        getIsHaveDraft(2,opt);
      });
      //相册
      dom.on("click", ".low-sdk-release-photo", function () {
        var opt = {
          needEnterAlbum:true
        };
        getIsHaveDraft(2,opt);
      });
      //文字
      dom.on("click", ".low-sdk-release-text", function () {
        getIsHaveDraft(2);
      });
      //语音感想
      dom.on("click", ".low-sdk-release-audio", function () {
        getIsHaveDraft(3);
      });
      return;
    }
  };

  //安卓虚拟按键点返回收起发帖的按钮
  var androidBackButtonEvent = function () {
    window._android_on_back_pressed = function() {
      if(dom.find(".flyout-btn").hasClass("btn-rotate")){
        dom.find(".flyout-btn").trigger("click");
        return;
      }
      if(!dom.find(".release-close-btn").hasClass("none")){
        dom.find(".release-close-btn").trigger("click");
        return;
      }
      base.back();
      return false;
    }
  };

  var initJuicer = function () {
    juicer.register("fsPath", function () {
      return CONFIG.fsPath;
    });
  };

  //转菊花
  var showLoading = function(){
    $(".fullBg").removeClass("none");
    $(".loader").removeClass("none");
  };
  //隐藏菊花
  var hideLoading = function(){
    $(".fullBg").addClass("none");
    $(".loader").addClass("none");
  };


  return {
    init: init
  };
});
