// 主界面
;
define(function (require, exports, module) {
  'use strict';
  var util = require("util");
  var base = require("base");
  var databind = require("databind");
  var listView = require("listView");
  var router = require("pageRouter");
  var dialog = require("dialog");
  var constant = require("constant");
  var dom;
  var winWidth;
  var mySwiper;
  var pushType;
  var timeOutEvent;
  var startTime;
  var endTime;
  var startX;
  var startY;
  var moveX;
  var moveY;

  var init = function () {
    dom = $("#task-list");
    router.init();
    base.saveData("inquireTaskType","1");
    // initSwiper();
    inquireReadingDiplomaNotReceiveList();
    initEvent();
    initJuicer();
  };

  var initEvent = function () {
    // $("#content").on("click", function () {
    //   dom.find(".delete").addClass("none");
    // });

    try {
      var only = base.isOnlyReadingStudentApp();
      if (only){
        dom.find(".backBtn").addClass("none");
      }
    }catch (e) {
      console.log(e);
    }

    dom.find(".onresume").bind("on-resume", function () {
      var type = base.getData("inquireTaskType");
      if (type == "1") {
        base.saveData("inquireTaskType","1");
        loadData(type);
        $(".student-task-list").removeClass("none");
        $(".student-history-task-list").addClass("none");
      } else {
        base.saveData("inquireTaskType","2");
        loadData(type);
        $(".student-history-task-list").removeClass("none");
        $(".student-task-list").addClass("none");
      }
    });

    dom.find(".header-tab").on("click", function () {
      $(".header-tab").removeClass("header-tab-active");
      $(".tab-border").removeClass("tab-border-active");
      $(this).addClass("header-tab-active");
      $(this).find(".tab-border").addClass("tab-border-active");
      var type = $(this).attr("type");
      if (type == 1) {
        base.saveData("inquireTaskType","1");
        $(".student-task-list").attr("loaded")=="loaded"?"":loadData(type);
        $(".student-task-list").removeClass("none");
        $(".student-history-task-list").addClass("none");
      } else {
        base.saveData("inquireTaskType","2");
        $(".student-history-task-list").attr("loaded")=="loaded"?"":loadData(type);
        $(".student-history-task-list").removeClass("none");
        $(".student-task-list").addClass("none");
      }
    });

    //展开
    //历史展开
    dom.on("click", ".task-item", function () {
      $(this).find(".task-book-list").css("display", "block");
      $(this).find(".collapse").removeClass("none");
    });
    //历史展开
    dom.on("click", ".task-history-item", function () {
      $(this).find(".task-book-list").css("display", "block");
      $(this).find(".history-collapse").removeClass("none");
    });

    //历史收起
    dom.on("click", ".collapse", function (e) {
      $(this).parent(".task-item").find(".task-book-list").css("display", "none");
      $(this).addClass("none");
      e.stopPropagation();
    });
    //历史收起
    dom.on("click", ".history-collapse", function (e) {
      $(this).parent(".task-history-item").find(".task-book-list").css("display", "none");
      $(this).addClass("none");
      e.stopPropagation();
    });

    //发现好书
    dom.on("click", ".find-book", function (e) {
      base.openUrl("index.html#studentPage.find", "YX_READING_STUDENT_APP");
      e.stopPropagation();
    });

    dom.on("click", ".scan-isbn", function () {
      try{
        base.getISBNCode();
      }catch (e){
        if (e.message.indexOf("defined") > -1 || e.message.indexOf("function") > -1) {
          base.alert(2,"使用扫一扫,请更新App到最新版本!")
        }
      }
    });

    window._android_on_isbn_select = function (isbn) {
      base.openUrl("index.html#studentPage.search-book?fromBookList=1&isbn="+isbn, "");
    };

    window._android_on_back_pressed = function() {
      try {
        var only = base.isOnlyReadingStudentApp();
        if (only){
          dialog.loadDialog("dialog.confirmDialog", {
            params: {
              tips: "确认退出程序？"
            },
            okFn: function() {
              $(".dialog-container").addClass("none");
              base.exitProgram();
            }
          }, "small");
        }
      }catch (e) {
        console.log(e);
      }
      return false;
    };

    dom.on("click", ".delete", function (e) {
      var bookId = $(this).attr("bookId");
      dialog.loadDialog("dialog.dialog-delete-book-confirm", {
        params: {
          tips: "锲而不舍，金石可镂。再坚持一下就看完啦！放弃会清空进度哦～",
        },
        okFn: function() {
          dialog.hideDialog();
          deleteReadingStudentBookAccount(bookId);
        }
      }, "small");
      e.stopPropagation();
    });

    //书籍阅读详情
    dom.on("click", ".task-book-list-item", function (e) {
      var bookId = $(this).find("input[name='bookId']").val();
      base.openUrl("index.html#studentPage.task-book-detail?bookId=" + bookId, "YX_READING_STUDENT_APP");
      e.stopPropagation();
    });

    dom.on("click", ".edit", function (e) {
      var content = $(this).text();
      if (content == "管理"){
        $(this).text("保存");
        $(this).parent().parent().parent().parent().find(".delete").each(function (idx, item) {
          if ($(item).parent().find(".book-pass-mark").length == 0){
            $(item).removeClass("none");
          }
        });
      } else {
        $(this).text("管理");
        dom.find(".delete").addClass("none");
      }
      e.stopPropagation();
    });

    // dom.on({
    //   touchstart: function(e){
    //     startTime = +new Date();
    //     var touch = e.originalEvent.targetTouches[0]; //获取第一个触点
    //
    //     var x = parseInt(touch.pageX); //页面触点X坐标
    //     var y = parseInt(touch.pageY); //页面触点Y坐标
    //     //记录触点初始位置
    //     startX = x;
    //     startY = y;
    //     var bookDom = $(this).parent();
    //     timeOutEvent = setTimeout(function () {
    //       longPress(bookDom);
    //     }, 1500);
    //     e.preventDefault();
    //   },
    //   touchmove: function(e){
    //     var touch = e.originalEvent.targetTouches[0]; //获取第一个触点
    //     var x = parseInt(touch.pageX); //页面触点X坐标
    //     var y = parseInt(touch.pageY); //页面触点Y坐标
    //     //记录触点初始位置
    //     moveX = x;
    //     moveY = y;
    //     if (Math.abs(moveX - startX) > 5 || Math.abs(moveY - startY) > 5){
    //       clearTimeout(timeOutEvent);
    //       timeOutEvent = 0;
    //     }
    //   },
    //   touchend: function(){
    //     endTime = +new Date();
    //     clearTimeout(timeOutEvent);
    //     if (endTime - startTime < 1500 && timeOutEvent !== 0){
    //       var bookId = $(this).parent().find("input[name='bookId']").val();
    //       base.openUrl("index.html#studentPage.task-book-detail?bookId=" + bookId, "YX_READING_STUDENT_APP");
    //     }
    //     return false;
    //   }
    // }, ".task-book-list-item .book-img");

    //删除任务按钮
    dom.on("click", ".task-delete-btn", function () {
      var taskId = parseInt($(this).parent().parent().parent().find("input[name='taskId']").val());
      dialog.loadDialog("dialog.dialog-delete-confirm", {
        params: {
          tips: "确定删除该历史任务?"
        },
        okFn: function () {
          databind.submit([], {
            action: "deleteReadingDeletedTaskAccount",
            version: "v1.0",
            data: {
              taskId: taskId
            },
            success: function () {
              dialog.hideDialog();
              base.alert(1, "删除成功");
              inquireReadingHistoryStudentTaskListAccount();
            }
          });
        }
      }, "medium");
    });
  };

  // var initSwiper = function () {
  //   if(mySwiper != undefined) {
  //     mySwiper.destroy();
  //   }
  //
  //   console.log("start!");
  //   var loadFlag = true;
  //   mySwiper = new Swiper('.swiper-container', {
  //     direction: 'vertical',
  //     scrollbar: '.swiper-scrollbar',
  //     slidesPerView: 'auto',
  //     mousewheelControl: true,
  //     freeMode: true,
  //     onTouchMove: function (swiper) {
  //       //手动滑动中触发
  //       var _viewHeight = document.getElementsByClassName('swiper-wrapper')[0].offsetHeight;
  //       var _contentHeight = document.getElementsByClassName('swiper-slide')[0].offsetHeight;
  //       var offsetTop = $(".swiper-container").offset().top;
  //       var containerHeight = $(".swiper-container").height();
  //       var containerWidth = $(".swiper-container").width();
  //       if (mySwiper.translate < 50 && mySwiper.translate > 0) {
  //         $(".init-loading").html('下拉刷新...').show();
  //       } else if (mySwiper.translate > 50) {
  //         $(".init-loading").html('释放刷新...').show();
  //       }
  //       //超过顶部范围
  //       if(swiper.touches.currentY<=offsetTop||swiper.touches.currentY>=(containerHeight+offsetTop)||swiper.touches.currentX<=0||swiper.touches.currentX>=containerWidth){
  //         // translateVOver();
  //       }
  //     },
  //     onTouchEnd: function (swiper) {
  //       var _viewHeight = document.getElementsByClassName('swiper-wrapper')[0].offsetHeight;
  //       var _contentHeight = document.getElementsByClassName('swiper-slide')[0].offsetHeight;
  //
  //       // 下拉刷新
  //       if (mySwiper.translate >= 50) {
  //         $(".init-loading").html('正在刷新...').show();
  //         $(".loadtip").html('');
  //
  //         setTimeout(function () {
  //           if($(".student-task-list").hasClass("none")){
  //             loadData("2");
  //           }else{
  //             loadData("1");
  //           }
  //
  //           $(".init-loading").html('刷新成功！');
  //           setTimeout(function () {
  //             $(".init-loading").fadeOut();
  //           }, 1500);
  //           setTimeout('$(".loadtip").slideUp()',1500);
  //         }, 1000);
  //       } else if (mySwiper.translate < 50) {
  //         $(".init-loading").html('').hide();
  //       }
  //       return false;
  //     },
  //     onTransitionEnd:function(){
  //       // var translates = $('.w').css('transform').replace(/[^0-9\-,]/g, '').split(',');
  //       // if (parseFloat(translates[translates.length - 1]) < 0 && parseFloat(translates[translates.length - 1]) != -50 ) {
  //       //   dom.find(".moveBtn").slideDown();
  //       // } else {
  //       //   dom.find(".moveBtn").slideUp();
  //       // }
  //     }
  //   });
  // };

  var loadData = function (type) {
    if (type == "1") {
      dom.find(".student-task-list").empty();
      inquireReadingStudentTaskListAccount();
    } else if (type == "2") {
      dom.find(".student-history-task-list").empty();
      inquireReadingHistoryStudentTaskListAccount();
    }
  };

  var deleteReadingStudentBookAccount = function (bookId) {
    databind.submit([], {
      action: "deleteReadingStudentBookAccount",
      version: "v1.0",
      data: {
        bookId: bookId
      },
      success: function (data) {
        loadData("1");
      }
    });
  };

  //查询学生是否有获得奖状，且是未读的
  var inquireReadingDiplomaNotReceiveList = function () {
    databind.submit([], {
      action: "inquireReadingDiplomaNotReceivedList",
      version: "v1.0",
      data: {},
      success: function (data) {
        if (data.datas.length > 0) {
          var needReceiveDiplomaNotification = [];
          for (var i = 0; i < data.datas.length; i++) {
            needReceiveDiplomaNotification.push(data.datas[i]);
          }
          pushType = base.getData("pushType");
          if(!pushType){
            receiveDiplomaNotification(needReceiveDiplomaNotification);
          }
        } else {
          loadData("1");
        }
      }
    });
  };

  var receiveDiplomaNotification = function (needReceiveDiplomaNotification) {
    var item = needReceiveDiplomaNotification[0];
    needReceiveDiplomaNotification.shift();//删除第一个元素
    var data = {};
    var datas = [];
    datas.push(item);
    data.datas = datas;

    dialog.loadDialog("dialog.dialog-obtain-diploma", {
      params: {
        tips: "您有新的奖状",
        diplomaData:data
      },
      okFn: function () {
        databind.submit([], {
          action: "receiveReadingDiplomaAccount",
          version: "v1.0",
          data: {
            diplomaId: item.diplomaId
          },
          success: function () {
            dialog.hideDialog();
            if (needReceiveDiplomaNotification != undefined && needReceiveDiplomaNotification.length != 0) {
              setTimeout(function () {
                receiveDiplomaNotification(needReceiveDiplomaNotification)
              }, 200);
            } else {
              loadData("1");
            }
          },
          fail: function () {
            dialog.hideDialog();
            loadData("1");
          }
        });
      }
    }, "large");
  };

  //当前任务
  var inquireReadingStudentTaskListAccount = function () {
    databind.submit([], {
      action: "inquireReadingStudentTaskListAccount",
      version: "v1.0",
      data: {},
      success: function (data) {
        var needNotificationArray = [];
        for (var i = 0; i < data.datas.length; i++) {
          //计算完成情况
          var bookList = data.datas[i].bookList;
          var passBookNum = 0;
          for(var j = 0; j< bookList.length; j++){
            if(bookList[j].isPass){
              passBookNum++;
            }
          }
          data.datas[i].passBookNum = passBookNum;
          data.datas[i].totalBookNum = bookList.length;
          var isAcceptTask = data.datas[i].isAcceptTask;
          var taskId = parseInt(data.datas[i].taskId);
          if (!isAcceptTask && taskId != -1) {
            needNotificationArray.push(data.datas[i]);
          }
        }
        if (needNotificationArray.length != 0) {
          newTaskNotificationArray(needNotificationArray);
        }

        var html = juicer(dom.find("#task-tpl").html(), data);
        dom.find(".student-task-list").html(html);

        $(".student-task-list").attr("loaded", "loaded");
        adaptFontSize();
        adaptReadingProgressAreaSize();
      }
    });
  };

  var newTaskNotificationArray = function (needNotificationArray) {
    var item = needNotificationArray[0];
    needNotificationArray.shift();//删除第一个元素

    dialog.loadDialog("dialog.dialog-accept-task", {
      params: {
        tips: "您有新的阅读任务",
        creatorName: item.creatorName,
        taskName: uncodeUtf16(decodeURIComponent(item.taskName)),
        expireDate: item.expireDate
      },
      okFn: function () {
        databind.submit([], {
          action: "acceptReadingTaskAccount",
          version: "v1.0",
          data: {
            taskId: item.taskId
          },
          success: function () {
            dialog.hideDialog();
            if (needNotificationArray != undefined && needNotificationArray.length != 0) {
              setTimeout(function(){newTaskNotificationArray(needNotificationArray)},200);
            }
          },
          fail:function () {
            dialog.hideDialog();
            base.alert(1,"该任务可能已被老师删除!",1000);
            setTimeout(function () {
              loadData("1");
            },1000);
          }
        });
      }
    }, "large");
  };

  //历史任务
  var inquireReadingHistoryStudentTaskListAccount = function () {
    databind.submit([], {
      action: "inquireReadingHistoryStudentTaskListAccount",
      version: "v1.0",
      data: {},
      success: function (data) {
        for (var i = 0; i < data.datas.length; i++) {
          //计算完成情况
          var bookList = data.datas[i].bookList;
          var passBookNum = 0;
          for(var j = 0; j< bookList.length; j++){
            if(bookList[j].isPass == true){
              passBookNum++;
            }
          }
          data.datas[i].passBookNum = passBookNum;
          data.datas[i].totalBookNum = bookList.length;
        }
        var html = juicer(dom.find("#history-task-tpl").html(), data);
        dom.find(".student-history-task-list").html(html);

        $(".student-history-task-list").attr("loaded", "loaded");
        adaptFontSize();
        adaptReadingProgressAreaSize();
      }
    });
  };

  var adaptFontSize = function () {
    // 获取窗口宽度
    if (window.innerWidth)
      winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
      winWidth = document.body.clientWidth;
    if (document.documentElement && document.documentElement.clientWidth) {
      winWidth = document.documentElement.clientWidth;
    }

    var fontSize = winWidth / 30;
    dom.find(".book-name").css("font-size",fontSize + "px");
    dom.find(".book-reading-progress").css("font-size", fontSize + 10 + "px");
  };

  var adaptReadingProgressAreaSize = function () {
    var imgItemWidth = winWidth * 0.34 - 32;//32是图片外层div有16的padding
    var imgItemHeight = imgItemWidth * 1.41;//1.41由图片分辨率计算得出
    var progressAreaWidth = imgItemWidth * 0.5;
    var progressAreaPositionTop = ( imgItemHeight - progressAreaWidth ) / 2;
    var progressAreaPositionLeft = ( imgItemWidth - progressAreaWidth ) / 2;
    dom.find(".book-reading-progress").css("width", progressAreaWidth + "px");
    dom.find(".book-reading-progress").css("height", progressAreaWidth + "px");
    dom.find(".book-reading-progress").css("top", progressAreaPositionTop + "px");
    dom.find(".book-reading-progress").css("left", progressAreaPositionLeft + "px");
    dom.find(".book-reading-progress").css("line-height", progressAreaWidth + "px");
    dom.find(".book-reading-progress").css("font-size", progressAreaWidth/4 + "px");
  };

  var initJuicer = function () {
    juicer.register("decode", function (replyContent) {
      return uncodeUtf16(decodeURIComponent(replyContent));
    });
  };

  var uncodeUtf16 = function (str) {
    var reg = /\&#.*?;/g;
    var result = str.replace(reg,function(char){
      var H,L,code;
      if(char.length == 9 ){
        code = parseInt(char.match(/[0-9]+/g));
        H = Math.floor((code-0x10000) / 0x400)+0xD800;
        L = (code - 0x10000) % 0x400 + 0xDC00;
        return unescape("%u"+H.toString(16)+"%u"+L.toString(16));
      }else{
        return char;
      }
    });
    return result;
  };

  return {
    init: init
  };
});
